(function($) { 
	var jadFn = {};
	jadFn.initSlider = function(posId,elId) {
		var cacheGame = {};
		var defatultGame = {};
		jad.getSliderAds(posId).onDefault(function(adGame){
			defatultGame = adGame;
			createSlider(elId||posId,posId,adGame);
		}).onCache(function(adGame){
			cacheGame = adGame||{};
			createSlider(elId||posId,posId,adGame);
		}).then(function(adGame) {
			if(cacheGame.hash != adGame.hash){
				if(adGame.adInfoList.length>0){
					createSlider(elId||posId,posId,adGame);
				}else{
					createSlider(elId||posId,posId,defatultGame);
				}
			}	
		}).catch(function(err){
			console.error(err.message,err);
		});
	};
	jadFn.initBanner = function(posId,elId) {
		jad.getBannerAd(posId).onDefault(function(adGame){
			if(adGame && adGame.adInfoList && adGame.adInfoList.length>0){
				//var ad = adGame.adInfoList[0];
				createBanner(elId||posId,posId,adGame);
			}
		}).then(function(adGame) {
			if(adGame && adGame.adInfoList && adGame.adInfoList.length>0){
				//var ad = adGame.adInfoList[0];
				createBanner(elId||posId,posId,adGame);
			}
		});
	};
	jadFn.initDyBanner = function(posId,elId) {
		var theGame = null;
		var defaultGame = null;
		jad.getBannerAd(posId).onDefault(function(adGame){
			defaultGame = adGame;
		}).then(function(adGame) {
			theGame = adGame;
		});
		return {
			refresh:function(){
				var adGame = theGame||defaultGame;
				if(!adGame||
					!adGame.adInfoList||
					!adGame.adInfoList.length||
					adGame.adInfoList.length==0) 
					return;
					
				var len = adGame.adInfoList.length,
					index = adGame.currIndex!=undefined?adGame.currIndex:-1;
				if(adGame.showRule==1){
					index = index+1>len-1?0:index+1;
				}else if(adGame.showRule==2){
					index = getRandom(0,len-1);
				}
				var ad = adGame.adInfoList[index];
				var adBox = document.getElementById(elId);
				_createBanner(adBox,posId,ad,adGame.gameId);
				adGame.currIndex = index;
			},
			createIndex:function(el){
				var adGame = theGame||defaultGame;
				if(!adGame||
					!adGame.adInfoList||
					!adGame.adInfoList.length||
					adGame.adInfoList.length==0) 
					return;
					
				var len = adGame.adInfoList.length,
					index = adGame.currIndex!=undefined?adGame.currIndex:-1;
				if(adGame.showRule==1){
					index = index+1>len-1?0:index+1;
				}else if(adGame.showRule==2){
					index = getRandom(0,len-1);
				}else{
					index = 0;
				}
				var ad = adGame.adInfoList[index];
				_createBanner(el,posId,ad,adGame.gameId);
				adGame.currIndex = index;
			}
		}
	};
	jadFn.showGuideAd = function(closeCB){
		closeCB = closeCB||mui.noop;
		if(guideAd){
			guideAd.showGuideAd(closeCB);
		}else{
			closeCB();
		}
	};
	
	jadFn.initList = function(posId,elId){
		var cacheGame = {};
		jad.getListAds(posId).onCache(function(adGame){
			cacheGame = adGame||{};
			createList(elId||posId,posId,adGame);
		}).then(function(adGame) {
			if(adGame && adGame.adInfoList && adGame.adInfoList.length>0){
				createList(elId||posId,posId,adGame);
			}
		});
	};
	
	var guideAd = null;
	function GuideAd(wait){
		var This = this;
		This._listeners={};
		This.closeCB = mui.noop;
		This.cacheGame = null;
		This.adGame = null;
		This.showTheAd = null;
		This.isShowed = false;
		This.isOnShow = false;
		This.isCancle = false;
		This.wait = wait||1200;
		This.waitInt = null;
		This.isCallBacked = false;
		
		function getShowAd(adGame){
			if(!adGame || 
				!adGame.adInfoList ||
				!adGame.adInfoList.length ||
				adGame.adInfoList.length == 0){
					return null;
			}
			var len = adGame.total;
			var showAd=null,
				index = adGame.currIndex!=undefined?adGame.currIndex:-1;
			var rule = adGame.showRule||1;
			if(rule==1){
				index = index+1>len-1?0:index+1;
			}else if(rule==2){
				index = getRandom(0,len-1);
			}else{
				index = 0;
			}
			var ad = adGame.adInfoList[index];
			ad.showTime = adGame.showTime;
			ad.isFullscreen = ad.isFullscreen || adGame.isFullscreen || false;
			ad.skipShowTime = ad.skipShowTime || adGame.skipShowTime || 0;
			ad.showIndex = index;
			ad.posId = adGame.posId;
			ad.gameId = adGame.gameId;
			isExistLocal(ad);
			return ad;
		}
		function isExistLocal(ad,yesCallback,noCallback){
			mui.plusReady(function(){
				plus.io.resolveLocalFileSystemURL(jad.imgPath+ad.hashName, function(en){
					ad.isExistLoc = true;
				},function(err){ 
					ad.isExistLoc = false;
				});
			});
		}
		This.callback = function(){
			if(This.isCallBacked) return;
			This.isCallBacked = true;
			This.closeCB();
		}
		This.getGuideAd = function(){
			var posId = 'guide';
			jad.getGuideAd(posId).onCache(function(adGame){
				if(This.adGame) return;
				This.cacheGame = adGame;
				This.showTheAd = getShowAd(adGame);
			}).then(function(adGame){
				This.adGame = adGame;
				This.showTheAd = getShowAd(adGame);
				if(This.isOnShow) This.showView();
			}).catch(function(err){
				console.error(err.message,err);
			});
		}
		This.showGuideAd = function(closeCB){
			This.closeCB=closeCB||mui.noop;
			if((This.adGame||This.cacheGame) && !This.isShowed){
				This.showView();
			}else{
				This.isOnShow = true;
				This.waitInt = setTimeout(function(){
					This.isCancle = true;
					This.callback();
				},This.wait);
			}
		};
		This.showView = function(){
			if(This.isCancle) return;
			clearInterval(This.waitInt);
			This.isShowed = true;
			if(!This.showTheAd){
				return This.callback();
			}
			var showAd = This.showTheAd;
			showAd.gameId = This.adGame.gameId;
			var adview = null;
			var adStr = encodeURIComponent(showAd.adImgPath);
			var url = 'advert.html?img='+adStr;
			adview = plus.webview.create(url,'guideAd',{
				plusrequire:'ahead',
				zindex:999,
				hardwareAccelerated:true,
				top:'0px',left:'0px',width:'100%',height:'100%',
				errorPage:'404.html'
			},{
				ad:showAd
			});
			adview.addEventListener('loaded',function(){
				adview.show('none');
			},false)
			console.log('guide-show:'+Date.now());
			adview.addEventListener('close',function(){
				This.callback();
			},false);
		};
	}

	function createSlider(elId,posId,adGame) {
		if(!adGame || 
			!adGame.adInfoList ||
			!adGame.adInfoList.length ||
			adGame.adInfoList.length == 0)
		return;
		
		var adBox = document.getElementById(elId);
		var sliderCont = document.createElement('div');
		sliderCont.className ='mui-slider-group mui-slider-loop';
		var pointCont = document.createElement('div');
		pointCont.className ='mui-slider-indicator';
		
		var placeholder = jad.getOptions(posId).placeholder;
		var Lazyload = $('#'+elId).imageLazyload({
			placeholder: placeholder,
			autoDestroy: false
		});
		
		var itemHtml = '',
			items = [],
			points = [],
			adList = adGame.adInfoList,
			len = adList.length;
		for(var i = 0; i < len; i++) {
			itemHtml = createSliderItem(adList[i]);
			items.push(itemHtml);
			points.push('<div class="mui-indicator' + (i == 0 ? ' mui-active' : '') + '"></div>');
		}
		
		items.push(createSliderItem(adList[0],true));
		items.unshift(createSliderItem(adList[len - 1],true));

		sliderCont.innerHTML = items.join('');
		pointCont.innerHTML = points.join('');
		
		adBox.classList.add("mui-slider");
		adBox.innerHTML='';
		adBox.appendChild(sliderCont);
		adBox.appendChild(pointCont);
		
		Lazyload.refresh(true);
		
		var interval = isNaN(adGame.showTime)?3000:adGame.showTime*1000;
		var options = adGame.showType == 1 ? {interval:0}:{interval:interval};
		var slider = $('#'+elId);
		//slider[0].classList.add("mui-slider");
		if(slider[0].getAttribute('data-slider')) slider.slider().destroy();
		slider.slider(options);
		var adLinks = $('#'+elId+' a');
		for(var i=0;i<adLinks.length;i++){
			var link = adLinks[i];
			link.addEventListener('tap',function(){
				var href = this.getAttribute('jhref');
				var adId = this.getAttribute('adid');
				var title = this.getAttribute('title');
				if(adGame.gameId) jad.adClick(adId,adGame.posId,adGame.gameId);
				if(/^http(s)?:\/\//.test(href)) {
					app.openUrl(href, {
						title: title,
						showCloseBtn: true,
						enableHistory: true,
						scalable: false
					});
				} else if(/^WXMiniPro:\/\//.test(href) && plus.LanuchMiniPro){
					 var reg = new RegExp("^WXMiniPro://([^/]+)(/.+)");
					 var match = reg.exec(href);
					 if(match.length==3) plus.LanuchMiniPro.open(match[1],match[2]);
				} else {
					$.openWindow({url: href});
				}
			},false);
		}
		function createSliderItem(item,duplicate){
			var html ='<div class="mui-slider-item'+(duplicate?' mui-slider-item-duplicate':'')+'">'
			      +'<a' + (item.adInfoId?' adid="'+item.adInfoId+'"':'')
			      	+ ' gameid="'+adGame.gameId+'"'
			      	+ (item.adTitle?' title="'+item.adTitle+'"':'')
				      + ' posid="'+posId+'" jhref="'+item.adTargetPath+'">'
			        +'<img data-lazyload="' + item.adImgPath
			          + '" src="'+placeholder+'">'
			      +'</a>'
			    +'</div>';
			return html;
		}
	}

	function createBanner(elId,posId,adGame) {
		if(!adGame) return;
		var ad = adGame.adInfoList[0];
		if(!ad) return;
		var adBox = document.getElementById(elId);
		_createBanner(adBox,posId,ad,adGame.gameId)
	}
	function _createBanner(el,posId,ad,gameId){
		el.innerHTML='';
		var link = document.createElement('a');
		if(ad.adInfoId) link.setAttribute('adid',ad.adInfoId);
		if(ad.adTitle) link.setAttribute('title',ad.adTitle);
		if(ad.adTargetPath) link.setAttribute('jhref',ad.adTargetPath);
		if(posId) link.setAttribute('posid',posId);
		if(gameId) link.setAttribute('gameid',gameId);
		
		link.innerHTML='<img src="'+ad.adImgPath+'">';
		el.appendChild(link);
		link.addEventListener('tap',function() {
			var href = this.getAttribute('jhref');
			var adId = this.getAttribute('adid');
			var title = this.getAttribute('title');
			var gameId = this.getAttribute('gameId');
			var posId = this.getAttribute('posId');
			if(adId) jad.adClick(adId,posId,gameId);
			if(/^http(s)?:\/\//.test(href)) {
				var options = {
					title: title,
					showCloseBtn: true,
					enableHistory: true,
					scalable: false
				};
				if(title) options.title = title;
				app.openUrl(href,options);
			}else if(/^WXMiniPro:\/\//.test(href) && plus.LanuchMiniPro){
				 var reg = new RegExp("^WXMiniPro://([^/]+)(/.+)");
				 var match = reg.exec(href);
				 if(match.length==3) plus.LanuchMiniPro.open(match[1],match[2]);
			} else {
				$.openWindow({url: href});
			}
		},false);
	}
	
	function createList(elId,posId,adGame){
		if(!adGame || 
			!adGame.adInfoList ||
			!adGame.adInfoList.length ||
			adGame.adInfoList.length == 0)
		return;
		
		var adBox = document.getElementById(elId);
		
		adBox.className='joy-ad ad-col-'+(adGame.showColumn||1);
		
		var items = [],
			adList = adGame.adInfoList,
			len = adList.length;
			
		for(var i = 0; i < len; i++) {
			var item = adList[i];
			items = items.concat(['<a class="list-ad-item"',
					(item.adInfoId?' adid="'+item.adInfoId+'"':''),
					(item.adTitle?' title="'+item.adTitle+'"':''),
					' gameid="',adGame.gameId,'"',
			    		' posid="',posId,'" jhref="',item.adTargetPath,'">',
		        '<img src="',item.adImgPath,'">',
		     '</a>']);
		}
		adBox.innerHTML=items.join('');

		var adLinks = $('#'+elId+' a');
		for(var i=0;i<adLinks.length;i++){
			var link = adLinks[i];
			link.addEventListener('tap',function(){
				var href = this.getAttribute('jhref');
				var adId = this.getAttribute('adid');
				var title = this.getAttribute('title');
				if(adGame.gameId) jad.adClick(adId,adGame.posId,adGame.gameId);
				if(/^http(s)?:\/\//.test(href)) {
					app.openUrl(href, {
						title: title,
						showCloseBtn: true,
						enableHistory: true,
						scalable: false
					});
				} else if(/^WXMiniPro:\/\//.test(href) && plus.LanuchMiniPro){
					 var reg = new RegExp("^WXMiniPro://([^/]+)(/.+)");
					 var match = reg.exec(href);
					 if(match.length==3) plus.LanuchMiniPro.open(match[1],match[2]);
				} else {
					$.openWindow({url: href});
				}
			},false);
		}
	}
	
 	function getRandom(min, max){
        var r = Math.random() * (max - min);
        var re = Math.round(r + min);
        re = Math.max(Math.min(re, max), min);
        return re;
    }
 	
 	function autoAdPos(){
 		var adBoxs = document.querySelectorAll('.joy-ad');
		mui.each(adBoxs,function(i,adbox){
			var boxId = adbox.getAttribute('id');
			var posId = adbox.getAttribute('ad-location')||boxId;
			if(!boxId) return;
			var options = $.extend(true,{
				type: adbox.getAttribute('ad-type')
				}, jad.getOptions(posId));
			
			if(options.type=='slider'){
				jadFn.initSlider(posId,boxId);
			}else if(options.type=='banner'){
				jadFn.initBanner(posId,boxId);
			}else if(options.type=='list'){
				jadFn.initList(posId,boxId);
			}
		});
 	}
 	
 	jadFn.mainAdinit = function(){
 		guideAd = new GuideAd();
		guideAd.getGuideAd();
		autoAdPos();
 	};
 	
 	if(!/main\.html/.test(location.pathname)){
		 autoAdPos();
	}
	
	window.jadFn = jadFn;
	
})(mui);