(function($,ad){
	var getAdsUrl = app._gwMarket +'/ad/getAdvGameAndInfo';
	var clickAdUrl = app._gwMarket +'/ad/adTypeStatistics';
	var locations = {
		guide:{},
		homebig:{type:'banner'},
		homesmall1:{type:'banner'},
		homesmall2:{type:'banner'},
		homesmall3:{type:'banner'},
		homeslider:{type:'slider',fillDefault:true,placeholder:'../images/loading-slider.png'},
		criedit_top:{type:'slider',fillDefault:true,placeholder:'../images/loading-criedit-ad.png'},
		baoxian_slider:{type:'slider',fillDefault:true,placeholder:'../images/loading-criedit-ad.png'},
		medicalpay_banner:{type:'banner'},
		baoxian_listad_1:{type:'list'},
		baoxian_listad_2:{type:'list'},
		baoxian_listad_3:{type:'list'},
		baoxian_listad_4:{type:'list'},
	};
	var defaults = {
		homeslider:{
			showType:2,
			showTime:3,
			showRule:1,
			adInfoList:[{
				adTitle:'社保交的钱去那儿了？',
				adTargetPath:'article-video.html?aid=1267',
				adImgPath:'../images/banner/1.jpg'
			},{
				adTitle:'招商信诺',
				adTargetPath:'https://www.heiniubao.com/activity/chayuesbzsxn1',
				adImgPath:'../images/banner/2.jpg'
			},{
				adTitle:'养老金计算',
				adTargetPath:'article-video.html?aid=1098',
				adImgPath:'../images/banner/3.jpg'
			},{
				adTitle:'众安保险',
				adTargetPath:'https://open.zhongan.com/standard/insure/productShowPageMobile.htm?productCode=PRD161120369050&requestId=c0723703bb1a467f83f6a1cc3fe6bf15&campaignId=1000420008&promotionCode=INST170407688008&payChannel=wxpay,alipay,alipay_app&accessChannel=mobile',
				adImgPath:'../images/banner/4.jpg'
			}]
		},
		criedit_top:{
			showType:1,
			showTime:3,
			showRule:1,
			adInfoList:[{
				adTitle:'工商银行',
				adTargetPath:'https://mims.icbc.com.cn/IMServiceServer/servlet/ICBCBaseReqNSServlet?dse_operationName=ApplyCreditCardOp&coreCode=HZDW000021477&paraPromoCode=EW88800086355100471',
				adImgPath:'../images/credit/1.jpg'
			},{
				adTitle:'招商银行',
				adTargetPath:'https://ccclub.cmbchina.com/mca/MPreContract.aspx?cardSel=8341&swbrief=Y&WT.mc_id=N57FHXM2073K688300HZ',
				adImgPath:'../images/credit/2.jpg'
			}]
		},
		baoxian_slider:{
			showType:1,
			showTime:3,
			showRule:1,
			adInfoList:[{
				adTitle:'平安健康',
				adTargetPath:'https://m.health.pingan.com/share/products/ikangbao_adult.html?re_from=chayueshebao_ikbzj&order_from=chayueshebao_ikbzj&noad=1',
				adImgPath:'../images/baoxian/1.jpg'
			},{
				adTitle:'招商信诺',
				adTargetPath:'https://www.heiniubao.com/activity/chayuesbzsxn1',
				adImgPath:'../images/baoxian/2.jpg'
			}]
		},
		medicalpay_banner:{
			showType:1,
			showTime:3,
			showRule:1,
			adInfoList:[{
				adTitle:'平安健康',
				adTargetPath:'https://m.health.pingan.com/share/products/ejb.html?re_from=chayueshebao_ejb&order_from=chayueshebao_ejb&noad=1',
				adImgPath:'../images/ad-ins.jpg'
			}]
		}
	};
	
	var imgPath = '_downloads/ads/';
	var adsStoreName = 'adverts';
	var gamesStoreName = 'adGames';
	
	var service = {
		getAdData:function(posId){
			var location = myStorage.getItem('location');
			var cusInfo = app.getDeviceInfo(),
				city = app.getCity();
			var postData = mui.extend({
				adLocationId:posId
			},cusInfo,city,{location:location});
			return request.post(getAdsUrl,postData);
		},
		clickCount:function(adId,posId,gameId,type){	
			return request.post(clickAdUrl,{
				adLocationId:posId,
				gameId:gameId,
				adInfoId:adId,
				countType:type
			});
		}
	};

	function getAdGame(posId){
		return service.getAdData(posId).then(function(adGame){
			var hash = md5.hex_md5(JSON.stringify(adGame));
			adGame= mui.extend({
				posId:posId,
				adInfoList:[],
				hash:hash,
				timestamp:Date.now()
			},adGame);
			mui.extend(adGame,{
				currIndex:-1,
				total:adGame.adInfoList.length
			});
			return adGame;
		});
	}
	function getAndCacheAdGame(posId){
		if(plus.networkinfo.getCurrentType()!=3){
			console.warn('非wifi环境不缓存');
		}
		return getAdGame(posId).then(function(data){
			cacheAdGame(posId,data);
		}).catch(function(error){
			console.error(err.message,err);
		});
	}
	function cacheAdGame(posId,adGame){
		jdb.saveData(gamesStoreName,adGame);
		if(adGame && adGame.adInfoList && adGame.adInfoList.length > 0){
			$.plusReady(function(){
				if(plus.networkinfo.getCurrentType()==3){
					saveImages(adGame);
				}
			});
		}
	}
	function getCacheAdGame(posId){
		return jdb.getData(gamesStoreName,posId);
	}
	function updateCacheGame(adGame){
		return jdb.saveData(gamesStoreName,adGame);
	}
	
	function getExt(url){
		var idx = url.lastIndexOf('.')
		return idx>0?url.substr(idx):'.jpg';
	}
	function saveImages(adGame){
		var hashs=[],urls = [];
		mui.each(adGame.adInfoList,function(i,ad){
			var ext = getExt(ad.adImgPath);
			var hashName = md5.hex_md5(ad.adImgPath)+ext;
			ad.gameId = adGame.gameId;
			ad.hashName = hashName;
			hashs[i] = hashName;
			urls[i] =  ad.adImgPath;
		});
		var downloadBack = function(res){
			var hasFalse = false;
			mui.extend(adGame.adInfoList,function(i,ad){
				if(res[ad.adImgPath]&& res[ad.adImgPath].successful){
					ad.cached = true;
				}else{
					hasFalse = true;
				}
			});
			if(!hasFalse) adGame.cached = true;
			jdb.saveData(gamesStoreName,adGame);
		};
		plus.io.resolveLocalFileSystemURL(imgPath, function(entry){
			var directoryReader = entry.createReader();
			directoryReader.readEntries(function(entries){
				mui.each(entries,function(i,nentry){
					var idx = hashs.indexOf(nentry.name)
					if(idx>=0){
						hashs.splice(idx,1);
						urls.splice(idx,1);
					}
				});
				download(urls,hashs,downloadBack);
			}, function (e){
				download(urls,hashs,downloadBack);
			});
		},function(err){
			download(urls,hashs,downloadBack);
		});
		
	}
	function download(urls,hashs,callback){
		var dl = downloader.createDownload(urls,{path:imgPath},hashs);
		dl.addEventListener('allComplete',function(res){
			if(callback) callback(res);
		},false);
	}

	function adClick(adId,posId,gameId){
		return service.clickCount(adId,posId,gameId,1);
	}
	function skipClick(adId,posId,gameId){
		return service.clickCount(adId,posId,gameId,2);
	}

	function getListAds(posId){
		var thePromise = getAdGame(posId);
		thePromise.onCache = function(callback){
			getCacheAdGame(posId).then(function(adGame){
				callback(adGame);
			}).catch(function(err){
				console.error(err.message,err);
			});
			return thePromise;
		};
		thePromise.then(function(adGame){
			cacheAdGame(posId,adGame);
			return adGame;
		}).catch(function(err){
			console.error(err.message,err);
		});
		return thePromise;
	}
	function getSliderAds(posId){
		var defaultObj = defaults[posId]||{};
		var thePromise = getAdGame(posId);
		thePromise.onDefault = function(callback){
			if(callback) callback(defaultObj);
			return thePromise;
		};
		thePromise.onCache = function(callback){
			getCacheAdGame(posId).then(function(adGame){
				callback(adGame);
			}).catch(function(err){
				console.error(err.message,err);
			});
			return thePromise;
		};
		thePromise.then(function(adGame){
			cacheAdGame(posId,adGame);
			return adGame;
		}).catch(function(err){
			console.error(err.message,err);
		});
		return thePromise;
	}
	function getBannerAd(posId){
		var defaultObj = defaults[posId]||{};
		var thePromise = getAdGame(posId);
		thePromise.onDefault = function(callback){
			if(callback) callback(defaultObj);
			return thePromise;
		};
		thePromise.onCache = function(callback){
			getCacheAdGame(posId).then(function(adGame){
				callback(adGame);
			}).catch(function(err){
				console.error(err.message,err);
			});
			return thePromise;
		};
		thePromise.then(function(adGame){
			cacheAdGame(posId,adGame);
			return adGame;
		});
		return thePromise;
	}
	function getGuideAd(posId){
		//return jad.getAndCacheAdGame('guide');
		var thePromise = getAdGame(posId);
		thePromise.onCache = function(callback){
			getCacheAdGame(posId).then(function(adGame){
				callback(adGame);
			}).catch(function(err){
				console.error(err.message,err);
			});
			return thePromise;
		};
		thePromise.then(function(adGame){
			cacheAdGame(posId,adGame);
		    return adGame;
		}).catch(function(err){
			console.log(err.message,err);
		});
		return thePromise;
	}
	function getDefaultGame(posId){
		return defaults[posId];
	}
	function addDefaultGame(posId,data){
		defaults[posId] = data;
	}
	function getOptions(posId){
		return locations[posId];
	}
	ad.imgPath = imgPath;
	ad.getDefaultGame = getDefaultGame;
	ad.addDefaultGame = addDefaultGame;
	ad.getOptions = getOptions;
	ad.getAdGame = getAdGame;
	ad.getAndCacheAdGame = getAndCacheAdGame;
	ad.cacheAdGame = cacheAdGame;
	ad.getCacheAdGame = getCacheAdGame;
	ad.updateCacheGame = updateCacheGame;
	
	ad.getListAds = getListAds;
	ad.getSliderAds = getSliderAds;
	ad.getBannerAd = getBannerAd;
	ad.getGuideAd = getGuideAd;
	
	ad.adClick = adClick;
	ad.skipClick = skipClick;

})(mui,window.jad={});
