(function($,myStorage) {
	var app = {};
	
	/* 运行环境
	 * {dev:"开发&测试",pre:"验证||预上线",prd:"生产环境"}
	 */
	var env = 'prd';
	
	/* 神策SDK集成模式
	 * {0:"不集成",1:"DEBUG_ONLY-只调试",2:"DEBUG_AND_TRACK-调试并采集数据"}
	 */
	var saMode = 2;
	
	/* 显示神策日志
	 * true-显示，false-不显示
	 */
	var saShowLog = true;
	
	/* 控制台日志输出级别
	 * 0-trace,1-log,2-info,3-warn,4-error
	 */
	var logLevel = 0;
	
	app.name='查悦社保';
	app.needLoginCode = '30005';
	app.androidChannel = 'joyshebao';
	app.iosChannel = 'joyshebao_AppStore';
	
	var environment = {
		dev:{
			baseUrl:'https://app.chayueshebao.com',
			webUrl:'https://m.chayueshebao.com',
			imUrl:'https://im.chayueshebao.com',
			saUrl:'https://sc.joyshebao.com:8106/sa?project=default',
			joyData:'https://m.chayueshebao.com'
		},
		pre:{
			baseUrl:'https://pre.app.chayueshebao.com',
			webUrl:'https://pre.m.chayueshebao.com',
			imUrl:'https://pre.im.chayueshebao.com',
			saUrl:'https://sc.joyshebao.com:8106/sa?project=default',
			joyData:'https://pre.m.chayueshebao.com'
		},
		prd:{
			baseUrl:'https://app.joyshebao.com',
			webUrl:'https://m.joyshebao.com',
			imUrl:'https://im.joyshebao.com',
			saUrl:'https://sc.joyshebao.com:8106/sa?project=production',
			joyData:'https://sc.joyshebao.com:8106'
		},
		saweb:'https://sc.joyshebao.com'
	};
	
    (function(){
		app._baseUrl=environment[env].baseUrl;
		app._webUrl=environment[env].webUrl;
		app._customURL=environment[env].imUrl;
		app._saServer=environment[env].saUrl;
		app._saWeb=environment.saweb;
		app._joyData=environment[env].joyData;
		
		app.logLevel=env=='prd'?4:logLevel;
    		
		if(!/joyshebao-mobile/g.test(navigator.userAgent)){
			//非app环境
			app._baseUrl = {dev:'/apptest',pre:'/apppre',prd:'/appprd'}[env];
			app._customURL = {dev:'/imtest',pre:'/impre',prd:'/imprd'}[env];
		} 
		app._gwCoop=app._baseUrl+'/coop';	
		app._gwCons=app._baseUrl+'/cons';
		app._gwEpay=app._baseUrl+'/pay';
		app._gwUser=app._baseUrl+'/u';
		app._gwCalc=app._baseUrl+'/calc';
		app._gwWx=app._baseUrl+'/wechat';
		app._gwMarket=app._baseUrl+'/mt';
		app._gwO2o=app._baseUrl+'/o2o';
    		
        var appRoot = myStorage.getItem('appRoot');
        var appVer = myStorage.getItem('appver');
        app.oldVersion =  appVer;
         $.plusReady(function(){
            if(!appRoot){
                app.appRoot = plus.io.convertLocalFileSystemURL('_www').replace('/www/','/');
                myStorage.setItem('appRoot',app.appRoot);
            }
            if(!appVer){
                app.appVer = plus.runtime.version;
                myStorage.setItem('appver',app.appVer);
            }
            setDeviceInfo();
        });
        app.appRoot = appRoot;
        app.appVer = appVer;
        
        app._saMode = saMode;
		app._saShowLog = saShowLog;
		if(saMode==1){
			app._saServer='';
			app._saWeb='';
		}
    })();

 	function getState(key){
 		var state = null;
 		if(window.plus) 
 			state = myStorage.getItemPlus("StatePlus") || {};
 		else
 			state = myStorage.getItem("State") || {};
 		var res = key ? state[key]:state;
 		return res;
 	}
 	function setState(key,value){ 
 		var state = getState();
 		state[key] = value;
 		myStorage.setItem("State",state);
 		if(window.plus) myStorage.setItemPlus('StatePlus',state);
 	}
 	function createState(data){
 		var state = getState();
 		if(!data.headPath) data.headPath = '../images/user-photo.png';
 		state.info = data;
 		state.token = data.token;
		myStorage.setItem("State",state);
		if(window.plus) myStorage.setItemPlus('StatePlus',state);
		if(window.jTrack) jTrack.login(data.userId);
 	}
 	function siginOut(notToLogin){
 		var state = myStorage.getItem("State")||{},
			statePlus = myStorage.getItemPlus("StatePlus")||{},
			rf = state.token||statePlus.token;
 		if(state.token){
 			delete state.token;
	 		delete state.info;
	 		myStorage.setItem("State",state);
 		}
		if(statePlus.token){
			delete statePlus.token;
	 		delete statePlus.info;
	 		myStorage.setItemPlus('StatePlus',state);
		}
		if(rf && !notToLogin){
			if(window.jTrack) jTrack.logout();
	 		toLogin();
			refresh();
		}
 	}
 	
 	function removeLogin(notToLogin){
		$.plusReady(function(){
			if(!notToLogin){
				plus.webview.getLaunchWebview().evalJS('app.siginOut()');
			}else{
				plus.webview.getLaunchWebview().evalJS('app.siginOut(1)');
			}
		});
 	}
 	
	function setDeviceInfo(){
		var deviceInfo = myStorage.getItem("deviceInfo")||{};
		if(!deviceInfo.geTuiId || deviceInfo.geTuiId=='null'){
			try{
				var geTuiInfo = plus.push.getClientInfo();
				deviceInfo.geTuiId = geTuiInfo?geTuiInfo.clientid:'';
			}catch(e){
				deviceInfo.geTuiId ='';
			}
		}
		deviceInfo.resVersion = myStorage.getItem('resver')||plus.runtime.version;
		
   		deviceInfo.appid = plus.runtime.appid;
 		deviceInfo.appVersion = plus.runtime.version;
 		deviceInfo.origin = plus.runtime.origin;
 		deviceInfo.innerVersion = plus.runtime.innerVersion;
 		
 		deviceInfo.deviceId = plus.device.uuid;
		deviceInfo.deviceModel = plus.device.model;
		deviceInfo.deviceVendor = plus.device.vendor;
		deviceInfo.deviceImei = plus.device.imei;
		
		deviceInfo.os = plus.os.name;
		deviceInfo.osVersion = plus.os.version;
		deviceInfo.osLanguage = plus.os.language;

		deviceInfo.channel = getChannel();
		deviceInfo.idfa = mui.os.ios?app.getIOSIdfa():'';
		deviceInfo.idfv = mui.os.ios?app.getIOSIdfv():'';
		deviceInfo.androidId =  mui.os.android?app.getAndroidID():'';
		deviceInfo.androidDeviceId = mui.os.android?app.getAdrDeviceId():'';

		myStorage.setItem("deviceInfo",deviceInfo);
		return deviceInfo;
	}
	function getDeviceInfo(){
 		var deviceInfo = myStorage.getItem("deviceInfo");
 		if(deviceInfo){
 			deviceInfo.resVersion = myStorage.getItem('resver')|| window.plus&&plus.runtime.version || '';
	 		deviceInfo.appVersion = window.plus&&plus.runtime.version || myStorage.getItem('appver');
	 		deviceInfo.innerVersion = window.plus&&plus.runtime.innerVersion||'';
	 		return deviceInfo;
 		}else{
 			return setDeviceInfo();
 		}
 	}
 	function getUser(){
		return getState('info');
	}
 	function checkLogin(){
		var token = getState('token');
		return token ? true :false;
	}
	function checkToLogin(){
		var token = getState('token');
		if(!token) toLogin(true);
	}
 	function getSetting(key){
 		var settings = myStorage.getItem("Settings")||{};
 		var res = key ? settings[key]:settings;
 		return res;
 	}
 	function setSetting(key,value){
 		var settings = myStorage.getItem("Settings")||{};
 		settings[key] = value;
 		myStorage.setItem("Settings",settings);
 	}
	function getCity(allowEmpty){
		var city = myStorage.getItem('city');
		if(!city && window.plus) city = myStorage.getCookiePlus('city',true);
        if(!city && !allowEmpty) city = {cityName:'北京市',cityCode:'110000',geo:0};
		return city; 
	}
	function getVersionCode(callback) {
        callback = callback || $.noop;
        plus.runtime.getProperty(plus.runtime.appid, function(inf) {
            callback(inf.version);
            console.log("当前版本："+inf.version);
        });
    }
	function backToQuit(){
		//var backButtonPress = 0;
		if(typeof backButtonPress == 'undefined') backButtonPress = 0;
		backButtonPress++;
		if (backButtonPress > 1) {//一秒内连续按两次则推出
			plus.runtime.quit();
		} else {
			$.toast('再按一次退出应用');
		}
		setTimeout(function() {
			backButtonPress = 0;
		}, 1000);
		return false;
	}    
	function testQuit(){
		$.oldBack = $.back;
		$.back = backToQuit;
	}	
	function toLogin(notBack,showCallBack,closeCallBack){
		document.activeElement.blur();
		$.plusReady(function(){
			var lws = plus.webview.getWebviewById('login');
			if(!lws){
				lws = $.openWindow({
					url:"_www/view/auth-login.html",
					id:'login',
					show:{aniShow:'slide-in-bottom'},
					styles:{softinputMode:'adjustResize'},
					waiting:{autoShow:false},
					extras:{notback:notBack}
				});
				if(showCallBack){
					lws.addEventListener('show',function(){
						showCallBack(lws);
					});
				}
				if(closeCallBack) {
					lws.addEventListener('close',function(){
						closeCallBack(lws);
					});
				}
			}else{
				lws.show();
			}
		});
	}
	function toKefu(){
		$.plusReady(function(){
			$.fire(plus.webview.getLaunchWebview(),'openChat');
		});
	}
	
	function showUnlock(showCallBack){
 		document.activeElement.blur();
		var unlock =  plus.webview.getWebviewById('unlock');
		if(!unlock){
			unlock = $.preload({
				url:'_www/view/auth-unlock.html',
				id:'unlock',
				styles:{zindex:999,hardwareAccelerated:true},
				show:{aniShow:'none'},
				waiting:{autoShow:false}
			});
	 		unlock.addEventListener('loaded',function(){
	 			unlock.show();
	 			if(showCallBack) showCallBack();
	 		},false);
		}else{
			unlock.show();
		}
		return unlock;
	}
	function showGuide(callback){
 		document.activeElement.blur();
 		var guide = $.preload({
			url:'_www/view/guide.html',
			id:'guide',
			styles:{zindex:99},
			show:{aniShow:'none'},
			waiting:{autoShow:false}
		});
 		guide.addEventListener('loaded',function(){
 			guide.show();
 			if(callback) callback();
 		},false);
 		return guide;
	}
	function showSheBaoAdd(options){
		options = $.extend(true,{}, options);
		var href = '_www/view/shebaobind.html?t='+Date.now();
		if(options.viewId){
			href+='&vwid='+options.viewId;
		}
		if(options.events){
			href+='&evts='+options.events.join(',');
		}
		return $.openWindow({ url:href, id:'addSbk' });
	}
	function showGongJiJinAdd(options){
		options = $.extend(true,{}, options);
		var href = '_www/view/gjj-bind.html?t='+Date.now();
		if(options.viewId){
			href+='&vwid='+options.viewId;
		}
		if(options.events){
			href+='&evts='+options.events.join(',');
		}
		return $.openWindow({ url:href, id:'addGjj' });
	}
	function showSheBaoInfo(id,extras){
		var vw = plus.webview.getWebviewById('sbkinfo')||plus.webview.getWebviewById('sbk-info.html');
		var options = {};
		if(!vw){
			options = {
				url:'_www/view/sbk-info.html?id='+id,
				id:'sbkinfo'
			};
			if(extras) options.extras=extras;
			vw = $.openWindow(options);
		}else{
			options = {"securityAcctId":id};
			if(extras) options.extras=extras;
			app.fireEvent('sbkinfo','show',options);
			vw.show();
		}
		return vw;
	}
	function showGongJiJinInfo(id,extras){
		var vw = plus.webview.getWebviewById('gjjinfo')||plus.webview.getWebviewById('gjj-info.html');
		var options = {};
		if(!vw){
			options = {
				url:'_www/view/gjj-info.html?id='+id,
				id:'gjjinfo'
			};
			if(extras) options.extras=extras;
			vw = $.openWindow(options);
		}else{
			options = {"fundAcctId":id};
			if(extras) options.extras=extras;
			app.fireEvent('gjjinfo','show',options);
			vw.show();
		}
		return vw;
	}
	
	function openUrl(url,options,bwsOptions){
		options = $.extend(true,{
			id:url,
			url:url,
			showCloseBtn:true,
			enableHistory:true,
			scalable:false
		}, options);
		var opts = {
			url:'_www/view/openUrl.html',
			id:options.id,
			extras:options
		};
		if(options.styles) opts.styles = options.styles;
		var vw = $.openWindow(opts);
		if(bwsOptions&&bwsOptions.cssText){
			vw.setCssText(bwsOptions.cssText);
		}
		if(bwsOptions&&bwsOptions.jsFiles){
			$.each(bwsOptions.jsFiles, function(i,js) {
				vw.appendJsFile(js);
			});
		}
		return vw;
	}
	function openMultiURL(url,options){
		if(/^http(s)?:\/\//.test(url)) {
			openUrl(url,$.extend(true,  {
				showCloseBtn: true,
				enableHistory: true,
				scalable: false
			}, options));
		} else if(/^WXMiniPro:\/\//.test(url) && plus.LanuchMiniPro){
			 var reg = new RegExp("^WXMiniPro://([^/]+)(/.+)");
			 var match = reg.exec(url);
			 if(match.length==3) plus.LanuchMiniPro.open(match[1],match[2]);
		} else {
			url = url.indexOf('_www/view/')<0?'_www/view/'+url:url;
			$.openWindow({url: url});
		}
	}
	
	function fireEvent(viewId,eventName,data) {
        $.plusReady(function() {
            var view = null;
            if(viewId==='main'){
            		view = plus.webview.getLaunchWebview();
            }else if(viewId==='sbkinfo'){
            		view = plus.webview.getWebviewById(viewId)||plus.webview.getWebviewById('sbk-info.html');
            }else if(viewId==='gjjinfo'){
            		view = plus.webview.getWebviewById(viewId)||plus.webview.getWebviewById('gjj-info.html');
            }else if(viewId==='gjj'){
                    view = plus.webview.getWebviewById(viewId)||plus.webview.getWebviewById('gjj-list.html');
            }else if(viewId==='sbk'){
                    view = plus.webview.getWebviewById(viewId)||plus.webview.getWebviewById('sbk-list.html');
            }else{
            		view = plus.webview.getWebviewById(viewId);
            }
            if(view) $.fire(view,eventName,data);
        });
    }
	function refresh(){
       $.plusReady(function() {
            var views =  plus.webview.all();
	        for(var i=0;i<views.length;i++){
	            $.fire(views[i],'refresh_data');
	        }
       });
    }

	var $openWindow= $.openWindow;
    function openWindow(url, id, options){
	    	if(typeof url === 'object') {
			options = url;
			url = options.url;
			id = options.id || url;
		} else {
			if(typeof id === 'object') {
				options = id;
				id = options.id || url;
			} else {
				id = id || url;
			}
		}
		options = options||{statusBarStyle:'dark'};
		var cc = plus.navigator.getStatusBarStyle();
		var pc = options.statusBarStyle=='light'?'light':'dark';
		var vw = $openWindow(url, id, options);
		if(vw){
			vw.addEventListener('loading',function(){
				plus.navigator.setStatusBarStyle(pc);
			},false);
			vw.addEventListener('show',function(){
				plus.navigator.setStatusBarStyle(pc);
			},false);
			vw.addEventListener('hide',function(){
				plus.navigator.setStatusBarStyle(cc);
			},false);
			vw.addEventListener('close',function(){
				plus.navigator.setStatusBarStyle(cc);
			},false);
		}
		return vw;
    }
    
	function showMask(){
 		app.mask = app.mask || $.createMask();
 		app.mask.show();//显示遮罩
 	}
	function closeMask(){
 		if(app.mask) app.mask.close();//关闭遮罩
 	}
	
	function openSoftKeyboard() {
        if (mui.os.ios) {
            var webView = plus.webview.currentWebview().nativeInstanceObject();
            webView.plusCallMethod({
                "setKeyboardDisplayRequiresUserAction": false
            });
        } else {
            var Context = plus.android.importClass("android.content.Context");
            var InputMethodManager = plus.android.importClass("android.view.inputmethod.InputMethodManager");
            var main = plus.android.runtimeMainActivity();
            var imm = main.getSystemService(Context.INPUT_METHOD_SERVICE);
            imm.toggleSoftInput(0, InputMethodManager.SHOW_FORCED);
        }
    }
	function copyText(text){
		if(mui.os.ios){
			var UIPasteboard  = plus.ios.importClass("UIPasteboard");
			var generalPasteboard = UIPasteboard.generalPasteboard();
			// 设置/获取文本内容:
			generalPasteboard.setValueforPasteboardType(text, "public.utf8-plain-text");
		}else if(mui.os.android){
		    var Context = plus.android.importClass("android.content.Context");
		    var main = plus.android.runtimeMainActivity();
		    var clip = main.getSystemService(Context.CLIPBOARD_SERVICE);
		    plus.android.invoke(clip,"setText",text);
		}
    }
	
	function getIOSIdfa(){
		try{
			var ASIdentifierManager = plus.ios.importClass("ASIdentifierManager");
			var sharedManager = ASIdentifierManager.sharedManager();
			var advertisingIdentifier = sharedManager.advertisingIdentifier();
			var idfa = plus.ios.invoke(advertisingIdentifier,"UUIDString");
			return idfa;
		}catch(e){
			return ''; 
		}
	}
	function getIOSIdfv(){
		try{
			var UIDevice = plus.ios.importClass("UIDevice");
			var currentDevice = UIDevice.currentDevice();
			var identifierForVendor = currentDevice.identifierForVendor();
			var idfv = plus.ios.invoke(identifierForVendor,"UUIDString");
			return idfv;
		}catch(e){
			return ''; 
		}
	}
	function getIOSAppInfo(key){
		var NSBundle = plus.ios.importClass('NSBundle'),
			bundle = NSBundle.mainBundle(),
			infoDictionary = bundle.infoDictionary(),
			value = infoDictionary.plusGetAttribute(key);
		plus.ios.deleteObject(bundle);
		plus.ios.deleteObject(infoDictionary);
		return value;
	}
	function getIOSGPStatus(){
		var CLLocationManager = plus.ios.import("CLLocationManager");
		var authorizationStatus = CLLocationManager.authorizationStatus();
		return authorizationStatus;
    }

    function getAndroidID(){
    		try{
    			var context = plus.android.runtimeMainActivity();
			var Settings = plus.android.importClass("android.provider.Settings");
			var androidId = Settings.System.getString(context.getContentResolver(), Settings.System.ANDROID_ID);
			return androidId;
    		}catch(e){
			return '';
    		}
    }
    function getAdrDeviceId(){
    		try{
    			var context = plus.android.runtimeMainActivity();
			var TelephonyManager = plus.android.importClass("android.telephony.TelephonyManager");
			var tm = context.getSystemService("phone");
			return tm.getDeviceId();
    		}catch(e){
			return '';
    		}
    }
	function getAndroidAppMeta(key){
		try{
    			var PackageManager=plus.android.importClass("android.content.pm.PackageManager");
			var context = plus.android.runtimeMainActivity();
			var appInfo=plus.android.invoke(context.getPackageManager(), "getApplicationInfo", context.getPackageName(),PackageManager.GET_META_DATA);
			return plus.android.invoke(appInfo.plusGetAttribute('metaData'),'getString',key.toString());
    		}catch(e){
			return '';
    		}
	}
	function getAndroidGPStatus(){
		var context = plus.android.importClass("android.content.Context");
        var locationManager=plus.android.importClass("android.location.LocationManager");
        var main=plus.android.runtimeMainActivity();
        var mainSvr=main.getSystemService(context.LOCATION_SERVICE);
        console.log(mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER));
        return mainSvr.isProviderEnabled(locationManager.GPS_PROVIDER);
    }

	function openAndroidSettings(key){
		var main = plus.android.runtimeMainActivity();
		var Intent = plus.android.importClass("android.content.Intent");
		var Settingts  = plus.android.importClass("android.provider.Settings");
		var setting = new Settingts();
		var intent =  new Intent(setting[key]);
		main.startActivity(intent);
	}
	
	function openWeixin() {
	    if (plus.os.name == "android") {
	        plus.runtime.launchApplication( {pname:"com.tencent.mm"}, function ( e ) {
	                plus.nativeUI.confirm( "检查到您未安装\"微信\"，是否到商城搜索下载？", function(i){
	                    if (i.index == 0) {
	                        plus.runtime.openURL("market://details?id=com.tencent.mm");
	                    }
	                } );
	        } );
	    } else if(plus.os.name == "ios") {
	        plus.runtime.launchApplication({action:"weixin://RnUbAwvEilb1rU9g9yBU"}, function ( e ) {
	            plus.nativeUI.confirm( "检查到您未安装\"微信\"，是否到商城搜索下载？", function(i){
	                if (i.index == 0) {
	                    plus.runtime.openURL("itms-apps://itunes.apple.com/cn/app/wechat/id414478124?mt=8");
	                }
	            });
	        });
	    }
	}
	
	function getChannel(){
		return mui.os.ios?app.iosChannel:app.getAndroidAppMeta('UMENG_CHANNEL')||app.androidChannel;
	}
	
	app.setDeviceInfo = setDeviceInfo;
	app.getDeviceInfo = getDeviceInfo;
	
	app.getState = getState;
	app.setState = setState;
	app.createState = createState;
	app.siginOut = siginOut;
	app.removeLogin = removeLogin; 
	app.getSetting = getSetting;
	app.setSetting = setSetting;
	app.getUser = getUser;
	app.checkLogin = checkLogin;
	app.checkToLogin = checkToLogin;
	app.getCity = getCity;
	app.getVersionCode = getVersionCode;
	
	app.toKefu = toKefu;
	app.toLogin = toLogin;
	app.showUnlock = showUnlock;
	app.showGuide = showGuide;
	app.showSheBaoAdd = showSheBaoAdd;
	app.showGongJiJinAdd = showGongJiJinAdd;
	app.showSheBaoInfo = showSheBaoInfo;
	app.showGongJiJinInfo = showGongJiJinInfo;
	app.openUrl = openUrl;
	app.openMultiURL = openMultiURL;
	
	app.backToQuit = backToQuit;
	app.testQuit = testQuit;

	app.fireEvent = fireEvent;
	app.appRefresh = refresh;
	app.showMask = showMask;
 	app.closeMask = closeMask;
	
	app.copyText = copyText;
	app.openSoftKeyboard = openSoftKeyboard;
	
	app.getIOSIdfa = getIOSIdfa;
	app.getIOSIdfv = getIOSIdfv;
	app.getIOSGPStatus = getIOSGPStatus;
	app.getIOSAppInfo = getIOSAppInfo;
	
	app.getAndroidID = getAndroidID;
	app.getAdrDeviceId = getAdrDeviceId;
	app.getAndroidAppMeta = getAndroidAppMeta;
	app.getAndroidGPStatus = getAndroidGPStatus;
	app.openAndroidSettings = openAndroidSettings;
	
	
	app.openWeixin = openWeixin;
	app.getChannel = getChannel;
	
	app.openWindow = openWindow;
	//$.openWindow = openWindow;
	
	window.app= app;
	window.g = function(id){
		return document.getElementById(id);
	};
	window.$g = function(selector){
		var els = document.querySelectorAll(selector);
		if(els.length==1) els = els[0];
		return els;
	};
	return app;
	
})(mui,myStorage);

(function (clsp) {
    /**
     * 输出信息扩展类
     * @author sodaChen
     * Date:2017/2/15
     */
    var ConsolePlus = (function () {
        function ConsolePlus() {}
        ConsolePlus.init = function (isPlusMode) {
            if (isPlusMode === void 0) { isPlusMode = false; }
            this.funList = [];
            this.funPulsList = [];
            this.emptyFun = function () { };
            //存放原来的方法
            for (var i = 0; i < this.funNames.length; i++) {
                this.funList.push(console[this.funNames[i]]);
            }
            //生成新的扩展方法
            for (var j = 0; j < this.funNames.length; j++) {
                this.createPlusFun(this.funList[j], this.funNames[j]);
            }
            this.setConsoleMode(isPlusMode);
        };
        /**
         * 设置日志等级，所有大于等于这个日志级别的输出都可以正常输出，小于的则不能进行输出
         * @param level
         */
        ConsolePlus.setLevel = function (level) {
            this.$level = level;
            this.openConsole();
        };
        /**
         * 设置输出模式
         * @param isPlusMode 是否为扩展模式
         */
        ConsolePlus.setConsoleMode = function (isPlusMode) {
            this.isPlusMode = isPlusMode;
            if (isPlusMode)
                this.openConsolePlus();
            else
                this.openConsole();
        };
        /**
         * 打开日志
         */
        ConsolePlus.openConsole = function () {
            this.closeConsole();
            //扩展默认，则调用扩展方法
            if (this.isPlusMode) {
                this.openConsolePlus();
                return;
            }
            for (var i = this.$level; i < this.funNames.length; i++) {
                //还原成最初的方法
                console[this.funNames[i]] = this.funList[i];
            }
        };
        /**
         * 关闭所有的日志输出
         */
        ConsolePlus.closeConsole = function () {
            //设置回最初的方法
            for (var i = 0; i < this.funNames.length; i++) {
                //定义个空方法屏蔽掉
                console[this.funNames[i]] = this.emptyFun;
            }
        };
        /**
         * 开启日志输出的扩展模式
         */
        ConsolePlus.openConsolePlus = function () {
            this.isPlusMode = true;
            //扩展console的所有方法
            for (var i = this.$level; i < this.funNames.length; i++) {
                console[this.funNames[i]] = this.funPulsList[i];
            }
        };
        /**
         * 关闭日志输出的扩展模式
         */
        ConsolePlus.closeConsolePlus = function () {
            this.isPlusMode = false;
            //还原成原来的方法
            this.openConsole();
        };
        /**
         * 创建扩展函数
         * @param oldFun 原有的函数
         * @param funName 函数名称
         */
        ConsolePlus.createPlusFun = function (oldFun, funName) {
            var fun = function (message) {
                var optionalParams = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    optionalParams[_i - 1] = arguments[_i];
                }
                console.group("[" + funName + "][" + new Date() + "]");
                oldFun.apply(console, arguments);
                console.groupEnd();
            };
            this.funPulsList.push(fun);
        };
        /////////////////日志级别////////////////
        /** 调试级别，trace函数路径 **/
        ConsolePlus.TRACE = 0;
        /** 普通日志级别 **/
        ConsolePlus.LOG = 1;
        /** 信息日志级别 **/
        ConsolePlus.INFO = 2;
        /** 警告日志级别 **/
        ConsolePlus.WARN = 3;
        /** 错误日志级别 **/
        ConsolePlus.ERROR = 4;
        /** 默认是最初的日志级别，改变这个值。可以改变日志输出的结果 **/
        ConsolePlus.$level = ConsolePlus.LOG;
        /** 需要屏蔽覆盖的方法名 **/
        ConsolePlus.funNames = ["trace", "log", "info", "warn", "error"];
        return ConsolePlus;
    }());
    clsp.ConsolePlus = ConsolePlus;
    clsp.ConsolePlus.init();
	clsp.ConsolePlus.setLevel(app.logLevel);
	
})(window.asf={});

(function($,imbar){
	var hHeight = 44;
	var safeHeight = 34;
	
	 $.extend(true,imbar,{
		isSet:false,
		getStatusbar:getStatusbar,
		ImmersedStatusbar:ImmersedStatusbar,
		setSafeFooter:setSafeFooter,
		initImbar:initImbar
	},getStatusbar());
	
	imbar.initImbar();

	function setSafeFooter(footerEl){
		if(footerEl && !footerEl.getAttribute('safeArea') && imbar.bottomSafeArea>0){
			footerEl.style.height = (footerEl.offsetHeight + imbar.bottomSafeArea) + "px";
			footerEl.style.paddingBottom = imbar.bottomSafeArea+'px';
			footerEl.setAttribute('safeArea','1');
		}
	}
	function ImmersedStatusbar(navOpts,conOpts){
		if(imbar.isIphoneX){
			document.body.classList.add('iphonex');
		}
		var pEl = document.querySelector(navOpts.selector||navOpts);
		if(pEl && imbar.isImmersedStatusbar && !imbar.isSet){
			var style = getStyle(pEl,null);
			var barH = parseInt(style.height);
			if(style.boxSizing==='border-box'){
				barH = parseInt(imbar.statusbarHeight) + parseInt(style.height);
				pEl.style.height = barH + "px";
			}
			pEl.style[navOpts.field||'paddingTop'] = imbar.statusbarHeight + "px";
			
			if(conOpts!=false){
				con = conOpts ? document.querySelector(conOpts.selector||conOpts) : pEl.nextElementSibling;
				if(!pEl.classList.contains('mui-bar-transparent') && con && con.classList.contains('mui-content')){
					con.style[conOpts&&conOpts.field?conOpts.field:'paddingTop'] = barH + "px";
				}
			}
			imbar.RelNarBarHeight = barH;
			imbar.isSet = true;
		}
	}
	function initImbar(){
		ImmersedStatusbar('body>.mui-bar:first-child');
		var footer = document.querySelector('body>footer')||document.querySelector('body>.mui-bar-footer');
	    if(footer) setSafeFooter(footer);
	}

	function getStatusbar(){
		var thebar = myStorage.getItem('immersedBar');
		if(thebar){
			document.body.classList.add('Immersed'+thebar.statusbarHeight);
			return thebar;
		} 
		var reg = /Immersed\/(\d+(\.\d+)?)/gi,
			match = reg.exec(navigator.userAgent);
		if(!match) return null;
		
		thebar={};
		thebar.isImmersedStatusbar = !!match;
		thebar.isIos =/Mac OS/gi.test(navigator.userAgent);
		thebar.isAndroid = /Android/gi.test(navigator.userAgent);
		thebar.display = {
			resolutionHeight:screen.availHeight,
			resolutionWidth:screen.availWidth
		};
		thebar.screen = {
			resolutionHeight:screen.availHeight,
			resolutionWidth:screen.availWidth,
			scale:devicePixelRatio
		};
		
		thebar.isIphoneX= thebar.isIos && (
			(thebar.screen.resolutionHeight == 812 && thebar.screen.resolutionWidth == 375) || 
			(thebar.screen.resolutionHeight == 852 && thebar.screen.resolutionWidth == 414) || 
			(thebar.screen.resolutionHeight == 896 && thebar.screen.resolutionWidth == 414)
		);
			
		thebar.statusbarHeight = parseInt(match[1]);
		document.body.classList.add('Immersed'+thebar.statusbarHeight);
		var outH = thebar.screen.resolutionHeight - thebar.display.resolutionHeight;
		if(thebar.isImmersedStatusbar){
			thebar.statusbarHeight = outH>0?outH:thebar.statusbarHeight;
			thebar.navBarHeight = thebar.statusbarHeight + hHeight;
		}else{			
			thebar.navBarHeight = hHeight;
		}
		if(thebar.isIphoneX){
			thebar.bottomSafeArea = safeHeight;
		}else{
			thebar.bottomSafeArea = 0;
		}
		myStorage.setItem('immersedBar',thebar);
		return thebar; 
	}
	function getStyle(ele,pclass) {
	    var style = ele.style;
	    if(window.getComputedStyle) {
	        style = window.getComputedStyle(ele, pclass);
	    }else if(ele.currentStyle){
	        style = ele.currentStyle;
	    }
	    return style;
	}
})(mui,window.imbar={});

(function($,app){
	var tracks = {}
	tracks.cates = {1:'文章分类',2:'视频分类',3:'代缴分类',4:'商保类型',5:'银行名称',6:'贷款分类',7:'订单状态',8:'Feed流'};
	tracks.contypes = {1:'文章',2:'视频',3:'社保产品',4:'商业保险',5:'信用卡',6:'贷款产品'};
	tracks.searchType = {1:'文章搜索',2:'综合搜索',3:'O2O店铺搜索',4:'O2O产品搜索'};
	tracks.orderType = {1:'社保服务类订单',2:'保险服务类订单',3:'贷款服务类订单',4:'叮当快药类订单',5:'付费咨询类订单',6:'体检订单'};
	tracks.shareType = {1:'图文',2:'视频',3:'链接'};
	tracks.sharePlatform = {1:'微信',2:'朋友圈',3:'QQ',4:'微博'};

	tracks.noTrack = ['invitation.html','openUrl.html','article.html','article-video.html','activity.html','advert.html'];
	//补全预置参数
	var cp = {};
	var netNames = ['unknow','none','ethernet','wifi','2g','3g','4g'];
	
	function initSaSdk(){
		var appjs = document.querySelector('script[src$="/app.js"]');
		var sdkPath = '../js/lib/';
		sdkPath = appjs.src.replace('/app.js','/lib');
		(function(para) {
			var p = para.sdk_url,
				n = para.name,
				w = window,
				d = document,
				s = 'script',
				x = null,
				y = null;
			w['sensorsDataAnalytic201505'] = n;
			w[n] = w[n] || function(a) {
				return function() {
					(w[n]._q = w[n]._q || []).push([a, arguments]);
				}
			};
			var ifs = ['track', 'quick', 'register', 'registerPage', 'registerOnce', 'clearAllRegister', 'trackSignup', 'trackAbtest', 'setProfile', 'setOnceProfile', 'appendProfile', 'incrementProfile', 'deleteProfile', 'unsetProfile', 'identify', 'login', 'logout', 'trackLink', 'clearAllRegister'];
			for(var i = 0; i < ifs.length; i++) {
				w[n][ifs[i]] = w[n].call(null, ifs[i]);
			}
			if(!w[n]._t) {
				x = d.createElement(s), y = d.getElementsByTagName(s)[0];
				x.async = 1;
				x.src = p;
				y.parentNode.insertBefore(x, y);
				w[n].para = para;
			}
		})({
			sdk_url: sdkPath+'/sensorsdata.min.js ',
			name: 'sa',
			server_url: app._saServer,
			show_log:!!app._saShowLog,
			use_app_track:true,
		});
	}

	function JTrackReady(fn){
		if(window.jtrackReady){
			fn();
		}else{
			document.addEventListener('jtrackReady',fn,false);
		}
	}
	
	function $ga(s){
		return document.querySelectorAll(s);
	}
	function queryString(name,url){
		url = url || location.search.substr(1);
		var reg = new RegExp("(^|&|\\?)"+name+"=([^&]*)(&|$)", "i");
		var matchs = url.match(reg);
		if(matchs!==null) return decodeURIComponent(matchs[2]);
		return null;
	}
	function fillAttribute(){
		var devInfo = app.getDeviceInfo();
		var cntype = plus.networkinfo.getCurrentType();
		var imsi = plus.device.imsi;
		var prdName = '';
		if(imsi){
			if($.isArray(imsi) && imsi.length>0) imsi = imsi[0];
			if ( imsi.indexOf("46000")==0 || 
				 imsi.indexOf("46002")==0 || 
				 imsi.indexOf("46007")==0 ) {
	            prdName = "中国移动";
	        } else if (imsi.indexOf("46001")==0  || 
				 imsi.indexOf("46006")==0 ) {
	            prdName = "中国联通";
	        } else if (imsi.indexOf("46003")==0 ) {
	            prdName = "中国电信";
	        }
		}
		cp.$title = document.title;
		cp.$url = location.href.replace(/^.*\/www(\/.+)$/,'$1');
		cp.app_id = plus.runtime.appid;
		cp.app_name = app.name;
		cp.$app_version = plus.runtime.version;
		cp.$network_type = netNames[cntype];
		cp.$wifi = cntype==3;
		cp.$carrier = prdName;
		var opener = plus.webview.currentWebview().opener();
		if(opener){
			cp.$referrer =opener.getURL().replace(/^.*\/www(\/.+)$/,'$1');
		}
	}
	function getFieldValue(el,field){
		var reg = new RegExp('([^\.]+)(\.(string|number))?\:((this|attr|search)\.)?(.+)');
		var matchs = field.match(reg);
		if(!matchs[1] || !matchs[6]) return null;
		var obj = {};
		obj.key = matchs[1];
		if('this'==matchs[5]){
			obj.value = el[matchs[6]].trim();
		}else if('attr'==matchs[5]){
			obj.value = el.getAttribute(matchs[6]);
		}else if('search'==matchs[5]){
			obj.value = queryString(matchs[6]);
		}else{
			obj.value = matchs[6];
		}
		if(matchs[3] && matchs[3].toLowerCase()=='number'){
			obj.value = Number(obj.value);
		}
		return obj;
	}
	
	function trackBack(){
		var backBtn = document.querySelector('.mui-action-back');
		if(backBtn){
			backBtn.addEventListener('tap',function(evt){
				sa.track('joyPageBack',$.extend({"jtrack_name":"返回","jtrack_type":1},cp));//software-key
			},false);
		}
		plus.key.addEventListener("backbutton",function(){
			 sa.track('joyPageBack',$.extend({"jtrack_name":"返回","jtrack_type":2},cp));//hardware-key
		});
		
		/*
		$.currentWebview.addEventListener("popGesture",function(){
			 sa.track('joyPageBack',$.extend({"jtrack_name":"返回","jtrack_type":3},cp));//popGesture
		});
		*/
	}
	function $pageView(){		
		var pageName = location.pathname.substr(location.pathname.lastIndexOf('/')+1);	
		if(tracks.noTrack.indexOf(pageName)<0){
			sa.track('$pageview',$.extend({},cp));
		}
	}
	function $joyClick(obj){
		JTrackReady(function(){
			var fields = obj.getAttribute('joy-track-fields');
			fields = fields?fields.split(','):[];
			var attrs = {};
			for(var i=0;i<fields.length;i++){
				var field = fields[i];
				if(!field) continue;
				var attr = getFieldValue(obj,field);
				if(attr) attrs[attr.key] = attr.value;
			}
			var evtName = obj.getAttribute('joy-track')||'joyLinkClick';
			attrs.jtrack_selector = obj.className;
			var trackData = $.extend({},attrs,cp);
			sa.track(evtName,trackData);
		});
	}
	function customTrack(evtName,data){
		JTrackReady(function(){
			if(!evtName) return;
			var trackData = $.extend({},cp,data);
			sa.track(evtName,trackData);
		});
	}

	function bindClickTracks(box){
		var box = box || document;
		var els = box.querySelectorAll('[joy-track]');
		mui.each(els,function(n,el){
			if(el.getAttribute('joy-track-bind')) return;
			el.addEventListener('tap',function(evt){
				$joyClick(this);
			},false);
			el.setAttribute('joy-track-bind',true);
		});
	}
	function watchTracks(){
		var watchs = document.querySelectorAll('[joy-track-watch]');
		var MutationObserver = MutationObserver || WebKitMutationObserver;
	    mui.each(watchs,function(i,el){
		    if(MutationObserver){
		        var config={childList: true, subtree: true};
		        var observer=new MutationObserver(function(mutations){
		            bindClickTracks(el);
		        });
		        observer.observe(el,config);
		    }else if(el.addEventListener){
		        watchEl.addEventListener("DOMSubtreeModified", function(evt) {
		            bindClickTracks(el);
		        }, false);
		    }else{
		        console.log('unsupported browser');
		    }
	    });
	}

	function regEvents(els,evtName,attrs){
		els = typeof els=='string'? document.querySelectorAll(els) : els;
		var isEls = els instanceof NodeList || els instanceof HTMLCollection || els instanceof Array;
		if(!isEls) els = [els];
		mui.each(els,function(n,el){
			if(!el.setAttribute) return;
			if(el.getAttribute('joy-track-bind')) return;
			el.setAttribute('joy-track-fields',attrs);
			el.setAttribute('joy-track',evtName);
			el.addEventListener('tap',function(evt){
				$joyClick(this);
			},false);
			el.setAttribute('joy-track-bind',true);
		});
	}

	function regEventsLive(watchEl,itemSelector,evtName,attrs){
		watchEl = typeof watchEl=='string'? document.querySelector(watchEl) : watchEl;
		var MutationObserver = MutationObserver || WebKitMutationObserver;
	    if(MutationObserver){
	        var config={childList: true, subtree: true};
	        var observer=new MutationObserver(function(mutations){
				var els = watchEl.querySelectorAll(itemSelector);
	            regEvents(els,evtName,attrs);
	        });
	        observer.observe(watchEl,config);
	    }else if(el.addEventListener){
	        watchEl.addEventListener("DOMSubtreeModified", function(evt) {
				var els = watchEl.querySelectorAll(itemSelector);
	            regEvents(els,evtName,attrs);
	        }, false);
	    }else{
	        console.log('unsupported browser');
	    }
	}
	
	function autoTracks(){
		bindClickTracks();
		watchTracks();
		$pageView();
		trackBack();
		//sa.quick('autoTrack');
	}
	
	if(app._saMode){
		$.plusReady(function(){
			initSaSdk();
			fillAttribute();
				
			if($.os.android){
				var androidID = app.getAndroidID();
				if(androidID) sa.identify(androidID,true);
			}else if($.os.ios){
				var idfv = app.getIOSIdfv();
				if(idfv) sa.identify(idfv,true);
			}
			
			autoTracks();
			window.jtrackReady = true;
			$.fire($.currentWebview,'jtrackReady');
		});
	
		window.SDAnalytics = window.jTrack = {
			$default : cp,
			login:function(userId){
				sa.login(userId);
			},
			logout:function(){
				sa.logout();
			},
			startTime:Date.now(),
			customTrack:customTrack,
			regEvents:regEvents,
			regEventsLive:regEventsLive
		};
	}
})(mui,app);