String.prototype.splitByCharArray = function (arr,igone) {
	if(this.length<=1) return [this];
	var result = [];
	var i,temp = 0 ;
	for(i=0;i<this.length;i++){
		if(arr.indexOf(this[i])>-1){
			if(!igone || temp!==i) result.push(this.substring(temp,i));
			temp = i+1;
		}
	}
	result.push(this.substr(temp));
	return result;
};
String.prototype.trim=function(){
	return this.replace(/(^\s*)|(\s*$)/g, "");
};
String.prototype.ltrim=function(){
	return this.replace(/(^\s*)/g,"");
};
String.prototype.rtrim=function(){
	return this.replace(/(\s*$)/g,"");
};

(function($,doc) {
	var utils = {};
	utils.patternStr = function(){
		var pattern = new RegExp("{[^/{}]+}","g");
		var str = arguments[0];
		for(var i=1,l=arguments.length;i<l;i++){
			var match = pattern.exec(str);
			str = str.replace(match,arguments[i]);
		}
		return str;
	};
	
	utils.patternStrPlus = function(str, data){
		return str.replace(/\{{([^\}]\w*)\}}/g, function($1, $2){
			return data[$2] || '';
		})
	};
	
	utils.copyValue = function(target,origin){
		var obj = {};
		$.each(origin,function(value,key){
			if(key in target){
				obj[key] = value;
			}
		});
		return obj;
	};
	utils.compress = function(src,keys){
		var obj = {};
		for(var i= 0,len=keys.length;i<len;i++) if (keys[i] in src) obj[keys[i]] = src[keys[i]];
		return obj;
	};
	utils.arrayToMap = function(array,keyField){
		var obj = {};
		$.each(array,function(item){
			var key = item[keyField] || keyField;
			obj[key] =item;
		});
		return obj;
	};
	utils.utf16to8 = function (str) {
		var out, i, len, c;
		out = "";
		len = str.length;
		for(i = 0; i < len; i++) {
			c = str.charCodeAt(i);
			if ((c >= 0x0001) && (c <= 0x007F)) {
				out += str.charAt(i);
			} else if (c > 0x07FF) {
				out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
				out += String.fromCharCode(0x80 | ((c >>  6) & 0x3F));
				out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
			} else {
				out += String.fromCharCode(0xC0 | ((c >>  6) & 0x1F));
				out += String.fromCharCode(0x80 | ((c >>  0) & 0x3F));
			}
		}
		return out;
	};
	utils.randomStr = function(len){
		len = len || 32;
		var $chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz2345678';/****默认去掉了容易混淆的字符oOLl,9gq,Vv,Uu,I1****/
		var maxPos = $chars.length;
		var pwd = '';
		for (i = 0; i < len; i++) {
			pwd += $chars.charAt(Math.floor(Math.random() * maxPos));
		}
		return pwd;
	};
	utils.timeStamp = function(){
		var d =  new Date();
		return d.getTime()/1000;
	};
	utils.queryString = function(name,url){
		url = url || location.search.substr(1);
		var reg = new RegExp("(^|&|\\?)"+name+"=([^&]*)(&|$)", "i");
		var matchs = url.match(reg);
		if(matchs!==null) return matchs[2];
		return null;
	};
	utils.queryStringParse = function(url){
		 var reg_url = /^[^\?]+\?([\w\W]+)$/,
		 	reg_para = /([^&=]+)=([\w\W]*?)(&|$|#)/g,
		 	arr_url = reg_url.exec(url),
		 	ret = {};
		 if(arr_url && arr_url[1]) {
		 	var str_para = arr_url[1],
		 		result;
		 	while((result = reg_para.exec(str_para)) != null) {
		 		ret[result[1]] = result[2];
		 	}
		 }
		 return ret;
	};
	
	utils.getBolbByBase64 = function(b64Str){
		var regx = /data:(.*);base64,/;
		var type = b64Str.match(regx)[1];
        var b64 = b64Str.replace(regx,'');
        var binary = atob(b64);
        var array = [];
        for (var i = 0; i < binary.length; i++) {
            array.push(binary.charCodeAt(i));
        }
        var blob = new Blob([new Uint8Array(array)], {type: type});
        return blob;
	};
	utils.convertImgToBase64 = function(url, callback, outputFormat){ 
		var canvas = document.createElement('CANVAS'); 
		var ctx = canvas.getContext('2d'); 
		var img = new Image(); 
		img.crossOrigin = 'Anonymous'; 
		img.onload = function(){ 
			canvas.height = img.height; 
			canvas.width = img.width; 
			ctx.drawImage(img,0,0); 
			var dataURL = canvas.toDataURL(outputFormat || 'image/png'); 
			callback.call(this, dataURL); 
			canvas = null; 
		}; 
		img.src = url;
	};

	utils.toBase64Code = function (file,callback){
		var reader = new FileReader();
		reader.onload = function(){
			callback.call(this, this.result);
		};
		reader.readAsDataURL(file);
	};
	
	utils.getDateDiff = function(startTime,endTime,format){
		var isAddHour = (/\d+H/gi).test(endTime);
		var isAddDay = (/\d+D/gi).test(endTime);
		var isAddMonth = (/\d+M/gi).test(endTime);
		var isAddYear = (/\d+Y/gi).test(endTime);
		startTime = startTime.toString().replace(/-/g, "/");
		var sTime = null; //开始时间
		var eTime = null; //结束时间
		if(isAddHour||isAddDay||isAddMonth||isAddYear){
			var intValue = parseInt(endTime.match(/(\d+)[H|D|M|Y]/)[1]);
			var sDate = new Date(startTime);
			if(isAddHour) endTime = sDate.setHours(intValue);
			if(isAddDay) endTime = sDate.addDays(intValue);
			if(isAddMonth) endTime = sDate.addMonths(intValue);
			if(isAddYear) endTime = sDate.addMonths(12*intValue);
			sTime = new Date(new Date());
			eTime = new Date(endTime);
		}else{
			endTime = endTime.toString().replace(/-/g, "/");
			sTime = new Date(startTime);
			eTime = new Date(endTime);
		}
		var intCount = parseInt(eTime.getTime() - sTime.getTime());
		var day = parseInt(intCount/(1000 * 3600 * 24));
		intCount = intCount % (1000 * 3600 * 24);
		var hour = parseInt(intCount/(1000 * 3600));
		intCount = intCount % (1000 * 3600);
		var minute = parseInt(intCount/(1000 * 60));
		intCount = intCount % (1000 * 60);
		var second = parseInt(intCount/1000);
		var str = "";
		if(format){
			str = format.replace(/D/g, day).replace(/H/g, hour).replace(/M/g, minute).replace(/S/g, second);
		}else{
			str = day +"天"+hour+"小时"+minute+"分"+second+"秒";
		}
		return str;
	};
	utils.getTimeFormatText = function(dateo) { 
		if(!dateo) return '很久以前';

		var now = new Date(),
			regTime = /^(\d{4})-(\d{2})-(\d{2})(\s|T)(0\d{1}|1\d{1}|2[0-3]):([0-5]\d{1}):([0-5]\d{1})$/,
			regDate = /^(\d{4})-(\d{2})-(\d{2})$/,
			dateTime = new Date(), x;
		var x = dateo.match(/^(\d{4})-(\d{2})-(\d{2}).*/);
		var timeArr = dateo.split(/[^0-9]/g);
	
		if(typeof dateo==='string'){
			if(regTime.test(dateo)){
				dateTime.setFullYear(timeArr[0]);
				dateTime.setMonth(timeArr[1]-1);
				dateTime.setDate(timeArr[2]);
				dateTime.setHours(timeArr[3]);
				dateTime.setMinutes(timeArr[4]);
				dateTime.setSeconds(timeArr[5]);
			}else if(regDate.test(dateo)){
				dateTime = new Date(dateo);
			}else{
				return dateo;
			}
		}else{
			return dateo;
		}
		

		var intCount = parseInt(now.getTime() - dateTime.getTime())/1000;

		var day = parseInt(intCount/(3600 * 24));
		intCount = intCount % (3600 * 24);
		var hour = parseInt(intCount/(3600));
		intCount = intCount % (3600);
		var minute = parseInt(intCount/(60));
		intCount = intCount % (60);
		var second = parseInt(intCount);

		if(day>365){
			return x?x[1]+'年'+x[2]+'月'+x[3]+'日':dateo;
			//return parseInt(day/365)+'年前';
		}else if(now.getYear()>dateTime.getYear()){
			return x?x[1]+'年'+x[2]+'月'+x[3]+'日':dateo;
		} else if(day>60){
			return x?x[2]+'月'+x[3]+'日':dateo;
			//return parseInt(day/30)+'个月前';
		}else if(day>30){
			return x?x[2]+'月'+x[3]+'日':dateo;
			//return '1个月前';
		}else if(day>0){
			return day+'天前';
		}else if(hour>0){
			return hour+'小时前';
		}else if(minute>0){
			return minute+'分钟前';
		}else{
			return '刚刚';
		}
	};
	utils.numberArray = function(number,start){
		var arr = [];
		for(var n=0;n<number;n++){
			arr[n] = n+(start||1);
		}
		return arr;
	};
	utils.validCertNo = function(num){
		num = num.toUpperCase();
		//身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X。
		if (!(/(^\d{15}$)|^\d{17}([0-9]|X)$/.test(num))) {
			//alert('输入的身份证号长度不对，或者号码不符合规定！\n15位号码应全为数字，18位号码末位可以为数字或X。');
			return false;
		}
		//校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
		//下面分别分析出生日期和校验位
		var len, re,arrSplit,dtmBirth,bGoodDay,
			arrInt,arrCh,nTemp,i;
		len = num.length;
		if (len == 15) {
			re = new RegExp(/^(\d{6})(\d{2})(\d{2})(\d{2})(\d{3})$/);
			arrSplit = num.match(re);
			dtmBirth = new Date('19' + arrSplit[2] + '/' + arrSplit[3] + '/' + arrSplit[4]);//检查生日日期是否正确
			bGoodDay = (dtmBirth.getYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
			if (!bGoodDay) {
				//alert('输入的身份证号里出生日期不对！');
				return false;
			} else {
				//将15位身份证转成18位
				//校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
				arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
				arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
				nTemp = 0;
				num = num.substr(0, 6) + '19' + num.substr(6, num.length - 6);
				for (i = 0; i < 17; i++) {
					nTemp += num.substr(i, 1) * arrInt[i];
				}
				num += arrCh[nTemp % 11];
				return num;
			}
		}
		if (len == 18) {
			re = new RegExp(/^(\d{6})(\d{4})(\d{2})(\d{2})(\d{3})([0-9]|X)$/);
			arrSplit = num.match(re);
			//检查生日日期是否正确
			dtmBirth = new Date(arrSplit[2] + "/" + arrSplit[3] + "/" + arrSplit[4]);
			bGoodDay = (dtmBirth.getFullYear() == Number(arrSplit[2])) && ((dtmBirth.getMonth() + 1) == Number(arrSplit[3])) && (dtmBirth.getDate() == Number(arrSplit[4]));
			if (!bGoodDay) {
				//alert('输入的身份证号里出生日期不对！');
				return false;
			} else {
				//检验18位身份证的校验码是否正确。
				//校验位按照ISO 7064:1983.MOD 11-2的规定生成，X可以认为是数字10。
				var valnum;
				arrInt = new Array(7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2);
				arrCh = new Array('1', '0', 'X', '9', '8', '7', '6', '5', '4', '3', '2');
				nTemp = 0;
				for (i = 0; i < 17; i++) {
					nTemp += num.substr(i, 1) * arrInt[i];
				}
				valnum = arrCh[nTemp % 11];
				if (valnum != num.substr(17, 1)) {
					//alert('18位身份证的校验码不正确！应该为：' + valnum);
					return false;
				}
				return num;
			}
		}
		return false;
	};
	utils.formatCurrency = function(num) {
		if(!num || isNaN(num)) num = "0";
	    num = num.toString().replace(/\$|\,/g,'');
	    sign = (num == (num = Math.abs(num)));
	    num = Math.floor(num*100+0.50000000001);
	    cents = num%100;
	    num = Math.floor(num/100).toString();
	    if(cents<10)
	    cents = "0" + cents;
	    for (var i = 0; i < Math.floor((num.length-(1+i))/3); i++)
	    num = num.substring(0,num.length-(4*i+3))+','+
	    num.substring(num.length-(4*i+3));
	    return (((sign)?'':'-') + num + '.' + cents);
	}
	var cookies = {};
	cookies.getCookie =function(name){
		var reg=new RegExp("(^| )"+name+"=([^;]*)(;|$)");
		var arr=document.cookie.match(reg);
		if(arr!==null)
			return decodeURIComponent(arr[2]);
		else
			return null;
	};
	cookies.setCookie = function (name,value,day){
		var days = day || 30;
		var exp = new Date();
		exp.setTime(exp.getTime() + days*24*60*60*1000);
		document.cookie = name+"="+encodeURIComponent(value)+";expires="+exp.toGMTString();
	};
	cookies.delCookie = function(name){
		var exp = new Date();
		exp.setTime(exp.getTime() - 1);
		var val=cookies.getCookie(name);
		if(val!==null) document.cookie= name+"="+val+";expires="+exp.toGMTString();
	};
	
	var jel = function(selector,psel){
		return new jel.fn.init(selector,psel);
	};
	jel.fn = jel.prototype = {
		constructor: jel,
		context:doc,
		selector: "",
		length: 0
	};
    var init = jel.fn.init = function(selector,psel){
    	var context = doc.querySelector(psel) || doc;
		var el = { 0:[] };
		el[0] = context.querySelectorAll(selector);
	    this[0] = el[0];
	    this.selector = selector;
	    this.context = context;
		return this;
	};
    init.prototype = jel.fn;
	jel.prototype.text = function(txt){
		var els = this[0];
		if(typeof(txt)!=="undefined"){
			for(var i=0;i<els.length;i++){
				if(els[i]) els[i].innerText = txt;
			}
			return this;
		}else{
			return this[0][0] ? this[0][0].innerText : "";
		}
	};
	jel.prototype.html = function(txt){
		var els = this[0];
		if(typeof(txt)!=="undefined"){
			for(var i=0;i<els.length;i++){
				if(els[i]) els[i].innerHTML = txt;
			}
			return this;
		}else{
			return els[0] ? els[0].innerHTML : "";
		}
	};
	jel.prototype.val = function(txt){
		var els = this[0];
		if(typeof(txt)!=="undefined"){
			for(var i=0;i<els.length;i++){
				if(els[i]){
					els[i].value=txt;
				} 
			}
			return this;
		}else{
			return els[0] ? els[0].value : undefined;
		}
	};
	jel.prototype.show = function(){
		var els = this[0];
		for(var i=0;i<els.length;i++){
			els[i].style.display = '';
		}
		return this;
	};
	jel.prototype.hide = function(){
		var els = this[0];
		for(var i=0;i<els.length;i++){
			els[i].style.display = 'none';
		}
		return this;
	};
 	jel.prototype.attr = function(name,val){
 		var els = this[0];
 		if(typeof(val)==="undefined"){
 			return els[0] ? els[0].getAttribute(name) : undefined;
 		}else{
 			for(var i=0;i<els.length;i++){
				if(els[i]) els[i].setAttribute(name,val);
			}
 			return this;
 		}
 	};
 	jel.prototype.removeAttr = function(name){
 		var els = this[0];
 		for(var i=0;i<els.length;i++){
			if(els[i]) els[i].removeAttribute(name);
		}
		return this;
 	};
 	jel.prototype.css = function(name,str){
 		var els = this[0];
 		for(var i=0;i<els.length;i++){
	 		if(els[i] && els[i].style.hasOwnProperty(name)){
	 			els[i].style[name] = str;
	 		}
 		}
 		return this;
 	};
	jel.prototype.addClass = function(name){
		var els = this[0];
		for(var i=0;i<els.length;i++){
			if(els[i]) els[i].classList.add(name);
		}
		return this;
	};
 	jel.prototype.removeClass = function(name){
		var els = this[0];
		for(var i=0;i<els.length;i++){
			if(els[i]) els[i].classList.remove(name);
		}
		return this;
	};
	jel.prototype.toggleClass = function(name){
		var els = this[0];
		for(var i=0;i<els.length;i++){
			if(els[i]) els[i].classList.toggle(name);
		}
		return this;
	};
 	jel.prototype.getStyle = function(pclass){
	    var els=this[0],styles=[],style;
	    if(els.length===0) return [];
	    for(var i=0;i<els.length;i++){
			style = els[i].style;
		    if(window.getComputedStyle) {
		        style = window.getComputedStyle(els[i], pclass);
		    }else if(els[i].currentStyle){
		        style = els[i].currentStyle;
		    }
		    styles.push({"el":els[i],"style":style});
		}
	    return styles;
	};
 	jel.hasClass = function(selector,name){
 		var jel = jel(selector);
		return jel[0][0] && jel[0][0].classList.contains(name);
	};

    function calcFn(o) {
        var fn = null;
        switch(o){
            case '+':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value + r.value : r.value;};
                break;
            case '-':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value - r.value : -r.value;};
                break;
            case '*':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value * r.value : NaN;};
                break;
            case '/':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value / r.value : NaN;};
                break;
            case '%':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value % r.value : NaN;};
                break;
            case '=':
                fn = function (l,r) { return l.type === 'VAR' ? l.value = r.value : ''; };
                break;
            case '!':
                fn = function (l,r) {return !(r.value); };
                break;
            case '&':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value & r.value : false; };
                break;
            case '|':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value | r.value : false; };
                break;
            case '&&':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value && r.value : false; };
                break;
            case '||':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value || r.value : false; };
                break;
            case '!=':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value != r.value : false; };
                break;
            case '!==':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value !== r.value : false; };
                break;
            case '<':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value < r.value : false; };
                break;
            case '>':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value > r.value : false; };
                break;
            case '>=':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value >= r.value : false; };
                break;
            case '<=':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value <= r.value : false; };
                break;
            case '==':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value == r.value : false; };
                break;
            case '===':
                fn = function (l,r) {return l.type !== 'NULL' ? l.value === r.value : false; };
                break;
        }
        return fn;
    }
    function jobj(expr,data) {
        var obj = {};
        expr = expr.trim();
        expr = expr[0] === '(' ? expr.substring(1,expr.length-1) : expr;
        var isstr = expr[0] === "'" || expr[0] === '"';
        var isnum = /^(-?\d+)(\.\d+)?$/.test(expr);
        var isvar = /^[._a-zA-Z0-9]+$/.test(expr);
        if(expr===''){
            obj.type = 'NULL';
            obj.value = '';
        }else if(isstr){
            obj.type = 'STR';
            obj.value = expr.substring(1,expr.length-1);
        }else if(isnum){
            obj.type = "NUM";
            obj.value  = expr.indexOf('.')>0 ? parseFloat(expr) : parseInt(expr);
        }else if(isvar){
            obj.type = "VAR";
            obj.value  = data[expr];
        }else{
            obj.type = "EXPR";
            obj.value = parseExpr(expr,data);
        }
        return obj;
    }
    function parseExpr(expr,data) {
        expr = expr.trim();
        expr = expr[0] === '(' ? expr.substring(1,expr.length-1) : expr;
        var poper = "\\+|-|\\*|\\/|\\?|\\:|\\%|<|>|\\||&|\\!|\\+\\+|--|\\=|\\+\\=|\\-\\=|\\*\\=|\\/\\=|\\%\\=|\\=\\=|\\|\\||&&|>\\=|<\\=|\\!\\=|\\=\\=\\=|\\!\\=\\=";
        var reg = new RegExp("(-?\d{0,}[.a-zA-Z0-9_\'\"]*)("+poper+")(.*)");
        var matchs = expr.match(reg);
        console.log(matchs);
        var vl = jobj(matchs[1],data);
        var vr = jobj(matchs[3],data);
        return calcFn(matchs[2])(vl,vr);
    }

    function elementIF(el,dr,iterator) {
        var jif = el.getAttribute('jif');
        if(jif) {
            var field = jif.replace(iterator + ".", "");
            if(!dr[field]){
                el.style.display="none";
                el.setAttribute('remove','true');
            }else{
            	el.style.display = "";
                el.removeAttribute('remove');
            }
        }
    }
	function bindData(el,dr,iterator) {
		var biname = el.getAttribute('jbind');
		if(biname) {
			var field = biname.replace(iterator + ".", "");
			var txt = typeof(dr[field])==="undefined" || dr[field]===null ? '' : dr[field];
			el.innerHTML = txt;
		}
	}
	function bindAttr(el,dr,iterator) {
		var attr = el.getAttribute('jattr');
		if(attr){
			var arr = attr.substring(1,attr.length-1).split(',');
			$.each(arr,function (i,item) {
				var map = item.split(':');
				if(map.length===2){
                    var field =  map[1].replace(iterator+".","");
					var txt = typeof(dr[field])==="undefined" || dr[field]===null ? '' : dr[field];
					el.setAttribute(map[0],txt);
				}
			});
		}
	}
	function bindClass(el,dr,iterator) {
		var clazz = el.getAttribute('jclass');
		if(clazz){
			var arr = clazz.substring(1,clazz.length-1).split(',');
			$.each(arr,function (i,item) {
				var map = item.split(':');
				if(map.length===2){
                    var field = map[1][0]==='!'? map[1].substr(1): map[1];
                    field = field.replace(iterator+".","");
                    var val = map[1][0]==='!' ? !dr[field] : dr[field];
					el.classList[val?'add':'remove'](map[0]);
				}
			});
		}
	}

	function createBindElement(element,dr,iterator) {
		if(!element || !dr) return;
		if(iterator){
            bindAttr(element,dr,iterator);
            bindClass(element,dr,iterator);
            bindData(element,dr,iterator);
            elementIF(element,dr,iterator);
		}
        var els = element.children;
        for(var i=0;i<els.length;i++){
            if(els[i].getAttribute('jrepeat')){
                createRepeatElement(els[i],dr,iterator);
            } else{
                createBindElement(els[i],dr,iterator);
            }
        }
	}
    function createRepeatElement(element,data,iterator) {
        if(!element || !data) return;
        var repeat = element.getAttribute('jrepeat');
        if(!repeat)  return;
        var container = element.parentNode;
        var oir = element.getAttribute('item');
        var field = iterator ? repeat.replace(iterator+".","") : repeat;
        var ds = data[field];
        element = element.cloneNode(true);
        container.innerHTML = '';
        container.appendChild(element);
        var tempEl = null;
        for(var i in ds){
            tempEl = element.cloneNode(true);
            createBindElement(tempEl, ds[i], oir);
            tempEl.removeAttribute('jrepeat');
            tempEl.removeAttribute('item');
			container.appendChild(tempEl);
        }
        //container.removeChild(element);
    }
    function appendRepeatElement(element,data,iterator,container) {
        if(!element || !data) return;
        var repeat = element.getAttribute('jrepeat');
        if(!repeat)  return;
        var container = container || element.parentNode;
        var oir = element.getAttribute('item');
        var field = iterator ? repeat.replace(iterator+".","") : repeat;
        var ds = data[field];
        for(var i=0;i<ds.length;i++){
            var tempEl = element.cloneNode(true);
            createBindElement(tempEl, ds[i], oir);
            tempEl.removeAttribute('jrepeat');
            tempEl.removeAttribute('item');
            container.appendChild(tempEl);
        }
        //container.removeChild(element);
    }
    
    function bindRepeat(element,data,iterator) {
        if(!element || !data) return;
        var repeat = element.getAttribute('jrepeat');
        if(repeat){
			var container = element.parentNode;
			var field = iterator ? repeat.replace(iterator+".","") : repeat;
			var ds = data[field];
			var oir = element.getAttribute('item');
	        var tempEl = null;
	        for(var i in ds){
	        	var dr = ds[i];
	            tempEl = element.cloneNode(true);	            
        		bindAttr(tempEl,dr,iterator);
	            bindClass(tempEl,dr,iterator);
	            bindData(tempEl,dr,iterator);
	            elementIF(tempEl,dr,iterator);
	            tempEl.removeAttribute('jrepeat');
	            tempEl.removeAttribute('item');
				bindRepeat(tempEl,dr,oir);
				container.appendChild(tempEl);
	        }
	        //container.removeChild(element);
        }else{
    	    bindAttr(element,data,iterator);
            bindClass(element,data,iterator);
            bindData(element,data,iterator);
            elementIF(element,data,iterator);
    		var els = element.children;           
        	$.each(els, function(n,el) {
            	bindRepeat(el,data,iterator);
            });
        }
    }

    var jscope = {};
    jscope.bindSelect = function (element,data,valf,textf) {
        element.innerHTML='';
        for(var i in data){
            element.innerHTML += utils.patternStr('<option value="{1}">{2}</option>',data[i][valf],data[i][textf]);
        }
    };
    jscope.paddingSelect = function (element,data,valf,textf) {
        for(var i in data){
            element.innerHTML += utils.patternStr('<option value="{1}">{2}</option>',data[i][valf],data[i][textf]);
        }
    };

    jscope.bindRepeat = function (element,data,iterator) {
        var el = element.children[0];
        if(el.getAttribute('jrepeat')){
        	var template  = el.cloneNode(true);
	        element.innerHTML ='';
	        element.appendChild(template);
        }
        bindRepeat(element,data,iterator)
    };
    jscope.jvalue = function(expr,data) {
        return parseExpr(expr,data);
    };
    jscope.appendBind = function (container,template,data) {
        appendRepeatElement(template,data,null,container);
    };
    jscope.bind = function (element,data,iterator) {
        createBindElement(element,data,iterator);
    };
	
	function jpl(selector){
		var jql = function(selector) { 
			if(typeof selector == 'string'){
				if(/^<.+\/>$/.test(selector)){
					return {innerHTML:selector};
				}else{
					return document.querySelector(selector);
				} 
			} else{
				return selector;
			};
		};
		var replace = function(str, data){
			return str.replace(/\{{([^\}]\w*)\}}/g, function($1, $2){
				if($2=='$this'){
					return data;
				}else{
					return  data[$2] || '';
				}
			})
		};
		var tpl = jql(selector)||{innerHTML:''};
		tpl.getPatternStr = function(data){
			return replace(tpl.innerHTML,data);
		};
		tpl.getPatternEachStr = function(data){
			var html = [];
			mui.each(data,function(i,item){
				html.push(replace(tpl.innerHTML,item));
			});
			return html.join('');
		};
		tpl.pattern = function(selector,data){
			var box = jql(selector);
			if(box){
				box.innerHTML = replace(tpl.innerHTML,data);
			}
		};
		tpl.patternEach = function(selector,data,isAppend){
			var html = [];
			var box = jql(selector);
			if(box){
				mui.each(data,function(i,item){
					html.push(replace(tpl.innerHTML,item));
				});
				if(isAppend) {
					box.innerHTML += html.join('');
				}else{
					box.innerHTML = html.join('');
				}
			}
		};
		return tpl;
	}
	
	function formSerializer(selector){
		var form = document.querySelector(selector);
		var fns = {};
		var checkForm = function(input){
			var required = input.getAttribute('required');
			var pattern = input.getAttribute('pattern');
			var valMethod = input.getAttribute('val-method');
			var title = input.getAttribute('title');
			if(required && !input.value.trim()){
				return {el:input,message:required};
			}else if(pattern){
				var reg = new RegExp(pattern);
				var flag = reg.test(input.value);
				return flag ? null : {el:input,message:title};
			}else if(valMethod){
				var fn = fns[valMethod];
				return fn?fn.call(this,input):null;
			}
			return null;
		}; 
		var serialize = function(){
			var elements = form.elements;
			var messages = [];
			var formData = {data:{},errors:[]};		
			mui.each(elements,function(i,input){
				if(input.type == 'radio'){
					if(input.checked) formData.data[input.name] = input.value;
				}else if(input.type == 'checkbox'){
					if(!formData[input.name]) formData.data[input.name] = [];
					if(input.checked) formData.data[input.name] = formData.data[input.name].push(input.value);
				}else{
					formData.data[input.name] = input.value;
					var error = checkForm(input);
					if(error){
						formData.errors.push(error);
						messages.push(error.message)
					}
				}
				if(formData.data[input.name]) formData.dirty=true;
			});
			formData.messages = messages;
			return formData;
		};
		var addValidityMethod = function(name,fn){
			fns[name] = fn;
		};
		return {
			addValidityMethod:addValidityMethod,
			serialize:serialize
		}
	};
	
	utils.formSerializer = formSerializer;
	
	var common = {};
	common.utils=utils;
	common.cookies=cookies;
	common.openUrl = function(url){
		$.openWindow({
			url:'_www/view/openUrl.html',
			id:url,
			styles:{
				background:'#fff'
			},
			extras:{
				url:url,
				showTiming:'firstTime',
				showCloseBtn:true,
				enableHistory:true,
				scalable:false
			}
		});
	}
	common.setLink = function(){
		var links = doc.querySelectorAll('.joy-link');
		$.each(links, function(i,link) {
            link.addEventListener('tap',function(){            	
            	var url = link.getAttribute('jhref');
            	var id = link.getAttribute('jviewid');
            	if(!url && !id) return;
            	var options = {};
            	if(url) options.url = url;
            	options.id = id || url;
            	
            	var jstyles = link.getAttribute('jstyles');
            	if(jstyles) options.styles = JSON.parse(jstyles) || {dock:"top"};
            	
            	var params = link.getAttribute('jparams');
            	if(params) options.extras = JSON.parse(params);
				$.openWindow(options);
            },false);
		});
	};
	common.tapLink = function(box){
		$(box||document.body).on('tap','a[href^="http"]',function(){
			var url = this.getAttribute('href');
			common.openUrl(url);
			return false;
		});
	};
	common.setRemoteLink = function(box){
		$(box||document.body).on('tap','.remote-link',function(){
			var url = this.getAttribute('jhref');
			common.openUrl(url);
			return false;
		});
	};

    common.setLink();
    common.setRemoteLink();
    
	window.jel = jel;
	window.jutils = utils;
	window.jscope = jscope;
	window.common = common;
	window.jpl = jpl;
	
})(mui,document);
