(function($,jad){
	$.back = $.noop;
	var ad = {};
	var showloc = false;
	var canSkip = false;
	
	function g(id){ 
		return document.getElementById(id); 
	}
	function queryString(name,url){
		url = url || location.search.substr(1);
		var reg = new RegExp("(^|&|\\?)"+name+"=([^&]*)(&|$)", "i");
		var matchs = url.match(reg);
		if(matchs!==null) return matchs[2];
		return null;
	}
	function isWiFi(){
		var con = navigator.connection;
		if(con && con.type=='wifi'){
			return true;
		}else if(window.plus && plus.networkinfo.getCurrentType()==3){
			return true;
		}
		return false;
	}
	function closeSplashscreen(){
		if(plus.navigator.hasSplashscreen()) plus.navigator.closeSplashscreen();
		console.log('guide-closeSplashscreen:'+Date.now());
	}
	
	function getPixelRatio(context) {
	    var backingStore = context.backingStorePixelRatio 
	    || context.webkitBackingStorePixelRatio 
	    || context.mozBackingStorePixelRatio 
	    || context.msBackingStorePixelRatio 
	    || context.oBackingStorePixelRatio || 1;
	    return (window.devicePixelRatio || 1) / backingStore;
	}

	function countDown(countTime,skipShowTime){
		var currentSeconds = countTime||3;
    	var countDownSeconds = countTime||3;
		var skipSeconds = skipShowTime||0;

		var canvas = document.getElementById('canvas');
		var context = canvas.getContext('2d');
		var pixelRatio  = getPixelRatio(context);
		var rwidth = 30,
			rheight = 30;
		var width = rwidth * pixelRatio,
			height = rheight * pixelRatio;
			
		canvas.width = width;
		canvas.height = height;
		
		var fontSize8 = 8*pixelRatio;
		var fontSize10 = 10*pixelRatio;
		var lineWidth = 1.5*pixelRatio;
		
		var cx = width/2,
			cy = height/2,
			r = (width-lineWidth)/2
			ir = width/2-lineWidth;
			
		var interval_id = null,
			fps = 40,
			fit = 1000/fps;
			
		interval_id = setInterval(run, fit);

		function drawBase(){
			context.beginPath();
			context.arc(cx, cy, ir, 0, Math.PI * 2, false);
			context.closePath();
			context.fillStyle = 'rgba(0,0,0,0.3)';//rgba(238,238,238,0.3) rgba(0,0,0,0.7)#ce9167
			context.fill();
		}
		function drawText(){
			context.fillStyle = "#f2d4b3";//white
			context.textAlign = "center";
			context.textBaseline = 'middle';
			var seconds = parseInt(skipSeconds-(countDownSeconds-currentSeconds));
			if(seconds <=  0){
				canSkip = true;
				context.font = fontSize8+"px Arial";
				context.fillText('跳过', cx, cy); //Math.ceil(currentSeconds)
			}else{
				context.font = fontSize10+"px Arial";
				context.fillText(seconds+'s', cx, cy);
			}
		}
		function drawProgress(){
			var progress = (countDownSeconds - currentSeconds) / countDownSeconds;
			var endArc =  progress * 2 * Math.PI - 0.5*Math.PI;
			context.beginPath();
			context.arc(cx, cy, r, Math.PI * 1.5, endArc, true);
			context.lineCap = 'round';
			context.lineWidth = lineWidth;
			context.strokeStyle = '#f2d4b3';// #f8b62d #ffbb43
			context.stroke();
			currentSeconds -= fit / 1000;
		}
		
	    function run() {
	    	context.clearRect(0, 0, width, height);
			drawBase();
			drawText();
			if(currentSeconds <= 0) {
				clearInterval(interval_id);
				$.currentWebview.close('zoom-in');
				return;
			}
			drawProgress();
		};
	}
	
	function getImgUrl(ad){
		var imgurl = '';
		if(ad.hashName){
			imgurl = plus.io.convertLocalFileSystemURL(jad.imgPath+ad.hashName);
		}else if(plus.networkinfo.getCurrentType()==3){
			imgurl = ad.adImgPath
		}else{
			$.currentWebview.close('zoom-in');
		}
		return imgurl;
	}
	
	function showImgAd(ad,callback){
		callback = callback||$.noop;
		var adBox = g('adBox');
		adBox.innerHTML='';
		
		adBox.setAttribute('adid',ad.adInfoId);
		adBox.setAttribute('title',ad.adTitle);
		adBox.setAttribute('jhref',ad.adTargetPath);
		adBox.setAttribute('posid','guide');
		adBox.setAttribute('gameid',ad.gameId);
		
		var preimg = document.querySelector('#hidden img');
		if(preimg){
			g('adBox').appendChild(preimg);
			callback();
		}else{
			var img = document.createElement('img');
			if(ad.hashName && ad.isExistLoc){
				img.src = plus.io.convertLocalFileSystemURL(jad.imgPath+ad.hashName);
				showloc = true;
			}else if(isWiFi()){
				img.src = ad.adImgPath;
			}else{
				console.warn('Not WiFi environment is not cache the image display');
				$.currentWebview.close('zoom-in');
			}
			img.addEventListener('load',function(){
				g('adBox').appendChild(img);
				if(showloc) document.querySelector('.tip').classList.remove('mui-hidden');
				callback();
			},false);
			img.addEventListener('error',function(){
				console.warn('ad image url invalid');
				$.currentWebview.close('zoom-in');
			},false);
		}
	}
	
	function showVideoAd(ad){
		var imgurl = getImgUrl(ad);
		var video = document.createElement('video');
		video.className='mui-hidden';
		video.setAttribute('webkit-playsinline','1');
		video.setAttribute('playsinline','1');
		video.src = imgurl;
		video.load();
		video.addEventListener('canplay',function(){
			video.classList.remove('mui-hidden');
			video.play();
		},false);
		g('adBox').appendChild(video);
	}
	
	function adClick(ad){
		jad.adClick(ad.adInfoId,ad.adLocationId,ad.gameId);
		if(ad.adTargetPath){
			var advw = null;
			if(ad.adTargetPath.indexOf('http')==0){
				advw = app.openUrl(ad.adTargetPath,{
					id:'openAd',
					title:ad.title,
					showCloseBtn:true,
					enableHistory:true,
					scalable:false
				});
			}else{
				advw = $.openWindow(ad.adTargetPath);
			}
			advw.addEventListener('titleUpdate',function(){
				$.currentWebview.close('none');
			},false);
		}
	}
	
	g('countDownBox').addEventListener('tap',function(event){
		if(!canSkip) return;
		jad.skipClick(ad.adInfoId,ad.adLocationId,ad.gameId);
		setTimeout(function(){
			$.currentWebview.close('zoom-in');
		},100);
		event.preventDefault();
		event.stopPropagation();
	},false);
	
	var imgUrl = queryString('img');
	if(imgUrl && isWiFi()){
		imgUrl = decodeURIComponent(imgUrl);
		var img = document.createElement('img');
		img.addEventListener('load',function(){
			g('hidden').appendChild(img);
		},false);
	} 
	
	function run(){
		showImgAd(ad,function(){
			countDown(ad.showTime,ad.skipShowTime);
			g('txt').classList.remove('mui-hidden');
			jad.getCacheAdGame(ad.posId).then(function(cacheGame){
				if(cacheGame){
					cacheGame.currIndex = ad.showIndex;
					jad.updateCacheGame(cacheGame);
				}
			});
		});
		closeSplashscreen();
		/*if(ad.advType==1){
			showImgAd(ad);
		}else if(ad.advType==2){
			showVideoAd(ad);
		}*/		
		g('adBox').addEventListener('tap',function(){
			adClick(ad);
		},false);
	}
	//神策埋点
	function joyTrack(){
		//活动开屏广告
		jTrack.regEvents('#adBox','joyAdClick','jtrack_name:attr.title,jtrack_ad_gameid:attr.gameid,jtrack_ad_id:attr.adid,jtrack_ad_posid:attr.posid,jtrack_ad_url:attr.jhref');
	}
	$.plusReady(function(){
		ad = $.currentWebview.ad;
		if(ad.isFullscreen) document.body.classList.add('fullscreen-ad');
		run();
		joyTrack();
	});
})(mui,jad);