(function($,win,doc){
	$.init({swipeBack:true});

	var queryString = function (name){
	    var reg = new RegExp("(^|&)"+name+"=([^&]*)(&|$)", "i");
	    var matchs = location.search.substr(1).match(reg);
	    if(matchs!==null) return matchs[2];
	    return '';
	};
	var initCityPicker = function(){
		bizSvc.getConsultCity(type).then(function(data){
			var citys = [];
			for(var i in data){
				citys.push({text:data[i].value,value:data[i].key});
			}
			cityPicker.setData(citys);
		});
	};
	var initCatePicker = function(){
		bizSvc.getAdviceCate(type).then(function(data){
			var cates = [];
			for(var i in data){
				cates.push({text:data[i].value,value:data[i].key});
			}
			catePicker.setData(cates);
		});
	};
	
	var cityPicker = null;
	var catePicker = null;
	var type = queryString('type');
	var nt = queryString('nt');

	g('selCity').addEventListener('tap',function(){
		$.openWindow({
            url:'pick-city-zixun.html?workType=2',
            extras:{type:type}
      });
     },false); 
	
	g('counCate').addEventListener('tap',function(){
		catePicker.show(function(items) {
   			g('cateId').value = items[0].value;
			g('counCate').value = items[0].text;
		});
	},false);
	
	g('counTitle').addEventListener('input',function(){
		if(/[\uD800-\uDBFF][\uDC00-\uDFFF]/.test(this.value)){
			$.toast('咨询问题不可包含emoji符号');
		}
	},false);

	g('postAdvice').addEventListener('tap',function(){
		var postData = {type:type};
		if(nt==='1') postData.counCate = g('counCate').value.trim();
		postData.cityCode = g('cityCode').value.trim();
		postData.counContent = g('counContent').value.trim();
		postData.title = g('counTitle').value.trim();
		if(postData.title.length<10){
			return $.alert('咨询问题不少于10个字符');
		}
		if(postData.counContent.length<20){
			return $.alert('咨询内容不少于20个字符');
		}
		if(/[\uD800-\uDBFF][\uDC00-\uDFFF]/.test(postData.title)){
			return $.alert('咨询问题不可包含emoji符号');
		}
		postData.counContent = postData.counContent.replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, function(w){
			return w.codePointAt ? '&#'+w.codePointAt()+";":'';
		});
		plus.nativeUI.showWaiting();
		bizSvc.postAdvice(postData).then(function(data){
			plus.nativeUI.closeWaiting();
			app.fireEvent('advices','refresh_data');
			$.alert('咨询内容已成功提交',"",function(){
				$.back();
			});
		}).catch(function(err){
			plus.nativeUI.closeWaiting();
			$.alert(err.message);
			console.error(err.message,err);
		});
	},false);
	
	$.ready(function(){
		//cityPicker = new $.PopPicker();
		catePicker = new $.PopPicker();
		//initCityPicker();
		initCatePicker();
		g('cate-type').style.display=nt==='0'?'none':'block';
		
		if(imbar.isImmersedStatusbar){
			document.querySelector('.mui-content').style.paddingTop=imbar.navBarHeight+'px';
		}

	});
	window.addEventListener('changeCity',function(event){
		  //获得事件参数
		  var cityName = event.detail.cityName;
		  //根据id向服务器请求新闻详情
		  var cityCode = event.detail.cityCode;
		  g('cityCode').value = cityCode;
		  g('city').value = cityName;
	});
})(mui,window,document);