(function($, app, myStorage) {
	var city = app.getCity();
	var apps={
		'100100':{appName:'医疗',appIcon:'icon-yll'},
		'100200':{appName:'生育',appIcon:'icon-sey'},
		'100300':{appName:'工伤',appIcon:'icon-gs'},
		'100400':{appName:'养老',appIcon:'icon-yl'},
		'100500':{appName:'失业',appIcon:'icon-siy'},
		'200100':{appName:'居住证/落户',appIcon:'icon-jzz'},
		'200200':{appName:'买房',appIcon:'icon-mf'},
		'200300':{appName:'买车',appIcon:'icon-mc'},
		'200400':{appName:'子女上学',appIcon:'icon-sx'}
	};
	var joyFun = {
		getSecInfo: function(sbkid, callback) {
			callback = callback || $.noop;
			shebaoSvc.getSecInfo(sbkid).then(function(data) {
				callback(data);
			}).catch(function() {
				callback({
					payBase: 0,
					payCity: city.cityCode
				});
				console.error(err.message, err);
			});
		},
		setApps: function() {
			// 去除老数据，如果更新失败也不会造成数据混乱
			jel('.apps .app-link').removeAttr('state');
			jel('.apps .app-link').removeAttr('mid');
			jel('.apps .app-link').removeAttr('jhref');
			// 没有网络（考虑到页面需要更快速的获取数据，进行填充，所以不在plusReady之后在取数据）
			if (window.plus && plus.networkinfo.getCurrentType() == 1) {
				jdb.getData('joyState', 'joyState').then(function(data) {
					if (data && data.data) {
						joyFun.setAppLink(data.data);
					}
				});
			} else {
				joyFun._getAIlist();
			}
		},
		/* 设置分析列表数据
		 * @param {Object} data  listData of analysis
		**/
		_setAppLink: function(data){
			if (!Array.isArray(data)) {
				return;
			}
			$.each(data, function(i, app) {
				// 配置列表需要更新appIcon
				app.appIcon = app.modularId ? apps[app.modularId + ''].appIcon : app.appIcon;
				var link = document.querySelector('.app-link.' + app.appIcon);
				if (!link) return;
				// 配置列表数据
				if (app.modularId) {
					link.setAttribute('state', app.flag);
					link.setAttribute('mid', app.modularId);
					link.setAttribute('citycode', city.cityCode);
				} else {
					// 默认数据
					link.setAttribute('jhref', app.appUrl);
				}
			});
		},
		// 获取险种分析列表数据 
		_getAIlist: function(){
			var promises = [joySvc.getInsList(city.cityCode), joySvc.getAIList(city.cityCode)];
			Q.all(promises).then(function(res){
				$.hideLoading();
				if (res[1]) {
					joyFun._setAppLink(res[1]);
				}
				if (res[0]) {
					joyFun._setAppLink(res[0]);
					jdb.saveData('joyState', {
						id: 'joyState',
						data: res[0]
					});
				}
			}).catch(function(err){
				$.hideLoading();
			})
		},
		getJoyStyle: function() {
			var curVer = 2;
			var cStyle = myStorage.getItemPlus('JoyHtmlStyle') || {
				version: 1
			};
			if (parseInt(cStyle.version) > curVer) {
				return cStyle;
			} else {
				return {
					version: curVer,
					filename: '_www/view/joymods/css.css'
				};
			}
		},
		updateJoyStyle: function() {
			var cStyle = joyFun.getJoyStyle();
			appSvc.getAppResourceUrl('JoyHtmlStyle').then(function(data) {
				if (data && parseInt(data.version) > parseInt(cStyle.version)) {
					var dtask = plus.downloader.createDownload(data.path, {
						filename: '_doc/joymods/css_' + data.version + '.css'
					}, function(d, status) {
						if (status == 200) {
							cStyle = data;
							cStyle.filename = d.filename;
							myStorage.setItemPlus('JoyHtmlStyle', cStyle);
						}
					});
					dtask.start();
				}
			}).catch(function(err) {
				console.log(err.message, err);
			});
		},
		setDataBySecId:function(securityAcctId){
			joyFun.getSecInfo(securityAcctId, function(data) {
				city = {
					cityCode: data.payCity,
					cityName: geo.getCityNameByCode(data.payCity)
				};
				g('pickCity').querySelector('.pick-city').classList.remove('mui-navigate-right');
				g('cityName').innerHTML = city.cityName;
				g('citTips').innerHTML = '参保城市';
				joyFun.setApps();
			});
			shebaoSvc.getPayMonthsAndState(securityAcctId).then(function(data) {
				g('yiLiaoMonth').innerHTML = data.medMonths;
				g('yangLaoMonth').innerHTML = data.pensMonths;
				g('state').innerHTML = data.states;
			});
		},
		// 获取页面内容信息
		refresh: function() {
			$.showLoading('加载中...', 'div');
			var user = app.getUser();
			if (user) {
				if(user.securityAcctId){
					g('dataInfo').classList.add('loged');
					joyFun.setDataBySecId(user.securityAcctId);
				}else{
					g('dataInfo').querySelector('.notloged').innerHTML='<div>绑定社保账户，了解更多信息</div><a class="login-btn">立即绑定</a>';
					joyFun._noCardHandle();
				}
			} else {
				joyFun._noCardHandle();
			}
		},
		// 无卡用户
		_noCardHandle: function(){
			g('pickCity').querySelector('.pick-city').classList.add('mui-navigate-right');
			g('cityName').innerHTML = city.cityName;
			g('citTips').innerHTML = '请选择城市';
			g('dataInfo').classList.remove('loged');
			joyFun.setApps();
		},
		init: function() {
			joyFun.refresh();
			joyFun.updateJoyStyle();
			$('.mui-scroll-wrapper').scroll({
				deceleration: 0.0005,
				indicators: false,
				bounce: false
			});

			$('.data-info').on('tap', '.login-btn', function() {
				if(app.checkLogin()){
					app.showSheBaoAdd();
				}else{
					app.toLogin();
				}
			});
			$('.apps').on('tap', '.app-link', function() {
				var flag = this.getAttribute('state');
				var mid = this.getAttribute('mid');
				var url = this.getAttribute('jhref');
				var citycode = this.getAttribute('citycode');
				if (flag == '1' && mid) {
					var href = 'joymods/index.html?mcode=' + mid + '&cityCode=' + citycode;
					var cStyle = joyFun.getJoyStyle();
					// 为了不显示打开webview时的加载loading
					plus.webview.open(href,'joy_' + mid + Math.random(1,200).toFixed(2),null,'slide-in-right');
				} else if (url) {
					$.openWindow({
						id: 'joy_apps' + Math.random(1,200).toFixed(2),
						url: url + '?t=' + Date.now()
					});
				} else {
					$.alert('该城市无相关政策介绍', '智能应用', '确定', function() {}, 'div');
				}
			});

			$('#pickCity').on('tap', '.mui-navigate-right', function() {
				document.activeElement.blur();
				$.openWindow({
					url: 'pick-city.html?workType=0',
					id: 'pickCity',
					waiting: {
						autoShow: false
					}
				});
			});

			window.addEventListener("changeCity", function(event) {
				city = event.detail;
				joyFun.refresh();
			});
			window.addEventListener("refresh_data", function(event) {
				joyFun.refresh();
			});
			//埋点
			function joyTrack(){
				jTrack.regEvents('.apps a','joyLinkClick','jtrack_name:this.innerText,jtrack_page:attr.jhref');
			}
			joyTrack();
		}
	};

	joyFun.init();

})(mui, app, myStorage);
