/**
 * Created by tuchl on 2016-08-12.
 */
(function($, window) {

	var g = function(id) {
		return document.getElementById(id);
	};
	var querySelector = function(selector) {
		return document.querySelector(selector)
	};
	var documentId;
	var repuserContent = '';

	/**
	 * 评论
	 */
	function Publish(oComment) {
		this.signData = {};
		this.commentFixed = querySelector('.comment-fixed');
		this.commentBtn = querySelector('.comment-fixed .input-box');
		this.commentPlaceholderBox = querySelector('.comment-placeholder-box');
		this.commentInput = querySelector('.comment-input');
		this.commentSend = querySelector('.comment-send');
		this.textarea = querySelector('.comment-input textarea');
		this.bBtn = true;
		var This = this;
		this.comment = oComment;
		this.windowH = window.innerHeight;
		this.requests = {

			// 是回复
			reply: function(context, callback) {
				plus.nativeUI.showWaiting('');
				newsSvc.replycomment(This.signData.id, context).then(function(res) {
					successHandler();
					This.signData.reViewId = res.reViewId;
					This.signData.context = context;
					This.signData.repuserContent = repuserContent;
					$.toast('回复成功');
					This.comment._addReplyLine(This.signData, This.signData.id);
					// 通知评论已经成功
					callback && callback();
					document.querySelector('.r-body').scrollTop = 0;
				}).catch(errorHandler)
			},

			comment: function(context, callback) {
				plus.nativeUI.showWaiting('');
				newsSvc.commentArticle(This.signData.id, context).then(function(res) {
					successHandler();
					$.toast('评论成功');
					mui.extend(res, {
						context: context
					});
					This.comment.addCommentLine(res);

					// 通知评论已经成功
					callback && callback();
					var iTop = document.querySelector('.article_body').offsetHeight + document.querySelector('.recommend-cont').offsetHeight;
					var clientTop = This.signData.dom.getBoundingClientRect().top;

					if(clientTop < 400 && clientTop > 0 && This.type == 1) return;
					mui('.mui-scroll-wrapper').scroll().scrollTo(0, -iTop, 300);
				}).catch(errorHandler);
			}

		}

		function getParentOffsetTop(dom) {
			var top = dom.offsetTop;

			var parent = dom.offsetParent;

			while(parent) {
				top += parent.offsetTop;

				parent = parent.offsetParent;

				if(!parent) {
					break;
				}
			}
			return top;
		}

		function successHandler() {
			This._closeCommentLayer();
			This.bBtn = true;
			plus.nativeUI.closeWaiting();
		}

		/**
		 * 错误处理
		 * @param {Object} res 返回的错误信息
		 */
		function errorHandler(res) {
			if(res.code !== '30005') {
				$.toast(res.message);
			}
			This.bBtn = true;
		}
		this.textarea.onblur = function() {
			This._closeCommentLayer();
		}
	}

	Publish.prototype = {
		constructor: Publish,
		preventDefault: function(e) {
			e.preventDefault();
		},

		/**
		 * 显示评论输入框
		 * @param signData { Object } 
		 * @param {String} placeholder 评论输入框的默认值
		 * @param { Number } id 回复的ID (评论orw文章)
		 * @param { Object } dom 触发事件的元素
		 * @param { sendName } 发布评论的人
		 */
		_showCommentInput: function(signData) {
			var This = this;
			this.signData = signData;
			this.commentPlaceholderBox.classList.add('mui-hidden');
			this.commentInput.classList.remove('mui-hidden');
			this.textarea.setAttribute('placeholder', signData.repuserName ? '回复 @' + signData.repuserName : '写评论');
			//This.textarea.focus();
			setTimeout(function(){
				This.textarea.focus();
				if(mui.os.ios){
					app.openSoftKeyboard();
				}
			},300)
			this.insertMark();
		},

		/**
		 * 加入键盘蒙层
		 */
		insertMark: function() {
			var This = this;

			if(this.oMark) {
				return this.oMark.removeAttribute('hidden');
			};
			this.oMark = document.createElement('div');
			this.oMark.id = 'mark';
			document.body.appendChild(this.oMark);
			this.oMark.ontouchmove = function(e) {
				This.textarea.blur();
			};
			if(mui.os.android) {
				window.onresize = function() {
					if(document.body.offsetHeight === This.windowH) {
						This.textarea.blur();
					}
				}
			}
			document.querySelector('.comment-input-body textarea').oninput = function(e) {
				var textareaScrollHeight = this.scrollHeight;

				if(textareaScrollHeight < 80) {
					this.style.height = textareaScrollHeight + 'px';
				}
				if(this.value.length > 300) {
					this.value = this.value.substr(0, 300);
				};
			}
		},
		/**
		 * 关闭输入
		 */
		_closeCommentLayer: function() {
			this.commentPlaceholderBox.classList.remove('mui-hidden');
			this.commentInput.classList.add('mui-hidden');
			this.oMark && this.oMark.setAttribute('hidden', '');
			this.textarea.blur();
		},

		/**
		 * 监听评论显示
		 * @param { Number } 文章的ID
		 * @param { Boolean } 是否禁止评论
		 */
		_listenShowComment: function(documentId, isAllow) {
			var This = this;

			$('.comment-fixed').on('tap', '.input-box', function() {

				if(isAllow) {
					mui.toast('评论已关闭');
					return;
				}
				if(!app.checkLogin()) {
					app.toLogin();
					return;
				}

				// 在回复列表回复
				if(This.curComment && This.curComment.mask.classList.contains('show')) {
					This._showCommentInput({
						COMMENTID: This.curComment.id,
						type: 'reply',
						id: This.curComment.id
					})
				} else {
					This._showCommentInput({
						type: 'comment',
						id: documentId,
						dom: document.querySelector('.comment-body')
					})
				}
			})
			this.textarea.onfocus = function() {
				setTimeout(function() {
					document.querySelector('.comment-fixed').scrollIntoView(false);
				}, 200)
			}
		},

		/**
		 * 发表
		 * @param { Function } callback 
		 */
		_publishHandler: function(callback) {
			var content = this.textarea.value.trim().replace(/[\uD800-\uDBFF][\uDC00-\uDFFF]/g, function(w) {
					return w.codePointAt ? '&#' + w.codePointAt() + ";" : '';
				}),
				re = /\S/,
				This = this;

			// 输入为空
			if(!re.test(content)) {
				this.textarea.value = '';
				this.textarea.style.height = '24px';
				mui.toast('发表的内容不能为空');
				return;
			}

			if(!this.bBtn) return;
			this.bBtn = false;
			var callback = function() {

				if(This.signData.type == 'reply') {
					This.comment.setReplySize(true, true);
				}
				This.comment._setCommentSize(This.signData.COMMENTID, true);
				This.textarea.value = '';
				This.textarea.style.height = '24px';
			};
			this.requests[this.signData.type](content, callback);
		},

		_listenPublish: function() {
			var This = this;
			var oSub = document.querySelector('.comment-send').parentNode.parentNode;
			oSub.onsubmit = function() {
				This._publishHandler();
			}
			// 发送评论or回复
			mui('.comment-fixed').on('tap', '.comment-send', function() {
				oSub.onsubmit();
			})

		},

		/**
		 * 显示底部评论输入框
		 * @param {Object} content
		 */
		showCommentLayer: function(content) {
			querySelector('.comment-fixed').style.transform = 'translateY(0)';
			querySelector('.comment-fixed').style.webkitTransform = 'translateY(0)';
			!content.replyCount && querySelector('.reply-count').classList.add('mui-hidden');
			querySelector('.reply-count').innerHTML = content.replyCount;
			// 监听（禁止评论，隐藏评论的情况，也不允许发送评论）
			this._listenShowComment(content.id, content.isAllowReview || content.isHideReview);
			this._listenPublish();
			this.type = content.type;
		},
	}

	/**
	 * 赞
	 * @param {Object} oComment 回复的实例对象
	 */
	function Praise(oComment) {
		this.thred = true;
		this.oComment = oComment;
	}
	Praise.prototype = {
		constructor: Praise,

		/**
		 * 初始化
		 * @param {Object} content
		 */
		init: function(content) {
			var follow = querySelector('.follow-count');
			var This = this;

			// 赞过的 是 1；
			follow.setAttribute('data-praise', content.agreeStates == 1 ? 'true' : 'false');
			follow.setAttribute('aid', content.id);
			follow.setAttribute('title', content.title);

			if(content.agreeStates == 1) {
				follow.querySelector('.jcon').classList.add('jcon-dianzan1');
				follow.querySelector('.jcon').classList.remove('jcon-dianzan');
			}
			this._setFollowCount(follow, content.agreeCount);

			// 文章点赞或取消赞
			follow.addEventListener('tap', function() {
				This._followArticalHandle(this, content.id);
			}, false);

			// 评论点赞
			$('.comment-body').on('tap', '.comment-praise', function(e) {
				This._followCommentHandle(this);
				e.stopPropagation();
			})
		},
		/**
		 * 文章或评论
		 * 
		 * @param { Number } like 0 => 文章  1=》 评论
		 * @param { Number } id    评论or文章的ID
		 * @patam { Boolean } dir 是点赞还是取消
		 * @param { Function } callback 回调函数
		 */
		_followHandler: function(like, id, dir, callback) {

			// 未登录
			if(!app.checkLogin()) {
				app.toLogin();
				return;
			}
			if(!this.thred) return;
			this.thred = false;
			var This = this;

			newsSvc.follow(like, id, dir).then(function(res) {
				callback();
				This.thred = true;
			}).catch(function(res) {

				if(res && res.code == '90001') {
					mui.toast(res.message);
				}
				This.thred = true;

			});
		},
		/**
		 * 评论点赞
		 * @param { DOM } ele 点击的元素
		 */
		_followCommentHandle: function(ele) {
			var This = this,
				commentId = ele.getAttribute('data-commentid') || ele.getAttribute('data-replyid'),
				isPraise = ele.getAttribute('data-praise') || 'false',
				callback = function(res) {
					var className = 'c-yellow';
					isPraise = ele.getAttribute('data-praise') || 'false';

					if(!/false/.test(isPraise)) {
						isPraise = 'false';
					} else {
						isPraise = 'true';
					}
					This._setCommentFollowCount(ele, isPraise);

					// 评论点赞才会通知
					ele.getAttribute('data-commentid') && This._noticeCommentListPraiseStates(commentId, !/false/.test(isPraise));
				};

			commentId = commentId.replace('r', '');
			commentId && this._followHandler(1, commentId, !/false/.test(isPraise), callback);
		},

		/**
		 * 设置数量并返回当前数量
		 * @param {Object} ele
		 * @param {Object} isAgree
		 */
		_setCommentFollowCount: function(ele, isAgree) {
			var oI = ele.querySelector('em'),
				targetIcon = ele.querySelector('i'),
				count = oI.innerText,
				praiseActive = 'jcon-dianzan1',
				praiseDefault = 'jcon-dianzan',
				praiseAmong = 'jcon-fabulous';
			isAgree = isAgree.toString();

			if(!/false/.test(isAgree)) {
				count++
				targetIcon.classList.add(praiseActive);
				targetIcon.classList.remove(praiseDefault);
			} else {
				count--
				targetIcon.classList.remove(praiseActive);
				targetIcon.classList.add(praiseDefault);
			}

			ele.setAttribute('data-praise', isAgree);
			ele.setAttribute('data-praised', isAgree);
			if(count == 0) {
				oI.setAttribute('data-count', '0');
			} else {
				oI.removeAttribute('data-count');
			}
			oI.innerText = count;
			return count;
		},

		/**
		 * 文章点赞
		 * @param { Object } 当前的DOM
		 * @param { Number } documentId 文章Id
		 */
		_followArticalHandle: function(ele, documentId) {
			var isPraise = ele.getAttribute('data-praise') || 'false';
			var This = this;

			var callback = function() {
				var className = 'c-yellow';
				isPraise = ele.getAttribute('data-praise') || 'false';

				if(!/false/.test(isPraise)) {
					isPraise = 'false';
				} else {
					isPraise = 'true';
				}
				ele.setAttribute('data-praise', isPraise);
				ele.setAttribute('data-praised', isPraise);
				This._setFollowCount(ele, isPraise == 'true');
				var countBox = ele.querySelector('.praise-count'),
					count = isNaN(parseInt(countBox.innerText)) == true ? 0 : parseInt(countBox.innerText);

				$.fire(plus.webview.getLaunchWebview(), 'praiseSwitch', {
					aid: documentId,
					dir: isPraise == 'true',
					count: count
				});
			};
			this._followHandler(0, documentId, !/false/.test(isPraise), callback);
		},

		/**
		 * 设置文章赞的数量
		 * @param { DOM } 
		 * @param { Number or Bollean } count 如果是Boolean true => 加  false => 减 
		 */
		_setFollowCount: function(ele, count) {
			var praiseActive = 'jcon-dianzan1';
			var praiseDefault = 'jcon-dianzan';
			var targetDom = ele.querySelector('span');
			var targetIcon = ele.querySelector('i');
			var tempCount = Number(targetDom.innerText) || 0;

			if(typeof count !== 'boolean') {
				tempCount = count;
			} else {

				if(count) {
					tempCount++
					targetIcon.classList.add(praiseActive);
					targetIcon.classList.remove(praiseDefault);
				} else {
					tempCount--
					targetIcon.classList.remove(praiseActive);
					targetIcon.classList.add(praiseDefault);
				}
			}

			if(tempCount < 1) {
				tempCount = '赞';
			}
			targetDom.innerText = tempCount;
		},
		/**
		 * 通知评论列表赞的状态
		 * @param {Number} commentId 赞的评论ID
		 * @param {Object} isPraise
		 */
		_noticeCommentListPraiseStates: function(commentId, isPraise) {

			// 在回复列表点赞or取消赞
			if(this.oComment.mask.classList.contains('show')) {
				this._setCommentFollowCount(g(commentId).querySelector('.comment-praise'), isPraise);
			}
			var praiseCount = this.oComment._changeCommentListPraise(commentId, isPraise);

		}
	}

	/**
	 * 评论
	 */
	function Comment() {
		this.replayCont = querySelector('.reply-body'); // 回复wrap
		this.threadBtn = true; // ajax 开关
		this.commentList = [];
		this.pageNumber = 0;
		this.articleId = 0;
		this.downLoading = null;
		this.commentTempData = {}; // 评论的缓存数据
		this.mask = g('popover');
		this.replyList = [];
		this.replyListView = document.querySelector('.reply-list-cont');
		this.isShowReply = false;
		this.muiBack = mui.back;
	}

	Comment.prototype = {

		constructor: Comment,

		/**
		 * 通过ID获取评论的内容
		 * @param {Object} data
		 * @param {Object} id
		 */
		getCommentListById: function(id) {
			var result;

			mui.each(this.commentList, function(index, val) {

				if(val.id == id || val.viewId == id) {
					result = val;
				}
			})

			return result;
		},

		/**
		 * 监听删除
		 */
		listenDelete: function() {
			var This = this;
			mui(document.body).on('tap', '.jcon-shanchu', function() {
				var id = this.getAttribute('data-id');
				var commentId = this.getAttribute('data-commentid');
				var type = this.getAttribute('type');
				//删除
				mui('#options').popover('hide');

				id = id.replace('r', '');

				var btnArray = ['否', '是'];
				mui.confirm('', '确认删除吗？', btnArray, function(e) {
					var reCount;
					if(e.index == 1) {
						This._deleteComment(id, function() {
							if(type == 'reply') {
								// 减少回复数量
								reCount = This.setReplySize(false, true, id);
								This._setCommentSize(commentId || id, false, false, reCount);
							} else {
								This._setCommentSize(commentId || id, false, true);
							}
							This._setReplyShowStates(id, type);
						});
					}
				}, 'div')
			})
		},
		/**
		 * 设置评论区或者回复区的显示状态
		 */
		_setReplyShowStates: function(id, type) {
			// 带r的ID是回复列表下的评论（为了不和评论列表）
			g(id).remove();
			//var parentInreply;
			// 删除二级评论 三级评论不删除
			//var selector = "[brepid='" + id + "']";
			if('reply' == type) {
//				parentInReply = document.querySelectorAll(selector);
//				if(parentInReply) {
//					for(var i = 0; i < parentInReply.length; i++) {
//						parentInReply[i].remove();
//					}
//				}
				if(0 == querySelector('#reply-list').children.length) {
					querySelector('#reply-list').innerHTML = '<div class="mui-text-center fs-12"><i class="jcon jcon-sofa"></i><br/><span class="quick-sofa">还没有回复，赶紧抢占沙发哦！</span></div>'
				}
			} else {
				if(0 == querySelector('#comment-list').children.length) {
					querySelector('#comment-list').innerHTML = '<div class="mui-text-center fs-12"><i class="jcon jcon-sofa"></i><br/><span class="quick-sofa">还没有评论，赶紧抢占沙发哦！</span></div>'
				}

				// 如果删除的评论是当前回复列表头的评论，关闭回复层
				if(this.mask.classList.contains('show')) {
					this.hideReplyList();
				}
			}
		},
		/**
		 * 修改评论列表赞的状态
		 * @param {String} type
		 * @param {Boolean} isPraise
		 */
		_changeCommentListPraise: function(id, isPraise) {
			var praiseCount = 0;

			mui.each(this.commentList, function(index, value) {

				if(id == value.id) {
					value.agreeStates = isPraise ? 1 : 0;
					value.agreeCount = isPraise ? Number(value.agreeCount) + 1 : Number(value.agreeCount) - 1;
					praiseCount = value.agreeCount;
				}
			})
			return praiseCount;
		},

		/**
		 * 修改评论列表回复数量
		 * @param {String} type
		 * @param {Boolean} isPlus
		 * @param {Number} count 直接减去数量
		 */
		_changeCommentListReplySize: function(id, isPlus, count) {
			if(1 == arguments.legnth || 'boolean' != typeof isPlus) return;
			mui.each(this.commentList, function(index, value) {
				if(id == value.id) {
					console.log(value);
					if(count) {
						value.replySize = value.replySize - count;
						value.commentReply = 'dddd';
					} else {
						value.replySize = isPlus ? value.replySize + 1 : value.replySize - 1;
						value.commentReply = 'dddd';
					}
				}
			})
		},

		/**
		 * 下拉and上拉
		 * @param {Object} data {documentId:'2', page: 1, }
		 */
		getInitCommentList: function(data, pull) {
			var This = this;
			!This.downLoading && (This.downLoading = g('pullRefresh').querySelector('.mui-pull-bottom-tips'));
			data.documentId && (This.articleId = data.documentId);
			if(data.page == 'down') {
				This.pageNumber = 1;
			} else {
				This.pageNumber++;
			}
			var callbackHandler = function(res) {

				// 请求失败
				if(res.code !== undefined) {
					This.pageNumber--;
					try {
						data.page == 'down' && pull.endPullDownToRefresh();
						data.page == 'up' && pull.endPullUpToRefresh(false);
					} catch(e) {
						console.log(e)
					}
				} else {
					try {
						if(data.page == 'down') {
							pull.endPullDownToRefresh();

							// 重新设置上拉加载
							if(res.pagination.totalItems > res.pagination.pageSize * res.pagination.pageNum) {
								pull.refresh(true);
							}
						}
						data.page == 'up' && pull.endPullUpToRefresh(res.pagination.totalItems < res.pagination.pageSize * res.pagination.pageNum);
						if(1 == This.pageNumber && res.pagination.totalItems < res.pagination.pageSize * res.pagination.pageNum) {
							This.downLoading.classList.add('mui-hidden');
						} else {
							This.downLoading.classList.remove('mui-hidden');
						}
					} catch(e) {
						console.log(e)
					}
				}
				if(res.pagination.totalItems == 0) {
					This.downLoading.classList.add('mui-hidden');
				}
			}

			/* 加载评论 列表*/
			This.getCommentList(This.articleId, This.pageNumber, callbackHandler);
		},

		/**
		 * 文章评论列表
		 * @param { Number } documentId
		 * @param { Numbet } pageNumber评论分页页码
		 * @param { Function } 回调函数
		 */
		getCommentList: function(documentId, pageNumber, callback) {
			var cont = document.querySelector('#comment-list');
			var This = this;
			loadData();

			function loadData() {
				newsSvc.getCommentAllList(documentId, pageNumber).then(function(res) {
					var tempDom = null;
					var children = null;
					if(callback) callback(res);
					if(res.pagination.pageNum == 1 && res.list.length == 0) {
						res = '<div class="mui-text-center fs-12"><i class="jcon jcon-sofa"></i><br/><span class="quick-sofa">暂无回复，抢占沙发！</span></div>'
						This._addHtml(cont, res);
					} else {
						// 处理发布时间
						res.list = This.serializeDate(res.list);

						if(res.pagination.pageNum == 1) {
							This.commentList = res.list;
							This._addHtml(cont, This.commentList);
						} else {
							This.commentList = This.commentList.concat(res.list);
							tempDom = document.createElement('ul');
							tempDom.innerHTML = This._addHtml(res.list);
							children = tempDom.children;
							mui.each(children, function(i, ele) {
								cont.appendChild(ele.cloneNode(true));
							})
							tempDom = children = null;
						}
					}
				}).catch(function(res) {
					This._exceptionHandler(This.downLoading, res, loadData);
				})
			}
		},

		/**
		 * 错误处理
		 * @param {Object} context 当前的dom
		 * @param {Object} res ajax 错误返回
		 * @param {Object} fn 
		 */
		_exceptionHandler: function(context, res, fn) {
			if(!this._listenerFn) {
				this._listenerFn = function(content) {
					fn();
					context.innerHTML = '加载中...';
				}
			}
			if(!context && 1 != context.nodeType) return;
			// 没有网络
			if(res.code == 0) {
				context.innerHTML = '网络连接失败,请检查网络连接';
			} else {
				context.innerHTML = '加载失败, 点击重新加载';
			}
			context.removeEventListener('tap', this._listenerFn, false);
			context.addEventListener('tap', this._listenerFn, false);
		},

		/**
		 * 处理时间
		 * @param {Array} data
		 */
		serializeDate: function(data) {

			mui.each(data, function(i, val) {
				val.createTime = common.utils.getTimeFormatText((val.createTime || val.createDate) || val.releaseTime);
			})
			return data;
		},

		/**
		 * 添加一条回复
		 * @param { Object } data 
		 * @param {Number} commentId 评论ID
		 * dom 指点添加的父级
		 * context 回复的内容
		 * name 被回复者
		 */
		_addReplyLine: function(data, commentId) {
			var targetDom = g('reply-list');
			var oTempDom = null;
			var userData = myStorage.getItem("State");

			var tempData = {
				brepId: data.id,
				commentId: commentId,
				reviewerId: data.reViewId,
				headpath: userData.info.headPath,
				reviewerName: userData.info.userName,
				createTime: '刚刚',
				agreeCount: '0',
				noAgreeCount: '0',
				content: data.context,
				isPrasie: '',
				praiseClass: 'jcon-dianzan',
				repuserName: data.repuserName,
				repuserContent: repuserContent, //被回复的内容
				reviewerCont: data.context, //回复的内容
				isHideRepuser: data.repuserName ? '' : 'hidden'
			};

			var html = common.utils.patternStrPlus(querySelector('#reply-line').innerHTML, tempData);
			this.addReplyList(tempData);

			var lineComent = document.createElement('div');
			lineComent.innerHTML = html;

			try {
				if(0 == targetDom.children.length) {
					targetDom.appendChild(lineComent.querySelector('.comment-line').cloneNode(true));
				} else {
					targetDom.insertBefore(lineComent.querySelector('.comment-line').cloneNode(true), targetDom.firstChild);
				}
			} catch(e) {
				console.log(e)
			}
			lineComent = null;
			targetDom.querySelector('.mui-text-center') && targetDom.querySelector('.mui-text-center').remove();
		},

		/**
		 * 添加一条评论
		 * @param {Object} content
		 */
		addCommentLine: function(data) {
			var userData = myStorage.getItem("State");
			var commentBody = document.querySelector('.comment-body');

			var tempData = {
				id: data.reViewId,
				headpath: userData.info.headPath,
				reviewerName: userData.info.userName,
				reviewerId: userData.info.userId,
				createTime: '刚刚',
				replySize: 0,
				agreeCount: '0',
				noAgreeCount: '0',
				content: data.context,
				isPrasie: '',
				praiseClass: 'jcon-dianzan',
			};

			html = this._addHtml([tempData]);
			var lineComent = document.createElement('div');
			this.commentList.unshift(tempData);
			lineComent.innerHTML = html;
			commentBody.insertBefore(lineComent.querySelector('.comment-line').cloneNode(true), commentBody.firstChild);
			lineComent = null;
			commentBody.querySelector('.mui-text-center') && commentBody.querySelector('.mui-text-center').remove();
		},

		/**
		 * 删除评论
		 * @param {Number} commentId
		 * @param { FUnction } callback
		 */
		_deleteComment: function(commentId, callback) {
			var This = this;
			plus.nativeUI.showWaiting('');
			newsSvc.deleteComment(commentId).then(function(res) {
				$.toast('删除成功');
				callback();
				plus.nativeUI.closeWaiting('');
			}).catch(function(res) {
				plus.nativeUI.closeWaiting('');
			})

		},
		//		/**
		//  	 * 评论列表渲染回复
		//  	 * @param {Object} ele
		//  	 * @param {Object} data
		//  	 * @param { Number } 评论ID
		//		 * @return {String} 
		//  	 */
		//		_addHtmlToReply: function (ele, data, id){
		//  		var resultHtml = '';
		//  		
		//  		if ('undefined' == typeof ele) return resultHtml;
		//  		if (ele.nodeType != 1) {
		//  			id = data;
		//  			data = ele;
		//  			ele = null;
		//  		}
		//  		
		//  		if (typeof data == 'string') {
		//  			resultHtml = data;
		//  		} else {
		//	    		resultHtml = (Array.isArray(data) && data.length > 0) ? '<li class="react"><em>'+ (data[0].repuserName)+'</em>: ' +  data[0].repContent +'</li>' : '';	
		//  		}
		//  		ele && (ele.innerHTML = resultHtml);
		//  		return resultHtml;
		//  	},
		/**
		 * 渲染回复列表
		 * @param {Object} ele
		 * @param {Object} data
		 * @param { Number } 评论ID
		 * @return {String} 
		 */
		_renderReplyList: function(ele, data, id) {
			var resultHtml = '';
			var userData = app.getUser() || {};
			if(ele.nodeType != 1) {
				id = data;
				data = ele;
				ele = null;
			}

			if(typeof data == 'string') {
				resultHtml = data;
			} else {
				mui.each(data, function(i, val) {

					resultHtml += common.utils.patternStrPlus(querySelector('#reply-line').innerHTML, {
						brepId: val.brepId,
						commentId: id,
						headpath: val.headpath ? val.headpath : val.repheadpath ? val.repheadpath : '../images/user-photo.png',
						reviewerName: val.repuserName,
						reviewerCont: val.repContent,
						repuserContent: val.repUserContent,
						reviewerId: val.repId,
						createTime: val.repTime,
						agreeCount: val.agreeCount || '0',
						content: val.repContent,
						isMe: val.replyUserId == userData.userId ? '' : 'hidden',
						isPrasie: val.agreeStates == 1 ? 'true' : '',
						praiseClass: val.agreeStates == 1 ? 'jcon-dianzan1' : '',
						isHideRepuser: val.RerepuserName ? '' : 'hidden',
						repuserName: val.RerepuserName
					});
				})
			}
			ele && (ele.innerHTML = resultHtml);
			return resultHtml;
		},
		/**
		 * 填充评论列表
		 * @param {Object} ele DOM
		 * @param {Object} data 数据
		 */
		_addHtml: function(ele, data) {
			var userData = app.getUser() || {};
			var resultHtml = '';
			var This = this;

			if(!ele.nodeType) {
				data = ele;
				ele = null;
			}

			if(typeof data === 'string') {
				resultHtml = data;
			} else {
				data.forEach(function(val) {
					resultHtml += common.utils.patternStrPlus(querySelector('#comment').innerHTML, {
						id: val.isInReply ? 'r' + val.id : val.id,
						headpath: val.headpath ? val.headpath : val.repheadpath ? val.repheadpath : '../images/user-photo.png',
						reviewerName: val.reviewerName,
						reviewerId: val.reviewerId,
						createTime: val.createTime,
						agreeCount: val.agreeCount || '0',
						noAgreeCount: val.noAgreeCount || '0',
						replaySize: val.replySize > 0 ? val.replySize : '0',
						content: val.content,
						isPrasie: val.agreeStates == 1 ? 'true' : '',
						praiseClass: val.agreeStates == 1 ? 'jcon-dianzan1' : 'jcon-dianzan',
						isInReply: val.isInReply,
						isShowReplySize: val.replySize > 0 ? '' : 'hidden',
						isMe: userData.userId == val.reviewerId ? '' : 'hidden',
						commentReply: val.replySize > 0 ? "comment-resize" : ""
					});
				})
			}

			if(ele) {
				ele.innerHTML = resultHtml
			} else {
				return resultHtml;
			}
		},

		/**
		 * 设置评论数量
		 * @param {Number} id 评论的ID
		 * @param {Object} res
		 * @param {Boolean} isSpecity 是不是特殊处理
		 * @param {Number} count 直接添加或者减少的数量
		 */
		_setCommentSize: function(id, res, isSpecity, count) {
			var curComment;
			if('boolean' == typeof id) {
				res = id;
				id = null;
			}
			var len = 0;
			var oReplyCount = document.querySelector('.reply-count');
			if(!oReplyCount) return;
			if('boolean' !== typeof res) {
				len = res.length;
			} else {
				len = oReplyCount.innerHTML.match(/[0-9]{1,10000}/)[0];
				if(count) {
					len -= count;
				} else {
					if(res) {
						len++;
					} else {
						if(id && isSpecity) {
							curComment = this.getCommentListById(id);
							len -= (curComment && curComment.replySize ? curComment.replySize + 1 : 1);
						} else {
							len--;
						}
					}
				}
			}
			// 修改replySize
			this._changeCommentListReplySize(id, res, count);
			if(len) {
				oReplyCount.classList.remove('mui-hidden');
			} else {
				oReplyCount.classList.add('mui-hidden');
			}
			oReplyCount.innerText = len;

			mui.fire(plus.webview.getLaunchWebview(), 'reply', {
				id: this.articleId,
				len: len
			})
		},

		/**
		 * 设置回复数量
		 * @param {Number} commentId
		 * @param {Number} count 
		 */
		_noticeCommentOfId: function(commentId, count) {

			var replyNumBox = g(commentId).querySelector('.reply-react span'),
				commentBox = g(commentId).querySelector('.reply-react');

			if(!replyNumBox) return;
			if(count > 0) {
				replyNumBox.removeAttribute('hidden');
				replyNumBox.innerHTML = '' + count;
				commentBox.classList.add('comment-resize');
			} else {
				replyNumBox.setAttribute('hidden', '0');
				commentBox.classList.remove('comment-resize');
			}

		},
		/**
		 * 显示回复列表
		 * @param {Object} data 当前回复列表的评论ID或者回复ID {commentId:'',replyId:''}
		 * @param {Boolean} showInput 是否激活输入框
		 * @param {Number} iTop 
		 */
		showReplyList: function(data, showInput, iTop) {
			var This = this;
			var currComment = this.getCommentListById(data.commentId);
			var reply;
			this.curComment = {
				id: data.commentId
			}

			// 当前回复列表已经显示
			if(this.mask.classList.contains('show')) {
				This._setShowReplyData(data, showInput);
			} else {
				currComment.isInReply = 'in-reply';
				currComment.mask = this.mask;
				this.oPublish.curComment = currComment;
				this._addHtml(document.querySelector('.replay-comment'), [currComment]);
				mui('#shoucang')[0].classList.add('mui-hidden');
				mui('.control-btns')[0].classList.remove('comment-content');
				mui('.control-btns')[0].classList.add('reply-content');
				this.mask.classList.remove('hide');
				this.mask.classList.add('show');
				this.mask.style.top = iTop + 'px';
				this.getReplyList(data.commentId, function(res) {
					This._setShowReplyData(data, showInput);
				})
				mui('#popover').on('tap', '.close-btn', function() {
					This.hideReplyList();
				})
				mui('#popover').on('swipedown', '.r-body', function(e) {
					This.hideReplyList();
				})

				mui.back = function() {
					This.hideReplyList();
					mui.back = This.muiBack;
				}
			}
		},
		_setShowReplyData: function(data, showInput) {
			var reply = this.getReplyById(data.replyId);
			repuserContent = data.repuserContent ? data.repuserContent : '';
			if(showInput) {
				this.oPublish._showCommentInput({
					COMMENTID: data.commentId,
					type: 'reply',
					id: data.replyId || data.commentId, // 前后位置不能颠倒（如果有回复Id一定是回复的回复）
					repuserName: reply.repuserName || reply.reviewerName
				})
			} else {
				this.oPublish.signData = {
					COMMENTID: data.commentId,
					type: 'reply',
					id: data.replyId || data.commentId, // 前后位置不能颠倒（如果有回复Id一定是回复的回复）
					repuserName: reply.repuserName || reply.reviewerName
				}
			}
		},

		hideReplyList: function() {
			this.oPublish.curComment = null;
			this.oPublish._closeCommentLayer();
			mui.back = this.muiBack;
			this.mask && this.mask.classList.remove('show');
			this.mask.classList.add('hide');
			mui('#shoucang')[0].classList.remove('mui-hidden');
			mui('.control-btns')[0].classList.remove('reply-content');
			mui('.control-btns')[0].classList.add('comment-content');

		},
		/**
		 * 添加回复
		 * @param {Object} data
		 */
		addReplyList: function(data) {
			this.replyList.unshift(data);
		},
		getReplyList: function(commentId, callback) {
			var This = this;
			loadData();

			function loadData() {
				newsSvc.getReplyList(commentId).then(function(res) {
					res = {
						list: res,
						pagination: {
							pageNum: 1,
							pageSize: 20,
							totalItems: 19
						}
					};
					This.replyList = res.list || [];

					if(res.list.length == 0) {
						res.pagination.totalItems = 0;
						res.list = '<div class="mui-text-center fs-12"><i class="jcon jcon-sofa"></i><br/><span class="quick-sofa">暂无回复，抢占沙发！</span></div>'
					}
					This.setReplySize(This.replyList);
					This._renderReplyList(document.querySelector('.replay-list'), res.list, commentId);
					callback && callback(res);
				}).catch(function(res) {
					This._exceptionHandler(This.mask.querySelector('.nothing'), res, loadData);
				})
			}

		},
		/**
    	 * 获取回复
    	 * @param {Object} id
    	 * @return {Rerepheadpath: ""
					RereplyUserId: 0
					RerepuserName: ""
					repContent: "嗯嗯"
					repId: 1643
					repTime: "2017-09-15 16:09:27"
					repheadpath: "http://192.168.1.223:8082/upload/icon/100122_41526869498130.png"
					replyUserId: 100122
					repuserName: "积极的"
					agreeCount: "0"
				content: "D"
				createTime: "刚刚"
				headpath: "http://192.168.1.223:8082/upload/icon/100122_41526869498130.png"
				id: 1889
				isPrasie: ""
				noAgreeCount: "0"
				praiseClass: "jcon-praise"
				repuserName: undefined
				reviewerId: 1889
				reviewerName: "积极的"
				userId: 100122}
    	 */
		getReplyById: function(id) {
			var result = {};

			if(!id) return {};
			this.replyList.map(function(val) {

				if(id == val.id || id == val.repId || id == val.reviewerId) {
					result = val;
				}
			})
			return result;
		},
		/**
		 * 通知评论下的回复数量改变
		 * @param {Object} res true => 增加 false => 减少； 数组时直接设置数组的长度
		 * @param {Object} isNotice true 通知
		 * @param {Number} id 当前的回复id
		 */
		setReplySize: function(res, isNotice, id) {
			var replySize = document.querySelector('.reply-size');
			var count;
			var selector = "[brepid='" + id + "']";
			var parentInReply = document.querySelectorAll(selector);
			var reCount = parentInReply ? (parentInReply.length + 1) : 1;
			if(typeof res == 'boolean') {
				count = replySize.innerText.match(/[0-9]{1,10000}/) && replySize.innerText.match(/[0-9]{1,10000}/)[0] || 0;
				if(res) {
					count++;
				} else {
					count -= 1;
				}
			} else {
				count = res.length;
			}
			replySize.innerText = (0 == count ? '还没有回复哦！' : count + '条回复');
			if(isNotice) {
				this._noticeCommentOfId(this.curComment.id, count); // 回复消息 更新评论列表回复数量
			}

			return reCount;
		}
	}
	window.Praise = Praise;
	window.Comment = Comment;
	window.Publish = Publish;
	window.Pull = {
		scroll: null,

		/**
		 * 初始化下拉和上拉
		 * @param {Object} documentId
		 * @param {Object} callback
		 * @param {Object} sign 
		 * @param {Number} scrollY 默认位置
		 * @param 
		 */
		init: function(documentId, callback, sign, scrollY) {

			if(typeof documentId == 'function') {
				callback = documentId;
				documentId = {};
			}
			var initData = {
				down: {
					callback: function() {
						var self = this;
						setTimeout(function() {
							callback({
								documentId: documentId,
								page: 'down'
							}, self);
						}, 10);
					}
				},
				up: {
					auto: true,
					callback: function() {
						var self = this;
						setTimeout(function() {
							callback({
								documentId: documentId,
								page: 'up'
							}, self);
						}, 10);
					}
				}
			};
			if(sign) {

				if(!sign.up) {
					delete initData.up;
				}

				if(!sign.down) {
					delete initData.down;
				}

			}
			Pull.scroll = $('.mui-scroll-wrapper').scroll({
				bounce: false,
				startY: scrollY || 0,
				indicators: true,
				deceleration: mui.os.ios ? 0.003 : 0.0009
			});
			return $('#pullRefresh').pullToRefresh(initData);
		}
	}

	function Funcs() {
		return {
			creatList: function(aid, boxId) {
				newsSvc.getEntranceByDocId(aid).then(function(data) {
					if(!$.isArray(data)) {
						data = $.isEmptyObject(data) ? [] : [data];
					}
					$.each(data, function(i, item) {
						item.showPrice = item.price ? '' : 'mui-hidden';
					});
					jpl('#tplFunction').patternEach(boxId, data);
				}).catch(function(err) {
					console.error(err.message, err);
				});
				$(boxId).on('tap', '.fun', function() {
					var href = this.getAttribute('jhref');
					app.openMultiURL(href);
				});
			}
		}
	}
	window.Funcs = Funcs();

})(mui, window);