/**
 * Created by tuchl on 2016-08-12.
 */

(function($) {
	$.init({
		swipeBack: true,
		swipe: true,
		beforeback:function(){
			plus.navigator.setFullscreen(false);
		}
	});
	$.oldBack = $.back;
	/*$.back = function(){
		plus.navigator.setFullscreen(false);
		$.oldBack();
	};*/
	var querySelector = function(selector) {
		return document.querySelector(selector)
	};
	var documentId; // 文章ID
	var releaseOperator = ''; //作者ID
	var articleContent; // 文章数据
	var oVideo = null; // 视频
	var collectionBtn = g("shoucang");

	var oComment = new Comment();
	var oPublish = new Publish(oComment);
	oComment.oPublish = oPublish;
	var oPraise = new Praise(oComment);
	var scrollTop = 0;

	/**
	 * 设置视频占位图片
	 */
	(function() {
		
		var imgUrl = common.utils.queryString('image');
		var videoCont = querySelector('.article-video-box');
		var clientWidth = document.documentElement.clientWidth;
		var iHeight = clientWidth * 9 / 16;
		videoCont.style.height = iHeight + 'px';
		querySelector('.mui-content').style.top = (iHeight + 44 + imbar.statusbarHeight) + 'px';
		querySelector('.video-cont').style.paddingTop = imbar.statusbarHeight + 'px';
		if(imbar.isIphoneX) {
			querySelector('.mui-content').style.bottom = (imbar.bottomSafeArea + 51) + 'px';
		}
		if(imgUrl){
			videoCont.innerHTML = '<img src="'+decodeURIComponent(imgUrl)+'" />';
		}
		documentId = common.utils.queryString('aid');
		initData(documentId);
		Funcs.creatList(documentId,'#funcs');
		var styles = document.head.appendChild(document.createElement('style'));
		styles.type = 'text/css';
		styles.innerText = '.mui-bar~.mui-pull-top-tips{top:' + (iHeight + 44) + 'px}';
	})();
	
	/*收藏*/
	var collection = {
		initStates: function(states){
			if(states == 1) {
				collectionBtn.classList.add('c-cyan');
				collectionBtn.classList.add('jcon-shoucang11');
				collectionBtn.colorchangge = true;
			} else {
				collectionBtn.colorchangge = false;
			}
		}
	};
	/*收藏*/
	collectionBtn.addEventListener('tap', function() {
		var shoucang = this;

		// 未登录
		if(!app.checkLogin()) {
			app.toLogin();
			return;
		}
		if(!this.colorchangge) {
			//1关注 
			newsSvc.collectionNews(documentId, '1').then(function() {
				mui.toast('收藏成功'); //提示内容
				shoucang.classList.add('c-cyan');
				shoucang.classList.add('jcon-shoucang11');
				shoucang.colorchangge = true;
			});
		} else {
			//0取消关注
			newsSvc.collectionNews(documentId, '0').then(function() {
				mui.toast('取消收藏成功');
				shoucang.classList.remove('c-cyan');
				shoucang.classList.remove('jcon-shoucang11');
				shoucang.colorchangge = false;
			});
		};
	});

	
	/**
	 * 初始化数据
	 * @param {Object} id
	 * @param {Object} isRefresh 是否刷新
	 */
	function initData(id, isRefresh) {
		newsSvc.documentContent(id).then(function(content) {
			if(!isRefresh) {
				playVideo(content);
				showContent(content);
				/* 是否隐藏评论  */
				if(!content.isHideReview) {
					querySelector('.comment-cont').removeAttribute('hidden');
					Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {
						up: true,
						down: true
					});
				}
				shareVideo(content);
				oComment.listenDelete();//隐藏评论
				
				//神策文章详情埋点
				if(window.SDAnalytics){
					SDAnalytics.customTrack('joyArticle',{
						 jtrack_article_id:content.id,
						 jtrack_article_title:content.title,
						 jtrack_article_cid:content.documentClassSerial,
						 jtrack_article_cate:content.className,
						 jtrack_article_type:content.type,
						 jtrack_article_read:content.readAmount,
						 jtrack_article_comment:content.replyCount,
						 jtrack_article_praise:content.agreeCount,
						 jtrack_article_share:content.forwardAmount,
						 jtrack_article_collect:!!content.isCollection,
						 jtrack_article_smode: '日间',
						 jtrack_article_cswitch:!!content.isAllowReview
					});
				}
			}
			collection.initStates(content.isCollection);
			initRecommendList(content);
			/* 显示评论输入框 */
			oPublish.showCommentLayer(content);
			oPraise.init(content);
		}).catch(function(res) {
			querySelector('.comment-cont').removeAttribute('hidden');
			Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {
				up: true,
				down: true
			});
			oComment.exceptionHandler(res);
		});
	}
	
	function getParentOffsetTop(dom) {
		var top = dom.offsetTop;
		var parent = dom.offsetParent;
		while(parent) {
			top += parent.offsetTop;
			parent = parent.offsetParent;
			if(!parent) {
				break;
			}
		}
		return top;
	}

	function playVideo(content){
		var shareMsg = {
			title: content.title,
			content: content.introduce,
			thumbs:[content.image],
			href: app._webUrl + "/article.html?id=" + content.id,
			weixin_WXSceneSession:{
				type:'miniProgram',
				title: content.title,
				content: content.introduce,
				thumbs:[content.image],
				miniProgram:{
					id: 'gh_beaab2f0c619', //小程序的原始ID
					path: '/pages/article/article?type=video&id=' + content.id, //微信小程序打开的页面路径
					type: '0', // 微信小程序版本类型 0-正式版； 1-测试版； 2-体验版。 默认值为0。
					webUrl: app._webUrl + "/article.html?id=" + content.id // 兼容低版本的网页链接
				}
			},
			successCB:function(){
				newsSvc.setDocumentForwardAmount(content.id);
			}
		};
	    	joyPlayer.play({
	    		src:content.videoUrl,
	    		title:content.title,
	    		parent:document.querySelector('.article-video-box'),
	    		poster:content.image,
	    		shareMsg:shareMsg
		});
	}
	function shareVideo(content) {
		var shareMsg = {
			href: app._webUrl + "/article.html?id=" + content.id,
			title: content.title,
			content: content.introduce,
			weixin_WXSceneSession:{
				type:'miniProgram',
				title: content.title,
				content: content.introduce,
				thumbs:[content.image],
				miniProgram:{
					id: 'gh_beaab2f0c619', //小程序的原始ID
					path: '/pages/article/article?type=video&id=' + content.id, //微信小程序打开的页面路径
					type: '0', // 微信小程序版本类型 0-正式版； 1-测试版； 2-体验版。 默认值为0。
					webUrl: app._webUrl + "/article.html?id=" + content.id // 兼容低版本的网页链接
				},
			}
		};
		var oImgs = contentInfo.querySelectorAll('img');
		var pictures = [];
		var picNum = Math.min(oImgs.length, 9);
		for(var i = 0; i < picNum; i++) {
			pictures.push(oImgs[i].src);
		}
		if(content.image) {
			shareMsg.thumbs = [content.image];
		}
		shareMsg.pictures = pictures;
		share.initShare("share_button", shareMsg, function() {
			$.toast('分享成功');
			newsSvc.setDocumentForwardAmount(content.id);
		}, function(e) {
			if(e.code === -100) {
				$.toast('已取消分享');
			} else {
				$.toast('分享失败：' + e.message);
			}
		});
		share.initShare("share_button2", shareMsg, function() {
			$.toast('分享成功');
			newsSvc.setDocumentForwardAmount(content.id);
		}, function(e) {
			if(e.code === -100) {
				$.toast('已取消分享');
			} else {
				$.toast('分享失败：' + e.message);
			}
		});
	}
	function showVideoCover(content){
		var videoCont = querySelector('.article-video-box');
		if(!videoCont.querySelector('img')){
			var img = document.createElement('img');
			img.src = content.image;
			videoCont.appendChild(img);
		}
		var cover = document.createElement('div');
		cover.className='video-cover';
		cover.innerHTML='<span class="video-btn jcon jcon-play"></span>';
		cover.addEventListener('tap',function(){
			playVideo(content);
		},false);
		videoCont.appendChild(cover);
	}
	function showContent(content) {
		var author = document.querySelector('#author');
		author.innerHTML = common.utils.patternStrPlus(querySelector('#video-author').innerHTML, {
			authorName: content.authorName.length > 10 ? content.authorName.slice(0,10).concat('...') : content.authorName || '悦社',
			photoImg: content.authorHeadPath || '../images/user-photo.png',
			followType: content.isFollow == 1 ? 'followed' : 'nofollow',
			type: content.isFollow == 1 ? '1' : '0',
			content: content.isFollow == 1 ? '已关注' : '+关注'
//			readNum: content.readAmount
		});
		g('collapse').querySelector('.read-num span').innerHTML = content.readAmount;
		g('articleTitle').innerHTML = content.title;
		g('releaseDate').innerHTML = content.openTime;
		showVideoCover(content);
		setTags(content);
		releaseOperator = content.releaseOperator;
		// 关注
		g('btnFollow').addEventListener('tap',function(){
			var self = this,
				followType = self.getAttribute('data-type') == 1 ? 0 : 1;// 关注-1 取关-0
			if(!app.checkLogin()){
				app.toLogin();
				return false;
			}
			newsSvc.followMan(followType,releaseOperator).then(function(res){
				if(followType == 1){
					// 关注
					self.classList.remove('nofollow');
					self.classList.add('followed');
					self.innerHTML = '已关注';
					self.setAttribute('data-type','1');
					$.toast('关注成功');
				}else{
					// 取关
					self.classList.remove('followed');
					self.classList.add('nofollow');
					self.innerHTML = '+关注';
					self.setAttribute('data-type','0');
					$.toast('取消关注成功');
				}
			}).catch(function(err){
				$.toast(err.message);
			})
		},false)
		// 个人中心
		g('authorInfo').addEventListener('tap',function(){
			var mId = this.getAttribute('data-id');
			$.openWindow("minfo/person.html?mId=" + releaseOperator);
		},false)
	}
	function setTags(content) {
		var oTag = document.querySelector('.tag-box');
		var tags = content.keyWord && content.keyWord.split(/(,|，)/g).filter(function(val){if(',' != val&& '，'!=val)return val});
		
		Array.isArray(tags) && mui.each(tags, function(i, val){
			var oA = document.createElement('a');
			oA.setAttribute('href', 'javascript:;');
			oA.innerHTML = val;
			oTag.appendChild(oA);
			oA = null;
		})
		mui('.tag-box').on('tap', 'a', function(){
			var searchNews = plus.webview.getWebviewById('search_news');
			var words = this.innerText;
			(function(callback){
				if (searchNews) {
					searchNews.addEventListener('close',function(){
						callback();
					},false);
					searchNews.close('none');
	   			}else{
	   				callback();
	   			}
			})(function(){
				searchNews = mui.openWindow({
					url: './search_news.html?words=' + words,
					id: 'search_news'
				});
			});
		})
	}
	function initRecommendList(content){
		var recommend = querySelector('.recommend-cont');
		var targetDom = document.querySelector('.re-body');
		var moreDom = recommend.querySelector('.re-more');
		newsSvc.docLikeRecommended(content.id, 5).then(function(res){
			var htmlResult = '';
			if (0 == res.length) return;
			recommend.classList.remove('mui-hidden');
			if (3 < res.length) {
				targetDom.style.height = '324px';
			} else {
				moreDom.style.display = 'none';
			}
			res.forEach(function(val){
				
				if (val.type == 1) {
					val.isVideo = 'hidden';
				}
				val.isHavReply = !val.replyCount ? 'hidden' : '';
				htmlResult += common.utils.patternStrPlus(querySelector('#recommend').innerHTML, val);
			})
			
			targetDom && (targetDom.innerHTML = htmlResult);
		}).catch(function(err){
		})
		
		$('.recommend').on('tap', '.video-li', function(){
			var aid = this.getAttribute('aid');
			var image = this.getAttribute('image');
			var videoUrl = this.getAttribute('videourl');
			var type = this.getAttribute('type');
			
			mui.openWindow({
				url: type == 1 ? 'article.html?aid=' + aid : 'article-video.html?aid=' + aid + '&image=' + image + '&videoUrl=' + videoUrl
			})
			type == 1 && plus.navigator.setFullscreen(false);
			setTimeout(function(){
				var curView = plus.webview.currentWebview();
				curView.hide();
				curView.close();
			}, 1000)
		})
		
		var bBtn = false;
		$('.recommend').on('tap', '.re-more', function(e){
			bBtn = !bBtn;
			targetDom.style.height = bBtn ? 'auto' : '324px';
			
			if (bBtn) {
				moreDom.querySelector('.fa').classList.remove('fa-angle-down');
				moreDom.querySelector('.fa').classList.add('fa-angle-up');
			} else {
				moreDom.querySelector('.fa').classList.add('fa-angle-down');
				moreDom.querySelector('.fa').classList.remove('fa-angle-up');
			}
		})
	}

	$.plusReady(function() {
		$.currentWebview.setStyle({
			softinputMode:"adjustResize"
		});
		window.addEventListener('refresh_data', function(e) { //执行刷新
			initData(documentId, true);
			joyPlayer.playing();
			oComment.getInitCommentList(documentId, 'down');
		});
		window.addEventListener('video-playing-listen', function(e) { //执行刷新
			joyPlayer.playing();
		});
		//滚动条高度
		document.querySelector('.mui-scroll-wrapper' ).addEventListener('scroll', function (e) {
			var detail_y = -e.detail.y,
				top = document.querySelector('.comment-cont').offsetTop,
				type = document.querySelector('.go-comment-list').getAttribute('data-type');
			// 评论置顶 不需要记录
			if(type == 1){
				return false;
			}
			if(-detail_y < top && detail_y !== top){
				scrollTop = -detail_y;
			}
		})
		// 评论置顶
		$(document).on('tap', '.go-comment-list', function() {
			var that = this,
				type = that.getAttribute('data-type'),
				iTop = 0,
				scroll = scrollTop;
			document.querySelector("#pullRefresh").style.transitionDuration = ".2s";
			document.querySelector("#pullRefresh").style.webkitTransitionDuration = ".2s";
			if(type == 0){
				iTop = document.querySelector('.comment-cont').offsetTop;
				that.setAttribute('data-type',1);
				document.querySelector("#pullRefresh").style.transform = "translateY(-" + iTop + "px)";
				document.querySelector("#pullRefresh").style.webkitTransform = "translateY(-" + iTop + "px)";
				document.querySelector('#pullRefresh').classList.remove('hide');
				document.querySelector('#pullRefresh').classList.add('show');
			}else{
				iTop = -scroll;
				that.setAttribute('data-type',0);
				document.querySelector("#pullRefresh").style.transform = "translateY(-" + iTop + "px)";
				document.querySelector("#pullRefresh").style.webkitTransform = "translateY(-" + iTop + "px)";
				document.querySelector('#pullRefresh').classList.remove('show');
				document.querySelector('#pullRefresh').classList.add('hide');
			}
			mui('.mui-scroll-wrapper').scroll().scrollTo(0,-iTop);
		});
		$('.extra-controll').on('tap', '.understand-more', function(){
//			mui.fire(plus.webview.getLaunchWebview(), 'goTab', {tabid:'tab-joy'});	
//			var allWebview = plus.webview.all();
//			for (var i = 0; i < allWebview.length; i++) {
//				if (plus.webview.getLaunchWebview().id != allWebview[i].id) {
//					allWebview[i].close('none');
//				}
//			}
			$.openWindow('analysis.html','analysis');
		});
	
		//var iTop = document.body.clientWidth * 9/16 + (imbar.isIphoneX ? 50 : 0);
		var iTop = g('author').offsetTop;
		// 显示评论的回复
		$('.comment-body').on('tap', '.comment-line', function(e){
//			e.stopPropagation();
			var list = e.target.className.split(' ');
			var that = this.getElementsByClassName('reply-react')[0];
			var commentId = that.getAttribute('commentId');
			var replyId = that.getAttribute('replyId');
			if(list.indexOf('jcon-delete') == -1){
				oComment.showReplyList({artId: documentId, commentId: commentId, replyId: replyId}, false, iTop);
			}else{
			}
		});
		$('.comment-body').on('tap', '.comment-line .reply-react', function(e){
			e.stopPropagation();
			var commentId = this.getAttribute('commentId'),
				replyId = this.getAttribute('replyId'),
				closed = g('popover').className.indexOf('show') !== -1 ? true : false, // 回复列表 true -显示 false-隐藏
				repuserContent = this.getAttribute('pubContent'),
				count = parseInt(this.getAttribute('data-count')),
				showInput = count <= 0 ? true : false;
			setTimeout(function(){
				if(closed){
					oComment.showReplyList({commentId: commentId, replyId: replyId,repuserContent: repuserContent}, true,  iTop);
				}else {
					oComment.showReplyList({commentId: commentId, replyId: replyId}, showInput,  iTop);
				}
				
			},300)
		})
		// 显示评论的回复
		$('.comment-body').on('tap', '.show-all span', function(){
			var commentId = this.getAttribute('commentId');
			oComment.showReplyList({artId: documentId, commentId: commentId}, false, iTop);
		});
	});
	
	// 埋点
	function joyTrack(){
		jTrack.regEventsLive('.tag-box','a','joyKeyword','jtrack_name:文章搜索,jtrack_keyword:this.innerText,jtrack_search_type:1');
		jTrack.regEvents('#share_button','joyLinkClick','jtrack_name:文章分享(中间)');
		jTrack.regEvents('#share_button2','joyLinkClick','jtrack_name:文章分享(底部)');
		jTrack.regEvents('.understand-more','joyLinkClick','jtrack_name:了解更多');
		jTrack.regEvents('#shoucang','joyLinkClick','jtrack_name:收藏文章');
		
		// 功能入口
		jTrack.regEventsLive('#funcs','.funs','joyEntranceClick','jtrack_name:attr.title,jtrack_page:attr.jhref');
		jTrack.regEvents('.follow-count','joyPraise','jtrack_praise_type:attr.data-praise,jtrack_name:attr.title,jtrack_con_type:2,jtrack_con_id:attr.aid');
	}
	joyTrack();

})(mui);