/**
 * Created by tuchl on 2016-08-12.
 */
(function($) {
    $.init({swipeBack:true});

	var querySelector = function(selector) {
		return document.querySelector(selector)
	};
	var documentId; // 文章ID
	var releaseOperator = ''; //作者ID
	var articleContent; // 文章数据
	var contentInfo = g("contentInfo");

	var collectionBtn = g("shoucang");
	var shareBtn = g("share_button");

	var oComment = new Comment();
	var oPublish = new Publish(oComment);
	oComment.oPublish = oPublish;
	var oPraise = new Praise(oComment);
	var scrollTop = 0;

	(function() {
		documentId = common.utils.queryString('aid');
		initData(documentId);
		Funcs.creatList(documentId,'#funcs');
	}());

	/*收藏*/
	var collection = {
		initStates: function(states){
			if(states == 1) {
				collectionBtn.classList.add('c-cyan');
				collectionBtn.classList.add('jcon-shoucang11');
				collectionBtn.colorchangge = true;
			} else {
				collectionBtn.colorchangge = false;
			}
		}
	};
	/*收藏*/
	collectionBtn.addEventListener('tap', function() {
		var shoucang = this;

		// 未登录
		if(!app.checkLogin()) {
			app.toLogin();
			return;
		}
		if(!this.colorchangge) {
			//1关注 
			newsSvc.collectionNews(documentId, '1').then(function() {
				mui.toast('收藏成功'); //提示内容
				shoucang.classList.add('c-cyan');
				shoucang.classList.add('jcon-shoucang11');
				shoucang.colorchangge = true;
			});
		} else {
			//0取消关注
			newsSvc.collectionNews(documentId, '0').then(function() {
				mui.toast('取消收藏成功');
				shoucang.classList.remove('c-cyan');
				shoucang.classList.remove('jcon-shoucang11');
				shoucang.colorchangge = false;
			});
		};
	});


	// 夜间模式
	var screen = (function() {
		var screenBtn = querySelector('#read-mode');

		/**
		 * 设置阅读模式
		 * @param { Boolean } isChange （是否改变阅读模式）
		 */
		function setReadMode(isChange) {
			var defaultMode = myStorage.getItem('read');

			if(isChange) {
				defaultMode = !defaultMode;
				myStorage.setItem('read', defaultMode);
			}

			if(defaultMode) {
				querySelector('body').classList.add('night');

				screenBtn.classList.remove('jcon-moon-o');
				screenBtn.classList.add('jcon-sun');

			} else {
				querySelector('body').classList.remove('night');
				screenBtn.classList.remove('jcon-sun');
				screenBtn.classList.add('jcon-moon-o');
			}
		}
	}());

	var func = (function() {
		var screenBtn = g('read-mode');

		function theme(idx) {
			var bgs = ['#fff', '#080C10', '0,0,0', '0,0,0'];
			var cls = ['#262626', '#424952', '0,0,0', '0,0,0'];

		}

		function light(sw) {
			var defaultMode = myStorage.getItem('read');
			if(sw) {
				defaultMode = !defaultMode;
				myStorage.setItem('read', defaultMode);
			}
			if(defaultMode) {
				cover(0.5);
				screenBtn.classList.remove('jcon-moon-o');
				screenBtn.classList.add('jcon-sun');
			} else {
				jel('#lightCover').addClass('mui-hidden');
				screenBtn.classList.remove('jcon-sun');
				screenBtn.classList.add('jcon-moon-o');
			}
		}

		function cover(a, r, g, b) {
			var lightCover = document.getElementById('lightCover');
			if(!lightCover) {
				lightCover = document.createElement('div');
				lightCover.id = 'lightCover';
				lightCover.setAttribute('style', 'position:fixed;top:0;bottom:0;left:0;outline:4000px solid;z-index:99999;');
				document.body.appendChild(lightCover);
			} else {
				jel('#lightCover').removeClass('mui-hidden');
			}
			lightCover.style.outlineColor = 'rgba(' + (r || 0) + ',' + (g || 0) + ',' + (b || 0) + ',' + a + ')';
		}

		function setSize(size) {

		}

		screenBtn.addEventListener('tap', function() {
			light(true);
		}, false);

		light();

		return {
			light: cover,
			theme: theme,
			setSize: setSize
		};
	}());

	
	/**
	 * 初始化数据
	 * @param {Object} id
	 * @param {Object} isRefresh 是否刷新
	 */
	function initData(id, isRefresh) {
		newsSvc.documentContent(id).then(function(content) {
			releaseOperator = content.releaseOperator;
			if(!isRefresh) {
				setTitleView(content);
				g('loading').classList.add('ani-hidden');
				var shareMsg = {
					title: content.title,
					content: content.introduce,
					thumbs:[content.image],
					href: app._webUrl + "/article.html?id=" + content.id,
					weixin_WXSceneSession:{
						type:'miniProgram',
						title: content.title,
						content: content.introduce,
						thumbs:[content.image],
						miniProgram:{
							id: 'gh_beaab2f0c619', //小程序的原始ID
							path: '/pages/article/article?type=art&id=' + content.id, //微信小程序打开的页面路径
							type: '0', // 微信小程序版本类型 0-正式版； 1-测试版； 2-体验版。 默认值为0。
							webUrl: app._webUrl + "/article.html?id=" + content.id// 兼容低版本的网页链接
						},
					},
				};
				var oImgs = contentInfo.querySelectorAll('img');
				var pictures = [];
				var picNum = Math.min(oImgs.length, 9);
				for(var i = 0; i < picNum; i++) {
					pictures.push(oImgs[i].src);
				}

				if(content.image) {
					shareMsg.thumbs = [content.image];
				}
				shareMsg.pictures = pictures;

				share.initShare("share_button", shareMsg, function() {
					$.toast('分享成功');
					newsSvc.setDocumentForwardAmount(content.id);
				}, function(e) {
					if(e.code === -100) {
						$.toast('已取消分享');
					} else {
						$.toast('分享失败：' + e.message);
					}
				});
				share.initShare("share_button2", shareMsg, function() {
					$.toast('分享成功');
					newsSvc.setDocumentForwardAmount(content.id);
				}, function(e) {
					if(e.code === -100) {
						$.toast('已取消分享');
					} else {
						$.toast('分享失败：' + e.message);
					}
				});
				jel('.article_content img').attr("data-preview-src", "");
				jel('.article_content img').attr("data-preview-group", "1");
				$.previewImage();

				/* 是否隐藏评论  */
				if(!content.isHideReview) {
					querySelector('.comment-cont').removeAttribute('hidden');
	           	 	Pull.init(documentId, oComment.getInitCommentList.bind(oComment), {up: true});
				}
				oComment.listenDelete(); //监听删除
				
				/* 显示评论 */
				oPublish.showCommentLayer(content);
				
				//神策文章详情埋点
				if(window.SDAnalytics){
					var smode = g('read-mode').classList.contains('jcon-moon-o')?'日间':'夜晚';
					SDAnalytics.customTrack('joyArticle',{
						 jtrack_article_id:content.id,
						 jtrack_article_title:content.title,
						 jtrack_article_cid:content.documentClassSerial,
						 jtrack_article_cate:content.className,
						 jtrack_article_type:content.type,
						 jtrack_article_read:content.readAmount,
						 jtrack_article_comment:content.replyCount,
						 jtrack_article_praise:content.agreeCount,
						 jtrack_article_share:content.forwardAmount,
						 jtrack_article_collect:!!content.isCollection,
						 jtrack_article_smode: smode,
						 jtrack_article_cswitch:!!content.isAllowReview
					});
				}
			}
			collection.initStates(content.isCollection);
			oPraise.init(content);
			initRecommendList(content);
		}).catch(function(res) {
			g('loading').classList.add('ani-hidden');
		});
	}

	/**
	 * 设置标题
	 * @param {Object} content 文章相关信息
	 */
	function setTitleView(content) {
		var titView = querySelector('.mui-title');
		var html = '',authorName = '';
		var userPhoto;

		if(!content.authorName) {
			html = '<div id="aTitle"><img src="../images/joyshebao.png" />悦社</div>';
		} else {
			html = '<div id="aTitle"><img src="' + (content.authorHeadPath || '../images/user-photo.png') + '" />' + (content.authorName || '悦社') + '</div>';
		}
		if(content.authorName.length > 10){
			authorName = content.authorName.slice(0,10).concat('...');
		}else {
			authorName = content.authorName;
		}
		titView.innerHTML = html;
		g('articleTitle').innerHTML = content.title;
		g('read-amount').innerHTML = content.readAmount + '次阅读';
		g('releaseDate').innerHTML = content.openTime;
		g('articleContent').innerHTML = content.content;
		setTags(content);
		g('author').setAttribute('data-id',content.id);
		g('author').querySelector('.photo').setAttribute('src',content.authorHeadPath || "../images/user-photo.png");
		g('author').querySelector('.name').innerHTML = authorName;
		// 已关注-1 取消关注-0
		g('btnFollow').classList[content.isFollow == 1 ? 'remove' : 'add']('nofollow');
		g('btnFollow').classList[content.isFollow == 1 ? 'add' : 'remove']('followed');
		g('btnFollow').innerHTML = content.isFollow == 1 ? '已关注' : '+关注';
		g('btnFollow').setAttribute('data-type',content.isFollow);
	}
	
	function setTags(content) {
		var oTag = document.querySelector('.tag-box');
		var tags = content.keyWord && content.keyWord.split(/(,|，)/g).filter(function(val){if(',' != val&& '，'!=val)return val});
		
		Array.isArray(tags) && mui.each(tags, function(i, val){
			var oA = document.createElement('a');
			oA.setAttribute('href', 'javascript:;');
			oA.innerHTML = val;
			oTag.appendChild(oA);
			oA = null;
		})
		
		mui('.tag-box').on('tap', 'a', function(){
			var searchNews = plus.webview.getWebviewById('search_news');
			var words = this.innerText;
			var times = 0;
			
			if (searchNews) {
				searchNews.hide();
				searchNews.close();
				times = 200;
	   		} 
	   		setTimeout(function(){
	   			mui.openWindow({
					url: './search_news.html?&words=' + words,
					id: 'search_news'
				})	
	   		}, times)
		})
	}
	// 相关推荐
	function initRecommendList(content){
		var recommend = querySelector('.recommend-cont');
		
		newsSvc.docLikeRecommended(content.id).then(function(res){
			var htmlResult = '';
			if (0 == res.length) return;
			recommend.classList.remove('mui-hidden');
			res.forEach(function(val){
				if (val.type == 1) {
					val.isVideo = 'hidden';
				}
				htmlResult += common.utils.patternStrPlus(querySelector('#recommend').innerHTML, val);
			})
			var targetDom = document.querySelector('.recommend .mui-scroll');
			targetDom && (targetDom.innerHTML = htmlResult);	
		}).catch(function(err){})
		$('.recommend').on('tap', '.video-li', function(){
			var aid = this.getAttribute('aid');
			var image = this.getAttribute('image');
			var videoUrl = this.getAttribute('videourl');
			var type = this.getAttribute('type');
			
			mui.openWindow({
				url: type == 1 ? 'article.html?aid=' + aid : 'article-video.html?aid=' + aid + '&image=' + image + '&videoUrl=' + videoUrl
			})
			setTimeout(function(){
				var curView = plus.webview.currentWebview();
				curView.hide();
				curView.close();
			}, 1000)

		})
		$('.mui-scroll-wrapper2').scroll({bounce: false,  scrollX: true});
		
		$('.recommend').on('tap', '.re-more', function(e){
			mui.back();
		})
	}

	$.plusReady(function() {
		$.currentWebview.setStyle({
			softinputMode:"adjustResize"
		});
		window.addEventListener('refresh_data', function(e) { //执行刷新
			initData(documentId, true);
			oComment.getInitCommentList(documentId, 'down');
		});
		//滚动条高度
		document.querySelector('.mui-scroll-wrapper' ).addEventListener('scroll', function (e) {
			var detail_y = -e.detail.y,
				top = document.querySelector('.comment-cont').offsetTop,
				type = document.querySelector('.go-comment-list').getAttribute('data-type');
			// 评论置顶 不需要记录
			if(type == 1){
				return false;
			}
			if(-detail_y < top && detail_y !== top){
				scrollTop = -detail_y;
			}
		})
		//评论切换
		$(document).on('tap', '.go-comment-list', function() {
			var that = this,
				type = that.getAttribute('data-type'),
				iTop = 0,
				scroll = scrollTop;
			document.querySelector("#pullRefresh").style.transitionDuration = ".2s";
			document.querySelector("#pullRefresh").style.webkitTransitionDuration = ".2s";
			if(type == 0){
				// 评论置顶
				iTop = document.querySelector('.comment-cont').offsetTop;
				that.setAttribute('data-type',1);
				document.querySelector("#pullRefresh").style.transform = "translateY(-" + iTop + "px)";
				document.querySelector("#pullRefresh").style.webkitTransform = "translateY(-" + iTop + "px)";
				document.querySelector('#pullRefresh').classList.remove('hide');
				document.querySelector('#pullRefresh').classList.add('show');
			}else{
				iTop = -scroll;
				that.setAttribute('data-type',0);
				document.querySelector("#pullRefresh").style.transform = "translateY(-" + iTop + "px)";
				document.querySelector("#pullRefresh").style.webkitTransform = "translateY(-" + iTop + "px)";
				document.querySelector('#pullRefresh').classList.remove('show');
				document.querySelector('#pullRefresh').classList.add('hide');
			}
			mui('.mui-scroll-wrapper').scroll().scrollTo(0,-iTop);
		});
		$('.extra-controll').on('tap', '.understand-more', function(){
			mui.fire(plus.webview.getLaunchWebview(), 'goTab', {tabid:'tab-joy'});
			var allWebview = plus.webview.all();
			for (var i = 0; i < allWebview.length; i++) {
				if (plus.webview.getLaunchWebview().id != allWebview[i].id) {
					allWebview[i].close('none');
				}
			}
		});
	
		var iTop = imbar.getStatusbar().statusbarHeight + 44;
		// 显示评论的回复
		$('.comment-body').on('tap', '.comment-line', function(e){
//			e.stopPropagation();
			var list = e.target.className.split(' ');
			var that = this.getElementsByClassName('reply-react')[0];
			var commentId = that.getAttribute('commentId');
			var replyId = that.getAttribute('replyId');
			if(list.indexOf('jcon-shanchu') == -1){
				oComment.showReplyList({commentId: commentId, replyId: replyId}, false,  iTop);
			}else{
			}
		})
		
		$('.comment-body').on('tap', '.comment-line .reply-react', function(e){
			e.stopPropagation();
			var commentId = this.getAttribute('commentId'),
				replyId = this.getAttribute('replyId'),
				closed = g('popover').className.indexOf('show') !== -1 ? true : false,
				repuserContent = this.getAttribute('pubContent'),
				count = parseInt(this.getAttribute('data-count')),
				showInput = count <= 0 ? true : false;
			setTimeout(function(){
				if(closed){
					oComment.showReplyList({commentId: commentId, replyId: replyId,repuserContent: repuserContent}, true,  iTop);
				}else {
					oComment.showReplyList({commentId: commentId, replyId: replyId}, showInput,  iTop);
				}
				if(mui.os.ios){
					app.openSoftKeyboard();
				}
			},300)
		})
				
		// 显示评论的回复
		$('.comment-body').on('tap', '.show-all span', function(){
			var commentId = this.getAttribute('commentId');
			oComment.showReplyList({commentId: commentId}, false, iTop);
		})
		
		// 搜索页面
		mui('.mui-bar').on('tap','#read-search',function(){
			$.openWindow({
				url: "search_all.html",
				waiting:{autoShow:false}
			})
		})
		
		// 关注
		g('btnFollow').addEventListener('tap',function(){
			var self = this,
				followType = self.getAttribute('data-type') == '0' ? '1' : '0';
			if(!app.checkLogin()){
				app.toLogin();
				return false;
			}
			newsSvc.followMan(followType,releaseOperator).then(function(res){
				if(followType == 1){
					// 关注
					self.classList.remove('nofollow');
					self.classList.add('followed');
					self.innerHTML = '已关注';
					self.setAttribute('data-type','1');
					$.toast('关注成功');
				}else{
					// 取关
					self.classList.remove('followed');
					self.classList.add('nofollow');
					self.innerHTML = '+关注';
					self.setAttribute('data-type','0');
					$.toast('取消关注成功');
				}
			}).catch(function(err){
				$.toast(err.message);
			})
		},false)
		
		// 个人中心
		g('author').addEventListener('tap',function(){
			var mId = this.getAttribute('data-id');
			$.openWindow("minfo/person.html?mId=" + releaseOperator);
		},false)

	});
	// 埋点
	function joyTrack(){
		jTrack.regEventsLive('.tag-box','a','joyKeyword','jtrack_name:文章搜索,jtrack_keyword:this.innerText,jtrack_search_type:1');
		jTrack.regEvents('#share_button','joyLinkClick','jtrack_name:文章分享(中间)');
		jTrack.regEvents('#share_button2','joyLinkClick','jtrack_name:文章分享(底部)');
		jTrack.regEvents('#shoucang','joyLinkClick','jtrack_name:收藏文章');
		// 功能入口
		jTrack.regEventsLive('#funcs','.funs','joyEntranceClick','jtrack_name:attr.title,jtrack_page:attr.jhref');
		jTrack.regEvents('.follow-count','joyPraise','jtrack_praise_type:attr.data-praise,jtrack_name:attr.title,jtrack_con_type:2,jtrack_con_id:attr.aid');
	}
	joyTrack();

})(mui);