(function($, doc) {
	$.init({
		beforeback:function(){
			document.activeElement.blur();
			if(plus.navigator.isImmersedStatusbar()) {
				plus.navigator.setStatusBarStyle('light');
			}
		}
	});
    var sec = 0;
    var ouser = null;

	var regButton = doc.getElementById('reg');
	var mobileBox = doc.getElementById('mobile');
	var mcodeBox = doc.getElementById('mcode');
	var getMcodeBtn = doc.getElementById("getMcode");


	var bindMobile = function () {
		var mobile= mobileBox.value,rcode=mcodeBox.value;
		if(!/^1\d{10}$/.test(mobile)){
			$.toast('手机号码错误');
			return;
		}
		if (!/^\d{4,6}$/.test(rcode)) {
			$.toast('验证码错误');
			return;
		}
		var loginfo = {mobile:mobile,rcode:rcode},
			cusInfo = app.getDeviceInfo(),
			city = app.getCity();
		$.extend(loginfo,ouser,cusInfo,city);
		var thePromise;
		plus.nativeUI.showWaiting('正在绑定第三方账号...');
		if(ouser.thirdType=='weixin'){
			thePromise = userSvc.wxUserBind(loginfo);
		}else{
			thePromise = userSvc.oauthLoginNoUser(loginfo);
		}
		thePromise.then(function(data){
			plus.nativeUI.closeWaiting();
			$.toast('绑定成功');
			var login = plus.webview.getWebviewById('login');
			if(login) login.close('none');
			app.createState(data);
			app.appRefresh();
			$.back();
		}).catch(function(err){
			plus.nativeUI.closeWaiting();
			$.toast(err.message);
			console.error(err.message,err);
		});
	};
	
    var getRcode = function () {
    	if(getMcodeBtn.getAttribute("run")==="1") return;
        var intSms = null;
        if(sec>0){
            //$.toast(sec+"秒后再次获取");
            return;
        }else if(!/^1\d{10}$/.test(mobileBox.value)){
            $.toast('请输入正确的手机号码');
        }else{
            getMcodeBtn.innerHTML = '<i class="mui-spinner" style="margin-top:4px"></i>';
            var thePromise;
            thePromise = ouser.thirdType=='weixin'?
            	userSvc.wxGetBindMessageCode(mobileBox.value) :
            	userSvc.sendOptSms(mobileBox.value,'LOGIN_AuthCode');
            thePromise.then(function (data) {
                $.toast('验证码已发送');
                sec = 60;
                intSms = setInterval(function () {
                	getMcodeBtn.setAttribute("run","1");
                    sec--;
                    if(sec <= 0){
                        clearInterval(intSms);
                        getMcodeBtn.setAttribute("run","0");
                        getMcodeBtn.innerHTML = '获取验证码';
                    }else{
                        getMcodeBtn.innerHTML = sec+'s';
                    }
                },1000);
            }).catch(function (err) {
            	getMcodeBtn.setAttribute("run","0");
                getMcodeBtn.innerHTML = '获取验证码';
                $.toast(err.message);
                console.error(err.message,err);
            });
        }
    };

	getMcodeBtn.addEventListener('tap',getRcode,false);
	regButton.addEventListener('tap', bindMobile,false);
	
	/*doc.getElementById("mobile").addEventListener('focus',function(){
		document.getElementById("tipTxt").style.visibility='hidden';
	},false);
	doc.getElementById("mcode").addEventListener('blur',function(){
		document.getElementById("tipTxt").style.visibility='visible';
	},false);*/

	$.plusReady(function() {
		var oauths = {weixin:'微信',qq:'QQ',sinaweibo:'新浪微博',xiaomi:'小米',alipay:'支付宝'};
		var ws = plus.webview.currentWebview();
		ouser = ws.ouser;
		jel('#oathName').html(oauths[ouser.thirdType]);
		jel('#headImg').attr('src',ouser.head);
		jel('#nickName').html(ouser.nickname);
	});
}(mui, document,auth,userSvc));