(function($,doc,app,auth) {
	$.init({
		swipeBack: true,
		swipe: true,
		beforeback:function(){
			document.activeElement.blur();
			if(plus.navigator.isImmersedStatusbar()) {
				plus.navigator.setStatusBarStyle('light');
			}
		}
	});
	var privacyUrl = app._webUrl+'/agreement/privacy.html';
	var agreeUrl = app._webUrl+'/agreement/user-agreement.html';
	var auths = [];
	var loginUser = null;
	
	var oauthArea = doc.querySelector('.oauth-area .oauth-btns'); 
	var loginButton = doc.getElementById('login');
	var accountBox = doc.getElementById('account');
	var passwordBox = doc.getElementById('password');
	var mobileBox = doc.getElementById('mobile');
	var mcodeBox = doc.getElementById('mcode');
	var regButton = doc.getElementById('reg');
	var forgetButton = doc.getElementById('forgetPassword');
	var watchPassButton = doc.getElementById('watchPass');
	var getMcodeBtn = doc.getElementById("getMcode");

	var appendOauthBtn = function(el,auths){
		var faIcon = {
			weixin:'jcon jcon-weixin',
			sinaweibo:'jcon jcon-weibo',
			qq:'jcon jcon-qq',
			alipay:'jcon jcon-alipay'
		};
		var coln = (12/auths.length);
		for (var i in auths) {
			var auth = auths[i];
			var col = doc.createElement('div');
			col.className="mui-col-xs-"+coln;
			col.innerHTML='<span authId="'+auth.id+'" class="oauth-btn '+faIcon[auth.id]+'"></span>';
			el.appendChild(col);
		}
	};
	var loginBack = function(){
		app.appRefresh();
		plus.webview.currentWebview().close();
	};
	var openBindMobile = function(ouser){
		var bindWin = $.openWindow({
			url:'auth-bind.html',
			id:'bind',
			waiting:{
				autoShow:true,
				title:'用户未绑定,即将打开绑定页面...',
			},
			extras:{
				ouser:ouser
			}
		});
	};
	var getRcode = function (sec,intSms) {
 		if(getMcodeBtn.getAttribute("run")==="1") return;
		if(!/^1\d{10}$/.test(mobileBox.value)){
			return $.toast('请输入正确的手机号码');
		}
		getMcodeBtn.innerHTML = '<i class="mui-spinner" style="margin:10px"></i>';
		var clearBtn = document.querySelector('#mobile~.mui-icon-clear');
		userSvc.sendOptSms(mobileBox.value,'LOGIN_AuthCode').then(function (data) {
			mcodeBox.focus();
			$.toast('验证码已发送');
			sec = 60;
			intSms = setInterval(function () {
				getMcodeBtn.setAttribute("run","1");
				sec--;
				if(sec <= 0){
					clearInterval(intSms);
					getMcodeBtn.setAttribute("run","0");
					getMcodeBtn.innerHTML = '获取验证码';
					
					if(clearBtn){
						clearBtn.style.right=g('getMcode').offsetWidth+'px';
					}
				}else{
					getMcodeBtn.innerHTML = sec+'s';
					if(clearBtn){
						clearBtn.style.right=g('getMcode').offsetWidth+'px';
					}
				}
			},1000);
		}).catch(function (err) {
			getMcodeBtn.setAttribute("run","0");
			getMcodeBtn.innerHTML = '重新获取';
			$.toast(err.message);
			console.error(err.message,err);
		});
	};
	
	var login = function(mobile,pwd, callback) {
	    callback = callback || $.noop;
	    if (!/^1\d{10}$/.test(mobile)) {
	        return callback('手机号码不正确');
	    }
	    if (pwd.length < 6) {
	        return callback('密码不少于6个字符');
	    }
		var loginfo = {mobile:mobile,password:pwd},
			cusInfo = app.getDeviceInfo(),
			city = app.getCity();
		$.extend(loginfo,cusInfo,city);
		plus.nativeUI.showWaiting('正在登录...');
	    return userSvc.login(loginfo).then(function(data){
	    	app.createState(data);
			loginBack();
			plus.nativeUI.closeWaiting();
	    }).catch(function(err){
	    	plus.nativeUI.closeWaiting();
	    	callback(err.message);
	    	console.error(err.message,err);
	    });
	};
	var msgLogin = function(mobile,mcode,callback){
		callback = callback || $.noop;
	    if(!/^1\d{10}$/.test(mobile)){
	        return callback('手机号码错误');
	    }
	    if (!/^\d{4,}$/.test(mcode)) {
	        return callback('短信验证码错误');
	    }
		if (!checkAgreement(mobile,g('login'))) {
		    return callback('须同意“用户协议”和“隐私政策”');
		}

		var loginfo = {mobile:mobile,rcode:mcode},
			cusInfo = app.getDeviceInfo(),
			city = app.getCity();
		$.extend(loginfo,cusInfo,city);
		
		window.plus&&plus.nativeUI.showWaiting('正在登录...');
	    userSvc.msLogin(loginfo).then(function(data){
			app.createState(data);
			loginBack();
			plus.nativeUI.closeWaiting();
	    }).catch(function(err){
		    	plus.nativeUI.closeWaiting();
		    	if(err.code!==0){
		    		callback(err.message);
		    	}
		    	console.error(err.message,err);
	    });
	};	
	var oauthLogin = function(){
		document.activeElement.blur();
		var lbtn = this;
		var oauth = auth.oauths[lbtn.getAttribute('authId')];
		plus.nativeUI.showWaiting("正在请求第三方认证...");
		oauth.login(function(e) {
			plus.nativeUI.showWaiting('正在获取认证信息...');
			oauth.getUserInfo(function(userInfo) {
				plus.nativeUI.closeWaiting();
				loginUser = oauth;
				var user = auth.getOauthUser(oauth);
				if (!checkAgreement(user.openId,lbtn)) {
					$.toast('须同意“用户协议”和“隐私政策”');
				}else{
					joyLogin(oauth);
				}
			}, function(e) {
				plus.nativeUI.closeWaiting();
				$.toast("认证登录失败:" + e.message);
			});
		}, function(e) {
			plus.nativeUI.closeWaiting();
			$.toast("认证登录失败:" + e.message);
		});
    };
    
	var joyLogin = function(oauth) {
		plus.nativeUI.showWaiting('正在登录查悦社保...');
		var loginfo = {},
			ouser = auth.getOauthUser(oauth),
			cusInfo = app.getDeviceInfo(),
			city = app.getCity();
		$.extend(loginfo, ouser, cusInfo, city);
		var loginFun = oauth.id == 'weixin' ? userSvc.wxLogin : userSvc.oauthLogin;
		loginFun(loginfo).then(function(data) {
			plus.nativeUI.closeWaiting();
			$.toast("认证登录成功");
			app.createState(data);
			loginBack();
		}).catch(function(err) {
			plus.nativeUI.closeWaiting();
			if(err.code == '30010' || err.code == 'cu0003' || err.code == 'cu0008' || err.code == 'WX0008') {
				openBindMobile(ouser);
			} else {
				$.toast(err.message);
			}
			console.error(err.message, err);
		});
	};

	var initViews = function(){
		g('conbox').style.height = (document.documentElement.clientHeight-120)+'px';
		document.querySelector('#agreements .mui-scroll-wrapper').style.top=imbar.statusbarHeight+'px';
		g('wellcome').style.paddingTop=imbar.navBarHeight+'px';
	};
	var setStatusBarColor = function(dark){
		if(imbar.isImmersedStatusbar){
			plus.navigator.setStatusBarStyle(dark?'dark':'light');
		}
	};
	
	var loginBtn;
	var checkAgreement = function(uid,btn){
		loginBtn = btn;
		var agreement = myStorage.getItem('agreement')||{};
		if(!agreement[uid]){
			showAgreement(uid,btn);
			return false;
		}
		return true;
	};
	
	var showAgreement = function(uid){
		g('mask').classList.add('active');
		g('agreements').classList.add('active');
		g('agreements').setAttribute('uid',uid);
	};
	
	g('quitAgree').addEventListener('tap',function(){
		g('mask').classList.remove('active');
		g('agreements').classList.remove('active');
	},false);
	
	g('sureAgree').addEventListener('tap',function(){
		var uid = g('agreements').getAttribute('uid');;
		var agreement = myStorage.getItem('agreement')||{};
		agreement[uid] = Date.now();
		myStorage.setItem('agreement',agreement);
		g('mask').classList.remove('active');
		g('agreements').classList.remove('active');
		if(loginBtn.id=='login') {
			$.trigger(loginBtn,'tap');
		}else{
			joyLogin(loginUser);
		}
	},false);
	
	g('mobile').addEventListener('focus',function(){
		var clearBtn = this.parentNode.querySelector('.mui-icon-clear');
		if(clearBtn){
			clearBtn.style.right=g('getMcode').offsetWidth+'px';
		}
	},false);
	
	g('getMcode').addEventListener('tap',function(){
		getRcode(0,null);
	},false);
	
	g('login').addEventListener('tap', function(event) {
		mui.currentWebview.setStyle({mask:'rgba(0,0,0,0.1)'});
		document.activeElement.blur();
		setTimeout(function(){
			msgLogin(mobileBox.value, mcodeBox.value,function(msg){
				mui.currentWebview.setStyle({mask:'none'});
				$.toast(msg);
			});
		},10);
		
	},false);
	$('.oauth-btns').on('tap', '.oauth-btn',oauthLogin);

	window.addEventListener('scroll',function(e){
		var scrollTop = e.detail ? Math.abs(e.detail.y) :
				document.body.scrollTop|| document.documentElement.scrollTop;
		if(scrollTop<=150){
			var opacity = scrollTop/150;
			$('.mui-bar')[0].style.backgroundColor='rgba(255,255,255,'+opacity+')';
			$('.mui-title')[0].style.color='rgba(0,0,0,'+opacity+')';
		}else{
			$('.mui-bar')[0].style.backgroundColor='rgba(255,255,255,1)';
			$('.mui-title')[0].style.color='rgba(0,0,0,1)';
		}
	});
	$.enterfocus('#login-form1 input', function(){
		$.trigger(loginButton, 'tap');
	});

	
	var openUserAgreement = function(){
		app.openUrl(agreeUrl);
	};
	var openPrivacyAgreement = function(){
		app.openUrl(privacyUrl);
	};
	
	$('.xieyi-box').on('tap','.agree-user',openUserAgreement);
	$('.xieyi-box').on('tap','.agree-privacy',openPrivacyAgreement);
	
	$('#agreements').on('tap','.agree-user',openUserAgreement);
	$('#agreements').on('tap','.agree-privacy',openPrivacyAgreement);
	
	
	$('.mui-bar-transparent').transparent({
	    top: 0,
	    offset: 72,
	    duration: 16,
	    scrollby:document.querySelector('.mui-scroll-wrapper')
	});
	
	$('.mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: false,
		deceleration:mui.os.ios?0.003:0.0009
    });
    
	initViews();
	
	$.plusReady(function() {
		var nw = plus.webview.currentWebview();
		nw.setStyle({
			softinputMode:"adjustPan",
		    scrollIndicator:"none"
		});
		initViews();
		setStatusBarColor(true);
		if(nw.notback) $.back = function () {};
		
		auth.setAuths(function(data,oauths){
			auths = data;
			if(auths.length>0){
				g('oauth').classList.remove('mui-hidden');
				appendOauthBtn(oauthArea,auths);
			}
		},function(err){
			
		});
		
		nw.addEventListener('popGesture',function(e){
			setStatusBarColor(false);//e.progress<50
		},false);
		nw.addEventListener('close',function(){
			setStatusBarColor(false);
		},false);
		nw.addEventListener('hide',function(){
			setStatusBarColor(false);
		},false);
		nw.addEventListener('show',function(){
			setStatusBarColor(true);
		},false);
	});
	
}(mui,document,app,auth));