/**
 * Created by tuchl on 2016-08-12.
 */
(function($) {
	var pager = {
			pageIndex: 0,
			pages: 1,
			status: 0,
			type: 2
		},
		oldBack = $.back,
		scroll, pull;
	var getListHtml = function(list) {
		var html = '';
		for(var i in list) {
			var item = list[i];
			html += [
				'<li class="order mui-table-view-cell mui-media">',
					'<div class="order-top orderTop" orderType="', item.orderType, '" buzzId="', item.buzzId, '">',
						'<div class="order-hd">',
							'订单编号 <span>', item.buzzId, '</span>',
						'</div>',
						'<img class="org-logo mui-media-object mui-pull-left" src="', item.orgLogoAddr, '" />',
						'<div class="mui-media-body',(item.orderStatus=='102' ?' border':''),'">',
							'<a class="mui-navigate-right">',
								'<p class="order-info">',
									'<span class="order-goods">', item.productName, '</span>',
									'<span class="org-name mui-ellipsis">',
										item.orgShortName, '：', item.createTime,
									'</span>',
									'<span class="org-name">',
										'订单状态：',item.orderStatusName,
									'</span>',
								'</p>',
								'<span class="order-amt">',
									item.orderAmount > 0 ? '¥'+item.orderAmount:'',
								'</span>',
							'</a>',
						'</div>',
						'<div class="orderBottom"  buzzId="',item.buzzId,'" orderStatus="',pager.status,'"></div>',
					'</div>',
				'</li>'
			].join('');
		}
		return html;
	};

	var getOrderList = function(pageIndex, pullSel, dou) {
		if(!app.checkLogin() || pageIndex > pager.pages) {
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh(true);
			return;
		}
		if(pageIndex === 1) {//第一页
			if(pullSel) pullSel.refresh(true);
			scroll.scrollTo(0, 0);
			pager.pullUpTips.style.display = 'none';
		}
		if(pageIndex === 1 && pullSel) pullSel.refresh(true);
		sbSvc.getOrderListByEx_new(pageIndex, 10, pager.status, pager.type).then(function(data) {
			pager.pageIndex = data.pageNum || 1;
			pager.pages = data.pages || 1;
			if(pager.pageIndex === 1) {
				g('list').innerHTML = '';
			}
			g('list').innerHTML += getListHtml(data.list);
			pager.pullUpTips.style.display = data.total < 10 ? 'none' : 'block';
			if(data.total === 0) g('list').innerHTML = '<div class="not-network"><span>您还没有此类订单</span></div>';
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh(data.pageNum === data.pages);
		}).catch(function(err) {
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh();
			if(err.code=='0') g('list').innerHTML = '<div class="not-network"><span>点击页面 重新加载</span></div>';
			console.error(err.message,err);
		});
	};

	var openOrderDetail = function() {
		var buzzId = this.getAttribute("buzzId");
		var orderType = this.getAttribute("orderType");
		$.openWindow({
			url:"order-detail-zhongan.html?buzzId=" + buzzId + "&orderType=" + orderType,
			id: "order",
			waiting: {
				autoShow: false
			}
		});
	};

	$.init();
	window.addEventListener('refresh_data', getOrderList, false);
	$.ready(function() {
		if(imbar.isImmersedStatusbar) {
			g('wrapper').style.top = imbar.statusbarHeight+44+'px';
		} else {
			g('wrapper').style.top = '68px';
		}
		
		$('#list').on('tap', '.orderTop', openOrderDetail);

		$('#list').on('tap', '.not-network', function() {
			pull.pullDownLoading();
		});
		scroll = $('.mui-scroll-wrapper').scroll({
			bounce: false,
			indicators: true,
			deceleration: mui.os.ios ? 0.003 : 0.0009
		});
		pull = $('#pullRefresh').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getOrderList(1, self, true);
					}, 10);
				}
			},
			up: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getOrderList(pager.pageIndex + 1, self, false);
					}, 10);
				}
			}
		});
		pager.pullUpTips = g('pullRefresh').querySelector('.mui-pull-bottom-tips');
		pager.pullUpTips.style.display = 'none';
		pull.pullDownLoading();
	});

	window.addEventListener('refresh_data', function() {
		pull.pullDownLoading();
	}, false)
})(mui);