var functionConfig =  {
	"订单": {
		"isCheckLogin": true,
		"icon": "order",
		"title": "订单",
		"des": "查询我的订单",
		"target": {
			"app" : {
				"url": "_www/view/order-list.html"
			}
		}
	},
	"医院": {
		"icon": "hospital",
		"title": "医院",
		"des": "查询附近医院地点",
		"target": {
			"app" : {
				"url": "_www/view/joy-map.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?wd='+encodeURIComponent(this.title);
				}
			}
		}
	},
	"药房": {
		"icon": "pharmacy",
		"title": "药房",
		"des": "查询附近药房地点",
		"target": {
			"app" : {
				"url": "_www/view/joy-map.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?wd='+encodeURIComponent('药店');
				}
			}
		}
	},
	"社保网点": {
		"icon": "security",
		"title": "社保网点",
		"des": "查询附近服务网点",
		"target": {
			"app" : {
				"url":"_www/view/joy-map.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?wd='+encodeURIComponent('社会保险局');
				}
			}	
		}
		
	},
	"公积金网点": {
		"icon": "fund",
		"title": "公积金网点",
		"des": "查询附近公积金网点",
		"target": {
			"app" : {
				"url": "_www/view/joy-map.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?wd='+encodeURIComponent('住房公积金管理中心');
				}
			}
		}
	},
	"社保查询": {
		"isCheckLogin": true,
		"icon": "security",
		"title": "社保查询",
		"des": "在线查询社保余额入账明细",
		"target": {
			"app" : {
				"url": "_www/view/sbk-info.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?id=' + userData.securityAcctId;
				}
			},
			"wechat": {
				"url": "/pages/securitycard/security.detail/security.detail",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?securityAcctId=' + userData.securityAcctId;
				}
			}
		}
	},
	"公积金查询": {
		"isCheckLogin": true,
		"icon": "fund-query",
		"title": "公积金询",
		"des": "在线查询社保余额入账明细",
		"target": {
			"app": {
				"url": "_www/view/gjj-info.html",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?id=' + userData.fundAcctId;
				}
			},
			"wechat": {
				"url": "/pages/fundcard/fund.detail/fund.detail",
				"createNewTarget": function(userData, url){
					if (!url || -1 < url.indexOf('?')) return url;
					return url += '?fundAcctId=' + userData.fundAcctId;
				}
			}
		}	
	},
	"养老保险": {
		"icon": "personal",
		"title": "养老保险",
		"des": "养老保险收益计算，养老金额度",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('养老', '100400', userData);
				}
			}
		},
		
	},
	"医疗保险": {
		"icon": "medic",
		"title": "医疗保险",
		"des": "医疗保险实际比例和报销保障",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('医疗', '100100', userData);
				}
			}
		}
	},
	"工伤保险": {
		"icon": "injury",
		"title": "工伤保险",
		"des": "工伤保险赔偿额度和保障",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('工伤', '100300', userData);
				}
			}
		}
	},
	"生育保险": {
		"icon": "bearing",
		"title": "生育保险",
		"des": "生育保险报销金额和津贴额度",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('生育', '100200', userData);
				}
			}
		}
	},
	"失业保险": {
		"icon": "lostjob",
		"title": "失业保险",
		"des": "失业保险领取条件和额度",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('失业', '100500', userData);
				}
			}
		}
	},
	"子女上学": {
		"icon": "children-school",
		"title": "子女上学",
		"des": "解读当地子女上学政策",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('子女上学', '0', userData);
				}
			}
		}
	},
	"买车": {
		"icon": "buy-car",
		"title": "买车",
		"des": "解读当地购车政策，",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('买车', '0', userData);
				}
			}
		}
	},
	"买房": {
		"icon": "buy-house",
		"title": "买房",
		"des": "解读当地买房政策",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('买房', '0', userData);
				}
			}
		}
	},
	"居住证/落户": {
		"icon": "residence-permit",
		"title": "居住证/落户",
		"des": "解读居住证/落户,当地政策法规",
		"target": {
			"wechat": {
				"url": "/pages/insurance/insurance",
			},
			"app": {
				"url": "",
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('居住证/落户', '0', userData);
				}
			}
		}
	},
	"问题咨询": {
		"isCheckLogin": true,
		"icon": "custom_pay",
		"title": "问题咨询",
		"des": "专业的社保查询工具,数据清晰",
		"target": {
			"app": {
				"url": "_www/view/login-zixun.html"
			}
		}
	},
	"社保服务": {
		"icon": "security",
		"title": "社保服务",
		"des": "社保代理+代办+咨询服务",
		"target": {
			"app": {
				"url": "_www/view/advice-cate.html"
			}
		}
	},
	"药品商城": {
		"icon": "medinice_shop",
		"title": "药品商城",
		"des": "方便快捷 闪电送货",
		"target": {
			"app": {
				"url": "http://m.ddky.com/index.html?channel=chayue"
			}
		}
	},
	"微保": {
		"icon": "wesure",
		"title": "微保",
		"des": "平安出行，立减30",
		"target": {
			"app": {
				"url": "http://m.ddky.com/index.html?channel=chayue"
			}
		}
	},
	"商业保险": {
		"icon": "insurance_bussiness",
		"title": "商业保险",
		"des": "灵活投保，社保外的贴心保障",
		"target": {
			"app": {
				"url": "_www/view/insurances.html"
			}
		}
	},
	"信用卡": {
		"icon": "credit",
		"title": "信用卡",
		"des": "智能申卡 个性定制",
		"target": {
			"app": {
				"url": "_www/view/creditNew.html"
			}
		}
	},
	"贷款": {
		"icon": "loan",
		"title": "贷款",
		"des": "无抵押 审核快",
		"target": {
			"app": {
				"url": "_www/view/daikuanNew.html"
			}
		}
	},
	"重疾": {
		"icon": "insurance_bussiness",
		"title": "重疾",
		"des": "重大疾病保险，抵御意外风险",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('重疾');
				}
			}
		}
	},
	"住院": {
		"icon": "insurance_bussiness",
		"title": "住院",
		"des": "全面健康保障，减轻家庭经济负担",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('住院');
				}
			}
		}
	},
	"少儿": {
		"icon": "insurance_bussiness",
		"title": "少儿",
		"des": "提高全面保障，家庭生活安定",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('少儿');
				}
			}
		}
	},
	"女性": {
		"icon": "insurance_bussiness",
		"title": "女性",
		"des": "专享保险，专项呵护",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('女性');
				}
			}
		}
	},
	"意外": {
		"icon": "insurance_bussiness",
		"title": "意外",
		"des": "多重保证，专业呵护",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('意外');
				}
			}
		}
	},
	"养老": {
		"icon": "insurance_bussiness",
		"title": "养老",
		"des": "提供晚年幸福生活坚实保障",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('养老');
				}
			}
		}
	},
	"车险": {
		"icon": "insurance_bussiness",
		"title": "车险",
		"des": "精准报价，省心方便",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('车险');
				}
			}
		}
	},
	"财险": {
		"icon": "insurance_bussiness",
		"title": "财险",
		"des": "保障家庭、企业、个人财产安全",
		"target": {
			"app": {
				"sync": false,
				"createNewTarget": function(userData, url, requestHandle){
					requestHandle('财险');
				}
			}
		}
	},
}
// {"key":"医院"}
// {"key":"药房"}
// {"key":"社保网点"}
// {"key":"公积金网点"}
// {"key":"子女上学"}
// {"key":"买车"}
// {"key":"买房"}
// {"key":"居住证/落户"}
// {"key":"重疾"}
// {"key":"女性"}
// {"key":"住院"}
// {"key":"少儿"}
// {"key":"养老"}
// {"key":"车险"}
// {"key":"财险"},
// {"key":"社保查询"}
// {"key":"公积金查询"}
// {"key":"养老保险"}
// {"key":"工伤保险"}
// {"key":"失业保险"}
// {"key":"医疗保险"}
// {"key":"生育保险"}
// {"key":"登录咨询"}
// {"key":"付费咨询"}
// {"key":"社保服务"}
// {"key":"药品商城"}
// {"key":"信用卡"}
// {"key":"贷款"}

function Custom(masterPhoto, masterName, guestPhoto){
	// 客服头像
	this.masterPhoto = masterPhoto;
	// 访客头像
	this.guestPhoto = guestPhoto;
	this.masterName = masterName;
	// 是不是微信
	this.isWechat = navigator.userAgent.toLowerCase().indexOf('micromessenger') != -1;
	this.isAli = navigator.userAgent.toLowerCase().indexOf('alipayclient') != -1;
	this.isToutiao = navigator.userAgent.toLowerCase().indexOf('toutiao') != -1;
	// 是不是小程序
	this.isWechatApp = window.__wxjs_environment === 'miniprogram';
	this.service_end = false;
	// 是不是智能客服
	this.ai = false;
	this.scoke = null;
	this.wordinx = 0;
	this.isSpeechStart = true;
	this.textarea = document.getElementById("message");
}
Custom.prototype = {
	/**
	 * 获取用户基本信息
	 */
	getUser: function (){
		var state = {};
		var tempData;
		if(window.plus){
			var jsonStr = plus.storage.getItem("StatePlus");
			try {
				tempData = JSON.parse(jsonStr)
			} catch (e) {
				
			} finally {
				if (tempData) {
					state = tempData.data;
				}
			}
		} else {
			// 微信小程序端获取用户的信息
			tempData = this.getUrlSearch();
			return {
				userId: tempData.cid,
				token: tempData.cid ? true : false,
				securityAcctId: tempData.securityAcctId
			}
		}
		return state.info;
	},
	getUrlSearch: function(){
		var url = location.search.substring(1);
		var tempArr = url.split('&');
		var result = {};
		var index = 0;
		tempArr.forEach(function(val, i){
			index = val.indexOf('=');
			result[val.substring(0,index)] = val.substring(index+1);
		})
		return result;
	},
	/**
	* 获取device
	*/
	getDeviceInfo: function (){
		var state = {};
		var tempData;
		if(window.plus){
			var jsonStr = plus.storage.getItem("StatePlus");
			try {
				tempData = JSON.parse(jsonStr)
			} catch (e) {
				
			} finally {
				if (tempData) {
					state = tempData.data;
				}
			}
		}
		return state.cusinfo;
	},
	getCity: function(){
		var state = {};
		var tempData;
		if(window.plus){
			var jsonStr = plus.storage.getItem("city");
			try {
				tempData = JSON.parse(jsonStr)
			} catch (e) {
				
			} finally {
				if (tempData) {
					state = tempData.data;
				}
			}
		}
		return state;
	},
	isIos: function(){
		return navigator.userAgent.toLowerCase().indexOf('phone') != -1;
	},
	initData: function(appId, userId, userName, cId, deviceId, sessionId, orgi, aiId, themeColor){
		this.appId = appId;
		this.userId = userId;
		this.userName = userName;
		this.cId = cId;
		this.deviceId = deviceId;
		this.contextId = sessionId;
		this.aiId = aiId;
		this.orgi = orgi;
		this.themeColor = themeColor;
	},
	initSocketData: function(socketData){
		this.socketData = socketData;
	},
	initView: function(){
		var This = this;
		if(!window.name){         
			var str = Math.random().toString(36).substr(2);//随机字符串        
			window.location.href += '&S='+ str;//兼容微信浏览器刷新
			window.name = 'isreload';    
		}
		var editor , words , textheight , wordinx = 0 ;
		
		/**
		 * 文本框根据输入内容自适应高度
		 * @param                {HTMLElement}        输入框元素
		 * @param                {Number}                设置光标与输入框保持的距离(默认0)
		 * @param                {Number}                设置最大高度(可选)
		 */
		var autoTextarea = function (elem, extra, maxHeight) {
			extra = extra || 0;
			var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
			isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
			addEvent = function (type, callback) {
				elem.addEventListener ?
						elem.addEventListener(type, callback, false) :
						elem.attachEvent('on' + type, callback);
			},
			getStyle = elem.currentStyle ? function (name) {
				var val = elem.currentStyle[name];
				if (name === 'height' && val.search(/px/i) !== 1) {
					var rect = elem.getBoundingClientRect();
					return rect.bottom - rect.top -
							parseFloat(getStyle('paddingTop')) -
							parseFloat(getStyle('paddingBottom')) + 'px';
				};
				return val;
			} : function (name) {
				return getComputedStyle(elem, null)[name];
			},
			minHeight = parseFloat(getStyle('height'));
			elem.style.resize = 'none';
			var change = function () {
				var scrollTop, height,
					padding = 18,
					style = elem.style,
					emptyRE = /\S/,
					sendBtn = $('.send-btn');
				if (emptyRE.test(elem.value)) {
					sendBtn.addClass('active');	
				} else {
					sendBtn.removeClass('active');
					return;
				}
				if (elem._length === elem.value.length) return;
				elem._length = elem.value.length;
				if (!isFirefox && !isOpera) {
					padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
				};
				scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
				elem.style.height = minHeight + 'px';
				if (elem.scrollHeight > minHeight) {
					if (maxHeight && elem.scrollHeight > maxHeight) {
						height = maxHeight - padding;
						style.overflowY = 'auto';
					} else {
						height = elem.scrollHeight - padding;
						style.overflowY = 'hidden';
					};
					style.height = height + extra + 'px';
					scrollTop += parseInt(style.height) - elem.currHeight;
					document.documentElement.scrollTop  = document.body.scrollTop = scrollTop;
					elem.currHeight = parseInt(style.height);
				};
				changeTextArea();
				This.wordinx = This.getPositionForTextArea($('#message')[0]);
			};
		
			addEvent('propertychange', change);
			addEvent('input', change);
			addEvent('focus', function(e){
				This._scrollToBottom();
				// 隐藏选择图片和表情的层
				$('.select-input-type').hide();
				change(e);
			});
			change();
		};
		function changeTextArea(){ 
			This._changeChatBodyHeight(document.getElementById('bottom'));
		}
		
		$(document).ready(function(){
			window.addEventListener('resize', function () {
				if (document.activeElement.tagName === 'INPUT' || document.activeElement.tagName === 'TEXTAREA') {
					window.setTimeout(function () {
						document.activeElement.scrollIntoViewIfNeeded();
					}, 0)
				}
			});
		});
		This._initInputView();
		autoTextarea(this.textarea, 0, 60);// 调用
	},
	_scrollToBottom: function(){
		var This = this;
		This.timer && clearInterval(This.timer);
		var count = 0;
		This.timer = setInterval(function(){
			document.body.scrollTop = document.documentElement.scrollTop = document.body.scrollHeight;
			$('.chat-above').scrollTop($('.chat-above')[0].scrollHeight);
			count ++;
			if (4 == count) {
				clearInterval(This.timer);
			}
		}, 100);
	},
	// 修改聊天内容区域的高度
	_changeChatBodyHeight: function(minusDom){
		$("#above").height("calc(100% - "+ (minusDom.scrollHeight) +"px)");
		this._scrollToBottom();
	},
	initSpeech: function(){
		// 切换到手动输入
		var chatInput = $('.mobile-chat-bottom');
		var oSelectTypeBox = $('.select-input-type');
		var oSpeechBox = $('.speech');
		var oSwitchBox = $('.speech-switch');
		var speechTextarea = $('#speech-message');
		var This = this;
		// 切换到手动输入内容界面
		$('.speech').on('click', '.keyboard-btn', function(){
			chatInput.fadeIn();
			oSpeechBox.fadeOut();
			This._changeChatBodyHeight(document.getElementById('bottom'));
		});
		// 切换到默认界面
		chatInput.on('click', '.switch-speech-btn', function(){
			chatInput.fadeOut();
			speechTextarea.hide();
			oSpeechBox.fadeIn();
			oSelectTypeBox.fadeOut();
			This.closeFaceDialog();
			This._changeChatBodyHeight(document.querySelector('.speech-input'));
		});
		// 切换显示图片和表情输入视图
		chatInput.on('click', '.show-input-type-btn', function(){
			if ('block' == oSelectTypeBox.css('display')) {
				oSelectTypeBox.fadeOut(0);
				This.closeFaceDialog();
			} else {
				// 特殊判断如果显示表情图层
				if (This.isShowFaceDialog()) {
					This.closeFaceDialog();
				} else {
					oSelectTypeBox.fadeIn(0);	
				}
			}
			This._changeChatBodyHeight(document.getElementById('bottom'));
		});
		// 语音输入识别中
		$('.speech .speech-micro')[0].addEventListener('touchstart', function(){
			if (plus.navigator.getUserAgent().toUpperCase().indexOf('IPHONE') > -1) {
				oSwitchBox.children().fadeOut(0);
				$('.speech-send-btn').fadeOut(0);
				This.showTextarea();
				$('#speech-message').attr('placeholder', '请说话...');	
			}
			This.startSpeech();
		}, false);
		
		// 关闭语音输入
		$('.speech').on('click', '.keyboard-btn', function(){
			oSwitchBox.children().fadeOut();
			oSpeechBox.find('.keyboard-btn').fadeIn();
			This._changeChatBodyHeight(document.querySelector('#bottom'));
		});
		// 清除识别文本
		$('.speech').on('click', '.clear-speech-btn', function(){
			This._defaultStyle();
		})
		// 发送语音内容
		$('.speech').on('click', '.speech-send-btn', function(){
			This.sendMessage(This._textareaText);
			This._textareaText = '';
			This._defaultStyle();
		});
		$('.speech').on('touchstart', '.edit-send-btn', function(){
			This.sendMessage($('#speech-message').val());
			This._textareaText = '';
			This._defaultStyle();
		});
		$('#speech-message').focus(function(){
			$('.speech-input').hide();
			setTimeout(function(){
				This._changeChatBodyHeight(document.querySelector('.speech'));
			}, 200);
		})
		$('#speech-message').on('input', function(){
			$(this).scrollTop(this.scrollHeight)
		})

		$('#speech-message').blur(function(){
			$('.speech-input').fadeIn();
			This._textareaText = this.value;
			if (!This._textareaText) {
				This._defaultStyle();
			} else {
				setTimeout(function(){
					This._changeChatBodyHeight(document.querySelector('.speech'));
				}, 200);	
			}
		})
		This._changeChatBodyHeight(document.querySelector('.speech'));
	},
	// 恢复默认的样式
	_defaultStyle: function (){
		$('.keyboard-btn').fadeIn();
		$('.clear-speech-btn').hide();
		$('.speech-send-btn').fadeOut();
		$('#speech-message').val('').attr('disabled', true).hide();
		$('.speech').removeClass('show-shandow');
		$('.speech-micro .top-text').show();
		this._changeChatBodyHeight(document.querySelector('.speech'));
	},
	showTextarea: function(){
		$('#speech-message').show();
		$('.speech').addClass('show-shandow');
		$('.speech-micro .top-text').hide();
		this._changeChatBodyHeight(document.querySelector('.speech'));
	},
	_textareaText: '',
	/**
	 * @param {Function} callback
	 */
	startSpeech: function(callback){
		var oMessageSpeech = $('#speech-message');
		var oSpeechBox = $('.speech');
		var oSwitchBox = $('.speech-switch');
		this._textareaText = oMessageSpeech.val();
		var This = this;
		if (window.plus) {
			var options = {
				onstart: function(){
					oSwitchBox.children().fadeOut(0);
					$('.speech-send-btn').fadeOut(0);
					This.showTextarea();
					oMessageSpeech.attr('placeholder', '请说话...');
				},
				onend: function(e){
					This.isSpeechStart = true;
					if (This._textareaText) {
						$('.speech-send-btn').fadeIn();
						$('.clear-speech-btn').fadeIn();
						$('#speech-message').attr('disabled', false);
						oMessageSpeech.val(This._textareaText);
						This._scrollToBottom();
					} else {
						// 用户取消录音也可以触发onend
						This._defaultStyle();
					}
					
				},
				engine: 'iFly',
				timeout: 30000,
				userInterface: false
			};
//			if (!this.isSpeechStart) return;
//			this.isSpeechStart = false;
			plus.speech.startRecognize( options, function ( s ) {
				This._textareaText += s;
				
				if (plus.navigator.getUserAgent().toUpperCase().indexOf('IPHONE') > -1) {
					if (This._textareaText) {
						$('.speech-send-btn').fadeIn();
						$('.clear-speech-btn').fadeIn();
						$('#speech-message').attr('disabled', false);
						oMessageSpeech.val(This._textareaText);
						This._scrollToBottom();
					} else {
						// 用户取消录音也可以触发onend
						This._defaultStyle();
					}
				}
			}, function ( e ) {});
		
		}
	},
	/**
	 * 初始化输入框
	 */
	_initInputView: function(){
		var This = this;
//		document.addEventListener('plusready', function(){
//			if (plus.runtime.version >= '9.0.0' && This.ai) {
//				showSpeech();				
//			}
//		}, false);
		function showSpeech(){
			$('.speech').fadeIn(0);
			$('.show-input-type-btn').show();
			$('.switch-speech-btn').show();
			$('.face-btn').hide();
			$('#bottom').hide();
			This.initSpeech();
		}
// 		var shareMsg = {
// 			href: 'm.joyshebao.com',
// 			title: '查悦社保',
// 			content: '查悦社保'
// 		};
// //		shareMsg.thumbs = '/';
// //		shareMsg.pictures = pictures;
// 		share.initShare('share',shareMsg,function(){
//         	mui.toast('分享成功');
//         },function(e){
//         	mui.toast('分享失败');
//         });
	},
	openFaceDialog: function (){
		var newHeight = 0;
		if('block' != $("#faceindex").css('display')){
			$("#faceindex").fadeIn();
			newHeight = $('.chat-control')[0].scrollHeight + $("#faceindex").height();
			$('#bottom').height(newHeight + 'px');
			$('.btn-push').addClass('toggle');
		}else{
			this.closeFaceDialog();
			$('.btn-push').removeClass('toggle');
		}
		this._changeChatBodyHeight($('#bottom')[0]);
		$('.select-input-type').fadeOut(0);
		return false ;
	},
	// 关闭表情弹出层
	closeFaceDialog: function (){
		var hieght = $('.chat-control')[0].scrollHeight;
		$("#faceindex").hide();
		$("#bottom").height('auto');
		this._changeChatBodyHeight($('#bottom')[0]);
	},
	// 表情图层是不是显示
	isShowFaceDialog: function(){
		return 'block' == $('#faceindex').css('display');
	},
	// 插入表情图标
	insertImg: function (obj){
		if(this.wordinx >= 0){
			var text = $('#message').val();
			var value = text.substring(0 , this.wordinx) + "["+obj+"]" + text.substring(this.wordinx , text.length);
			$('#message').val(value);
			$('.send-btn').addClass('active');
			this.wordinx = this.wordinx + 2 + obj.length ;
		}
	},
	//多行文本框
	getPositionForTextArea: function (ctrl) {
		var CaretPos = 0;
		if (document.selection) { // IE Support
			ctrl.focus();
			var Sel = document.selection.createRange();
			var Sel2 = Sel.duplicate();
			Sel2.moveToElementText(ctrl);
			var CaretPos = -1;
			while (Sel2.inRange(Sel)) {
				Sel2.moveStart('character');
				CaretPos++;
			}
		} else if (ctrl.selectionStart || ctrl.selectionStart == '0') { // Firefox support
			CaretPos = ctrl.selectionStart;
		}
		return (CaretPos);
	},
	initFN: function(){
		var This = this;
		this.initOpenToArticle();
		this.initImageScale();
		window.onload = function(){
			$('.chat-above')[0] && $('.chat-above').scrollTop($('.chat-above')[0].scrollHeight);
		}
		document.body.addEventListener('touchmove', function(){}, false);
		
		$('#message').click(function() {
			this.wordinx = This.getPositionForTextArea(document.getElementById('message'));
			This.closeFaceDialog();
		});
		
	},
	insertMessage: function(msg){
		if ('in' == msg.calltype) {
			html = this._crateInHtml(msg);
		} else {
			html = this._createOutHtml(msg);
		}
		return html;
	},
	_crateInHtml: function(msg) {
		var childHtml = ('text' == msg.messageType ? 
		'<div class="msg">'+ msg.message + '</div>' :
		'<div class="msg pic-box scale-img"><img src="' + msg.message+ '"  /></div>');
		return '<div class="align-right">' +
		'<img class="header-photo" src="' + this.guestPhoto + '" />' +
		childHtml + '</div>';
	},
	outputJsonToHtml: function(domId){
		var htmlRE = /{[^}{]*}/i;
		var message = custom.htmlDecode($('#' + domId).attr('html'));
		var jsonStr;
		var childHtml = '';
		var parseResult = htmlRE.exec(message);
		if (parseResult && parseResult[0]) {
			jsonStr = parseResult[0].replace(/\\/g, "");
			childHtml = this._crateMsgByJson(jsonStr);
		}
		$('#' + domId).html(childHtml);
	},
	/**
	 * 创建输入消息
	 */
	_createOutHtml: function(msg){
		var tempData = null;
		var htmlRE = /{[^}{]*}/i;
		var jsonStr;
		var parseResult = htmlRE.exec(msg.message);
		if (parseResult && parseResult[0]) {
			jsonStr = parseResult[0].replace(/\\/g, "");
			childHtml = this._crateMsgByJson(jsonStr);
		} else {
			childHtml = this._createMsgByText(msg);
		}
		return '<div class="align-left">' +
			'<img class="header-photo" src="' + this.masterPhoto + '" />' +
			'<dl>' + childHtml + '</dl></div>';
	},
	// 创建特殊消息（根据json数据生成）
	_crateMsgByJson: function(parseResult){
		var childHtml = '';
		var msgObj = {};
		
		try {
			msgObj = JSON.parse(parseResult);
			// artType 属性是约定好的，如果有就是文章或者视频
			if (msgObj.artType) {
				childHtml = '<dd class="msg image-text" id="' + msgObj.artId + '" data-type="' + msgObj.artType+ '" data-title="' + msgObj.artTitle+ '">' +
					'<h3>' + msgObj.artTitle + '</h3><div class="box-relative"><img src="' + msgObj.artImage +'"/>' + 
					(2 == msgObj.artType ? '<span class="icon-video"></span>' : '')
					+ '</div>' +  (this.ai ? this._createAsk() : '')
					+ '</dd>'	
			} else {
				// 功能连接
				tempData = functionConfig[msgObj.key];
				childHtml = '<dd class="function" data-key="'+ msgObj.key 
				+'" onclick="return custom.listenerOpenWindow(\'' + msgObj.key + '\')"><img src="/im/img/function/' + tempData.icon +'.jpg" />' +
					'<div class="function-msg">' +
					'<h3>' + tempData.title + '</h3><p>' + tempData.des + '</p>'
					'</div>' +
				'<dd>'
			}		
		} catch (e) {
			console.log(e);
			return '录入的数据格式有误';
		}
		return childHtml;
	},
	// 创建普通消息
	_createMsgByText: function(msg){
		var childHtml;
		var msgHtml;
		var isFull;
		if ('text' == msg.messageType) {
			isFull = msg.message.indexOf('问题难住我') == -1;
			msgHtml = msg.message + (this.ai && false == msg.accept && isFull  ? this._createAsk() : '');
			// 如果是图文/img/.test(msg.message)
			childHtml = '<dd class="msg ' + (this.ai && false == msg.accept ? 'full' : '') + (/img/.test(msg.message) ?  ' image-text scale-img' : '') +'">' + msgHtml + '</dd>';
		} else {
			childHtml = '<dd class="msg pic-box scale-img"><img src="' + msg.message+ '"  /></dd>';
		}	
		return childHtml;
	},
	// 询问客户是否解决问题（人工智能查询出的问题的答案,都要带询问）
	_createAsk: function(){
		return '<div class="ask-guest" onclick="event.stopPropagation();"><span>是否已解决问题</span><span onclick="return resolved(event);">已解决</span><span onclick="return unresolved(event);">未解决</span></div>'
	},
	/**
	 * @param {String} socketUrl 连接地址
	 * @paran {String} aiSuccessTip 连接成功后默认提示语
	 * @param {Boolean} welcomeAd 欢迎
	 */
	initSocketConnect: function (socketUrl, aiSuccessTip, welcomeAd){
		var This = this;
		var socket = this.socket = io.connect(socketUrl);
		socket.on('connect',function(e){
			socket.emit('new', This.socketData);
			this.service_end = false;
		})
		socket.on("agentstatus",function(data){
			document.getElementById('connect-message').innerHTML=data.message;
		})
		socket.on("status",function(data){
			This.output('<div class="text-center"><span class="tips-text" id="connect-message">'+data.message+'</span></div>' , 'connect-message');
			
			// 断开连接
			if('坐席已断开和您的对话' == data.message){
				This.service_end = true ;
				This.chatingEnd();
			} else if (data.messageType == 'new' && !This.pushed) {
				if (This.pushHotList) {
					This.pushHotList();
					This.pushed = true;
				}
			}
			if (This.activeMessage) {
				This.activeMessage();
			}
			This.agentserviceid = data.agentserviceid;
			if (This.myConnectStatus) {
				This.myConnectStatus();
			}
		})
		socket.on('message', function(data) {
			var time = This.ai && data.calltype == "out" ? 1000 : 0;
			setTimeout(function(){
				var message = This.insertMessage(data);
				This.output(message, "chat-block");
				if(data.calltype == "out") {
					var isFull = message.indexOf('问题难住我') > -1;
					if (isFull) {
						This.output(This.appendQuickEntry());						
					}
					This.sendNotice(data);
				};
			}, time);
		});
		socket.on('disconnect',function(e) {
			This.chatingEnd();
			if (This.myDisconnect) {
				This.myDisconnect();
			} else {
				This.output('<div class="text-center"><span class="tips-text" id="connect-message">连接坐席失败,在线咨询服务不可用</span></div>' , 'connect-message');
			}
		});
	},
	// 关闭scokte
	disconnectSocket: function (){
		this.socket.disconnect();
	},
	// 监听打开新页面
	listenerOpenWindow: function(key){
		if (this.isBack) return;
		var targetData = functionConfig[key];
		var userData = this.getUser() || {};
		if (targetData.isCheckLogin && !userData.token) {
			url = window.plus ? '_www/view/auth-login.html' : null;
			return this.openWindow(url, null);
		}
		this._handleConfigTargetUrl(targetData, userData);
	},
	// 插入快捷入口
	appendQuickEntry: function(){
		this.output('<div class="other-link"><div><a href="javascript:void(0)" class="go-repository"><img src="/im/img/quick-function/repository.png" />问题库</a></div>' +
			'<div><a href="javascript:void(0)" onclick="return turnPerson();"><img src="/im/img/quick-function/person.png" />人工客服</a></div>' +
			'<div><a href="javascript:void(0)" onclick="return custom.listenerOpenWindow(\'问题咨询\');"><img src="/im/img/quick-function/custom.png" />问题咨询</a></div>' +
		'</div>');
	},
	// 处理配置文件的url动向
	_handleConfigTargetUrl: function(data, userData){
		var url;
		var tempData;
		var This = this;
		if (data.target) {
			tempData = data.target[window.plus ? 'app' : (this.isWechatApp || this.isAli || this.isToutiao) ? 'wechat' : 'web'];
			url = tempData ? tempData.url : null;
		}
		// 有特殊处理函数
		if (tempData && 'function' == typeof tempData.createNewTarget) {
			url = tempData.createNewTarget(userData, url, function(name, moduleId, userData){
				This._requestHandle(name, moduleId, userData);
			});	
			// 异步就直接跳出
			if (false === tempData.sync) return;
			
		}
		if (url) {
			this.openWindow(url, null);	
		} else {
			this._showDownloadPic();
		}
		
	},
	// 同意邀请
	acceptInvite: function (msgid,fileid){
		var This = this;
		document.getElementById("cooperation").style.display = "block" ;
		document.getElementById("ukefu_img_ctx").src = "/res/image.html?id=upload/"+fileid ;

		$("#ukefu_img_ctx").load(function() {
			var height = document.getElementById("ukefu-image-content").offsetHeight;
			var width = document.getElementById("ukefu-image-content").offsetWidth;
			var canvas = document.getElementById("canvas-borad") ;
			if(canvas.getContext){
				canvas.width = width;
				canvas.height = height;
				This.drawCanvasImage(fileid) ;
			}
		});
	},
	// 绘制cnavas
	drawCanvasImage: function (fileid){
		var canvas = document.getElementById("canvas-borad") ;
		if (canvas.getContext && document.getElementById("cooperation").style.display == "block") {
			var ctx = canvas.getContext("2d");

			//创建新的图片对象
			var img = new Image();

			//指定图片的URL
			img.src = "/res/image.html?id=upload/" + fileid + "_cooperation";
			//浏览器加载图片完毕后再绘制图片
			img.onload = function() {
					ctx.clearRect(0,0,canvas.width,canvas.height);
					//以Canvas画布上的坐标(10,10)为起始点,绘制图像
					ctx.drawImage(img, 0, 0 , canvas.width,canvas.height);
			};
		}
	},
	// 输出内容到界面
	output: function (message, clazz) {
		if (!message) return;
		var element = document.createElement('div');
		element.innerHTML = ("<div class='clearfix "+clazz+"'>" + " " + message + "</div>");
		this.setScrollPos(message);
		document.getElementById('above').appendChild(element);
		if (message.indexOf('断开') > -1 || message.indexOf('自动结束') > -1) {
			this.service_end = true;
			this.chatingEnd();
		}
		element = null;
	},
	/**
	 * @param {String} message 如果有message就不取textarea中的文本
	 */
	sendMessage: function sendMessage(message) {
		var isSpeechText = message;
		message = message || document.getElementById('message').value;
		var count = message.length;
		var emptyRE = /\S/;
		if (!emptyRE.test(message)) return;
		
		if (count > 0 && this.service_end == false) {
			this.sendMessageText(message);
			if (!isSpeechText) {
				$("#message").val("").css('height', 'auto');
				this.closeFaceDialog();
				$('.send-btn').removeClass('active');
				$('.btn-push').removeClass('toggle');
				this.wordinx = 0;
			}
		} else if (this.service_end == true) {
			this._showDialog();
		}
	},
	// 发送socket消息
	sendMessageText: function (message, id) {
		var oMsg = null
		if (message != "") {
			oMsg = {
				appid : this.appId,
				userid : this.userId,
				username : this.userName,
				deviceid: this.deviceId,
				channel : "webim",
				type : "message",
				contextid : this.contextId,
				orgi : this.orgi,
				mediaid: id,
				message: message
			};
			oMsg.mediaid = id;
			this.socket.emit('message', oMsg);
		}
	},
	
	// 设置内容滚动的位置(主要解决图片加载慢造成滚动位置不准确)
	setScrollPos: function (msg){
		var oImg = $(msg).find('.msg img')[0]; 
		var oNewImg;
		var iH = 0;
		if (oImg) {
			oNewImg = new Image();	
			oNewImg.src = oImg.src;
			oNewImg.onload = function(e){
				iH = oNewImg.width > oNewImg.height ? 190 : 150;
				document.getElementById('above').scrollTop = document
							.getElementById('above').scrollHeight + iH;
				oNewImg = null;
			}
		} else {
			setTimeout(function(){
				document.getElementById('above').scrollTop = document
						.getElementById('above').scrollHeight;
			}, 100)
		}
	},
	// 聊天断开    
	chatingEnd: function chatingEnd(){
		window.plus && plus.webview.getWebviewById('kefu').evalJS('startonline()');
		if (!this.isChatingActive()) {
			this.closeChatWebview();
		}
		!this.ai && this.showEvaluate();
	},
	closeChatWebview: function(){
		window.plus && plus.webview.getWebviewById('kefu').close();
	},
	// 判断 id=kefu 页面是不是前台页面
	isChatingActive: function isChatingActive(){
		var allWebview = window.plus && plus.webview.getDisplayWebview();
		if (!allWebview) return;
		for (var i = 0;i < allWebview.length; i ++) {
			if (allWebview[i].id == 'kefu' || allWebview[i].id == 'subChat') return true;
		}
		return false;
	},
	// 发通知（聊天页面在后台）
	sendNotice: function sendNotice(data){
		if (!this.isChatingActive()) {
			window.plus && plus.webview.getLaunchWebview().evalJS('customer.showNotice(' + JSON.stringify(data) + ')');
		}
	},
	initImageScale: function(){
		// 图片放大
		$(document.body).on('click', '.scale-img img', function(){
			window.plus && plus.nativeUI.previewImage([this.src])
		})
	},
	// 插入微信js
	insetWxJsbridge: function(){
		var This = this;
		var oScript = null;
		if (this.isWechat) {
			oScript = document.createElement('script');
			oScript.src = '/im/js/wechat_jsbridge.js';
			document.head.appendChild(oScript);
			if ('function' == typeof oScript.onload) {
				oScript.onload = wechatInit;	
			} else {
				setTimeout(wechatInit, 3000);
			}
		}
		oScript = null;
		function wechatInit(){
			function ready() {
				This.isWechatApp = window.__wxjs_environment === 'miniprogram'
			}
			if (!window.WeixinJSBridge || !WeixinJSBridge.invoke) {
				document.addEventListener('WeixinJSBridgeReady', ready, false)
			} else {
				ready()
			}
		}
	},
	/**
	* 显示loading
	*/
	showLoading: function (){
		var This = this;
		$('.toast-loading').fadeIn();
	},
	/**
	* 隐藏loading
	*/
	hideLoading: function (){
		$('.toast-loading').fadeOut();
	},
	preventDefault: function(e){
		e.preventDefault();
	},
	// 显示提示框
	_showDialog: function(){
		var This = this;
		if (!this.dialogView) {
			this.dialogView = document.querySelector('.my-mask-view');
			this.dialogView.addEventListener('touchmove', this.preventDefault, false);
			this.dialogView.querySelector('.d-f-l-btn').onclick = function(){
				if (window.plus) {
					plus.webview.getWebviewById('kefu').evalJS('refreshChat()');
				} else {
					// 重新连接客服
					location.reload();
				}
				This._hideDialog();
			}
			this.dialogView.querySelector('.d-f-r-btn').onclick = function(){
				This._hideDialog();
			}	
		}
		this.dialogView.classList.remove('hide-view');
		this.dialogView.classList.add('show-view');
	},
	_hideDialog: function(){
		this.dialogView.classList.remove('show-view');
		this.dialogView.classList.add('hide-view');
	},
	// 打开其他页面
	initOpenToArticle: function(){
		var This = this,
		listerOpenArticle = function(data){
			var data = this.dataset, targetUrl;
			if (!data.type) return;
			data = {id: this.id, type: data.type};
			if (window.plus) {
				targetUrl = (data.type == 2 ? '_www/view/article-video.html' : '_www/view/article.html') +
						'?aid='+data.id+'&image=';
			} else if (This.isWechatApp || This.isToutiao || This.isAli) {
				targetUrl =  '/pages/article/article?id='+ data.id + '&type=' + (data.type == 1 ? 'article' : 'video')
			} else {
				targetUrl = 'https://m.joyshebao.com/article.html?id=' + data.id;
			}		
			This.openWindow(targetUrl, data);
		}
		$('#above').on('click', '.image-text', '', listerOpenArticle);	
	},
	/**
	 * 打开新的页面
	 * @param { String } targetUrl url地址
	 * @param { Object } data 数据 {id：1,type:2}
	 */
	openWindow: function(targetUrl, data){
		if (!targetUrl) {
			return this._showDownloadPic();
		};
		// APP
		if (window.plus) {
//			var newView =  plus.webview.create(targetUrl, data ? data.type == 2 ? 'article-video' : 'article' : null, data ? data : {});
//			newView.show('slide-in-right');	
			this.openCreateWebview(targetUrl, data ? data.type == 2 ? 'article-video' : 'article' : null, data ? data : {});
		// 微信小程序	
		} else if (this.isWechatApp){
			wx.miniProgram.navigateTo({url: targetUrl});
		}  else if (this.isToutiao){
			tt.miniProgram.navigateTo({url: targetUrl});
		} else if (this.isAli){
			my.navigateTo({url: targetUrl});
		} else {
			location.href = targetUrl;
		}
	},
	/**
	 * 创建并打开webview
	 * @param {Object} webviewUrl
	 * @param {Object} webviewId
	 * @param {Object} data
	 */
	openCreateWebview: function(webviewUrl, webviewId, data){
		if (!window.plus){
			location.href = webviewUrl;
		} else {
			var newView =  plus.webview.create(webviewUrl, webviewId, data);
			newView.show('slide-in-right');
		};
		
	},
	// 回复下载图片
	_showDownloadPic: function(){
		this.output(this.insertMessage({
			callType: 'out',
			message: '<div><img src="/im/img/download-img.jpg" style="wdith: 100%; height: auto" /></div>',
			messageType: 'text'
		}) , "chat-block");
	},
	// 上传图片
	initUpdateImage: function(){
		var imgFile = $('input[name=imgFile]');
		var This = this;
		imgFile.on('change', fileHandle)
		$('#imgForm').submit(function(e){
			e.preventDefault();
		});
		function fileHandle(){
			var isSubmit = true;
			var oFile = this.files[0];
			
			if (/GIF$/.test(oFile.type.toUpperCase())){
				isSubmit = false;
				toast('图片必须为png、jpg、jpeg格式');
			}
			if (oFile.size > 1024*1024*5) {
				isSubmit = false;
				toast('图片不能大于5M');
			}
			
			if (isSubmit) {
				This.showLoading();
				$('#imgForm').submit();
			}
			$(this).val('');
		}
		
		function toast(msg){
			var oToast = $('.toast');
			oToast.text(msg).show();
			setTimeout(function(){
				oToast.hide();
			}, 1500)
		}
		//图片上传
		$(document).on('submit.form.data-api','[data-toggle="ajax-form"]', function ( e ) {
			var formValue = $(e.target) ;
			$(this).ajaxSubmit({
				url: formValue.attr("action"),
				async: true,
				success: function(data){
					This.hideLoading();
					$('.select-input-type').hide();
					This._changeChatBodyHeight($('#bottom')[0]);
				},
				error:function(xhr, type, s){
					This.hideLoading();
					alert('图片上传失败');
					console.log(xhr, type, s);
				}
			});
			
			return false;
		});
	},
	// 对客服评分
	submitScore: function (form){
		var This = this;
		$.ajax({
			type: 'POST',
			url: '/im/satis.html?orgi=' + this.orgi,
			data: this.sendObj,
			success: function(res){
				This.service_end = true;
				This.hideEvaluate();
				This.showScoreSuccess();
				
			},
			fail: function(err){
				
			},
			//dataType: ''
		})
	},
	/**
	 * 显示评价
	 */
	showEvaluate: function(){
		var This = this;
		if (!this.evaluateMask) {
			this.evaluateMask = $('.mask-view');
			this.scoreView = $('.score');
			this.addEventListScore();
			this.setScoreLevel(5, '非常满意');
		}
		this.textarea.blur();
		this.evaluateMask.removeClass('hide-view');
		this.evaluateMask.addClass('show-view');
		this.scoreView.removeClass('show-down');
		this.scoreView.addClass('show-up');
	},
	/**
	* 隐藏评价
	*/
	hideEvaluate: function(){
		this.evaluateMask.removeClass('show-view');
		this.evaluateMask.addClass('hide-view');
		this.scoreView.removeClass('show-up');
		this.scoreView.addClass('show-down');
	},
	addEventListScore: function(){
		var This = this;
		$('.score').on('click',  '.close', function(e){
			This.hideEvaluate();
			e.stopPropagation();
		});
		$('.score .score-list').on('click', 'span', function(e){
			This.setScoreLevel(this.dataset.value, this.innerHTML);
		});
		$('.score-footer').on('click', '', function(){
			This.submitScore();
		})
	},
	setScoreLevel: function(curLevel, value){
		this.sendObj = {
			id: this.agentserviceid,
			satislevel: curLevel,
		}
		var count = 5;
		do {
			if (count <= curLevel) {
				$('.score-list span[data-value=' + count + ']').addClass('active');	
			} else {
				$('.score-list span[data-value=' + count + ']').removeClass('active');	
			}
			count --;
		} while(count);
		$('.score .score-level').html(value);
	},
	/**
	* 显示评价成功提示
	*/
	showScoreSuccess: function(){
		var This = this;
		if (!this.scoreSuccess) {
			this.scoreSuccess = $('.score-success');
			this.scoreSuccess.on('click', '.close', function(){
				This.scoreSuccess.removeClass('show-view');
				This.scoreSuccess.addClass('hide-view');
				This.closeChatWebview();
			})
		}
		this.scoreSuccess.removeClass('hide-view');
		this.scoreSuccess.addClass('show-view');
	},
	
	_getUrlByName: function(data, name){
		for (var i = 0; i < data.length; i ++) {
			if (-1 != data[i].appName.indexOf(name)) {
				return data[i].appUrl;
			}
		}
		return false;
	},
	/**
	 * 功能请求回调
	 * @param {String} name 功能名称
	 * @param {Number} moduleId 智能应用的模块ID
	 * @param {Object} userData 用户信息
	 */
	_requestHandle: function(name, moduleId, userData){
		var This = this;
		if ('undefined' != typeof moduleId) {
			// 有默认的社保卡
			if (userData.token && userData.securityAcctId) {
				getSecurityInfoById({securityAcctId: userData.securityAcctId}, function(res){
					This._requestIntellingent(res.payCity, name, moduleId);	
				})
			} else {
				// 定位城市
				geo.setLocation(function(res){
					This._requestIntellingent(res.cityCode, name, moduleId);
				})	
			}	
		} else {
			this._requestInsurance(name);
		}
		
	},
	// 获取保险相关类型
	_requestInsurance: function(name){
		var This = this;
		getInsTypeInfoNew(function(res){
			if (Array.isArray(res)) {
				for (var i = 0; i < res.length; i ++) {
					if (name == res[i].value) {
						return This.openWindow('_www/view/baoxianList.html?type=' + res[i].key + '&name=' + name);	
					}
				}
			}
		}, function(err){
			alert("服务暂停中");
		});
	},
	_responseData: [],
	// 获取智能应用配置信息
	_requestIntellingent: function(cityCode, name, moduleId){
		var This = this;
		var count = 0;
		getIntelligent({cityCode: cityCode}, function(res){
			backHandle(0, res);
		}, function(err){
			backHandle(0, false);
		});
		getIAList({cityCode: cityCode}, function(res){
			backHandle(1, res);
		}, function(err){
			backHandle(0, false);
		});
		function backHandle(index, res){
			This._responseData[index] = res;
			count ++;
			if (2 == count)
			This._backHandle(name, moduleId);
		}
	},
	// 回调处理
	_backHandle: function (name, moduleId){
		var url = '';
		// 先用模块配置项
		if (!$.isEmptyObject(this._responseData[0]) && 0 < moduleId) {
			url = '_www/view/joymods/index.html?mcode=' + moduleId;
		} else {
			url = this._getUrlByName(this._responseData[1], name);
		}
		if (url) {
			this.openWindow(url);	
		} else {
			this._showDownloadPic();
		}
		
	},
	// 数组是不是有空值
	_isEmptyValueOfArray: function (arr){
		var isEmptyValue = false;
		arr.forEach(function(val){
			if ('undefined' == typeof val) {
				isEmptyValue = true;
			}
		})
		return isEmptyValue;
	},
	// html编码反转
	htmlDecode: function (text){
		var temp = document.createElement("div");
		temp.innerHTML = text;
		var output = temp.innerText || temp.textContent;
		temp = null;
		return output;
	}
}