(function($){
	var aId;
 	var pager = {pageNum:1,pageSize:10}; 

	$.init();		
			
	var getCriditList = function(data,bankId){
		var html = "";
		for(var i in data){
			var htmlSort="";
			item = data[i];
			if(item.showSort && bankId==undefined){
				htmlSort +=[
					'<div class="label">',
						'<div class="circle">',
							'<span class="borderStyle">',item.showSort,'</span>',
							'<span>HOT</span>',
						'</div>',
						'<div class="circleBottom">',
						'</div>',
						'<div class="triangle_border_up"></div>',
					'</div>'].join('');
			}
			
			html += [
				'<li class="creditLi" url="',item.spreadUrl,'" credId="',item.id,'">',
					'<div class="leftContent">',
						'<img data-lazyload="',item.productImg,'" src="../images/loading-credit.jpg"/>',
					'</div>',
					'<div class="rightContent">',
						'<span class="contentTitle setPadding mui-ellipsis">',item.productName,'</span>',
						'<div class="rightContentInfo">',
							'<span class="rightContentTxt mui-ellipsis">',item.productDesc,'</span>',
							'<div class="rightContentTxt mui-ellipsis"><span class="red">',item.applyCount,'人</span><span>申请</span></div>',
						'</div>',
						htmlSort,
					'</div>',
				'</li>'].join('');
			}
		return html;
	};
				
	var getCreditCardList = function(pageNum,pullSel,dir){
		if(pageNum===1) pullSel.refresh(true);
		var obj = {bankId:aId,pageSize:pager.pageSize,pageNum:pageNum};
		//g('creditAll').removeAttribute('data-imagelazyload');
    	var Lazyload = $('#creditAll').imageLazyload({
			placeholder: '../images/loading-credit.jpg',
			autoDestroy: false
		});
		bizSvc.getCreditCardList(obj).then(function(data){
			pager.pageNum = data.pageNum;
			if(pageNum ===1) g('creditAll').innerHTML = '';
			g('creditAll').innerHTML += getCriditList(data.list,obj.bankId);
			Lazyload.refresh(true);
			pager.pullUpTips.style.display=data.total<obj.pageSize?'none':'block';
			if(data.total === 0){
				g('creditAll').innerHTML ='<div class="not-network"><span>此银行业务还未开通</span></div>';
			}
			if(pullSel&&dir) pullSel.endPullDownToRefresh();
        	if(pullSel) pullSel.endPullUpToRefresh(data.pageNum===data.pages);
		}).catch(function(err){
        	if(pullSel&&dir) pullSel.endPullDownToRefresh();
        	if(pullSel&&!dir) pullSel.endPullUpToRefresh(); 
        	console.error(err.message,err);
		});
	};
	
	var getApplayCreditCard = function(id){
		bizSvc.getApplayCreditCard(id).then(function(data){
			console.log(data);
		}).catch(function(err){
			console.error(err.message,err);
		});
	};
	
	//$('#creditAll').on('tap','.not-network',getCreditCardList);
	$('#creditAll').on('tap','.creditLi',function(){
		var credId = this.getAttribute('credId');
		getApplayCreditCard(credId);
		app.openUrl(this.getAttribute('url'),{
			id:'credit-card',
			showCloseBtn:true,
			enableHistory:true,
			scalable:false
		});
	});
	
	$.plusReady(function(){
		aId = $.currentWebview.aId;
    	var bankName = $.currentWebview.bankName; 
    	if(bankName){
    		g("muiTitle").innerHTML = bankName+'信用卡';
    	}
    	
	    $.init({swipeBack:true});
	    
		var scroll = $('.mui-scroll-wrapper').scroll({
	    	bounce: false,
			indicators:true,
			deceleration:mui.os.ios?0.003:0.0009
	    });

		var pull = $('#pullRefresh').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getCreditCardList(1,self,true,aId);
					}, 10);
				}
			},
			up:{
				callback: function() {
					var self = this;
					setTimeout(function() {
						getCreditCardList(pager.pageNum+1,self,false,aId);
					}, 10);
				}
			}
		});
		
		pager.pullUpTips = g('pullRefresh').querySelector('.mui-pull-bottom-tips');
		pager.pullUpTips.style.display='none';
		pull.pullDownLoading();
	});
})(mui);
