(function($){
	var g = function(id) {
		return document.getElementById(id);
	};
	
	var queryString = function(name){
	    var reg = new RegExp("(^|&)"+name+"=([^&]*)(&|$)", "i");
	    var matchs = location.search.substr(1).match(reg);
	    if(matchs!==null) return matchs[2];
	    return null;
	}; 

	var testObj = {"moneyValue":0,"month":0};
	var tempObj = {"moneyValue":0,"month":0};
	
	var productId = queryString('productId');
	var proName = decodeURIComponent(queryString('productName'));
	var productType = queryString('productType');
	var spreadType = queryString('spreadType');
	var spreadUrl = decodeURIComponent(queryString('spreadUrl'));
	
	var typeArr = [
		{'dataType':'1','typeName':'日利率'},
		{'dataType':'2','typeName':'月利率'},
		{'dataType':'3','typeName':'年利率'}];
	
	var wordList = [
		{'type':1,'className':'colorInfo1','bgName':'bgName1'},
		{'type':2,'className':'colorInfo2','bgName':'bgName2'},
		{'type':3,'className':'colorInfo3','bgName':'bgName3'},
		{'type':4,'className':'colorInfo4','bgName':'bgName4'},
		{'type':5,'className':'colorInfo5','bgName':'bgName5'}];
		
	var checkProductType = function(data){
		var rateName = "";
		for(var i in typeArr){
			var item = typeArr[i];
			if(item.dataType == data.rateType){
				rateName = item.typeName;
			}
		}
		if(productType == 1){
			//g('titleHead').innerHTML = '现金贷';
			typeChangeHtml = [
				'<div class="prodDetailRight">',
					'<span class="prodDetailNum">10分钟</span>',
					'<div class="prodDetailTxt">最短放款时间</div>',
			    '</div>'].join('');
		}
		if(productType == 3){
			//g('titleHead').innerHTML = '银行贷';
			typeChangeHtml = [
				'<div class="prodDetailRight">',
					'<span class="prodDetailNum" id = "rateType">',data.rate,'%</span>',
					'<div class="prodDetailTxt">最低<span id="rateName">',rateName,'</span></div>',
			    '</div>'].join('');
			
		}
		return typeChangeHtml;
	};

	var setProductHtml = function(data){
		var cycleArr = data.cycle.split(','),
			j =  cycleArr.length,
			maxMonth = parseInt(cycleArr[j-1]),
			maxAmount = data.amountLimitMax;
			
		testObj.moneyValue = maxAmount;
		testObj.month = maxMonth;

		g('loanLable').innerHTML = data.amountLimitMax+"元";
		g('progressBar1').max = maxAmount;
		g('progressBar2').max = maxMonth;
		g('progressBar1').value =  maxAmount;
		g('progressBar2').value = maxMonth;
		g('loanCycle').innerHTML = maxMonth+"个月";
		if(maxMonth == "1"){
			g('progressBar2').min = "0";
			g('progressBar2').setAttribute('disabled',1);
		}
		
		if(maxMonth){
			g('progressBar1').style.background = 'linear-gradient(to right, #00a38f, #00a38f ' +100+ '%, #b5b5bf 50%)';
		}
		if(maxAmount){
			g('progressBar2').style.background = 'linear-gradient(to right, #00a38f, #00a38f ' +100+ '%, #b5b5bf 50%)';
		}
		g('titleProImg').src = data.orgLogoAddr;
		g('titleProName').innerText = data.productName;
		
		var typeChangeHtml = checkProductType(data);
		var html = '';
		html += [
			'<div class="product">',
				'<img src="',data.orgLogoAddr,'"/>',
				'<div class="prodName">',
					data.productName,
				'</div>',
			'</div>',
			'<div class="prodDetail">',
				'<div class="prodDetailLeft">',
					'<span class="prodDetailNum">',data.amountLimitMax,'</span>',
					'<span class="prodDetailTxt">最高限额</span>',
				'</div>',
				'<span class="bloadTop"></span>',
				typeChangeHtml,
			'</div>'].join("");
		g("producthead").innerHTML = html;
	};
		
	var setJoyLoanProductBaseInfoList = function(data){
		var html = '';
		for(var i in data){
			var item = data[i];
			var wordInfo ='';
			var wordBg = '';
			for(var n in wordList){
				var wordItem = wordList[n];
				var wordType = '0'+wordItem.type;
				if(item.type ==  wordType){
					wordInfo = wordItem.className; 
					wordBg = wordItem.bgName;
				}
			}
			html +=[
				'<div class="prodInfoTitle ',wordInfo,'">',
					'<span class="infoStyle ',wordBg,'"></span>',item.name,
				'</div>',
				'<div class="productContent">',
					item.content,
				'</div>'
			].join('');
		}
		g('prodInfo').innerHTML = html;
	};
	
	var getProductInfo = function(){
		loanSvc.getLoanProdInfo(productId).then(function(data){
			setProductHtml(data);
			setJoyLoanProductBaseInfoList(data.joyLoanProductBaseInfoList);
			trialmonRepAmt(productId,testObj.month,testObj.moneyValue);
		}).catch(function(err){
   		 	console.error(err.message,err);
   		});
	};
	
	var trialmonRepAmt = function(productId,month,moneyValue){
		loanSvc.trialmonRepAmt(productId,month, moneyValue).then(function(data){
			data.totalAmt = (data.rateTotalAmt + data.feeTotalAmt).toFixed(2);
			jscope.bind(prodCard,data,'info');
		});
		g('prodCard').classList.remove('none');
		g('prodCard').classList.add('show');
	};

	var addEvent = function(obj){
	 	var IntNum;
	 	obj.addEventListener('input',function(){
			obj.setAttribute('value',this.value);
			var maxVal = Number(obj.getAttribute('max'))-Number(obj.getAttribute('min'));
			var theVal = Number(this.value)-Number(obj.getAttribute('min'));
			var size = theVal/maxVal*100;
			testObj.moneyValue = parseInt(Number(g('progressBar1').value));
			testObj.month = parseInt(Number(g('progressBar2').value));
			IntNum = parseInt(Number(obj.parentNode.children[1].innerText));
			obj.parentNode.children[1].innerText = IntNum;
			obj.style.background = 'linear-gradient(to right, #00a38f, #00a38f ' +size+ '%, #b5b5bf 0, #b5b5bf 100%)';
		});
		
		obj.addEventListener('touchstart',function(e){
			tempObj.month = testObj.month;
			tempObj.moneyValue = testObj.moneyValue;
		});
		obj.addEventListener('touchend',function(e){
			if(tempObj.month!=testObj.month || tempObj.moneyValue!=testObj.moneyValue){
				trialmonRepAmt(productId,testObj.month,testObj.moneyValue);
			}
		});
	};
	 
	addEvent(g('progressBar1'));
    addEvent(g('progressBar2'));

	$.init({
		swipeBack:true
	});

	g('kefu').addEventListener('tap',function(){
		app.toKefu();
	},false);
	
	document.addEventListener('scroll',function(e){
		var oH = g('header').offsetHeight;
		if(document.body.scrollTop>150){
			g('titleHead').classList.remove('mui-hidden');
		}else{
			g('titleHead').classList.add('mui-hidden');
		}
	},false);
	
	var applyLoan = function(){
		if(spreadType == 1){
			app.openUrl(spreadUrl,{
				id:'daikuan-info',
				title:proName,
				showCloseBtn:true,
				enableHistory:true,
				scalable:false
			});
		}else{
			if(!app.checkLogin()){
				$.alert('请先登录后再申请！',function(){
					app.toLogin();
				});
			}else{
				loanSvc.getapplyLoan(productId).then(function(url){
			  	 	app.openUrl(url,{
						id:'daikuan-info',
						title:proName,
						showCloseBtn:true,
						enableHistory:true,
						scalable:false
					});
				}).catch(function(err){
					$.alert(err.message);
				});
			}
		}
	};
	
	g('applyNow').addEventListener("tap", applyLoan, false);
	
	if(imbar.isImmersedStatusbar){
		document.querySelector('.mui-content').style.paddingTop= imbar.navBarHeight+'px';
		document.querySelector('.mui-content').style.backgroundSize= '100% '+(195+imbar.navBarHeight)+'px';
	}else{
		document.querySelector('.mui-content').style.paddingTop= '44px';
		document.querySelector('.mui-content').style.backgroundSize= '100% 239px';		
	}
	//神策埋点
	function joyTrack(){
		jTrack.regEvents('#kefu','joyLinkClick','jtrack_name:"在线咨询"');
		jTrack.regEvents('#applyNow','joyLinkClick','jtrack_name:"申请贷款"');
	}
	$.plusReady(function(){
		getProductInfo();
		joyTrack()
	});

})(mui);