(function($){
	var productId = "";
	var proName = "";
	var productType = "";
	var initCycle ='';
	var picker = new mui.PopPicker();
	var prodCard = document.getElementById('prodCard');
	var prodCardContent = document.getElementById('prodCardContent');
	var cardContentRight = document.getElementById('cardContentRight');
	var moneyValue = document.getElementById('moneyBox').value;
	
	var g = function(id) {
		return document.getElementById(id);
	};
	
	var queryString = function(name){
	    var reg = new RegExp("(^|&)"+name+"=([^&]*)(&|$)", "i");
	    var matchs = location.search.substr(1).match(reg);
	    if(matchs!==null) return matchs[2];
	    return null;
	}; 
	
	productId = queryString('productId');
	proName = decodeURIComponent(queryString('productName'));
	productType = queryString('productType');
	var spreadType = queryString('spreadType');
	var spreadUrl = decodeURIComponent(queryString('spreadUrl'));
	
	var wordList = [
		{'type':1,'className':'colorInfo1','bgName':'bgName1'},
		{'type':2,'className':'colorInfo2','bgName':'bgName2'},
		{'type':3,'className':'colorInfo3','bgName':'bgName3'},
		{'type':4,'className':'colorInfo4','bgName':'bgName4'},
		{'type':5,'className':'colorInfo5','bgName':'bgName5'}];
	
	var getProductHtml = function(data){
		var html = "";
		var type ="";
		if(data.rateType == "1"){
			type = "日利率";
		}
		else if(data.rateType == "2"){
			type = "月利率";
		}
		else if(data.rateType == "3"){
			type = "年利率";
		}
		g('titleProImg').src = data.orgLogoAddr;
		g('titleProName').innerText = data.productName;
		html += ['<div class="product">',
					'<img src="',data.orgLogoAddr,'"/>',
					'<div class="prodName">',
					data.productName,
					'</div>',
				'</div>',
				'<div class="prodDetail">',
				'<div class="prodDetailLeft">',
				'<span class="prodDetailNum">',data.amountLimitMax,'</span>',
				'<span class="prodDetailTxt">最高限额</span>',
				'</div>',
				'<span class="bloadTop">',
				'</span>',
				'<div class="prodDetailRight">',
				'<span class="prodDetailNum">',data.rate,'%</span>',
				'<div class="prodDetailTxt">最低<span id="prodRate">',
				type,
				'</span></div>',
				'</div>',
				'</div>'].join("");
		return html;
	};
	
	var getProductInfo = function(){
		loanSvc.getLoanProdInfo(productId).then(function(data){
			if(moneyValue == ''){
				moneyValue = 1;
			}	
			g("producthead").innerHTML = getProductHtml(data);
   			setPicker(data.cycle);
   			getJoyLoanProductBaseInfoList(data.joyLoanProductBaseInfoList);
   			trialmonRepAmt(productId,initCycle,moneyValue)
		}).catch(function(err){
   		 	console.error(err.message,err);
   		});
	};
	
	g("cycle").addEventListener("tap",function(){
		picker.show(function(arr2) {
			g("months").innerHTML = arr2;
			initCycle = Number(arr2);	
			trialmonRepAmt(productId,initCycle, moneyValue);
		})
	});
	
	var setPicker = function(data){
		var str = data;
		var arr = [];
		var arr2 = [];
		arr = str.split(',');
		initCycle = arr[0];
		g('months').innerHTML = initCycle;  
		for(var i in arr){
			item = arr[i];
			arr2.push(item);
		}
		picker.setData(arr2);
	};
	
	g('moneyBox').addEventListener('change',function(){
		moneyValue = this.value;
		if(moneyValue.length >3){
			this.value = this.value.slice(0,3);
			$.toast("请输入1-3位有效数字");
		}
		trialmonRepAmt(productId,initCycle, moneyValue);
	});

	var createChart = function(data){
		var chartPan = document.getElementById('main');
		var chart = echarts.init(chartPan);
		var option = {
		    series : [{
	            type: 'pie',
	            avoidLabelOverlap:'true',
	            startAngle:50,
	            radius: ['70%','85%'],
	            left:'0px',
	            avoidLabelOverlap: false,
	            label: {
	                normal: {
	                    show: false,
	                    position: 'left'
	                },
	                emphasis: {
	                    show:false,
	                    textStyle: {
	                        fontSize: '14',
	                    }
	                }
	            },
	            labelLine: {
	                normal: {
	                    show: false
	                }
	            },
	            data:[
 					{value:data.toAccount,name:"到账金额"+data.toAccount+"元"},
	                {value:data.feeTotalAmt,name:"总服务费"+data.feeTotalAmt+"元"},
	                {value:data.rateTotalAmt,name:"总利息"+data.rateTotalAmt+"元"},
	                {value:data.monthRepayAmt,name:"月供"+data.monthRepayAmt+"元"},
	            ],
	            color:['#ffb100','#e23e46','#00a2ee','#00a49a'],
			}]
		};
		chart.setOption(option);
	};
	
	var trialmonRepAmt = function(productId,month,moneyValue){
		moneyValue = moneyValue*10000;
		loanSvc.trialmonRepAmt(productId,month, moneyValue).then(function(data){
			data.totalAmt =  data.feeTotalAmt;
			createChart(data);
			jscope.bind(prodCardContent,data,'info');
		});
		g('bingLeftText').classList.add('show');
		g('cardContentRight').classList.add('show');
	};
	
	var getJoyLoanProductBaseInfoList = function(data){
		var html = '';
		for(var i in data){
			var item = data[i];
			var str = item.content;
			var arr = str.split(',');
			var prodInfo = "";
			var htmlInfo ='';
			var wordInfo ='';
			var wordBg = '';
			for(var n in wordList){
				var wordItem = wordList[n];
				var wordType = '0'+wordItem.type;
				if(item.type ==  wordType){
					wordInfo = wordItem.className; 
					wordBg = wordItem.bgName;
				}
			}
			html +=['<div class="prodInfoTitle ',wordInfo,'"><span class="infoStyle ',wordBg,'"></span>',item.name,'</div>',
					 item.content,
					].join('');
		}
		g('prodInfo').innerHTML = html;
	};

	$.init({
		swipeBack:true
	});
	
	g('kefu').addEventListener('tap',function(){
		app.toKefu();
	},false);
	
	document.addEventListener('scroll',function(e){
		var oH = g('header').offsetHeight;
		if(document.body.scrollTop>150){
			g('titleHead').classList.remove('mui-hidden');
		}else{
			g('titleHead').classList.add('mui-hidden');
		}
	},false);
	
	var applyLoan = function(){
		if(spreadType == 1){
			app.openUrl(spreadUrl,{
				id:'daikuan-info',
				title:proName,
				showCloseBtn:true,
				enableHistory:true,
				scalable:false
			});
		}else{
			if(!app.checkLogin()){
				$.alert('请先登录后再申请！',function(){
					app.toLogin();
				});
			}else{
				loanSvc.getapplyLoan(productId).then(function(url){
			  	 	app.openUrl(url,{
						id:'daikuan-info',
						title:proName,
						showCloseBtn:true,
						enableHistory:true,
						scalable:false
					});
				}).catch(function(err){
					$.alert(err.message);
				});
			}
		}
	};
	g('applyNow').addEventListener("tap", applyLoan, false);
	
	if(imbar.isImmersedStatusbar){
		document.querySelector('.mui-content').style.paddingTop= imbar.navBarHeight+'px';
		document.querySelector('.mui-content').style.backgroundSize= '100% '+(195+imbar.navBarHeight)+'px';
	}else{
		document.querySelector('.mui-content').style.paddingTop= '44px';
		document.querySelector('.mui-content').style.backgroundSize= '100% 239px';		
	}
	//神策埋点
	function joyTrack(){
		jTrack.regEvents('#kefu','joyLinkClick','jtrack_name:"在线咨询"');
		jTrack.regEvents('#applyNow','joyLinkClick','jtrack_name:"申请贷款"');
	}
	$.plusReady(function(){
		getProductInfo();
		joyTrack()
	});
})(mui);