/*!
 * ======================================================
 * FeedBack Template For MUI (http://dev.dcloud.net.cn/mui)
 * =======================================================
 * @version:1.0.0
 * @author:cuihongbao@dcloud.io
 */
(function() {
	var index = 1;
	var size = null;
	var imageIndexIdNum = 0;
	var starIndex = 0;
	var feedback = {
		question: document.getElementById('question'), 
		contact: document.getElementById('contact'), 
		imageList: document.getElementById('image-list'),
		submitBtn: document.getElementById('submit')
	};
	
	feedback.files = [];
	feedback.uploader = null;  
	feedback.deviceInfo = null;
	//初始化容器高度
	var initFeed = function () {
		var windowH = document.documentElement.clientHeight,
			headerH = g('header').offsetHeight || 68;
			g('header').style.boxSizing = 'border-box';
			g('header').style.height = imbar.navBarHeight +'px';
			g('mainContent').style.top = imbar.navBarHeight +'px';
			g('mainContent').style.height = (windowH - imbar.navBarHeight)+'px';
	}
	initFeed();
	mui.plusReady(function() {
		//设备信息，无需修改
		feedback.deviceInfo = {
			device_id: plus.device.uuid,
			appid: plus.runtime.appid, 
			imei: plus.device.imei, //设备标识
			images: feedback.files, //图片文件
			p: mui.os.android ? 'a' : 'i', //平台类型，i表示iOS平台，a表示Android平台。
			md: plus.device.model, //设备型号
			app_version: myStorage.getItem('appver'),
			plus_version: plus.runtime.innerVersion, //基座版本号
			os:  mui.os.version,
			net: ''+plus.networkinfo.getCurrentType()
		}
	});
	/**
	 *提交成功之后，恢复表单项 
	 */
	feedback.clearForm = function() {
		feedback.question.value = '';
		feedback.contact.value = '';
		feedback.imageList.innerHTML = '';
		feedback.newPlaceholder();
		feedback.files = [];
		index = 0;
		size = 0;
		imageIndexIdNum = 0;
		starIndex = 0;
		//清除所有星标
		mui('.icons i').each(function (index,element) {
			if (element.classList.contains('mui-icon-star-filled')) {
				element.classList.add('mui-icon-star')
	  			element.classList.remove('mui-icon-star-filled')
			}
		})
	};
	feedback.getFileInputArray = function() {
		return [].slice.call(feedback.imageList.querySelectorAll('.file'));
	};
	feedback.addFile = function(path) {
		feedback.files.push({name:"images"+index,path:path});
		index++;
	};
	/**
	 * 初始化图片域占位
	 */
	feedback.newPlaceholder = function() {
		var fileInputArray = feedback.getFileInputArray();
		if (fileInputArray &&
			fileInputArray.length > 0 &&
			fileInputArray[fileInputArray.length - 1].parentNode.classList.contains('space')) {
			return;
		};
		imageIndexIdNum++;
		var placeholder = document.createElement('div');
		placeholder.setAttribute('class', 'image-item space');
		var up = document.createElement("div");
		up.setAttribute('class','image-up')
		//删除图片
		var closeButton = document.createElement('div');
		closeButton.setAttribute('class', 'image-close');
		closeButton.innerHTML = 'X';
		//小X的点击事件
		closeButton.addEventListener('tap', function(event) {
			setTimeout(function() {
				feedback.imageList.removeChild(placeholder);
			}, 0);
			return false;
		}, false);
		
		var fileInput = document.createElement('div');
		fileInput.setAttribute('class', 'file');
		fileInput.setAttribute('id', 'image-' + imageIndexIdNum);
		fileInput.addEventListener('tap', function(event) {
			var self = this;
			var index = (this.id).substr(-1);
			plus.gallery.pick(function(e) {
				var name = e.substr(e.lastIndexOf('/') + 1);
				console.log("name:"+name);
				plus.zip.compressImage({
					src: e,
					dst: '_doc/' + name,
					overwrite: true,
					quality: 50
				}, function(zip) {
					size += zip.size;  
					console.log("filesize:"+zip.size+",totalsize:"+size);
					if (size > (10*1024*1024)) {
						return mui.toast('文件超大,请重新选择~');
					}
					if (!self.parentNode.classList.contains('space')) { //已有图片
						feedback.files.splice(index-1,1,{name:"images"+index,path:e});
					} else { //加号
						placeholder.classList.remove('space');
						feedback.addFile(zip.target);
						feedback.newPlaceholder();
					}
					up.classList.remove('image-up');
					placeholder.style.backgroundImage = 'url(' + zip.target + ')';
				}, function(zipe) {
					mui.toast('压缩失败！')
				});
			}, function(e) {
				mui.toast('取消选择');
				console.log(e.message);
			},{});
		}, false);
		placeholder.appendChild(closeButton);
		placeholder.appendChild(up);
		placeholder.appendChild(fileInput);
		feedback.imageList.appendChild(placeholder);
	};
	feedback.newPlaceholder();
	
	feedback.submitBtn.addEventListener('tap', function(event) {
		document.activeElement.blur();
		var ques = feedback.question.value.trim();
		if (ques.length<5) {
			return mui.toast('请准确填写问题或意见');
		}
		if(!app.checkLogin()){
			var regEmail = /^(\w+((-\w+)|(\.\w+))*\@[A-Za-z0-9]+((\.|-)[A-Za-z0-9]+)*\.[A-Za-z0-9]+)$/;
			var regQQ = /^[1-9]\d{4,9}$/;
			var regMobile  = /^[1-9]\d{10}$/;
			if(feedback.contact.value.search(regEmail) != 0 &&
				feedback.contact.value.search(regQQ) != 0 &&
				feedback.contact.value.search(regMobile) != 0 ){
				return mui.toast('请正确填写一种联系方式');
			}
		}
		if (feedback.question.value.length > 200 || feedback.contact.value.length > 200) {
			return mui.toast('信息超长,请重新填写~')
		}
		//判断网络连接
		if(plus.networkinfo.getCurrentType()==plus.networkinfo.CONNECTION_NONE){
			return mui.toast("连接网络失败，请稍后再试");
		}
		var userid = app.checkLogin() ? app.getUser().userId:'';
		feedback.send(mui.extend({}, feedback.deviceInfo, {
			content: ques,
			contact: feedback.contact.value,
			images: feedback.files,
			score:''+starIndex,
			userId:''+userid
		})); 
	}, false);
	
	feedback.send = function(content) {
		var url = app._gwUser+'/user/userFeedback';
		feedback.uploader = plus.uploader.createUpload(url, {
			method: 'POST'
		}, function(upload, status) {
			plus.nativeUI.closeWaiting();
			console.log("upload cb:"+upload.responseText);
			if(status==200){
				var data = JSON.parse(upload.responseText);
				if (data.err || data.code && data.code!=='000000') {
					var err = data.err || {code:data.code,message:data.message};
					mui.alert(err.message,"问题反馈");
				}else{
					console.log("upload success");
					mui.alert("感谢反馈，点击确定关闭","问题反馈","确定",function () {
						feedback.clearForm();
						mui.back();
					});
				}
			}else{
				mui.alert("对不起，提交问题失败了！","问题反馈");
			}
		});
		//添加上传数据
		mui.each(content, function(index, element) {
			if (index !== 'images') {
				console.log("addData:"+index+","+element);
				feedback.uploader.addData(index, element)
			} 
		});
		//添加上传文件
		mui.each(feedback.files, function(index, element) {
			var f = feedback.files[index];
			console.log("addFile:"+JSON.stringify(f));
			feedback.uploader.addFile(f.path, {
			    key:'images'+index
			});
		});

		//开始上传任务
		feedback.uploader.start();
		plus.nativeUI.showWaiting('正在发送...');
	};
	
	//应用评分
	mui('.icons').on('tap','i',function(){
		document.activeElement.blur();
	  	var index = parseInt(this.getAttribute("data-index"));
	  	var parent = this.parentNode;
	  	var children = parent.children;
	  	if(this.classList.contains("mui-icon-star")){
	  		for(var i=0;i<index;i++){
  				children[i].classList.remove('mui-icon-star');
  				children[i].classList.add('mui-icon-star-filled');
	  		}
	  	}else{
	  		for (var i = index; i < 5; i++) {
	  			children[i].classList.add('mui-icon-star');
	  			children[i].classList.remove('mui-icon-star-filled');
	  		}
	  	}
		starIndex = index;
	});
  	//选择快捷输入
	mui('.mui-popover').on('tap','li',function(e){
		document.getElementById("question").value = document.getElementById("question").value + this.children[0].innerHTML;
		mui('.mui-popover').popover('toggle');
	});
	//神策埋点
	function joyTrack(){
		//提交问题反馈 [发送按钮]
		jTrack.regEvents('#submit','joyLinkClick','jtrack_name:提交问题反馈');
	}
	$.plusReady(function(){
		joyTrack();
	});
})();