(function($){
	var cateId=common.utils.queryString('cate');
	var cateNames = {};
	
	var getCates = function(){
		bizSvc.getInsType().then(function(cates){
			 createCates(cates);
        }).catch(function(err){
			console.error(err.message,err);
        });
	};
	
	var createCates = function(list){
		var insCates = list || [];
        var sIdx = 0,
        		isActive ='',
        		catesHtml=[],
        		contentHtml=[],
            cateList=g('cateList'),
            conList=g('conList');
		$.each(insCates, function(i,cate) {
			cateNames[cate.key] = cate.value;
			isActive = i==0?' mui-active':'';
			catesHtml = catesHtml.concat([
				'<a cate="',cate.key,'" href="#cate',cate.key,'" class="mui-control-item',isActive,'"><span>',cate.value,'</span></a>'
			]);
			contentHtml = contentHtml.concat([
				'<div id="cate',cate.key,'" class="mui-slider-item mui-control-content',isActive,'">',
					'<div class="mui-scroll-wrapper">',
						'<div class="mui-scroll">',
							'<ul class="proList"></ul>',
						'</div>',
					'</div>',
				'</div>'
			]);
			if(cate.key==cateId){
				sIdx = i;
			}
			if(i==0 && !cateId){
				cateId = cate.key;
			}
		});
		cateList.innerHTML = catesHtml.join('');
		conList.innerHTML = contentHtml.join('');
		setPullRefresh();
		
        $('#conList .mui-scroll-wrapper').scroll({
			bounce: false,
			indicators: false,
			deceleration:mui.os.ios?0.003:0.0009
        });
		var cateSlider = $('#insSlider').slider();
        var cateScroller = $('#catesCtrl').scroll();
		cateSlider.refresh();
		cateScroller.refresh();
		
		if(sIdx==0){
			getList();
		}else{
			cateSlider.gotoItem(sIdx,0);
		}
	};
	
	var getList = function(pullSel){
		var conItem=g('cate'+cateId),
			proList=conItem.querySelector('.proList');
		var Lazyload = $('#cate'+cateId).imageLazyload({
			placeholder: '../images/baoxian/placeholder.jpg',
			autoDestroy: false
		});	
		var cateName = g('cateList').querySelector('.mui-control-item[cate="'+cateId+'"]');
		bizSvc.getInsProList(cateId).then(function(list){
			var item;
			if(list.length==0){
				proList.innerHTML = '<div class="not-network"><span>暂无此类 保险产品</span></div>';
			}else{
				var listHtml = [];
				$.each(list,function(i,item){
					var subText = '';
					if(i==0) subText='<div class="subtext">为您优选</div>';
					//if(i==1) subText='<div class="subtext">'+cateName.innerText+'</div>';
					listHtml = listHtml.concat([
						'<div class="ins-list mui-clearfix" pname="',item.pName,
							'" pid="',item.id,'" url="',item.pUrl,'" type="',item.pType,
							'" tname="',cateNames[item.pType],
							'" brand="',item.orgShortName||item.servicesCompName,
							'" price="',item.prince,'">',
							subText,
							'<div class="ins-img">',
								'<img data-lazyload="',item.pImg2,'" src="../images/baoxian/placeholder.jpg">',
							'</div>',
							'<div class="ins-info">',
								'<div class="title">',item.pName,'</div>',
								'<div class="intro mui-ellipsis">',item.pIntro,'</div>',
								'<div class="price">',
									'<span class="numb">',item.pAmount,'</span>',
									'<span class="unit"> 元起/月</span>',
									'<span class="comp-name mui-ellipsis">',item.orgShortName||item.servicesCompName,'</span>',
								'</div>',
							'</div>',
						'</div>']);
				});
				conItem.setAttribute('created','1');
				proList.innerHTML = listHtml.join('');
				Lazyload.refresh(true);
			}
			
			if(pullSel) pullSel.endPullDownToRefresh();
		}).catch(function(err){
	        	if(pullSel) pullSel.endPullDownToRefresh();
	        	if(err.code=='0') proList.innerHTML = '<div class="not-network"><span>点击页面 重新加载</span></div>';
	        	console.error(err.message,err);
		});
	};

    var setPullRefresh = function(){
		$.each(document.querySelectorAll('#conList .mui-scroll'), function(index, pullRefreshEl) {
			$(pullRefreshEl).pullToRefresh({
				down: {
					callback: function() {
						var self = this;
						setTimeout(function() {
							getList(self);
						}, 50);
					}
				}
			});
		});
	};
	
	var getBizParams = function(pid,callback){
		plus.nativeUI.showWaiting();
		bizSvc.getBizzParas(pid).then(function(data){
			plus.nativeUI.closeWaiting();
			callback(data);
		}).catch(function(err){
			plus.nativeUI.closeWaiting();
			callback();
			console.error(err.message,err);
		});
    };
	
	$('#conList').on('tap','.ins-list',function(){
		var pid = this.getAttribute('pid');
		var url = this.getAttribute('url');
		var type = this.getAttribute('type');
		var el = this;
		getBizParams(pid,function(data){
			if(data && data.visitUrl){
				url = data.visitUrl;
			}
			//支持小程序链接
			app.openMultiURL(url,{
				shareMsg:{
					title:el.querySelector('.title').innerText,
					content:el.querySelector('.intro').innerText,
					thumbs:[el.querySelector('img').src],
					href:el.getAttribute('url')
				}
			});
		});
		bizSvc.saveInsPV(pid,type);
		return false;
	});
	
	g('insSlider').addEventListener('slide', function(event) {
    		var cates = g('cateList').children;
		cateId = cates[event.detail.slideNumber].getAttribute('cate');
		var conBox = g('conList').querySelector('#cate'+cateId);
		if(conBox.getAttribute('created')!='1'){
			getList();
		}
		bizSvc.saveInsTypePV(cateId); 
	},false);
		
	g('insSlider').style.top = imbar.navBarHeight+'px';
	document.body.style.backgroundSize = '100% '+(imbar.navBarHeight+40)+'px';
	
	//神策埋点
	function joyTrack(){
		//tab
		jTrack.regEventsLive('#cateList','a','joyCateClick','jtrack_name:this.innerText,jtrack_cate_type:4,jtrack_cate_id:attr.cate');
		//feed流
		jTrack.regEventsLive('#conList','.proList .ins-list','joyInsuranceClick','jtrack_ins_pname:attr.pname,jtrack_ins_pid:attr.pid,jtrack_ins_type:attr.type,jtrack_ins_tname:attr.tname,jtrack_ins_brand:attr.brand,jtrack_ins_price:attr.price');
	}
	$.plusReady(function(){
		getCates();
		joyTrack();
	});
	
	
})(mui);