/**
 * Created by tuchl on 2016-09-17.
 */
(function ($) {
	
	$.init();
	var obj = {};
	var pagination = {pageNum:1,pageSize:5};
	var journalList = document.getElementById('journalList');
	
	var getHtml = function(list){
		var fragment = document.createDocumentFragment();
		for(var i in list){
			var item = document.createElement('div');
			item.className = 'mui-card journal';
			var imgStr = pagination.pageNum==1?'<img src="'+list[i].imageUrl+'" />':
				'<img data-lazyload="'+list[i].imageUrl+'" src="../images/loading-journal.png" />';
			var html = [
				'<div class="journal-bd">',
					imgStr,
					'<div class="mask"></div>',
					'<div class="journal-no">',
						'<div class="no-number">第 <span>',list[i].serialNumber,'</span> 期</div>',
						'<div class="no-month">',list[i].month,'</div>',
					'</div>',
					'<a class="journal-title" url="',list[i].linkUrl,'">',
						'<span jbind="journal.title">',list[i].title,'</span>',
					'</a>',
					'<div class="flag">Hot</div>',
				'</div>'].join('');
			item.innerHTML = html;	
			fragment.appendChild(item);
		}
		return fragment;
	};
	
	var getList = function(pageNum){
		var listmore = document.getElementById('listMore');
		var icon = listmore.querySelector('.fa')
		icon.classList.add("fa-refresh");  //fa color-dark fa-spin fa-refresh
		var moreTxt = document.getElementById('moreTxt');
		moreTxt.innerText = '正在加载';
		//g('journalList').removeAttribute('data-imagelazyload')
		var Lazyload = $('#journalList').imageLazyload({
			placeholder: '../images/loading-journal.png',
			autoDestroy: false
		});
		newsSvc.getSpecialList(pageNum,pagination.pageSize).then(function(data){
			var fragment = getHtml(data.list);
			var pagger = data.pagination;
			pagination.pageNum = pageNum;
			pagination.pageCount = parseInt((pagger.totalItems+pagger.pageSize-1)/pagger.pageSize);
			listmore.style.display = pagination.pageCount>1 && pagination.pageNum!== pagination.pageCount ?'block':'none';
			var journalList = document.getElementById('journalList');
			journalList.insertBefore(fragment,listmore);
			Lazyload.refresh(true);
			icon.classList.remove('fa-refresh');
			moreTxt.innerText='点击加载更多';
		}).catch(function(err){
			icon.classList.remove('fa-refresh');
			if(err.code=='0'){
				if(pageNum===1){
					journalList.innerHTML = '<div class="not-network"><span>点击页面 重新加载</span></div>';
				}else{
					moreTxt.innerText = '加载失败 点击重试';
				}
			}else{
				$.toast(err.message);
			}
			console.error(err.message,err);
        });
	};
	
	$('#journalList').on('tap','.journal-title',function(){
    	var extars = imbar.isImmersedStatusbar?"?isImbar=1&barHeight="+imbar.statusbarHeight:"";
    	var url = this.getAttribute('url') + extars;
		$.openWindow({url:url});
		return false;
    });
	
    $('.mui-content').on('tap','.not-network',function(){
		getList(1);
		return false;
    });
    
    document.getElementById('listMore').addEventListener('tap',function(){
    	getList(pagination.pageNum+1); 
    });
    
	$('.mui-scroll-wrapper').scroll({deceleration: 0.0005});
	
    getList(1);
})(mui);