(function($, doc) {
	$.init();
	var img;
	
	var locationBox = doc.getElementById("city");
	var pickBtn = doc.getElementById('pickCity');
	var submits = doc.getElementById('submits');
	var reSubmit = doc.getElementById('reSubmit');
	var getCameraBtn = doc.getElementById('getCamera');
	var galleryBtn = doc.getElementById('gallery');
	var addImgBtn = doc.getElementById('addImg');
	var photoBox = doc.getElementById('photoBox');
	var warn = doc.getElementById("warning");
	var closePopover = doc.getElementById('closePopover');
	
	var picInner = doc.getElementById("photoBox").innerHTML;
	var qsData = {isPay:0,cost:0};//提交问题的参数
	var num=0;
	var backStatus=0;//返回状态，当提交成功后直接返回不提示
	
	var openPickCity = function(){
		document.activeElement.blur();
		$.openWindow({url:'pick-city.html?workType=2',id:'pickCity',waiting: {autoShow: false}});
	};
	
	pickBtn.addEventListener('tap',openPickCity,false);
	
	var mask = $.createMask(callback);
	function callback(){
		console.log("关闭遮罩");
	}
	//改变城市
	var changeCityHandler = function(event){
		var city = event.detail;
	    doc.getElementById("pickCity").setAttribute("cityCode",city.cityCode);
        doc.getElementById("pickCity").setAttribute("cityName",city.cityName);
		locationBox.innerHTML = city.cityName;
	};
	window.addEventListener("changeCity",changeCityHandler);
	//统一样式的警告
	var warning = function(txt){
		warn.innerHTML  =txt;
		warn.style.display="block";
		setTimeout(function(){
			warn.style.display="none";
		},3000);
	}
	
	for(var j=0;j<$(".submits").length;j++){
		$(".submits")[j].addEventListener("tap",submitCheck,false);
	}
	doc.getElementById("qsTitle").addEventListener("input",function(){
		var matchEmoji = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
		if(matchEmoji.test(this.value)){
			$.toast('不支持emoji表情符号！');
			this.value = this.value.replace(matchEmoji,'');
		}
	},false);
	doc.getElementById("qsCon").addEventListener("input",function(){
		var matchEmoji = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
		if(matchEmoji.test(this.value)){
			$.toast('不支持emoji表情符号！');
			this.value = this.value.replace(matchEmoji,'');
		}
	},false);
	
	function submitCheck(){
		var title = doc.getElementById("qsTitle").value;
		var detail = doc.getElementById("qsCon").value;
		var matchEmoji = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
		if(matchEmoji.test(title) || matchEmoji.test(detail)){
			warning("不支持emoji表情符号！");
			return false;
		}
		
		if(title.length<5||title.length>30){
			warning("标题在5~30个字之间");
			return false;
		}else{
			qsData.title = title;
		}
		if(detail.length>500||detail.length<10){
			warning("内容在10~500字之间");
			return false;
		}else{
			qsData.content = detail;
		}
		qsData.cityCode = doc.getElementById("pickCity").getAttribute("cityCode");
		qsData.cityName = doc.getElementById("pickCity").getAttribute("cityName");
		qsData.type = 0; //免费
		qsData.conCateId = 0;
		qsData.conCateName = "";
		qsData.queCateId = 0;		
		var files = null,
			imgs = $('#photoBox .picPath');
		if(imgs){
			files = {};
			$.each(imgs,function(i,img){
				files["imageFile"+(i+1)] = img.src;
			});
		}
		postFiles(qsData,files);
	}

	function postFiles(data,files){
		var waitting = plus.nativeUI.showWaiting();
		bizSvc.loginZixun(data,files).then(function (res) {
			waitting.close();
			imgSrc = "";
			backStatus=1;
			doc.getElementById("mask").style.display="block";
		    doc.getElementById("popover").style.display="block";
		    //提交成功时隐藏提交失败的弹框failMask
		    doc.getElementById("failMask").style.display="none";
		}).catch(function (err) {
			fail();
			waitting.close();
			console.error(err.message,err);
		});
	}
	
	//提交失败
	var fail = function(){
		doc.getElementById("failMask").style.display="block";
		doc.getElementById("failPopover").style.display="block";
	}
	
	doc.getElementById('closePopover').addEventListener("tap",function(){
		backPage();
	},false);
	
	doc.getElementById("failClose").addEventListener("tap",function(){
		doc.getElementById("failMask").style.display="none";
		doc.getElementById("failPopover").style.display="none";
	},false);
	
	//图片居中
	function AutoResizeImage(maxWidth,maxHeight,objImg){
		var img = new Image();
		img.src = objImg.src;
		console.log(objImg.naturalWidth)
		var hRatio;
		var wRatio;
		var Ratio = 1;
		img.onload = function(){
			var w = img.width;
			var h = img.height;wRatio = maxWidth / w;
			hRatio = maxHeight / h;
			if (maxWidth ==0 && maxHeight==0){
				Ratio = 1;
			}else if (maxWidth==0){//
			if (hRatio<1) Ratio = hRatio;
			}else if (maxHeight==0){
			if (wRatio<1) Ratio = wRatio;
			}else if (wRatio<1 || hRatio<1){
			Ratio = (wRatio<=hRatio?wRatio:hRatio);
			}
			if (Ratio<1){
				w = w * Ratio;
				h = h * Ratio;
			}
			if(h>w){
				//长图
				h=h-2;
				objImg.height = h;
				objImg.width = w;
				var left = parseInt((68-w)/2);
				objImg.style.marginLeft = left+"px";
			}
			if(h<w){
				w=w-2;
				objImg.height = h;
				objImg.width = w;
				var top = parseInt((68-h)/2);
				objImg.style.marginTop = top+"px";
			}
		}
		
	}

	function bindEvent(){
		console.log($(".picPath").length)
		if($(".picPath").length==0){
			return false;
		}
		for(var i=0;i<$(".picPath").length;i++){
			$(".image-close")[i].addEventListener("tap",function(e){
				var obj = e.target.parentNode;
				obj.parentNode.removeChild(obj);
			},false);
			$(".picPath")[i].addEventListener("load",AutoResizeImage("68","68",$(".picPath")[i]),false);	
		}
	}
	
	function compressImg(path,callback){
		var ext = path.toLowerCase().substr(path.toLowerCase().lastIndexOf('.'));
		if(ext==".jpg"||ext==".png"||ext==".jpeg"){
			plus.nativeUI.showWaiting('正在压缩图片...');
			plus.io.resolveLocalFileSystemURL(path, function(entry) {
				//console.log(entry.fullPath);
				entry.file(function(file){
					//console.log(file.name);
					var unitM = 1024 * 1024;
					var mSize = file.size/unitM;
					var qper = mSize>2?2*unitM/file.size:0.92;
					var canvas = document.createElement('CANVAS');
					var ctx = canvas.getContext('2d'); 
					var img = new Image();
					img.crossOrigin = 'Anonymous'; 
					img.onload = function(){ 
						//console.log('imgSrc:',this.src);
						canvas.height = img.height; 
						canvas.width = img.width; 
						ctx.drawImage(img,0,0); 
						var dataURL = canvas.toDataURL('image/jpeg',qper); 
						callback.call(this, dataURL); 
						canvas = null; 
					}; 
					img.src = entry.fullPath;
				},function(e){
					//console.log(e.message);
					warning("读取文件失败！");
				});
			}, function (e) {
				console.log(e.message);
				warning("读取文件失败！");
			});
		}else{
			warning("请选择jpg/png格式的图片");
		}
	}
	
	//拍照
   	function captureImage(){
    	$('#picture').popover('hide');
		cmr = plus.camera.getCamera();
		var res = cmr.supportedImageResolutions[0];
		var fmt = cmr.supportedImageFormats[0];
		cmr.captureImage(function(path){
			compressImg(path,function(b64Src){
    			var pic = doc.createElement("div");
            	pic.setAttribute("class","qsPhoto");
	    		pic.innerHTML= "<img class='picPath' src='"+b64Src+"' data-preview-src='' data-preview-group='1' /><span class='image-close'>X<span>";
				photoBox.appendChild(pic);
				backStatus = 1;
				$.previewImage();
	    		bindEvent();
	    		plus.nativeUI.closeWaiting();
    		});
		},function( error ) {
			$.toast("拍照失败请重试");
		},{resolution:res,format:fmt});
    }
    //从相册中选择图片
	function galleryImgs(){
		$('#picture').popover('hide');
	    plus.gallery.pick( function(e){
	    	for(var i in e.files){
	    		if(i>2) break;
	    		compressImg(e.files[i],function(b64Src){
	    			var pic = doc.createElement("div");
	            	pic.setAttribute("class","qsPhoto");
		    		pic.innerHTML= "<img class='picPath' src='"+b64Src+"' data-preview-src='' data-preview-group='1' /><span class='image-close'>X<span>";
					photoBox.appendChild(pic);
					backStatus = 1;
					$.previewImage();
		    		bindEvent();
		    		plus.nativeUI.closeWaiting();
	    		});
	    	}
	    }, function (e) {
	    	$.toast( "取消选择图片" );
	    },{filter:"image",multiple:true});
	}
	
	getCameraBtn.addEventListener('tap',captureImage,false);
	galleryBtn.addEventListener('tap',galleryImgs,false);
	
	doc.getElementById('addImg').addEventListener('tap',function(){
		document.activeElement.blur();
		$('#picture').popover('show');
	},false);
	
	//查看咨询
	doc.getElementById("look").addEventListener("tap",function(){
		setTimeout(function(){
			mui.currentWebview.close('none');
		},1000);
		var vw = plus.webview.getWebviewById('zixun-list');
		if(vw){
			vw.hide("none");
			$.fire(vw,'refreshPage',{type:0});
			setTimeout(function(){
				vw.show("slide-in-right");
			},100);
		}else{
			mui.openWindow({
				id:'zixun-list',
				url:'zixun.html?type=0&back=0&classify=free'
			});
		}
	},false)
	
	//监听字数变化
	doc.getElementById("qsCon").addEventListener("input",function(){
		var con = doc.getElementById("qsCon").value;
		con = con.replace(/[\r\n]/g,"")//去掉回车换行
		var wordLimit = 500 - parseInt(con.length);
		doc.getElementById("wordLimit").innerHTML = wordLimit;
	},false);
	
	var getCity = function () {
    	var city = app.getCity();
    	if(city==null){
    		locationBox.innerHTML = '北京';
			doc.getElementById("pickCity").setAttribute("cityCode","110000");
			doc.getElementById("pickCity").setAttribute("cityName","北京");
			return false;
    	}
		locationBox.innerHTML = city.cityName;
		doc.getElementById("pickCity").setAttribute("cityCode",city.cityCode);
		doc.getElementById("pickCity").setAttribute("cityName",city.cityName);
	};
	
    //标题自适应高度
    var autoTextarea = function (elem, extra, maxHeight) {
        extra = extra || 0;
        var isFirefox = !!document.getBoxObjectFor || 'mozInnerScreenX' in window,
        isOpera = !!window.opera && !!window.opera.toString().indexOf('Opera'),
        addEvent = function (type, callback) {
            elem.addEventListener ?
                elem.addEventListener(type, callback, false) :
                elem.attachEvent('on' + type, callback);
        },
        getStyle = elem.currentStyle ? function (name) {
            var val = elem.currentStyle[name];
            if (name === 'height' && val.search(/px/i) !== 1) {
            var rect = elem.getBoundingClientRect();
            return rect.bottom - rect.top -
                parseFloat(getStyle('paddingTop')) -
                parseFloat(getStyle('paddingBottom')) + 'px';        
            };
            return val;
        } : function (name) {
            return getComputedStyle(elem, null)[name];
        },
        minHeight = parseFloat(getStyle('height'));   
		elem.style.resize = 'none';
		
	    var change = function() {
			var scrollTop, height,
				padding = 0,
				style = elem.style;
		
			if(elem._length === elem.value.length) return;
			elem._length = elem.value.length;
		
			if(!isFirefox && !isOpera) {
				padding = parseInt(getStyle('paddingTop')) + parseInt(getStyle('paddingBottom'));
			};
			scrollTop = document.body.scrollTop || document.documentElement.scrollTop;
		
			elem.style.height = minHeight + 'px';
			if(elem.scrollHeight > minHeight) {
				if(maxHeight && elem.scrollHeight > maxHeight) {
					height = maxHeight - padding;
					style.overflowY = 'auto';
				} else {
					height = elem.scrollHeight - padding;
					style.overflowY = 'hidden';
				};
				style.height = height + extra + 'px';
				scrollTop += parseInt(style.height) - elem.currHeight;
				document.body.scrollTop = scrollTop;
				document.documentElement.scrollTop = scrollTop;
				elem.currHeight = parseInt(style.height);
			};
		};
		
		addEvent('propertychange', change);
		addEvent('input', change);
		//addEvent('focus', change);
		change();
    };
    
    autoTextarea(doc.getElementById("qsTitle"));
    
    var backPage = $.back;
    //继续编辑或者退出
    var actionBtn = $(".chooseBtn button");
    
    for(var k=0;k<actionBtn.length;k++){
    	actionBtn[k].addEventListener("tap",function(){
        	console.log(this.getAttribute("optionType"));
        	if(this.getAttribute("optionType")==0){
        		backPage();
        	}else{
        		doc.getElementById("backInfo").style.display="none";
        		doc.getElementById("qsTitle").focus();
        	}
        },false);
    }
    
    //监听返回
    $.back = function(){
    	//检测是否全部为空
    	var title = doc.getElementById("qsTitle").value;
		var detail = doc.getElementById("qsCon").value;
		var picLen = $(".picPath").length;
		if(backStatus==1){
			//提交成功之后的返回
			backPage();
			return false;
		}
		if(title==""&&detail==""&&picLen==0){
			backPage();
		}else{
			doc.getElementById("backInfo").style.display="block";
		}
	};
	
	getCity();

})(mui, document);