(function(){
	
	var querySelector = function(selector){
		return document.querySelector(selector);
	}

	var oComment = new Comment();
	

	var oPraise = new Praise();
	var oPull;
	var commentDetail = {
		
		getMyComment: function(id, pageNum, callback){
			
			// 获取元素
			commentDetail.replyCont = querySelector('.c-reply');

    		
			newsSvc.getReviewedDocList(pageNum).then(function(res){
				
				// 没有评论
				if (res.pagination.totalItems == 0) {
					res.list = ['您还没有评论哦！'];
				} else {
					// 处理发布时间
					res.list = oComment.serializeDate(res.list);
					if (pageNum == 1) {
						oComment.commentList = res.list;
					} else {
						oComment.commentList = oComment.commentList.concat(res.list);
					}	
				}
				
    			addCommentList(pageNum, res.list);
    			callback && callback(res);
    			
    		}).catch(function(res){
    			
    			if (res.code != 0) {
    				res.message = pageNum == 1 ? '您还没有评论哦' : '没有更多数据了';
    			}
    			callback && callback(res);
    		})
		}
	};
	 /**
     * 获取回复列表
     * @param {Object} articleContent
     */
    function getMyComment(articleContent, pageSize, pull){
    	
    	oComment.getCommentList =  commentDetail.getMyComment;
    	oComment.getInitCommentList(articleContent, pageSize, pull)
    }
   
   	/**
   	 * 插入评论
   	 * @param {Object} pageNum
   	 * @param {Object} list
   	 */
    function addCommentList(pageNum, list){
    	var tempDom;
    	var body = querySelector('.comment-body');
    	var insertClass = 'comment-line-wrap';
    	
    	if (pageNum == 1) {
  			body.innerHTML = '';
  		}
    	mui.each(list, function(index, val){
    		tempDom = document.createElement('div');
    		
    	
    		if (typeof val == 'string') {
    			tempDom.innerHTML = val;
    			insertClass = 'mui-text-center';
    		} else {
    			
    			tempDom.innerHTML = common.utils.patternStrPlus(querySelector('#comment').innerHTML, 
	    			{id: val.id, 
	    				docId: val.docId,
	    				docTitle: val.docTitle,
	    				docImage: val.docImage || '../images/img-empty.jpg',
	    				headpath: val.headpath ? val.headpath : '../images/user-photo.png', 
	    				reviewerName: val.userName || '我', 
	    				reviewerId: val.viewId,
	    				createTime: val.createTime, 
	    				content: val.content,
	    				articleType: val.docType,
	    				agreeCount: val.agreeCount || '0', 
	    				noAgreeCount: val.noAgreeCount || '0',
	    				isPrasie: val.hateStates == 1 ? 'light-praise' : '',
	    				isTread: val.hateStates == 2 ? 'light-praise' : '',
	    				isNewState: val.agreeStates == 0 || val.repStates == 0 ? '' : 'mui-hidden'
	    			});	
    		}
    		
			tempDom.id = val.viewId;
	  		tempDom.classList.add(insertClass);  
	  		
	  		
    		body.appendChild(tempDom);
	    				
    	})
    	
		tempDom  = null;
    }
    
	mui.plusReady(function(e){

		oPull = Pull.init({}, getMyComment);
		
		mui(document).on('tap', '.comment-praise', function(e){
			var type = this.getAttribute('data-type');
			oPraise.followCommentHandle(type, this, oComment);
			e.stopPropagation();
		})
		
		// 去文章
		mui(document).on('tap', '.article-shrink', function(e){
			var articleType = this.getAttribute('data-articleType');
			var aId = this.getAttribute('data-articleId');
			var image = this.getAttribute('data-image');
			var targetUrl = 'article.html';
			var pageId = 'article';
				
			
			if (articleType == 2) {
				targetUrl = 'article-video.html';
				pageId = 'article-video';
			}
			mui.openWindow({
	            url: targetUrl + '?aid=' + aId + '&image=' + encodeURIComponent(image),
	            id: pageId,
	            extras: {prives: 'myComent'},
	            waiting: {autoShow: false}
	        });
	        e.stopPropagation();
		}, false)
		
		
		// 去回复详情
		mui(document).on('tap', '.comment-line-wrap', function(e){
	
			var commentId = this.getAttribute('id');
			var currentComment = oComment.getCommentListById(commentId);
			var tempData = {};
			
			var articleData = {
				image: currentComment.docImage || '../images/img-empty.jpg',
				title: currentComment.docTitle,
				author: currentComment.docOperator,
				id: currentComment.docId
			}
			
			mui.extend(tempData, currentComment);
			
			tempData.id = currentComment.viewId;
			tempData.agreeStates = currentComment.hateStates;
			tempData.type = currentComment.docType;
			mui.openWindow({
	            url:"article-comment-detail.html",
	            extras: {commentInfo: tempData, articleData: articleData, previes: 'myComment'},
	            id: "comment-detail",
	            waiting: {autoShow: false}
	        });
	        
	        
	        var noticeType;
	        // 有新的通知
	        if (currentComment.agreeStates == 0 || currentComment.reqStates == 0) {
	        	
	        	noticeType = currentComment.agreeStates == 0 || currentComment.repStates == 0 ? 3 : currentComment.agreeStates == 0 ? 1 : currentComment.reqStates == 0 ? 2 : '';
		        newsSvc.modityFollowState(2, noticeType, commentId).then(function(res){
		        }).catch(function(res){
		        	
		        })	
	        }
	        
	        g(commentId).querySelector('.red-light').classList.add('mui-hidden');
		}, false)

		//更新
		window.addEventListener('video-listen', function(e){		  

		    if (e.detail) {
		    	oPraise.setFollowState(e.detail, oComment);
		    }
		});
	
		window.addEventListener('refresh_data', function(e){//执行刷新
		    oPull.pullDownLoading();
		}); 
	})
}())
