(function($, doc) {
	var mId = common.utils.queryString('mId');
	var user = app.getUser();
	var followedId, authorInfo; //作者id
	var tab_index = 0;
	var rq_params = {
		pageSize: 10,
		pageNum: 1,
		releaseOperator: user.userId
	}; //头条评论的请求参数
	var articleParams = {
		pageSize: 10,
		pageNum: 1,
		reviewUserId: user.userId
	}; //文章评论的参数
	var visualParams = {
		pageSize: 10,
		pageNum: 1,
		reviewUserId: user.userId
	}; //小视频
	//文章默认图片
	var article_defaultPic = '../images/defaultheader.png',
		news_default = '../images/defaultheader.png';
	// 初始化
	var init = {
		getuser: function(user) {
			// headPath 头像
			document.querySelector('.infoCard .infoCard_headerpic img').setAttribute('src', user.headPath ? user.headPath : article_defaultPic);
			// userName
			document.querySelector('#authorName').innerHTML = user.userName ? user.userName : '暂无';
			// introduce
			document.querySelector('#personal_brief').innerHTML = user.introduce ? user.introduce : '暂无';
		}
	}
	//处理图片
	function dealPic(imgList, m) {
		var imgHTML = [],
			imgStr = "";
		for(k = 0; k < imgList.length; k++) {
			imgHTML = imgHTML.concat([
				'<div class="info_img pic"><img src="', imgList[k], '" data-preview-src="" data-preview-group="', m, '" /></div>'
			]);
		}
		imgStr = imgHTML.join("");
		return imgStr;
	}

	function pullupRefresh(pullSel, index) {
		if(index == 0) {
			//头条
			rq_params.pageNum++;
			getAllCom(rq_params, pullSel);
		} else if(index == 1){
			// 文章
			articleParams.pageNum++;
			getArticleCom(articleParams, pullSel);
		}else {
			// 小视频
			visualParams.pageNum++;
			getReviewList(visualParams,pullSel);
		}
	}

	var scroll_obj;
	var setPullToRefresh = function(tab_index) {
		var node = document.querySelectorAll('#pullRefreshs .mui-scroll')[tab_index];
		var deferred = Q.defer();
		scroll_obj = $(node).pullToRefresh({
			up: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						pullupRefresh(self, tab_index);
					}, 100);
				}
			}
		});
	}

	function delHtmlTag(str) {　　
		return str.replace(/<[^>]+>/g, "");
	}

	// 头条
	function getAllCom(params, pullSel) {
		var id = params.releaseOperator;
		var pageNum = params.pageNum;
		var pageSize = params.pageSize;
		newsSvc.getCommentLists(id, pageSize, pageNum).then(function(res) {
			var list = res.list;
			if(list.length <= 0) {
				if(pullSel) {
					pullSel.endPullUpToRefresh(true);
				} else {
					g("noComment").classList.remove("mui-hidden");
				}
			} else {
				g("noComment").classList.add("mui-hidden");
				if(authorInfo.headPath){
					news_default = authorInfo.headPath;
				}
				$.each(list, function(key, value) {
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class", "mes");
					oDiv.setAttribute("minfoId", value.minfoId);
					oDiv.setAttribute("commentType", value.minfoType);
					oDiv.setAttribute('status',value.status);
					var htmlCon = [];
					var userName = '';
					if(value.content == "") {
						value.content = "#头条#"
					} else {
						if(value.content.indexOf("img") > 0) {
							value.content = value.content.replace(/<img.*\/>/ig, "")
						}
						value.content = delHtmlTag(value.content);
					}
					if(value.minfoType == 4) {
						//纯文字
						htmlCon = htmlCon.concat([
							'<div class="authorMes"><div class="author_pic">',
							'<img src="',news_default,'"></div>',
							'<div class="author_info"><p class="authorName">', authorInfo.userName, '</p>',
							'<p class="publishTime">', value.createDate, '</p></div></div>',
							'<div class="comment_txt">', value.content, '</div>',
							'<div class="minfn_info word"><div class="wordTxt mui-ellipsis-2">', value.title, '</div></div>'
						]);
						oDiv.innerHTML = htmlCon.join("");
					} else {
						//文字和图片
						htmlCon = htmlCon.concat([
							'<div class="authorMes"><div class="author_pic">',
							'<img src="',news_default,'" /></div><div class="author_info">',
							'<p class="authorName">', authorInfo.userName, '</p><p class="publishTime">', value.createDate, '</p>',
							'</div></div><div class="comment_txt">', value.content, '</div>',
							'<div class="minfn_info pic clearfix">',
							'<div class="minfn_info_pic" style="background:url(',value.image,') no-repeat 50% 50%;background-size:cover;"></div>',
							'<div class="minfn_info word">',
							'<div class="wordTxt mui-ellipsis-2">', value.title, '</div></div></div>'
						]);
						oDiv.innerHTML = htmlCon.join("");
					}
					g("author_comment").appendChild(oDiv)
				})
				g("tab_comment").setAttribute("load", 1);
				if(pullSel) {
					var len = $("#author_comment .mes").length;
					pullSel.endPullUpToRefresh(len>=res.pagination.totalItems);
				} else {
					if(res.pagination.totalItems > res.pagination.pageSize){
						setPullToRefresh(0);
					}
				}
			}
		}).then(function(err) {
			console.log(err)
		});
	};

	// 文章评论
	function getArticleCom(params, pullSel) {
		newsSvc.getArticleCom(params.reviewUserId, params.pageSize, params.pageNum).then(function(res) {
			var comment_list = res.list;
			if(comment_list.length > 0) {
				g("no_article_comment").classList.add("mui-hidden");
				for(var m = 0; m < comment_list.length; m++) {
					var value = comment_list[m];
					var htmlCon = [];
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class", "mes");
					oDiv.setAttribute("articleId", value.documentId);
					oDiv.setAttribute("docType", value.docType);
					oDiv.setAttribute('status',value.status);
					var defaultPic = article_defaultPic;
					if(authorInfo.headPath){
						defaultPic = authorInfo.headPath;
					}
					htmlCon = htmlCon.concat([
						'<div class="authorMes"><div class="author_pic">',
						'<img src="', defaultPic, '" /></div><div class="author_info">',
						'<p class="authorName">', authorInfo.userName, '</p><p class="publishTime">', value.createDate, '</p>',
						'</div></div><div class="comment_txt">', value.content, '</div>',
						'<div class="minfn_info pic clearfix">',
						'<div class="minfn_info_pic" style="background:url(',value.image,') no-repeat 50% 50%;background-size:cover;"></div>',
						'<div class="minfn_info word">',
						'<div class="wordTxt mui-ellipsis-2">', value.title, '</div></div></div>'
					]);
					oDiv.innerHTML = htmlCon.join("");
					g("articleCom").appendChild(oDiv);
				};
				g('article_tab_comment').setAttribute('load',1);
				if(pullSel) {
					var len = $("#articleCom .mes").length;
					pullSel.endPullUpToRefresh(len >= res.pagination.totalItems);
				} else {
					if(res.pagination.totalItems > res.pagination.pageSize){
						setPullToRefresh(1)
					}
				}
			} else {
				if(pullSel) {
					pullSel.endPullUpToRefresh(true);
				} else {
					g("no_article_comment").classList.remove("mui-hidden");
				}
			}
		}).catch(function(e) {
			console.log(err.message.err)
		})
	}
	
	// 小视频评论
	function getReviewList(params,pullSel){
		newsSvc.getFirstReviewList(params.reviewUserId,params.pageNum,params.pageSize).then(function(data){
			if(data && data.list.length > 0){
				g('no_visual_comment').classList.add('mui-hidden');
				$.each(data.list,function(idx,val){
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					oDiv.setAttribute("visualId",val.contentId);
					oDiv.setAttribute("showType",val.showType);
					oDiv.setAttribute("status",val.status);
					oDiv.innerHTML = '<div class="authorMes">' +
							'<div class="author_pic"><img src="' + (authorInfo.headPath ? authorInfo.headPath : article_defaultPic) + '"></div>' +
							'<div class="author_info">' +
								'<p class="authorName">' + authorInfo.userName + '</p>' +
								'<p class="publishTime">' + val.showTime + '</p>' +
							'</div>' +
						'</div>' +
						'<div class="comment_txt">' + val.content + '</div>' +
						'<div class="minfn_info pic clearfix">' +
							'<div class="minfn_info_pic" style="background:url(' + val.image + ') no-repeat 50% 50%;background-size:cover;"><div class="play_icon"><div class="float-btn fa fa-play"></div></div></div>' +
							'<div class="minfn_info word">' +
								'<div class="wordTxt mui-ellipsis-2">' + val.title + '</div>' +
							'</div>' +
						'</div>' +
					'</div>';
					g('visualCom').appendChild(oDiv);
				})
				g('visual_tab_comment').setAttribute('load',1);
			}else{
				if(params.pageNum <= 1){
					g('no_visual_comment').classList.remove('mui-hidden');
				}
			}
			if(pullSel){
				var len = $("#visualCom .mes").length;
				pullSel.endPullUpToRefresh(len>=data.pagination.totalItems);
			}else{
				if(data.pagination.totalItems >= data.pagination.pageSize){
					setPullToRefresh(2)
				}
			}
		}).catch(function(err){
			console.log(err.message.err)
		})
	}

	// 导航
	g('slider').addEventListener('slide', function(event) {
		var index = event.detail.slideNumber;
		tab_index = index;
		var load = $("#tabs a")[index];
		var judge = load.getAttribute("load");
		if(judge == 0) {
			if(index == 0) {
				// 头条
				getAllCom(rq_params)
			} else if(index == 1) {
				// 文章
				getArticleCom(articleParams)
			}else {
				getReviewList(visualParams);
			}
		}
	}, false);

	//点击评论进入头条详情
	$("#author_comment").on("tap", ".mes", function(e) {
		e.stopPropagation();
		var minfoId = this.getAttribute("minfoId"),
			commentType = this.getAttribute('commentType'),
			status = parseInt(this.getAttribute('status'));
		if(status !== 2){
			$.toast('该内容已删除，无法查看哦！');
			return false;
		}else{
			if(commentType == 0 || commentType == 2 || commentType == 4) {
				$.openWindow("minfo/minfo.html?mId=" + minfoId);
			} else {
				$.openWindow("minfo/minfo-video.html?mId=" + minfoId);
			}
		}
	})

	//点击评论进入文章详情
	$('#articleCom').off('tap').on('tap', '.mes', function(e) {
		e.stopPropagation();
		var articleId = this.getAttribute("articleId"),
			docType = this.getAttribute('docType'),
			status = parseInt(this.getAttribute('status'));
		if(status !== 2){
			$.toast('该内容已删除，无法查看哦！');
			return false;
		}else{
			if(docType == 2) {
				$.openWindow("article-video.html?aid=" + articleId);
			} else {
				$.openWindow("article.html?aid=" + articleId);
			}
		}
	})
	
	//点击评论进入小视频详情
	$('#visualCom').off('tap').on('tap', '.mes', function(e) {
		e.stopPropagation();
		var visualId = this.getAttribute("visualId"),
			type = this.getAttribute('showType'),
			status = parseInt(this.getAttribute('status'));
		if(status !== 2){
			$.toast('该内容已删除，无法查看哦！');
			return false;
		}else{
			$.openWindow('visualFrequency.html?visualId=' + visualId);
		}
	})
	
	// 分享
	function initshare() {
			console.log('分享')
			var shareMsg = {
				href: 'https://m.joyshebao.com/app/activity/shangyebaoxian/index1.html',
				title: '测试',
				content: '测试',
				thumbs: ["http://img-cdn-qiniu.dcloud.net.cn/icon3.png"] //分享缩略图  
			};
				
			window.share.initShare("shareBth", shareMsg, function() {
				mui.toast('分享成功');
			}, function(e) {
				if(e.code === -100) {
					mui.toast('已取消分享');
				} else {
					mui.toast('分享失败：' + e.message);
				}
			});
	}
	
	var getAuthorInfo = function(id){
		var default_img = '../images/defaultheader.png';
		newsSvc.getUserInfo(id).then(function(res){
			authorInfo = res.userInfo;
//			g("follow_num").innerHTML=authorInfo.followCount;
//			g("follow_fans").innerHTML=authorInfo.followedCount;
			followedId = authorInfo.userId;
			articleParams.reviewUserId = followedId;
			rq_params.releaseOperator = followedId;
			g("authorName").innerHTML = authorInfo.userName;
			if(authorInfo.signName){g("personal_brief").innerHTML = authorInfo.signName;}
//			jel('#followBtn').attr('class',authorInfo.isFollow==1?'followBtn followed':'followBtn nofollow');
//			jel('#followBtn').html(authorInfo.isFollow==1?'已关注':'+关注');
			if(authorInfo.headPath){
				default_img = authorInfo.headPath;
			}
			g('autorImg').setAttribute('src',default_img);
			getAllCom(rq_params);
		}).catch(function(err){
			console.log(err.message.err)
		})
	};

	$.plusReady(function() {
		init.getuser(user);
		$('#pullRefreshs .mui-scroll-wrapper').scroll({
			bounce: false,
			indicators: true,
			deceleration: mui.os.ios ? 0.003 : 0.0009
		});
		window.addEventListener('refresh_data', function(e) { //执行刷新
			initData(user.userId, true);
		});
		initshare();
	});

	// 个人简介
	var main = {};
	main.myPageFun = {
		getUserInfo: function() {
			var state = app.getState();
			if(state.token) {
				$.openWindow({
					id: 'topHandImg',
					url: 'my-info.html'
				});
			} else {
				app.toLogin();
			}
		}
	}
	// 更新简介
	window.addEventListener('refreshSelf',function(){
		var user = app.getUser();
		init.getuser(user);
	},false)

	g('topHandImg').addEventListener('tap', function() {
		main.myPageFun.getUserInfo();
	}, false);
	getAuthorInfo(user.userId);
})(mui, document);