(function($,doc,app,userSvc) {
	var logUser = app.getUser()||{};
	var dirty = false;
	var auths = {};
	
	var saveNickNameBtn = doc.getElementById('saveNickName');
	var savePasswordBtn = doc.getElementById('savePassword');
	var mobileBar = doc.getElementById('mobileBar');
	var setMobileLink = doc.getElementById('setMobileLink');
	var getCameraBtn = doc.getElementById('getCamera');
	var galleryBtn = doc.getElementById('gallery');
	var signOutBtn = doc.getElementById('signOut');
	var intruduce = doc.getElementById('setIntroduce');
	var saveIntroduceBtn = doc.getElementById('saveintroduce');// 个性签名保存
	//var quitBtn = doc.getElementById('quit');

	$.init({
		swipeBack:true, //启用右滑关闭
		gestureConfig: {pinch: true,doubletap: true}//手势配置
	});
	
	//初始化单页的区域滚动
	$('.mui-scroll-wrapper').scroll();
	
	//初始化单页view
	var viewApi = $('#mainView').view({ defaultPage: '#info' });
	var view = viewApi.view;
	view.addEventListener('pageShow',function(e){
		setInfo();//初始化
		mui.currentWebview.setStyle({
			popGesture:e.detail.page.id=='info'?'close':'none'
		});
	},false);
	viewApi.onPageBack('setMobile',function(){
		g('mtelStep1').classList.remove('mui-hidden');
		g('mtelStep2').classList.add('mui-hidden');
		g('txtOldMobile').value='';
		g('txtNewMobile').value='';
		g('txtRCode').value='';
		document.activeElement.blur();
	});
	
	//处理view的后退与webview后退
	var oldBack = $.back;
	$.back = function() {
		if (viewApi.canBack()) {
			viewApi.back();
		} else {
			if(dirty){
				app.fireEvent('main','refreshUserShow');
			} 
			oldBack();
		}
	};

	var checkBind = function(){
		var oauths = {weixin:'微信',qq:'QQ',sinaweibo:'微博',xiaomi:'小米',alipay:'支付宝'};
		var user = app.getUser();
		$.each(oauths,function(i,auth){
			var li = g(i);
			if(!li) return;
			if(user[i]){
				li.classList.remove('unbind');
				li.classList.add('bind');
				li.innerHTML= '<a class="mui-navigate-right">'+auth+'</a>'
					+'<div id="mobile" class="item-des color-dark">已绑定</div>';//user[i].nickname
			}else{
				li.classList.remove('bind');
				li.classList.add('unbind');
				li.innerHTML= '<a class="mui-navigate-right">绑定'+auth+'账号</a>';
			}
		});
	};
	
	var setInfo = function(){
		var user = app.getUser()||{};
        if(user.headPath){
        	jel('#headImg').attr('src',user.headPath);
        }else{
        	jel('#headImg').attr('src','../images/user-photo.png');
        }
		jel('#nickName').text(user.userName);
		jel('#introduceName').text(user.introduce ? user.introduce : '请输入个性签名');//个人简介
		jel('#password').text(user.hasPwd ? '已设置':'未设置');
		jel('#mobile').text(user.mobile);
		jel('#name').text(user.realname || '');
		jel('#idcard').text(user.bodyCode);
		jel('#txtNickName').val(user.userName);
		jel('#qsCon').val(user.introduce);
		if(!user.hasPwd) jel('#opassPan').hide();
		jel('#txtOldPassword').val('');
		jel('#txtPassword').val('');
		jel('#txtRePassword').val('');		
		checkBind();
		realtime();
//		g("qsCon").addEventListener('change',realtime,false);
	};

	var setUser = function(obj){
		dirty = true;
		var user = mui.extend({},app.getUser(),obj);
		app.setState('info',user);
		app.fireEvent('main','refreshUserShow');
		app.fireEvent('topHandSelf','refreshSelf');
	};

	var setPassword = function () {
		var pass = jel('#txtPassword').val();
		var repass = jel('#txtRePassword').val();
		if (pass.length<6) {
			$.toast('密码不少于6个字符');
			return;
		}
		if(pass !== repass){
			$.toast('两次输入密码不一致');
			return;
		}
		var pdata = {newPassWord:pass,repPassWord:repass};
		if(logUser.hasPwd){
			var opass = jel('#txtOldPassword').val();
			if (opass.length<6) {
				$.toast('原密码错误');
				return;
			}
			data.oldPassWord = opass;
			userSvc.modifyPassWord(pdata).then(function (data) {
				$.toast('设置密码成功');
				$.back();
			}).catch(function (err) {
				$.toast(err.message);
				console.error(err.message,err);
			});
		}else{
			userSvc.setPassword(pdata).then(function (data) {
				$.toast('设置密码成功');
				setUser({hasPwd:true});
				$.back();
			}).catch(function (err) {
				$.toast(err.message);
				console.error(err.message,err);
			});
		}
	};
	
	var setUsername = function () {
		var uname = jel('#txtNickName').val();
		if(uname.length<2){
			$.toast('<span class="color-red">昵称不能少于2个字符</span>',{type:'div'});
			return;
		}
		if (!/^[a-zA-Z0-9_\u4e00-\u9fff]{2,20}$/.test(uname)) {
			$.toast('<span class="color-red">昵称只能为2至10个字符的汉字、字母、数字或下划线</span>',{type:'div'});
			return;
		}
		userSvc.setUsername(uname).then(function (data) {
			setUser({userName:uname});
			setInfo();
			$.toast('修改成功');
			$.back();
		}).catch(function (err) {
			$.toast(err.message);
			console.error(err.message,err);
		});
	};
	// 保存简介
	var setIntroduces = function(){
		var introduce = jel('#qsCon').val();
		var reg = /^[a-zA-Z\u4e00-\u9fff]{,30}$/;
		if(reg.test(introduce)){
			$.toast('<span class="color-red">个人简介只能30字符的汉字、字母</span>',{type:'div'});
			return;
		}
		userSvc.setIntroduce(introduce).then(function (data) {
			setUser({introduce:introduce});
			setInfo();
			$.toast('修改成功');
			$.back();
		}).catch(function (err) {
			$.toast(err.message);
			console.error(err.message,err);
		});
	}
	
	var setMobile = function () {
		var mobile = g('txtNewMobile').value;
		if (!/^1[2-9]\d{9}$/.test(mobile)) {
			$.toast('<span class="color-red">新手机号码错误</span>',{type:'div'});
			return;
		}
		var rcode = g('txtRCode').value;
		if (!/^\d{4}$/.test(rcode)) {
			$.toast('<span class="color-red">短信验证码错误</span>',{type:'div'});
			return;
		}
		plus.nativeUI.showWaiting();
		userSvc.modifyMobile(mobile,rcode).then(function (data) {
			$.toast('手机号码修改成功');
			var vmobile = mobile.replace(/^(\d{3})(.+)(\d{2})$/,'$1******$3');
			setUser({mobile:vmobile});
			g('mobile').innerHTML = vmobile;
			$.back();
		}).catch(function (err) {
			if(err.code.indexOf('cu')==0){
				$.alert(err.message);
			}else{
				$.toast('<span class="color-red">'+err.message+'</span>',{type:'div'});
			}
			console.error(err.message,err);
		});
	};

	var clipAndSaveImg = function(path){
		var wt=plus.nativeUI.showWaiting("正在上传图片...");       
		/*var zoomDiv = document.getElementById("zoomDiv");
        var zoomImg = document.getElementById("zoomImg");
        zoomImg.src = path;
        zoomDiv.style.display = "block";*/
        var savePath = "_doc/head.png";
        var zipOptions = {
    		src:path,
			dst:savePath,
			width:"100px",
			height:"100px",
			format:"png",
			overwrite:true,
			quality:100
        };
    	plus.zip.compressImage(zipOptions,function() {
    		jel('#headImg').attr('src',plus.io.convertLocalFileSystemURL(savePath));
	        userSvc.modifyUserHead(savePath,function (data) {
	        	if(data.indexOf('?')<0) data +='?'+Date.now();
	        	setUser({headPath:data});
    			setInfo();
	            wt.close();
	        },function (err) {
	            wt.close();
	            $.toast(err.message);
	        });
		},function(error) {
			wt.close();
			$.toast(error.message);
		});
	};
	
    var uploadHeadImg = function (path) {
    	var wt=plus.nativeUI.showWaiting("正在上传图片...");
        userSvc.modifyUserHead(path,function (data) {
            setUser({headPath:data});
            setInfo();
            wt.close();
        },function (err) {
            wt.close();
            $.toast(err.message);
        });
    };
	
	var preview = $.previewImage();
	var preDiv = g('__MUI_PREVIEWIMAGE');
	if(preDiv){
		preDiv.addEventListener('tap',function(event){
			preview.close();
			setTimeout(function(){
				preDiv.style.display='none';
			},300);
			event.stopPropagation();
		},false);
	}
	g('headImg').addEventListener('tap',function(event){
		preview.open(this);
		event.stopPropagation();
	},false);
	
	crop.title='设置头像';
	crop.addEventListener('complete',function(event){
		var file = event.detail.b64;
		jel('#headImg').attr('src',file);
		var wt = plus.nativeUI.showWaiting('正在上传图片...');
		userSvc.modifyPortrait(file).then(function(data){
			$.toast('设置头像成功');
			setUser({headPath:data});
            setInfo();
            wt.close();
		}).catch(function(err){
			wt.close();
	        $.toast(err.message);
		});
	},false);
	
	var setHeadByCamera = function () {
		crop.show('camera','portrait');
		$('#setHead').popover('toggle');
		/*$('#setHead').popover('toggle');
		var cmr = plus.camera.getCamera(2);
		cmr.captureImage(function(file){
			console.log(file);
			clipAndSaveImg(file);
		}, function(err){
			console.log('',err);
		});*/
	};
	
	var setHeadByGallery = function () {
		crop.show('gallery','portrait');
		$('#setHead').popover('toggle');
		/*$('#setHead').popover('toggle');
		plus.gallery.pick(function(path){
			console.log(path);
			clipAndSaveImg(path);
		}, function (err) {
			console.log("取消选择图片");
		}, {filter:"image"});*/
	};
	
	//初始化验证注销状态
	var statiing;
	var Initialization = function(){
		userSvc.getSetUpUserInfo(true).then(function (data) {
			if(data.logoutStatus == 0){
	       		//未申请注销[正常登录状态]
	       		statiing = 0 ;
	       		g('setMobileLink').setAttribute('href','#setMobile');
	       	}else if(data.logoutStatus == 1){
	       		//已申请注销，并在7天注销范围内
	       		statiing = 1 ;
	       		return;
	       	}else if (data.logoutStatus == 3){
	       		statiing = 3 ;
	       		//已申请注销
	       	}
        }).catch(function(err) {
			
		});
	}
	Initialization();
	//关闭注销提示
	g('logoutBtn').addEventListener('tap',function(e){
		g('logoutBox').style.display = 'none';
		g('maskBox').style.display = 'none';
	},false);
	//点击识别注销状态
	var setMobileVerification = function (){
		//获取用户信息，判断该用户所属注销状态
		if(statiing == 0){
       		//未申请注销[正常登录状态]
       	}else if(statiing == 1){
       		//已申请注销，并在7天注销范围内
       		g('logoutBox').style.display = 'block';
			g('maskBox').style.display = 'block';
//     		$.toast('抱歉，您的账号已申请注销，无法更换手机号码，如需更换，请到（我的-设置-账户注销）终止账号注销');
       		return;
       	}else if (statiing == 3){
       		//已申请注销
       	}
	}

	
	var siginOut = function () {
		app.removeLogin();
        //app.appRefresh();
        //app.toLogin();
        $.currentWebview.close();
	};
	
	var exit = function () {
		plus.runtime.quit();
	};
	
	var setImbar = function(){
		if(imbar.isImmersedStatusbar){
			var navbars = document.querySelectorAll('.mui-navbar-inner.mui-bar.mui-bar-nav');
			$.each(navbars,function(i,navbar){
				navbar.style.height = imbar.navBarHeight+"px";
				navbar.style.paddingTop=imbar.statusbarHeight+"px";
			});
			var content = document.querySelector('#mainView .mui-pages');
			content.style.top = imbar.navBarHeight+"px";
		}
	};

	var openBindMobile = function(oauth){
		var ouser = auth.getOauthUser(oauth);
		$.openWindow({
			url:'auth-bind.html',
			id:'bind',
			waiting:{
				autoShow:true,
				title:'即将打开绑定页面...',
			},
			extras:{
				ouser:ouser
			}
		});
	};
	
	var sec=0;
    var getRcode = function (btnSelector,mobile) {
    		var getMcodeBtn = document.querySelector(btnSelector);
		if(getMcodeBtn.getAttribute("run")==="1") return;
        var intSms = null;
        if(sec>0){
            return;
        }else if(!/^1[2-9]\d{9}$/.test(mobile)){
            $.toast('请输入正确的手机号码');
        }else{
            getMcodeBtn.innerHTML = '<i class="mui-spinner" style="margin-top:4px"></i>';
          	userSvc.sendOptSms(mobile,'SET_Mobile').then(function (data) {
                $.toast('验证码已发送');
                sec = 60;
                intSms = setInterval(function () {
                		getMcodeBtn.setAttribute("run","1");
                    sec--;
                    if(sec <= 0){
                        clearInterval(intSms);
                        getMcodeBtn.setAttribute("run","0");
                        getMcodeBtn.innerHTML = '重新获取';
                    }else{
                        getMcodeBtn.innerHTML = sec+'s';
                    }
                },1000);
            }).catch(function (err) {
            		getMcodeBtn.setAttribute("run","0");
                getMcodeBtn.innerHTML = '获取验证码';
                $.toast(err.message);
                console.error(err.message,err);
            });
        }
    };
	
	// 绑定第三方
	$('.oauths').on('tap', 'li',function(){
		$.openWindow({url:'oauth-unbind.html?type='+this.id});
	});
//	g('signOut1').addEventListener('tap', siginOut,false);
	g('txtNickName').addEventListener('input', function(){
		if(!/^[a-zA-Z0-9_\u4e00-\u9fff]+$/.test(this.value)){
			$.toast('<span class="color-red">昵称只能输入汉字、字母、数字或下划线</span>',{type:'div'});
		}
	},false);
	 var realtime = function (){
	 	var $_len = jel("#qsCon").val();
		var $_con = $_len.replace(/[\s]/g,"");
		var last_num = 30 - parseInt($_con.length);
		g("wordLimit").innerHTML = last_num;
	}
	// 个性签名实时改变
	g("qsCon").addEventListener('input',realtime,false);
	signOutBtn.addEventListener('tap', siginOut,false);
	//quitBtn.addEventListener('tap', exit,false);
	saveNickNameBtn.addEventListener('tap',setUsername,false);
	savePasswordBtn.addEventListener('tap',setPassword,false);
	saveIntroduceBtn.addEventListener('tap',setIntroduces,false);
	getCameraBtn.addEventListener('tap',setHeadByCamera,false);
	galleryBtn.addEventListener('tap',setHeadByGallery,false);
	setMobileLink.addEventListener('tap',setMobileVerification,false);
	g('checkMobile').addEventListener('tap',function(){
		var mobile = g('txtOldMobile').value;
		if(!/^1[2-9]\d{9}$/.test(mobile)){
			$.toast('<span class="color-red">旧手机号输入有误</span>',{type:'div'});
			return;
		}
		plus.nativeUI.showWaiting();
		userSvc.checkOldMobile(mobile).then(function(data){
			g('mtelStep1').classList.add('mui-hidden');
			g('mtelStep2').classList.remove('mui-hidden');
		}).catch(function(err){
			if(err.code.indexOf('cu')==0){
				$.alert(err.message);
			}else{
				$.toast('<span class="color-red">'+err.message+'</span>',{type:'div'});
			}
			console.error(err.message,err)
		});
	},false);
	g('getMcode').addEventListener('tap',function(e){
		getRcode('#getMcode',g('txtNewMobile').value);
	},false);
	g('modifyMobile').addEventListener('tap',function(e){
		setMobile();
	},false);
	
	window.addEventListener('checkBind',checkBind,false);
	window.addEventListener('refresh_data',checkBind,false);
	
	setImbar();
	setInfo();
	
	g('self_back').addEventListener('tap',function(e){
		mui.back();
	},false);
	//神策埋点
	function joyTrack(){
		//设置头像
		jTrack.regEvents('#head a','joyLinkClick','jtrack_name:设置头像');
		//设置昵称
		jTrack.regEvents('#nicknameBar a','joyLinkClick','jtrack_name:设置昵称');
		//设置手机号
		jTrack.regEvents('#mobileBar a','joyLinkClick','jtrack_name:设置手机号码');
		//绑定QQ账户
		jTrack.regEvents('#qq.bind','joyLinkClick','jtrack_name:绑定QQ账户');
		//绑定微信账户
		jTrack.regEvents('#weixin.bind','joyLinkClick','jtrack_name:绑定微信账户');
		//绑定微博账户
		jTrack.regEvents('#sinaweibo.bind','joyLinkClick','jtrack_name:绑定微博账户');
		//绑定支付宝账户
		jTrack.regEvents('#alipay.bind','joyLinkClick','jtrack_name:绑定支付宝账户');
		//解绑QQ账户
		jTrack.regEvents('#qq.unbind','joyLinkClick','jtrack_name:解绑QQ账户');
		//解绑微信账户
		jTrack.regEvents('#weixin.unbind','joyLinkClick','jtrack_name:解绑微信账户');
		//解绑微博账户
		jTrack.regEvents('#sinaweibo.unbind','joyLinkClick','jtrack_name:解绑微博账户');
		//解绑支付宝账户
		jTrack.regEvents('#alipay.unbind','joyLinkClick','jtrack_name:解绑支付宝账户');
	}
	$.plusReady(function() {
		auth.setAuths(function(data,oauths){
			auths = data;
			//authority = oauths;
			if(!oauths['weixin']) g('weixin').classList.add('mui-hidden');
			if(!oauths['qq']) g('qq').classList.add('mui-hidden');
			if(!oauths['sinaweibo']) g('sinaweibo').classList.add('mui-hidden');
			if(!oauths['alipay']) g('alipay').classList.add('mui-hidden');
		},function(err){
			console.log(JSON.stringify(err));
			$.toast(e.message);
		});
		var webview = plus.webview.currentWebview();
		// 安卓返回键
	    plus.key.addEventListener('backbutton', function() {
	        mui.back();
	    });
	    joyTrack();
	}); 

})(mui,document,app,userSvc);