(function($){
	$.init({swipeBack:true});
	
	var pager = {"pageNum":1,"pageSize":3};
	var videoList = document.getElementById('video-list');
	var zaiXian = document.getElementById('zaiXian');
	var deep = document.getElementById('deep');
  	var searchInput = document.getElementById('searchInput');

	zaiXian.addEventListener('tap',function(){
		app.toKefu();
	});
	
	deep.addEventListener('tap',function(){
		$.openWindow({url:'advice-cate.html'});
	});
	
	var getThumbsUrl = function(url){
		//return url;
		var sufIdx = url.lastIndexOf('.');
		return url.substr(0,sufIdx)+'_420x242'+url.substr(sufIdx);
	};
	
	var setLi = function(data,Lazyload){
		var liHtml ="";
		var allLiHtml = "";
		var length = data.length;
		for(var j = 0; j < data.length; j++){
			var liItem = data[j];
			var title = liItem.title.substr(0,26)+(liItem.title.length>26?'…':'');
			liHtml += [
				'<div class="viedo-li" aid="',liItem.id,'" atitle="',liItem.title,'" type="',liItem.type,'" image="',liItem.image,'" videoUrl="',liItem.videoUrl,'" authorName="',liItem.AuthorName,'" authorHeadPath="',liItem.AuthorHeadPath,'">',
					'<div class="img-cover">',
				  		'<img data-lazyload="'+liItem.image+'" src="../images/loading-news.png"/>',
						'<div class="video-cover">',
							'<span class="video-btn fa fa-play"></span>',
						'</div>',
				  	'</div>',
					'<div class="article-title">',
						title,
					'</div>',
	    		'</div>',
    		].join('');
		}
		allLiHtml = liHtml;
		return allLiHtml;
	};
	
	var titleColor = [
			{color:"#2EA4DD",vId:"1"},
			{color:"#E31673",vId:"2"},
			{color:"#009F97",vId:"3"},
			{color:"#F09500",vId:"4"}];
	
	var setListHtml = function(data){
		var html = "";
		var liHtml ="";
		$.each(data, function(i,item) {
			//var item = data[i];
			var colorStyle = titleColor[i]?' style="color:'+titleColor[i].color+'"':'';
			var videoDiv = document.createElement('div');
    		videoDiv.className='video-div';
    		videoDiv.setAttribute('videoId',item.videoId);
    		videoList.appendChild(videoDiv);
			var Lazyload = $('.video-div[videoId="'+item.videoId+'"]').imageLazyload({
				placeholder: '../images/loading-news.png',
				autoDestroy: false
			});
    		videoDiv.innerHTML =[
				'<div class="video-cate mui-clearfix">',
					'<div class="cate-title">',
						item.videoName,
						'<span class="cate-entitle title-color1"'+colorStyle+'>',
							item.videoEname,
						'</span>',
					'</div>',
					'<span videoSearch="',item.videoSearch,'" class="cate-more">更多<i class="fa fa-angle-right"></i></span>',
				'</div>',
				'<div class="video-group mui-scroll-wrapper mui-segmented-control mui-segmented-control-inverted">',
					'<div class="mui-scroll" cateid="',item.videoId,'" pindex="1">',
						setLi(item.videoList,Lazyload),
					'</div>',
				'</div>'].join('');
			Lazyload.refresh(true);
		});
	};
	var setWrapperHeight = function(box){
		var scss = box.querySelectorAll('.mui-scroll-wrapper');
		$.each(scss, function(idx,sc) {
			sc.style.height = sc.children[0].offsetHeight+'px';
		}); 
	};
	
	var getDocVideoClassList = function(){
		newsSvc.getDocVideoClassList().then(function(data){
			setListHtml(data);
			$('.video-list .mui-scroll-wrapper').scroll();
		}).catch(function(err){
			console.error(err.message,err);
		});
	};
	var pageDown = function(scrollEl){
		var cateId = scrollEl.getAttribute('cateid');
		var pageIndex = parseInt(scrollEl.getAttribute('pindex'))+1;
		var pageOver = scrollEl.getAttribute('pageover');
		var isPaging = scrollEl.getAttribute('paging');
		var pageSize = 3;
		if(pageOver!='1' && isPaging!='1'){
			var Lazyload = $('.video-div[videoId="'+cateId+'"]').imageLazyload({
    			placeholder: '../images/loading-news.png',
    			autoDestroy: false
			});
			scrollEl.setAttribute('paging','1'); 
			scrollEl.appendChild(g('pageLoader'));
			newsSvc.getVideoListById(cateId,pageIndex,pageSize).then(function(data){
				var pageCount = parseInt((data.pagination.totalItems+pageSize-1)/pageSize);
		        pageIndex = data.pagination.pageNum;
		        if(pageIndex >= pageCount){ 
		        	scrollEl.setAttribute('pageover','1'); 
		        }
				if(data.list.length>0){
					scrollEl.innerHTML += setLi(data.list,Lazyload);
					Lazyload.refresh(true);
					scrollEl.setAttribute('pindex',pageIndex);
				}
				g('loaderBox').appendChild(g('pageLoader'));
				scrollEl.setAttribute('paging','0');
			}).catch(function(err){
				g('loaderBox').appendChild(g('pageLoader'));
				scrollEl.setAttribute('paging','0');
				console.error(err.message,err);
			});
			
		}
	};
	
	getDocVideoClassList();

	$('#video-list').on('tap','.cate-more',function(){
		$.openWindow({
			url:'search_news.html?type=2&words=' + encodeURIComponent(this.getAttribute('videoSearch')),
			id:'searchNews',
			waiting: {autoShow: false}
		});
	});
	
	$('#searchInput').on('tap','.search-form',function(){
		$.openWindow({url:'search_news.html?type=2'});
	});
	
	$('#video-list').on('tap','.viedo-li',function(){
		var aid = this.getAttribute('aid');
		var params = {
        	aid:aid,
        	title:this.getAttribute('atitle'),
        	image:this.getAttribute('image'),
        	type:this.getAttribute('type'),
        	videoUrl:this.getAttribute('videoUrl'),
        	authorName:this.getAttribute('authorName'),
        	authorHeadPath:this.getAttribute('authorHeadPath')
        };
        var targetUrl = (params.type==2?'article-video.html':'article.html') +
        		'?aid='+params.aid+'&image='+encodeURIComponent(params.image);
        $.openWindow({
        	id: params.type==2 ? 'article-video' : 'article',
            url: targetUrl,
            extras: params,
            waiting: {autoShow: false}
        });
	});
	
	$('#video-list').on('scroll','.mui-scroll',function(event){
		var scrollLeft = Math.abs(event.detail.x);
		var scrollWidth = event.detail.scrollerWidth;
		var allwd = document.documentElement.clientWidth;
		if(scrollLeft+allwd>scrollWidth-40){
			pageDown(this);
		}
	});
	$(".mui-scroll-wrapper").scroll({bounce: false,indicators: false}); 

})(mui)