/**
 * Created by tuchl on 2017-02-21.
 */
(function($) {
	$.init();
	var oauth = null;
	var oauths = {weixin:'微信',qq:'QQ',sinaweibo:'微博',xiaomi:'小米',alipay:'支付宝'};
	var type = common.utils.queryString('type');
	var user = app.getUser();
	
	var g = function(id){ return document.getElementById(id); };
	
	var unBindSuccess = function(data){
    		plus.nativeUI.closeWaiting();
		if(oauth.userInfo && oauth.logout){
    			oauth.logout(function(evt){
    				console.log(JSON.stringify(evt));
    			}, function(e){
    				console.log(JSON.stringify(e));
    				//$.toast("获取登录认证失败：" + e.message);
    			});
    		}

    		user[type] = null;
    		app.setState('info',user);
    		$.toast("解除绑定成功");
    		$.fire(plus.webview.currentWebview().opener(),'checkBind');
    		$.back();
    	};
	
	var unBindFail = function(err){
		plus.nativeUI.closeWaiting();
		$.toast(err.message);
		console.error(err.message,err);
	};
	
	var unBind = function () {
		$.confirm('您确定要解除绑定吗？','',['确定','取消'],function(e){
			if(e.index == 0){
				var unBindFun = type=='weixin'?userSvc.wxUserUnbind:userSvc.oauthUnbind;
				plus.nativeUI.showWaiting('正在解除第三方绑定...');
				unBindFun(type)
					.then(unBindSuccess)
					.catch(unBindFail);
			}
		});
	};
	
	var bind = function(){
    	    var waiting = plus.nativeUI.showWaiting('正在请求第三方认证...');
		oauth.login(function() {
			waiting.setTitle('正在获取认证信息...');
			oauth.getUserInfo(function() {
				waiting.setTitle('正在绑定账户...');
				doBind(waiting, oauth);
			}, function(e) {
				waiting.close();
				$.toast("获取用户信息失败：" + e.message);
			});
		}, function(e) {
			waiting.close();
			$.toast("登录认证失败：" + e.message);
		});
    };

	//绑定第三方
	var doBind = function(waiting, oauth) {
		var ouser = auth.getOauthUser(oauth);
		var cusInfo = app.getDeviceInfo();
		var bindInfo = $.extend({}, ouser, cusInfo);
		var bindFun = type == 'weixin' ? userSvc.wxLoginBind : userSvc.oauthBind;
		bindFun(ouser).then(function(data) {
			waiting.close();
			$.toast('绑定成功');
			user[type] = ouser;
			app.setState('info', user);
			$.fire(plus.webview.currentWebview().opener(), 'checkBind');
			$.back();
		}).catch(function(err) {
			waiting.close();
			$.toast(err.message);
			console.error(err.message, err);
		});
	};

	$.ready(function(){
		g('oauthLogo').innerHTML = '<img src="../images/services/'+type+'.png">';
		if(user[type]){
			g('oauthName').innerHTML = user[type].nickname||oauths[type];
			g('content').classList.add('unbind');
			g('unbind').style.display='block';
		}else{
			g('oauthName').innerHTML = oauths[type];
			g('content').classList.remove('unbind');
			g('bind').style.display='block';
		}
	});
	
	$.plusReady(function() {
		auth.setAuths(function (data,auths) {
			oauth = auths[type];
			if(oauth){
				$('.btns').on('tap','#unbind:not(.mui-disabled)',unBind);
				$('.btns').on('tap','#bind:not(.mui-disabled)',bind);
				g('unbind').classList.remove('mui-disabled');
				g('bind').classList.remove('mui-disabled');
			}else{
				$.toast('不存在相关服务');
			}
		},function (err) {
			$.toast(err.message);
		});
	});

})(mui);