/**
 * Created by tuchl on 2016-08-12.
 */
(function($) {
	var pager = {
			pageIndex: 0,
			pages: 1,
			status: 0,
			type: 1
		},
		oldBack = $.back,
		scroll, pull;
		
	//数据处理
	var getListHtml = function(list) {
		var html = '';
		var addHtml = '';
		addHtml = ['<div class="order-reduce">',
			'<span>用户信息</span>',
			'<div class="order-right">',
			'<span>查看（可减员）</span>',
			'<span class="fa fa-angle-right"></span>',
			'</div>',
			'</div>'
		].join('');
		for(var i in list) {
			var item = list[i];
			var typeColor = 'color-gray';
			switch (item.orderStatus){
				case 100:
					//订单待支付
					typeColor = "color-red";
					break;
				case 101:
					//订单已支付
					typeColor = "color-green";
					break;
				case 102:
					//订单已完成
					typeColor = "color-gray";
					break;
				case 103:
					//订单已失效
					typeColor = "color-gray";
					break;
				default:
					//订单已取消
					typeColor = "color-gray";
					break;
			}
			html += [
				'<li class="order mui-table-view-cell mui-media">',
					'<div class="order-top orderTop" orderType="', item.orderType, '" buzzId="', item.buzzId, '">',
						'<div class="order-hd">',
							'<span class="order-goods">', item.productName, '</span>',
							'<span class="org-name order_status '+ typeColor + '">',
								,item.orderStatusName,
							'</span>',
						'</div>',
						'<div class="mui-media-body border">',
							'<a class="mui-navigate-right">',
								'<p class="order-info">',
									'<span>',
										'<span class="attribute_header">订单编号</span>', item.buzzId, '</span>',
									
									'<span class="org-name mui-ellipsis">',
										'<span class="attribute_header">下单时间</span>', item.createTime,
									'</span>',
									'<span class="order-amt">',
										'<span class="attribute_header">支付金额</span><span class="color-red span_dis">',
										item.orderAmount > 0 ? item.orderAmount+'元':'',
										'</span>',
									'</span>',
								'</p>',
							'</a>',
						'</div>',
						//<span class="mui-pull-right increase_or_decrease">增员失败</span>
						item.orderStatus == 102 ? '<div class="orderBottom"  buzzId="'+item.buzzId+'" orderStatus="'+pager.status+'"><span class="attribute_header">用户信息</span><button class="mui-pull-right look_details">查&nbsp;&nbsp;&nbsp;&nbsp;看</button></div>':'',
					'</div>',
				'</li>',
			].join('');
		}
		return html;
	};
	
	//初始时判断待支付是否有数据（Y:显示小红点；N：隐藏小红点）
	var getOrderListByEx = function (){
		sbSvc.getOrderListByEx_new(1, 10, 1, pager.type).then(function(data) {
			g('redSpot').classList[data.list.length?'remove':'add']('mui-hidden');
		}).catch(function(err) {
			console.error(err.message,err);
		});
	}
	//请求 我的订单列表接口 处理逻辑
	var getOrderList = function(pageIndex, pullSel, dou) {
		getOrderListByEx();
		if(!app.checkLogin() || pageIndex > pager.pages) {
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh(true);
			return;
		}
		if(pageIndex === 1) {
			if(pullSel) pullSel.refresh(true);
			scroll.scrollTo(0, 0);
			pager.pullUpTips.style.display = 'none';
		}
		if(pageIndex === 1 && pullSel) pullSel.refresh(true);
		sbSvc.getOrderListByEx_new(pageIndex, 10, pager.status, pager.type).then(function(data) {
			pager.pageIndex = data.pageNum || 1;
			pager.pages = data.pages || 1;
			if(pager.pageIndex === 1) {
				g('list').innerHTML = '';
			}
			g('list').innerHTML += getListHtml(data.list);
			pager.pullUpTips.style.display = data.total < 10 ? 'none' : 'block';
			if(data.total === 0) g('list').innerHTML = '<div class="not-network"><span>您还没有此类订单</span></div>';
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh(data.pageNum === data.pages);
		}).catch(function(err) {
			if(pullSel && dou) pullSel.endPullDownToRefresh();
			if(pullSel && !dou) pullSel.endPullUpToRefresh();
			if(err.code=='0') g('list').innerHTML = '<div class="not-network"><span>点击页面 重新加载</span></div>';
			console.error(err.message,err);
		});
	};

	var openOrderDetail = function() {
		var buzzId = this.getAttribute("buzzId");
		var orderType = this.getAttribute("orderType");
		var orderUrls = ["",
			"order-detail-shebao.html",
			"order-detail-zhongan.html",
			"order-detail-daikuan.html"
		];
		$.openWindow({
			url: orderUrls[orderType] + "?buzzId=" + buzzId + "&orderType=" + orderType,
			id: "order",
			waiting: {
				autoShow: false
			}
		});
	};

	$.init();
	var fundStateHtml = '';
	var cardStateHtml = '';
	var getPopoverHtml = function(data) {
		var html = '';
		for(var i in data) {
			var item = data[i];
			var cardPayStateColor = item.cardPayState == 0 ? 'zengYuanNo' : 'zengYuanYes';
			var fundPayStateColor = item.fundPayState == 0 ? 'zengYuanNo' : 'zengYuanYes';
			html += [
				'<div class="zengYuan-persion">',
				'<div class="zengYuan-info darkColor">',
				'<div class="zengyuan-head">',
				'<span>', item.name, '</span>',
				'<span class="zengYuan-phone">', item.phone.replace(/^(\d{3})\d{6}(\d+)/,"$1******$2"), '</span>',
				'</div>',
				'<span class="user-card">', item.bodyCode, '</span>',
				'</div>',
				'<div class="zengYuan-select">',
				'<span class="shebao">社保</span>',
				'<div class="zengYuan-right">',
				'<div class="click-Box mui-clearfix" aid="1" securityPersonnelId="', item.securityPersonnelId, '" cardPayStateName="', item.cardPayStateName, '">',
				'<span class="increase_personnel_type '+cardPayStateColor+'">', item.cardPayStateName, '</span>',
				'</div>',
				'</div>',
				'</div>',
				'<div class="zengYuan-select">',
				'<span class="shebao">公积金</span>',
				'<div class="zengYuan-right">',
				'<div class="clickBox mui-clearfix" aid="2" securityPersonnelId="', item.securityPersonnelId, '" cardPayStateName="', item.fundPayStateName, '">',
				'<span class="increase_personnel_type '+fundPayStateColor+'">', item.fundPayStateName, '</span>',
				'</div>',
				'</div>',
				'</div>',
				'</div>',
			].join('');
		}
		//联系客服
//		g('callServices').addEventListener('tap',app.toKefu,false);
		return html;
	}

	var getBuyerStatusList = function(e) {
		var buzzId = this.getAttribute("buzzId");
		var orderStatus = this.getAttribute("orderStatus");
		sbSvc.getBuyerStatusList(buzzId).then(function(data) {
			g('popoverCon').innerHTML = getPopoverHtml(data);
			if(orderStatus == '3' || orderStatus == '0') {
				g('userInformation').style.display = 'block';
				g('checkBtn').setAttribute('bid', buzzId);
				g('checkBtn').classList.remove('fa-dot-circle-o');
				g('checkBtn').classList.add('fa-circle-o');
				g('checkBtn').setAttribute('checkValue', 0);
				g('reduceBtn').classList.add('disabled');
			};
		});
		e.stopPropagation();
	}

	//监听向左滑动  
    document.getElementById('list').addEventListener("swipeleft", function() {  
    	var navA = mui('#nav .mui-tab-item');
    	var state = mui('#nav .mui-tab-item.mui-active')[0].getAttribute('state');
    	state++;
    	if(!(state>=4)){
    		for(var i = 0;i<navA.length;i++){
    			mui('#nav .mui-tab-item')[i].classList.remove('mui-active');
    			if(i==state){
    				mui('#nav .mui-tab-item')[i].classList.add('mui-active');
    			}
    		}
	    	if(pager.status !== state) {
				pager.status = state;
				pull.pullDownLoading();
			}
    	}else {
    		state = 4;
    	}
    	
    });
    
	document.getElementById('list').addEventListener("swiperight", function() {
		var navA = mui('#nav .mui-tab-item');
    	var state = mui('#nav .mui-tab-item.mui-active')[0].getAttribute('state');
    	state--;
    	if(!(state<0)){
    		for(var i = 0;i<navA.length;i++){
    			mui('#nav .mui-tab-item')[i].classList.remove('mui-active');
    			if(i==state){
    				mui('#nav .mui-tab-item')[i].classList.add('mui-active');
    			}
    		}
	    	if(pager.status !== state) {
				pager.status = state;
				pull.pullDownLoading();
			}
    	}else {
    		state = 0;
    	}
	});
	
	
	$('.mui-popup-inner').on('tap', '.jianYuan', function() {
		var cardPayStateName = this.parentNode.getAttribute('cardPayStateName');
		var aId = this.parentNode.getAttribute('aid');
		var securityPersonnelId = this.parentNode.getAttribute('securityPersonnelId');
		g('checkBtn').setAttribute('cid', securityPersonnelId);
		g('checkBtn').setAttribute('aid', aId);
		if(cardPayStateName != '处理中') {
			$('#reducePersion').popover('show');
		} else {
			$('#reducePersion2').popover('show');
		}
	}, false);

	g('checkBtn').addEventListener('tap', function() {
		var checkValue = this.getAttribute('checkValue');
		if(checkValue == 0) {
			this.classList.remove('fa-circle-o');
			this.classList.add('fa-dot-circle-o');
			this.setAttribute('checkValue', 1);
			g('reduceBtn').removeAttribute('disabled');
		} else {
			this.classList.remove('fa-dot-circle-o');
			this.classList.add('fa-circle-o');
			this.setAttribute('checkValue', 0);
			g('reduceBtn').setAttribute('disabled', 'disabled');
		}
	}, false);

	g('reduceBtn').addEventListener('tap', function() {
		if(this.getAttribute('disabled')) return;
		if(g('checkBtn').getAttribute('checkValue') == '1') {
			var aId = g('checkBtn').getAttribute('aid');
			var buzzId = g('checkBtn').getAttribute('bid');
			var securityPersonnelId = g('checkBtn').getAttribute('cid');
			plus.nativeUI.showWaiting();
			sbSvc.personReduceApplication(buzzId, securityPersonnelId, aId).then(function() {
				plus.nativeUI.closeWaiting();
				$('#reducePersion').popover('hide');
				mui.trigger($('.order .orderBottom[buzzid="' + buzzId + '"]')[0], 'tap');
			}).catch(function(err) {
				$.alert(err.message);
			});

		}
	});

	g('closeUserInfo2').addEventListener('tap', function() {
		$('#reducePersion').popover('hide');
	}, false);

	g('closeUserInfo3').addEventListener('tap', function() {
		$('#reducePersion2').popover('hide');
	}, false);
	
	//点击用户信息关闭按钮
	g('closeUserInfo').addEventListener('tap', function() {
		g('userInformation').style.display = "none";
	}, false);
	
	window.addEventListener('refresh_data', function() {
		getOrderList(1,null,true);
	} , false);
	
	$.ready(function() {
		if(imbar.isImmersedStatusbar) {
			g('navBar').style.top = imbar.navBarHeight + 'px';
			g('wrapper').style.top = (imbar.statusbarHeight + 90) + 'px';
		} else {
			g('navBar').style.top = '44px';
			g('wrapper').style.top = '90px';
		}
		
		$('#list').on('tap', '.orderTop', openOrderDetail);
		$('#list').on('tap', '.orderBottom', getBuyerStatusList);

		$('#list').on('tap', '.not-network', function() {
			pull.pullDownLoading();
		});
		$('#nav').on('tap', '.mui-tab-item', function() {
			var state = parseInt(this.getAttribute('state'));
//			g('title').innerText = ['全部', '待支付的', '服务中的', '已完成的'][state] + '订单';
			if(pager.status !== state) {
				pager.status = state;
				pull.pullDownLoading();
			}
		});
		scroll = $('.mui-scroll-wrapper').scroll({
			bounce: false,
			indicators: true,
			deceleration: mui.os.ios ? 0.003 : 0.0009
		});
		pull = $('#pullRefresh').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getOrderList(1, self, true);
					}, 10);
				}
			},
			up: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getOrderList(pager.pageIndex + 1, self, false);
					}, 10);
				}
			}
		});
		pager.pullUpTips = g('pullRefresh').querySelector('.mui-pull-bottom-tips');
		pager.pullUpTips.style.display = 'none';
		pull.pullDownLoading();
	});


})(mui);