(function ($) {
	$.init({swipeBack:true});
	
	var header = document.querySelector('header.mui-bar');
	var list = document.getElementById('list');
	var local = document.getElementById('location');
	var locName = document.getElementById('locName');
	var rlist = document.getElementById('rlist');
	var refresh = document.getElementById("refresh");
	
	var fixedHtml = document.getElementById("rlist").innerHTML;
	var href = location.href;
	var	typeId = href.split("=")[1];
	
	//设置默认地址
	var setLocation = function () {
		locName.innerHTML = '<i class="mui-spinner" style="font-size: 14px;"></i>正在获取位置信息...';
		geo.setLocation(function(city){
			if(city && city.geo!=0){
				document.getElementById("location").style.cssText="border:1px solid #e8e9ec;";
				//<span id="locationIcon"><img style="width:12px;height: 15px;" src="../images/location.png"/></span>
				locName.innerHTML = '<span id="locationIcon"><img style="width:12px;height: 15px;" src="../images/location.png"/></span>' + city.cityName;
				local.setAttribute('data-value',city.cityCode);
			}else{
				var reGeo = document.getElementById('reGeo');
				reGeo.addEventListener('tap',function(){
					local.removeAttribute("data-value"); 
					setLocation();
				},false);
				locName.innerHTML = '<i class="mui-icon icon-mui mui-icon-info color-red" style="color: #39bfb4;font-size: 20px;"></i>定位失败，点击重新定位';
			}
		});
	};
	
	var creatLi = function (city) {
		var li = document.createElement('li');
		li.setAttribute('data-value',city.value);
		li.setAttribute('data-tags',city.cityShort);
		li.className ="mui-table-view-cell mui-indexed-list-item";
		li.innerText = city.cityName;
		rlist.appendChild(li);
	};
	var creatGroup = function(fc) {
		var li = document.createElement('li');
		li.setAttribute('data-group',fc);
		li.className ="mui-table-view-divider mui-indexed-list-group";
		li.innerText = fc;
		rlist.appendChild(li);
	};
	var create = function (cityList) {
		var fChar = '';
		for(i in cityList){
			var item = cityList[i];
			//if(!item.value || item.value=='110000') return;
			var tChar = item.cityShort[0];
			if(tChar !== fChar){
				fChar = tChar.toUpperCase();
				creatGroup(tChar.toUpperCase());
			}
			creatLi(item);
		}
		
	};
	
	//从缓存获取城市列表数据
	var getCityList = function (){
		//先判断是类型
		jdb.getData("cityList","city").then(function (res){
			console.log(res);
			if(res.content.type==typeId){//类型和之前的类型相同
				var curTime = Date.parse(new Date());
				curTime = curTime / 1000;
				var timeDis = curTime - res.content.time;
				var day = Math.ceil(timeDis/86400);
				if(day>=3){
					getListData();
				}else{
					create(res.content.data);
					window.indexedList = new mui.IndexedList(list);
				};
				//判读数据是否为空
				if(res.content.data.length==0){
					getListData();
				}
			}else{
				getListData();
			}
		}).catch(function (err){
			console.log("出错");
			getListData();
		});
	};
	//请求接口获取列表数据
    var getListData = function(pullSel,dou){
    	if(pullSel && dou){
			pullSel.endPullDownToRefresh();
		} 
    	if(pullSel && !dou) {
    		pullSel.endPullUpToRefresh(true);
    	}
  		rlist.innerHTML = fixedHtml;
		appSvc.getNewCityList(typeId).then(function (data) {
			console.log(data)
			//获取时间戳
			var timestamp = Date.parse(new Date());
			timestamp = timestamp / 1000;
			//jdb.saveData("cityList",{id:"city",content:{data:data,time:timestamp,type:typeId}},'id')
			var citys = [];
			for(var i in data){
				citys.push({cityName:data[i].cityName,value:data[i].cityCode,cityShort:data[i].cityShort});
			}
			create(citys);
			window.indexedList = new mui.IndexedList(list);
		}).catch(function (err) {
			$.toast(err.message);
			console.error(err.message,err);
		});
    }
    //按钮刷新
    refresh.addEventListener('tap',function(){
		getListData()
	},false);
	
	$('#rlist').on('tap', 'li[data-value]',function () {
		var formView = plus.webview.currentWebview().opener();
		var city = {};
		city.cityName = this.innerText;
		city.cityCode = this.getAttribute("data-value");
		$.fire(formView, 'changeCity',{
			"cityName":city.cityName,
			"cityCode":city.cityCode
		});
		$.back();
	});
	
	list.style.height = (document.body.offsetHeight - header.offsetHeight) + 'px';
	
	function setPullRefresh(){
		var pull = null;
		var pullRefresh = g('pullRefresh');
        var oStyle;//样式
        var judgeDown;//判断是否允许下拉
        pullRefresh.addEventListener('touchmove', function(e){
			if (pullRefresh.scrollTop > 1) {
				judgeDown = false;//不允许下拉
				if (!oStyle) {
					oStyle = document.createElement('style');
					oStyle.innerText = '.mui-pull-top-tips{opacity: 0}';
					document.head.appendChild(oStyle);	
				}
			}else{
				judgeDown = true;
				oStyle && oStyle.remove();
				oStyle = null;
			}
		}, false);
		pull = $('#pullRefresh').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getListData(self,true);
					}, 10);
				}
			}
		});
	}
	
	getListData();
	
	$.plusReady(function() {
		setLocation();
	});
			
})(mui);