(function ($) {
	$.init({swipeBack:true});
	var rlist = g('rlist');
	var fixedHtml = rlist.innerHTML;
	var	typeId = common.utils.queryString('workType');
	
	//设置默认地址
	var setLocation = function () {
		g('headerNav').style.boxSizing = 'border-box';
		g('locName').parentNode.classList.add('geo-working');
		g('locName').innerHTML = '<i class="mui-spinner"></i>正在获取位置信息...';
		geo.setLocation(function(city){
			if(city && city.geo!=0){
				g('locName').parentNode.classList.remove('geo-working');
				g('locName').innerHTML = '<i class="mui-icon icon-mui mui-icon-location"></i>' + city.cityName;
				g('location').setAttribute('data-value',city.cityCode);
			}else{
				g('locName').innerHTML = '<i class="mui-icon icon-mui mui-icon-info color-red"></i>定位失败，点击重新定位';
			}
		});
	};
	
	//创建城市列表
	var creatLi = function (city) {
		var li = document.createElement('li');
		li.setAttribute('data-value',city.cityCode);
		li.setAttribute('data-tags',city.cityShort);
		li.className ="mui-table-view-cell mui-indexed-list-item";
		li.innerText = city.cityName;
		g('rlist').appendChild(li);
	};
	var creatGroup = function(fc) {
		var li = document.createElement('li');
		li.setAttribute('data-group',fc);
		li.className ="mui-table-view-divider mui-indexed-list-group";
		li.innerText = fc;
		g('rlist').appendChild(li);
	};
	var create = function (cityList) {
		var fChar = '';
		$.each(cityList,function (i,city) {
			if(!city.cityCode || city.cityCode=='000000') return;
			var tChar = city.cityShort[0];
			if(tChar !== fChar){
				fChar = tChar.toUpperCase();
				creatGroup(tChar.toUpperCase());
			}
			creatLi(city);
		});
	};
	//从缓存获取城市列表数据
	var getCityList = function (){
		//先判断是类型
		jdb.getData("cityList","city").then(function (res){
			console.log(res);
			if(res.content.type==typeId){//类型和之前的类型相同
				var curTime = Date.parse(new Date());
				curTime = curTime / 1000;
				var timeDis = curTime - res.content.time;
				var day = Math.ceil(timeDis/86400);
				if(day>=3){
					getListData();
				}else{
					create(res.content.data);
					window.indexedList = new mui.IndexedList(g('list'));
				};
				//判读数据是否为空
				if(res.content.data.length==0){
					getListData();
				}
			}else{
				getListData();
			}
		}).catch(function (err){
			console.log("出错");
			getListData();
		});
	};
	//请求接口获取列表数据
    var getListData = function(pullSel,dou){
		if(pullSel && dou){
			pullSel.endPullDownToRefresh();
		} 
    	if(pullSel && !dou) {
    		pullSel.endPullUpToRefresh(true);
    	}
  		g('rlist').innerHTML = fixedHtml;
		appSvc.getNewCityList(typeId).then(function (data) {
			//获取时间戳
			var timestamp = Date.parse(new Date());
			timestamp = timestamp / 1000;
			//jdb.saveData("cityList",{id:"city",content:{data:data,time:timestamp,type:typeId}},'id')
			create(data);
			window.indexedList = new mui.IndexedList(g('list'));
		}).catch(function (err) {
			$.toast(err.message);
			console.error(err.message,err);
		});
   };
    
	var setPullRefresh = function(){
		var pullRefresh = g('pullRefresh'),
			oStyle,//样式
			judgeDown,//判断是否允许下拉
			pull;
        pullRefresh.addEventListener('touchmove', function(e){
			if (pullRefresh.scrollTop > 1) {
				judgeDown = false;//不允许下拉
				if (!oStyle) {
					oStyle = document.createElement('style');
					oStyle.innerText = '.mui-pull-top-tips{opacity: 0}';
					document.head.appendChild(oStyle);	
				}
			}else{
				judgeDown = true;
				oStyle && oStyle.remove();
				oStyle = null;
			}
		}, false);
		pull = $('#pullRefresh').pullToRefresh({
			down: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						getListData(self,true);
					}, 10);
				}
			}
		});
	};
    
    //按钮刷新
    g("refresh").addEventListener('tap',function(){
		getListData();
	},false);
	
	//重新定位
	$('#list').on('tap', '#reGeo',function () {
		g('location').removeAttribute("data-value"); 
		setLocation();
		return false;
	},false);
	
	//点击列表中的城市
	$('#list').on('tap', '.mui-indexed-list-item:not(.geo-working)',function () {
		var formView = plus.webview.currentWebview().opener();
		var city = {};
		if(this.id==="location"){
			city = {cityCode:this.dataset.value,cityName:g('locName').innerText};
		}else{
			city = {cityCode:this.dataset.value,cityName:this.innerText,choice:1};
		}
		$.fire(formView, 'changeCity',{
			"cityName":city.cityName,
			"cityCode":city.cityCode
		});
		$.back();
	});
	
	g('list').style.height = (document.documentElement.clientHeight - g('headerNav').offsetHeight) + 'px';
	
	//不取缓存
	//getCityList();
	$.ready(function(){
		getListData();
	});

	$.plusReady(function() {
		setLocation();
	});
	
})(mui);