(function($) {
	$.init({
		beforeback:function(){
			document.activeElement.blur();
		}
	});
	$('.mui-scroll-wrapper').scroll({
		deceleration: 0.0005,
		indicators: true,
		bounce:false
	});
	var typeData = {},selectParams = {};
	var typeId = null;
	var keyword = '';
	var imbarSet = false;
	var city = app.getCity();
	
	var getNumFormatStr = function(num){
		if(!num) return '0';
		if(num>=10000){
			return (num/10000).toFixed(1)+'万';
		}else{
			return ''+num;
		}
	};
	
	var search = function(pno){
		setTimeout(function(){
			g('keyword').blur();
		},100);
		var wd = g('keyword').value;
		if(wd.trim()==''){
			$.toast('请输入要搜索的内容');
			return;
		}
		if(keyword!==wd){
			keyword = wd;
			jel('#pullRefresh .result-list').html('');
            $('#searchResult').slider().gotoItem(0,0);
            var pulls = $('#pullRefresh .mui-scroll').pullToRefresh();
            for(var i=0,len=pulls.length;i<len;i++){
				pulls[i].refresh();
            }
            jel('.mui-pull-bottom-tips').addClass('mui-hidden');
            getAllList();
		}
		
	};
	
	var fillEmpty = function(box){
		var li = document.createElement('div');
		li.className='empty-item';
		li.innerHTML='<div><img src="../images/empty.png"><span>没有找到你要的内容</span></div>';
		var box = document.querySelector('#all .result-list');
		box.innerHTML = li.outerHTML;
	};
	var createNavList = function(list,box){
		for(var i in list){
			var data = list[i];
			var link = document.createElement('div');
			link.className = 'link mui-clearfix';
			link.setAttribute('data-id',data.id);
			link.setAttribute('data-link',data.link);
			link.innerHTML=[
				'<img class="icon" src="',data.image,'"/>',
				'<span class="title">',data.entrance,'</span>',
				'<p class="des mui-ellipsis">',data.introduce,'</p>'
			].join('');
			box.appendChild(link);
		}
	};
	var createArtList = function(list,box){
		var li,reg=new RegExp(keyword,'g');
		for(var i in list){
			var ditem = list[i];
			li = document.createElement('div');
			li.className='mui-table-view-cell';
			li.setAttribute('aId',ditem.id);
			li.setAttribute('nav_type',0); //文章
			li.setAttribute('image',ditem.image);
			li.setAttribute('type',ditem.type);
			li.setAttribute('videoUrl',ditem.videoUrl);
			li.setAttribute('atitle',ditem.title);
			li.setAttribute('authorName',ditem.authorName);
			li.setAttribute('authorHeadPath',ditem.authorHeadPath);
		    	var imgStr = ditem.image?['<div class="mui-media-object mui-pull-right">',
		    			'<img src="',ditem.image,'">',
		    			ditem.type==2?'<div class="video-cover"><span class="video-btn fa fa-play"></span></div>':'',
		    		'</div>'].join(''):'';
			li.innerHTML = [
				imgStr,
				'<div class="mui-media-body">',
					'<div class="atitle">',ditem.title.replace(reg,'<span class="color-red">'+ keyword+'</span>'),'</div>',
					'<p class="mui-ellipsis">',
						'<span>',ditem.readAmount,'次阅读</span>',
						'<span>',getNumFormatStr(ditem.replyCount),'条评论</span>',
					'</p>',
				'</div>'
			].join('');
			box.appendChild(li);
		}
		
	};
	// 悦头条
	var createMinfoList = function(list,box){
		var li,reg=new RegExp(keyword,'g');
		for(var i in list){
			var ditem = list[i];
			li = document.createElement('div');
			li.className='mui-table-view-cell minfo';
			li.setAttribute('aId',ditem.id);
			li.setAttribute('image',ditem.image);
			li.setAttribute('nav_type',1); //悦头条
			li.setAttribute('type',ditem.type);
			li.setAttribute('videoUrl',ditem.videoUrl);
			li.setAttribute('atitle',ditem.title);
			li.setAttribute('authorName',ditem.authorName);
			li.setAttribute('authorHeadPath',ditem.authorHeadPath);
		    	var imgStr = ditem.image?['<div class="mui-media-object mui-pull-right">',
		    			'<div style="background:url(',ditem.image,') no-repeat 50% 50%;background-size:cover;"></div>',
		    			ditem.type==1?'<div class="video-cover"><span class="video-btn fa fa-play"></span></div>':'',
		    		'</div>'].join(''):'';
			li.innerHTML = [
				imgStr,
				'<div class="mui-media-body">',
					'<div class="atitle">',ditem.title.replace(reg,'<span class="color-red">'+ keyword+'</span>'),'</div>',
					'<p class="mui-ellipsis">',
						'<span>',ditem.readAmount,'次阅读</span>',
						'<span>',getNumFormatStr(ditem.replyCount),'条评论</span>',
					'</p>',
				'</div>'
			].join('');
			box.appendChild(li);
		}
		
	};
	// 店铺
	var createStoreList = function(list,box){
		var li,reg=new RegExp(keyword,'g');
		for(var i in list){
			var ditem = list[i],
				impres = ditem.impressions ? ditem.impressions : [],
				productList = ditem.productList ? ditem.productList : [];
			li = document.createElement('div');
			li.className='list_detail_con';
			var impressions = "",productAll = "";
			var storeName = ditem.storeName.replace(/<.*?>/ig,"");
			//店铺印象
			for(var m=0;m<impres.length;m++){
				impressions = impressions+'<span>'+impres[m]+'</span>';
			};
			// 产品
			for(var m=0;m<productList.length;m++){
				var systematicLevel1 = productList[m].systematicLevel1 ? productList[m].systematicLevel1 : '';
				productAll += '<div class="pro" level2="' + ditem.level2 + '" dis="' + ditem.distance + '" proid="' + productList[m].productId + '" storeid="' + ditem.storeId + '" s_name="' + storeName + '">' +
								'<p class="store_pro_name mui-ellipsis"><label class="buy">团</label><label>'+ systematicLevel1 +'</label><label>' + productList[m].productName + '</label></p>' +
								'<p class="pro_sale"><span><label class="cur_price">' + productList[m].salesPrice + '元</label><label class="old_price">' + productList[m].originalPrice + '元</label></span><span>已售' + productList[m].saleCount + '</span></p>' +
							'</div>';
			};
			li.innerHTML = [
				'<div class="produce_detail">',
					'<div class="place" storeid="' + ditem.storeId + '" dis="' + ditem.distance + '" level2="' + ditem.level2 + '">',
						'<div class="locationPic" style="background:url(' + ditem.thumbnail + ') no-repeat left top;background-size: cover;"></div>',
						'<div class="locationInfo">',
							'<p class="locationName mui-ellipsis">' + ditem.storeName + '</p>',
							'<div class="location mui-ellipsis"><label class="area_name">' + ditem.businessArea + '</label><label class="area_name">' + ditem.level2Name + '</label></div>',
							'<div class="location impression">' + impressions + '</div>',
							productAll,
						'</div>',
						'<div class="distance">' + ditem.distance + '</div>',
					'</div>',
				'</div>'
			].join('');
			box.appendChild(li);
		}
	};
	// 投票
	var createVoteList = function(list,box,type){
		var li,reg=new RegExp(keyword,'g');
		for(var i in list){
			var ditem = list[i];
			li = document.createElement('div');
			li.className='mui-table-view-cell';
			li.setAttribute('aId',ditem.id);
			li.setAttribute("vote-type",type===1?'0':'1'); //投票
			li.setAttribute('nav_type',2); //投票
			li.innerHTML = [
				'<div class="vote-list">',
					'<div class="vote-top">',
						'<div class="vote-text">投票</div>',
						'<div class="vote-attend">' + ditem.readAmount + '人参加</div>',
					'</div>',
					'<div class="vote-title">' + ditem.title + '</div>',
					'<div class="vote-select">',
						'<div class="vote-left vote-cont">' + ditem.rightContent + '</div>',
						'<div class="vote-compare"><img src="../images/vote-compare.png"/></div>',
						'<div class="vote-right vote-cont">' + ditem.opposContent + '</div>',
					'</div>',
				'</div>'
			].join('');
			box.appendChild(li);
		}
	};
	var createTab = function(datai){
		var ctrlbox = g('tabCtrl');
		var conbox = g('pullRefresh');
		var tab = document.createElement('a');
		tab.className = 'mui-control-item';
		tab.setAttribute('href','#cate-'+datai.id);
		tab.setAttribute('data-id',datai.id);
		tab.setAttribute('data-type',datai.type);
		tab.innerHTML=datai.name;
		ctrlbox.appendChild(tab);
		var con = document.createElement('div'); 
		con.className = 'mui-slider-item mui-control-content';
		con.setAttribute('id','cate-'+datai.id);
		con.setAttribute('data-id',datai.id);
		con.setAttribute('data-type',datai.type);
		con.innerHTML= [
			'<div class="mui-scroll-wrapper">',
				'<div class="mui-scroll pullbox">',
					'<div class="result-list">',
					'</div>',
				'</div>',
			'</div>'].join('');
		conbox.appendChild(con);	
	};
	var createTypeBox = function(data){
		var more = "";
		if(data.type === 5){
			more = data.totalNum>1 ? '<div class="pre-more" data-id="'+data.id+'">查看更多</div>' : '';
		}else {
			more = data.totalNum>2 ? '<div class="pre-more" data-id="'+data.id+'">查看更多</div>' : '';
		}
		var box = document.createElement('div');
		box.className = 'pre-box';
		box.innerHTML=[
			'<div class="pre-name">',data.name,'</div>',
			'<div class="pre-con less" data-type="',data.type,'"></div>',
			more,
		].join('');
		return box;
		//document.querySelector(itemId+' .result-list').appendChild(box);
		//return box.querySelector('.pre-con');
	};
	var createTypeiBox = function(itemId){
		var box = document.createElement('div');
		box.className = 'pre-box';
		box.innerHTML=[
			'<div class="pre-con"></div>'
		].join('');
		document.querySelector(itemId+' .result-list').appendChild(box);
		return box.querySelector('.pre-con');
	};
	var getAllList = function(){
		appSvc.searchAllNav(keyword,selectParams.lon,selectParams.lat).then(function(data){
			g('searchResult').style.zIndex=2;
			g('searchHistroy').style.zIndex=1;
			var ctrlbox = g('tabCtrl');
			var conbox = g('pullRefresh');
			while(ctrlbox.childElementCount>1){
				ctrlbox.children[ctrlbox.childElementCount-1].remove();
			}
			while(conbox.childElementCount>1){
				conbox.children[conbox.childElementCount-1].remove();
			}
			mui.each(data,function(i,item){
				typeData[item.id] = {
					index:i+1,
					type:item.type,
					typeId:item.id,
					typeName:'cate-'+item.id,
					pageNum:0,
					pages:0
				};
				createTab(item);
				var box = createTypeBox(item);
				var boxCon = box.querySelector('.pre-con');
				switch(item.type){
					case 1:
						// 功能入口
						createNavList(item.list,boxCon);
						break;
					case 2:
						// 内容
						createArtList(item.list,boxCon);
						break;
					case 3:
						// 悦头条
						createMinfoList(item.list,boxCon);
						break;
					case 5:
						// 投票
						createVoteList(item.list,boxCon,1);
						break;
					case 20:
						// 店铺
						createStoreList(item.list,boxCon);
						break;
				}
				document.querySelector('#all .result-list').appendChild(box);
			});
			
			if(document.body.classList.contains('mui-android-4')){
				conbox.innerHTML +=''; 
				var scroll = document.querySelector('#all .mui-scroll-wrapper');
				scroll.removeAttribute('data-scroll');
			}
			jel('.mui-pull-bottom-tips').addClass('mui-hidden');
			$('.mui-scroll-wrapper').scroll({ deceleration: 0.0005, indicators: true, bounce:false });
			
			
			var tabSlider = $('#searchResult').slider();
	        var tabScroller = $('#searchResult .type-tab').scroll();
			tabSlider.refresh();
			tabScroller.refresh();
	        tabSlider.gotoItem(0,0);
	        
			setPullRefresh();
			updateHistory(keyword);
			if(!data || data.length==0){
				fillEmpty(document.querySelector('#all .result-list'));
			}
		}).catch(function(err){
			fillEmpty(document.querySelector('#all .result-list'));
			console.error(err.message,err);
		});
	};
	var getTypeList = function(pno,pullSel){
		var typeObj = typeData[typeId];
		var itemId = '#'+typeObj.typeName;
        var box = g('pullRefresh').querySelector(itemId+' .result-list');
		pullSel = pullSel||$(itemId+' .pullbox').pullToRefresh();
		if(pno===1) typeObj.pages = null;
		if(typeObj.pages && pno>typeObj.pages && pullSel) return pullSel.endPullUpToRefresh(true);
		
		var postData = {id:typeObj.typeId,type:typeObj.type,keyWord:keyword,pageNum:pno,pageSize:10,lon:selectParams.lon,lat:selectParams.lat};
		appSvc.searchTypeNav(postData).then(function(data){
			var pagination = data.pagination;
			var list = data.list;
			typeObj.pages = parseInt((pagination.totalItems+pagination.pageSize-1)/pagination.pageSize);
			typeObj.pageNum = pagination.pageNum;
			if(pagination && pagination.pageNum==1){
				box.innerHTML = '';
				if(!data || !list || list.length==0){				
					fillEmpty(box);
				}
			}
			if(data && list && list.length>0){
				var ibox = box.querySelector('.pre-con') || createTypeiBox(itemId);
				switch(typeObj.type){
					case 1:
						createNavList(list,ibox);
						break;
					case 2:
						createArtList(list,ibox);
						break;
					case 3:
						createMinfoList(list,ibox);
						break;
					case 5:
						createVoteList(list,ibox);
						break;
					case 20:
						createStoreList(list,ibox);
						break;
				}
			}
			g('searchResult').style.zIndex=2;
			g('searchHistroy').style.zIndex=1;
			
	        var isEndPullUp = !pagination || pagination.totalItems==0 || typeObj.pages==typeObj.pageNum||typeObj.pages==1;
			if(pullSel) pullSel.endPullUpToRefresh(isEndPullUp);
			if(typeObj.pages<2){
				g('pullRefresh').querySelector(itemId+' .mui-pull-bottom-tips').classList.add('mui-hidden');
			}
			
		}).catch(function(err){
			if(pullSel) pullSel.endPullUpToRefresh();
			console.error(err.message,err);
		});
	};
	
	var setHistoryList = function(){
		var list = myStorage.getItem('keywords')||[];
		if(list.length==0){
			g('histroyBox').classList.add('mui-hidden');
			return;
		}else{
			g('histroyBox').classList.remove('mui-hidden');
		}
		
		list.reverse();
		var html = '';
		for(var i in list){
			html+='<span>'+list[i]+'</span>'
		}
		g('histroyList').innerHTML = html;
	};
	var updateHistory = function(keyword){
		var autoInput = g('keyword').getAttribute('autoInput');
		if(autoInput){
			g('keyword').removeAttribute('autoInput');
			return;
		} 
		var list = myStorage.getItem('keywords')||[];
		var index = list.indexOf(keyword);
		if(index<0){
			if(list.length>=6) list.shift();
		}else{
			list.splice(index,1);
		}
		list.push(keyword);
		myStorage.setItem('keywords',list);
	};
	var setPullRefresh = function(){
		$.each(document.querySelectorAll('#pullRefresh .pullbox'), function(index, pullRefreshEl) {
			$(pullRefreshEl).pullToRefresh({
				up: {
					callback: function() {
						var self = this;
						setTimeout(function() {
						 	getTypeList(typeData[typeId].pageNum+1,self);
						}, 100);
					}
				}
			});
		});
	};
	var getHotKeywords = function(){
		newsSvc.getHotKeywords(6).then(function(data){
			var html = '';
			for(var i in data){
				html+='<span>'+data[i]+'</span>'
			}
			g('hotKeywords').innerHTML = html;
		}).catch(function(err){
			console.error(err.message,err);
		})
	};
	var getKeyowrds = function(){
    		var keywords = myStorage.getItem('hotKeys');
    		$.each(keywords, function(i,words) {
			var span = document.createElement('span');
			span.innerHTML=words;
			g('searchWords').appendChild(span);
		});
	};
	
	g('searchBtn').addEventListener('tap',function(){
		search(1);
	},false);

	$('#searchHistroy .item-list').on('tap','span',function(){
		document.querySelector('.mui-search').classList.add('mui-active'); 
		g('keyword').value = this.innerText;
		document.querySelector('#keyword~.mui-icon-clear').classList.add('show');
		search(1);
	},false);
	
	g('keyword').addEventListener('change',function(){
		var clearBtn = document.querySelector('#keyword~.mui-icon-clear');
		if(this.value.length===0){
			g('searchResult').style.zIndex=1;
			g('searchHistroy').style.zIndex=2;
			setHistoryList();
			clearBtn.classList.add('mui-hidden');
			clearBtn.classList.remove('show');
		}else{
			clearBtn.classList.remove('mui-hidden');
			clearBtn.classList.add('show');
		}
		return false;
	},false);
	g('keyword').addEventListener('blur',function(){
		document.querySelector('#keyword~.mui-icon-clear').classList[
			this.value.length===0?'remove':'add'
		]('show');
	},false);
	
	g('clearHistory').addEventListener('tap',function(){
		myStorage.setItem('keywords','');
		g('histroyBox').classList.add('mui-hidden');
		g('histroyList').innerHTML = '';
	},false);
	
	g('searchResult').addEventListener('slide', function(event) {
		var ctrli = g('tabCtrl').children[event.detail.slideNumber];
		var type = ctrli.getAttribute('data-id');
		if(!type) return;
		if(!isNaN(type)) type=parseInt(type);
		if(type!==typeId){
			typeId = type;
			var itemId = '#'+typeData[typeId].typeName;
			var list = document.querySelector(itemId+' .result-list');
			if(list.children.length===0){
				var loading = document.createElement('div');
				loading.className='loading';
				loading.innerHTML = '<img src="../images/loading.svg">';
				list.appendChild(loading);
				getTypeList(1);
			}
		}
	},false);
	
	$('#searchResult').on('tap','.result-list .mui-table-view-cell',function(){
		var targetUrl = "",pageName = "",theView = "";
        var params = {
	        	aId:this.getAttribute("aId"),
	        	title:this.getAttribute('atitle'),
	        	image:this.getAttribute('image'),
	        	type:this.getAttribute('type'),
	        	nav_type:this.getAttribute('nav_type'),
	        	videoUrl:this.getAttribute('videoUrl'),
	        	authorName:this.getAttribute('authorName'),
	        	authorHeadPath:this.getAttribute('authorHeadPath')
        };
        if(params.nav_type == 0){
        		// 文章
        		targetUrl = (params.type==2?'article-video.html':'article.html') +
        			'?aid='+params.aId+'&image='+encodeURIComponent(params.image);
        		pageName = params.type==2 ? 'article-video' : 'article';
        		theView = plus.webview.getWebviewById(params.type==2?'article-video':'article');
        }else if(params.nav_type == 1){
        		// 悦头条
        		targetUrl = (params.type==1?'minfo/minfo-video.html':'minfo/minfo.html') +
        			'?mId='+params.aId+'&image='+encodeURIComponent(params.image);
        		pageName = params.type==1 ? 'minfo-video' : 'minfo';
			theView = plus.webview.getWebviewById(params.type==1?'minfo-video':'minfo');
        }else {
        		targetUrl = 'subscriber-vote.html?id='+params.aId;
        		pageName = 'vote';
			theView = plus.webview.getWebviewById('vote');
        }
      	if(theView) theView.close('none');
   		setTimeout(function(){
   		 	var aview = $.openWindow({
	        		id: pageName,
	            url: targetUrl,
	            extras: params,
	            waiting: {autoShow: false}
	        });
	        aview.addEventListener('close',function(){
	        		$.fire($.currentWebview,'videoQuitFullScreen');
	        },false);
   		}, 200);
	});
	//进入产品详情
	$('#searchResult').on('tap','.result-list .list_detail_con .pro',function(e){
		var evt=e||event;
		evt.stopPropagation();
		var storeId = this.getAttribute("storeid"),
			pid = this.getAttribute("proId"),
			distance = this.getAttribute("dis"),
			storeName = this.getAttribute("s_name"),
			level2 = this.getAttribute("level2");
		$.openWindow("_www/view/o2o/pro_detail.html?proId="+pid+"&distance="+distance+"&storeId="+storeId+"&level2="+level2+"&storeName="+encodeURIComponent(storeName));
	},false);
	//进入店铺详情
	$('#searchResult').on('tap','.result-list .list_detail_con .place',function(){
 		var storeId = this.getAttribute("storeId"),
 			dis = this.getAttribute("dis"),
			level2 = this.getAttribute("level2");
		if(level2==6){
			//体检跳转到原页面
			$.openWindow("_www/view/o2o/tijian_store.html?storeId="+storeId+"&dis="+dis+"&level2="+level2)
		}else{
			$.openWindow("_www/view/o2o/hospital.html?storeId="+storeId+"&dis="+dis+"&level2="+level2)
		}
	},false);
	$('#searchResult').on('tap','.link',function(){
		var href = this.getAttribute('data-link');
		app.openMultiURL(href);
		return false;
	},false);
	
	$('#chooseTitle').on('tap','.mui-icon-clear',function(){
		g('keyword').value='';
		keyword = '';
		typeId = null;
		g('keyword').focus();
		g('searchResult').style.zIndex=1;
		g('searchHistroy').style.zIndex=2;
		setHistoryList();
		return false;
	},false);
	    
    $('#pullRefresh').on('scroll','.mui-scroll-wrapper',function(){
	    	g('keyword').blur();
	    	return false;
    });
    // 查看更多
    $('#pullRefresh').on('tap','.pre-more',function(){
	    var typeId = this.getAttribute('data-id');
	    var index = typeData[typeId].index;
	    $('#searchResult').slider().gotoItem(index,0);
    });
    
    
	window.addEventListener('videoQuitFullScreen',function(event){
		HTMLCollection.prototype.indexOf =  Array.prototype.indexOf;
		var cateSlider = $('#searchResult').slider();
		cateSlider.refresh();
		var acti = document.querySelector("#tabCtrl .mui-control-item.mui-active");
		var idx = g('tabCtrl').children.indexOf(acti);
	    $('#searchResult').slider().gotoItem(idx,0);
	},false);
    
	window.searchNews = search;
 
 	$('#pullRefresh .mui-scroll-wrapper').scroll({
    		bounce: false,
		indicators: true,
		deceleration:mui.os.ios?0.003:0.0009
    });

	setHistoryList();
	getHotKeywords();
	//setPullRefresh();
	
 	jel('.mui-pull-bottom-tips').addClass('mui-hidden');
 	g('searchResult').style.width=document.documentElement.clientWidth+'px';
 	
	function setImbar(){
		var bh = 0;
		if(!imbarSet && imbar && imbar.isImmersedStatusbar){
			bh = imbar.navBarHeight;
			g('searchHistroy').style.top = imbar.navBarHeight +'px';
			g('searchResult').style.top = imbar.navBarHeight+'px';
			imbarSet = true;
		}
	}
	
	setImbar();
	getKeyowrds();
	
	var wdInput = g('keyword');
	var words = common.utils.queryString('words');
	if(words){
		wdInput.setAttribute('autoInput','1');
		wdInput.value = decodeURIComponent(words);
		search(1);
		g('searchHistroy').style.zIndex=0;
	}
	
	$.plusReady(function(){
		if (!words) {
			$.oldBack = $.back;
			$.back = function(){};
			app.openSoftKeyboard();
			setTimeout(function() {
				g('keyword').focus();
				$.back = $.oldBack;
		    }, 200);
		    
		}
	});
	// 获取经纬度
	function initData(coords) {
		var cur_city = app.getCity();
		var cityCode = cur_city.cityCode;
		if(coords) {
			selectParams.lat = coords.latitude;
			selectParams.lon = coords.longitude;
		}
		selectParams.cityCode = cur_city.cityCode;
	};
	geo.getPoint(initData);
	
	// 埋点
	function joyTrack(){
		jTrack.regEvents('#searchWords span','joyKeyword','jtrack_name:综合搜索,jtrack_keyword:this.innerText,jtrack_search_type:2');
		jTrack.regEventsLive('#histroyList','span','joyKeyword','jtrack_name:综合搜索,jtrack_keyword:this.innerText,jtrack_search_type:2');
		jTrack.regEventsLive('#hotKeywords','span','joyKeyword','jtrack_name:综合搜索,jtrack_keyword:this.innerText,jtrack_search_type:2');
	}
	joyTrack();
	
}(mui));