(function($) {
	$.init({
		beforeback:function(){
			document.activeElement.blur();
		}
	});
	
	var typeData = [{
		index:0,
		typeId:0,
		typeName:'all',
		pageNum:1,
		pages:0
	},{
		index:2,
		typeId:1,
		typeName:'article',
		pageNum:1,
		pages:0
	},{
		index:1,
		typeId:2,
		typeName:'video',
		pageNum:1,
		pages:0
	}];
	var typeOrder = [0,2,1];
	var artType = 0;
	
	var pageNum =[1,1,1];
	var pages = [0,0,0];
	
	var keyword = '';
	var imbarSet = false;
	
	var city = app.getCity();
	
	var g = function(id){ return document.getElementById(id); };
	var getNumFormatStr = function(num){
		if(!num) return '0';
		if(num>=10000){
			return (num/10000).toFixed(1)+'万';
		}else{
			return ''+num;
		}
	};
	var search = function(pno){
		setTimeout(function(){
			g('keyword').blur();
		},100);
		var wd = g('keyword').value;
		if(wd.trim()==''){
			$.toast('请输入要搜索的内容');
			return;
		}
		if(keyword!==wd){
			keyword = wd;
			jel('#pullRefresh .result-list').html('');
            $('#searchResult').slider().gotoItem(0,0);
            var pulls = $('#pullRefresh .mui-scroll').pullToRefresh();
            for(var i=0,len=pulls.length;i<len;i++){
				pulls[i].refresh();
            }
            jel('.mui-pull-bottom-tips').addClass('mui-hidden');
            getListData(pno);
		}
		
	};
	var getListData = function(pno,pullSel){
		var typeObj = typeData[artType];
		var itemId = '#'+typeObj.typeName;
        var list = g('pullRefresh').querySelector(itemId+' .result-list');
		var tips = g('pullRefresh').querySelector(itemId+' .mui-pull-bottom-tips');
		pullSel = pullSel||$('#pullRefresh .mui-scroll').pullToRefresh()[typeObj.index];
		if(pno===1) typeObj.pages = null;
		if(typeObj.pages && pno>typeObj.pages && pullSel) return pullSel.endPullUpToRefresh(true);
		newsSvc.getKeyWordDocList(keyword,pno,10,city.cityCode,artType).then(function(data){
			typeObj.pages = data.pages;
			typeObj.pageNum = data.pageNum;
			tips.classList[data.pages<2?'add':'remove']('mui-hidden');
			g('searchResult').style.zIndex=2;
			g('searchHistroy').style.zIndex=1;
			if(typeObj.pageNum===1) list.innerHTML = '';
			
			var li,reg=new RegExp(keyword,'g');
			for(var i in data.list){
				var ditem =  data.list[i];
				li = document.createElement('li');
				li.className='mui-table-view-cell';
				li.setAttribute('aId',data.list[i].id);
				li.setAttribute('image',data.list[i].image);
				li.setAttribute('type',data.list[i].type);
				li.setAttribute('videoUrl',data.list[i].videoUrl);
				li.setAttribute('atitle',data.list[i].title);
				li.setAttribute('authorName',data.list[i].authorName);
				li.setAttribute('authorHeadPath',data.list[i].authorHeadPath);
            	var imgStr = ditem.image?['<div class="mui-media-object mui-pull-right">',
            			'<img src="',ditem.image,'">',
            			ditem.type==2?'<div class="video-cover"><span class="video-btn fa fa-play"></span></div>':'',
            		'</div>'].join(''):'';
            		
				li.innerHTML = [
					imgStr,
					'<div class="mui-media-body">',
						'<div class="atitle">',ditem.title.replace(reg,'<span class="color-red">'+ keyword+'</span>'),'</div>',
						'<p class="mui-ellipsis">',
							'<span>',ditem.readAmount,'次阅读</span>',
							'<span>',getNumFormatStr(ditem.replyCount),'条评论</span>',
						'</p>',
					'</div>'
				].join('');
				list.appendChild(li);
			}
			
			if(document.body.classList.contains('mui-android-4')){
				 g('pullRefresh').innerHTML +=''; 
				$('#pullRefresh .mui-scroll-wrapper').each(function(i,wrapper){
					wrapper.removeAttribute('data-scroll');
				});
				$('.mui-scroll-wrapper').scroll({ deceleration: 0.0005, indicators: true, bounce:false });
			}
			
			updateHistory(keyword);
			if(typeObj.pageNum===1&&data.list.length==0){
				li = document.createElement('div');
				li.className='empty-item';
				li.innerHTML='<div><img src="../images/empty.png"><span>没有找到你要的内容</span></div>';
				list.appendChild(li);
				if(pullSel) pullSel.endPullUpToRefresh(true);
			}
	        if(pullSel) pullSel.endPullUpToRefresh(data.pageNum===typeObj.pages);
		}).catch(function(err){
			if(pullSel) pullSel.endPullUpToRefresh();
			console.error(err.message,err);
		});
	};
	
	var setHistoryList = function(){
		var list = myStorage.getItem('keywords')||[];
		if(list.length==0){
			g('histroyBox').classList.add('mui-hidden');
			return;
		}else{
			g('histroyBox').classList.remove('mui-hidden');
		}
		
		list.reverse();
		var html = '';
		for(var i in list){
			html+='<span>'+list[i]+'</span>'
		}
		g('histroyList').innerHTML = html;
	};
	
	var updateHistory = function(keyword){
		var autoInput = g('keyword').getAttribute('autoInput');
		if(autoInput){
			g('keyword').removeAttribute('autoInput');
			return;
		} 
		var list = myStorage.getItem('keywords')||[];
		var index = list.indexOf(keyword);
		if(index<0){
			if(list.length>=6) list.shift();
		}else{
			list.splice(index,1);
		}
		list.push(keyword);
		myStorage.setItem('keywords',list);
	};
	var setPullRefresh = function(){
		$.each(document.querySelectorAll('#pullRefresh .mui-scroll'), function(index, pullRefreshEl) {
			$(pullRefreshEl).pullToRefresh({
				up: {
					callback: function() {
						var self = this;
						setTimeout(function() {
						 	getListData(typeData[artType].pageNum+1,self);
						}, 1000);
					}
				}
			});
		});
	};
	var getHotKeywords = function(){
		newsSvc.getHotKeywords(6).then(function(data){
			var html = '';
			for(var i in data){
				html+='<span>'+data[i]+'</span>'
			}
			g('hotKeywords').innerHTML = html;
		}).catch(function(err){
			console.error(err.message,err);
		})
	};
	var getKeyowrds = function(){
    		var keywords = myStorage.getItem('hotKeys');
    		$.each(keywords, function(i,words) {
			var span = document.createElement('span');
			span.innerHTML=words;
			g('searchWords').appendChild(span);
		});
   };
	
	g('searchBtn').addEventListener('tap',function(){
		search(1);
	},false);
	
	$('#searchHistroy .item-list').on('tap','span',function(){
		document.querySelector('.mui-search').classList.add('mui-active'); 
		g('keyword').value = this.innerText;
		document.querySelector('#keyword~.mui-icon-clear').classList.add('show');
		search(1);
	},false);
	
	g('keyword').addEventListener('change',function(){
		var clearBtn = document.querySelector('#keyword~.mui-icon-clear');
		if(this.value.length===0){
			g('searchResult').style.zIndex=1;
			g('searchHistroy').style.zIndex=2;
			setHistoryList();
			clearBtn.classList.add('mui-hidden');
			clearBtn.classList.remove('show');
		}else{
			clearBtn.classList.remove('mui-hidden');
			clearBtn.classList.add('show');
		}
		return false;
	},false);
	g('keyword').addEventListener('blur',function(){
		document.querySelector('#keyword~.mui-icon-clear').classList[
			this.value.length===0?'remove':'add'
		]('show');
	},false);
	
	g('clearHistory').addEventListener('tap',function(){
		myStorage.setItem('keywords','');
		g('histroyBox').classList.add('mui-hidden');
		g('histroyList').innerHTML = '';
	},false);
	
	g('searchResult').addEventListener('slide', function(event) {
		var type = typeOrder[event.detail.slideNumber];
        if(type!==artType){
        	artType = type;
			var itemId = '#'+typeData[artType].typeName;
        	var list = document.querySelector(itemId+' .result-list');
        	if(list.children.length===0){
        		jel(itemId+' .mui-pull-bottom-tips').addClass('mui-hidden');
        		var loading = document.createElement('li');
        		loading.className='loading';
        		loading.innerHTML = '<img src="../images/loading.svg">';
    			list.appendChild(loading);
        		getListData(1);
        	}
        }
	},false);
	
	$('#searchResult').on('tap','.result-list li',function(){
        var params = {
        	aId:this.getAttribute("aId"),
        	title:this.getAttribute('atitle'),
        	image:this.getAttribute('image'),
        	type:this.getAttribute('type'),
        	videoUrl:this.getAttribute('videoUrl'),
        	authorName:this.getAttribute('authorName'),
        	authorHeadPath:this.getAttribute('authorHeadPath')
        };
        var targetUrl = (params.type==2?'article-video.html':'article.html') +
        		'?aid='+params.aId+'&image='+encodeURIComponent(params.image);
        		
      var theView = plus.webview.getWebviewById(params.type==2?'article-video':'article');
      if(theView) theView.close('none');
   		setTimeout(function(){
   		 	var aview = $.openWindow({
	        	id: params.type==2 ? 'article-video' : 'article',
	            url: targetUrl,
	            extras: params,
	            waiting: {autoShow: false}
	        });
	        aview.addEventListener('close',function(){
	        	$.fire($.currentWebview,'videoQuitFullScreen');
	        },false);
   		}, 200);
      	
       	
	});
	
	$('#chooseTitle').on('tap','.mui-icon-clear',function(){
		g('keyword').value='';
		keyword = '';
		g('keyword').focus();
		g('searchResult').style.zIndex=1;
		g('searchHistroy').style.zIndex=2;
		setHistoryList();
		return false;
	},false);
	    
    $('#pullRefresh').on('scroll','.mui-scroll-wrapper',function(){
		g('keyword').blur();
		return false;
    });
    
	window.addEventListener('videoQuitFullScreen',function(event){
		HTMLCollection.prototype.indexOf =  Array.prototype.indexOf;
		var cateSlider = $('#searchResult').slider();
		cateSlider.refresh();
		var acti = document.querySelector("#tabCtrl .mui-control-item.mui-active");
		var idx = g('tabCtrl').children.indexOf(acti);
	    $('#searchResult').slider().gotoItem(idx,0);
	},false);
    
	window.searchNews = search;
 
 	$('#pullRefresh .mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: true,
		deceleration:mui.os.ios?0.003:0.0009
    });
	
	setHistoryList();
	getHotKeywords();
	setPullRefresh();
	
 	jel('.mui-pull-bottom-tips').addClass('mui-hidden');
 	g('searchResult').style.width=document.documentElement.clientWidth+'px';
	
	var setImbar = function (){
		var bh = 0;
		if(!imbarSet && imbar && imbar.isImmersedStatusbar){
			bh = imbar.navBarHeight;
			g('searchHistroy').style.top = imbar.navBarHeight +'px';
			g('searchResult').style.top = imbar.navBarHeight+'px';
			imbarSet = true;
		}
	};
	
	setImbar();
	getKeyowrds();
	
	var wdInput = g('keyword');
	var words = common.utils.queryString('words');
	if(words){
		wdInput.setAttribute('autoInput','1');
		wdInput.value = decodeURIComponent(words);
		search(1);
		g('searchHistroy').style.zIndex=0;
	}
	
	$.plusReady(function(){
		if (!words) {
			app.openSoftKeyboard();
			setTimeout(function() {
		    	g('keyword').focus(); 
		    }, 200);
		}
	});
	
	// 埋点
	function joyTrack(){
		jTrack.regEvents('#searchWords span','joyKeyword','jtrack_name:文章搜索,jtrack_keyword:this.innerText,jtrack_search_type:1');
		jTrack.regEventsLive('#histroyList','span','joyKeyword','jtrack_name:文章搜索,jtrack_keyword:this.innerText,jtrack_search_type:1');
		jTrack.regEventsLive('#hotKeywords','span','joyKeyword','jtrack_name:文章搜索,jtrack_keyword:this.innerText,jtrack_search_type:1');
	}
	joyTrack();
	
}(mui));