(function($, doc) {
	$.init();
	
	$.plusReady(function() {
		var self = $.currentWebview;
		var gestures = app.getSetting('gestures');
		var locker = doc.querySelector('.mui-locker');		
		var tipTxt = doc.getElementById('tipTxt');

		tipTxt.innerText = self.type==1 ? '请设置手势密码':'请输入原手势密码';
		
		$.oldBack = $.back;
		$.back = function(event) {
			var gestures = app.getSetting('gestures');
			var settingView = plus.webview.getWebviewById('setting');
			//if(og!=gestures) 
			$.fire(settingView,'checkGestures');
			if(!gestures && self.type==1){
				$.confirm('是否放弃开启手势密码？','',['否','是'],function(e){
					if(e.index==1) $.oldBack();
				});
			}else{
				$.oldBack();
			}
		}; 
		
		var record = [];
		var tryNumber = 5;
		var startNew = false;
		var clearStateAndToLogin = function() {
			plus.nativeUI.showWaiting("正在执行...");
			app.setSetting('gestures','');
			app.setState('token','');
			waiting.close();
			$.toast('已清除手势密码，请重新登录');
			app.toLogin();
			$.currentWebview.close();
		};
		var open = function(event){
			tipTxt.style.color = '#8F8F94';
			var rs = event.detail;
			if (rs.points.length < 4) {
				tipTxt.style.color = '#FF0000';
				tipTxt.innerText='手势密码至少要包含4个点，请重新绘制';
				rs.sender.clear();
				record = [];
				return;
			}
			record.push(rs.points.join(''));
			if (record.length >= 2) {
				if (record[0] == record[1]) {
					app.setSetting('gestures',record[0]);
					rs.sender.clear();
					record = [];
					$.toast(self.type==1?'手势密码已开启':'手势密码已修改');
					$.back();
				} else {
					tipTxt.style.color = '#FF0000';
					tipTxt.innerText='密码不一致,请重新设定';
					rs.sender.clear();
					record = [];
				}
			} else {
				tipTxt.innerText='请再次输入以确认';
				rs.sender.clear();
			}
		};
		var close = function(event){
			tipTxt.style.color = '#8F8F94';
			var rs = event.detail;
			var gestures = app.getSetting('gestures');
			if (gestures == rs.points.join('')) {
				rs.sender.clear();
				record = [];
				app.setSetting('gestures','');
				$.toast('已关闭手势密码');
				$.back();
			} else {
				tryNumber--;
				rs.sender.clear();
				record = [];
				if (tryNumber > 0) {
					tipTxt.style.color = '#FF0000';
					tipTxt.innerText = '手势密码错误，还能尝试 ' + tryNumber + ' 次';
				}else{
					tipTxt.style.color = '#FF0000';
					tipTxt.innerText = '多次输入错误，请10分钟后再试';
					app.setSetting('lockTime',(new Date()).getTime());
					var txt = '输入错误次数过多，账户已被锁定，你可以点击忘记手势密码或10分钟后再试';
					$.confirm(txt,'',['取消','忘记手势密码'],function(e){
						if(e.index==0){
							app.setState('token','');
							app.toLogin();
							$.currentWebview.close();
						}else if(e.index==1){
							clearStateAndToLogin();
						}
					});
				}
			}
		};
		var modify = function(event){
			tipTxt.style.color = '#8F8F94';
			if(startNew){
				open(event);
				return;
			}
			var rs = event.detail;
			var gestures = app.getSetting('gestures');
			if (gestures == rs.points.join('')) {
				startNew = true;
				rs.sender.clear();
				record = [];
				tipTxt.innerText='请输入新的手势密码';
			} else {
				tryNumber--;
				rs.sender.clear();
				record = [];
				if (tryNumber > 0) {
					tipTxt.style.color = '#FF0000';
					tipTxt.innerText ='原密码错误，还能尝试 ' + tryNumber + ' 次';
				}else{
					app.setSetting('lockTime',(new Date()).getTime());
					tipTxt.style.color = '#FF0000';
					tipTxt.innerText = '多次输入错误，请10分钟后再试';
					var txt = '输入错误次数过多，账户已被锁定，你可以点击忘记手势密码或10分钟后再试';
					$.confirm(txt,'',['取消','忘记手势密码'],function(e){
						if(e.index==0){
							app.setState('token','');
							app.toLogin();
							$.currentWebview.close();
						}else if(e.index==1){
							clearStateAndToLogin();
						}
					});
				}
			}
		};
		locker.addEventListener('done', function(event) {
			if(self.type==0){
				close(event);
			}else if(self.type==1){
				open(event);
			}else{
				modify(event);
			}
			
		}, false);
	});

}(mui, document));