(function($, doc) {	
	$.init();

	var g = function(id){return document.getElementById(id);};
	
	var checkGestures = function(){
		var gestures = app.getSetting('gestures');
		g('lockState').classList[gestures ? 'add' : 'remove']('mui-active');
		g('lockIntro').style.display = gestures ? 'none':'block';
		g('modifyLocker').style.display = gestures ? 'block':'none';
	};

    var checkDownSet = function () {
        var auto = app.getSetting('autoUpdateInWifi');
        g('downSate').classList[auto ? 'add' : 'remove']('mui-active');
    };
    
	var showVersion=function(){
     	var newVer = myStorage.getItem('newVersion');
     	var curVer = myStorage.getItem('appver');
     	jel('#version-code').text(curVer);
    	if(newVer && newVer!==curVer){
            jel('#verPan').addClass('red-dot');
        }
    };
    
    g('push').addEventListener('tap',function () {
        $.openWindow({id:'push',url:'setting-push.html'});
    },false);
    
    g('downSate').addEventListener('toggle',function () {
        var isActive = event.detail.isActive;
        app.setSetting('autoUpdateInWifi',isActive);
    },false);
	
	g('cache').addEventListener('tap',function () {
		$.openWindow({id:'cache',url:'setting-cache.html'});
	},false);
    
    g('lockState').addEventListener('toggle', function(event) {
		var isActive = event.detail.isActive;
		var gestures = app.getSetting('gestures');
		if(!isActive && gestures){
			$.openWindow({
				id:'locker',
				url:'setting-locker.html',
				extras:{type:0}
			});
		}else if(isActive && !gestures){
			$.openWindow({
				id:'locker',
				url:'setting-locker.html',
				extras:{type:1}
			});
		}
	}, false);
	
	g('modifyLocker').addEventListener('tap', function() {
		$.openWindow({
			id:'locker',
			url:'setting-locker.html',
			extras:{type:3}
		});
	}, false);
	//意见反馈
    g('feedback').addEventListener('tap',function () {
        $.openWindow({id:'feedback',url:'feedback.html'});
    },false);
    //关于查悦
    g('aboutus').addEventListener('tap',function () {
        $.openWindow({id:'about',url:'about.html'});
    },false);
    
    //账号注销
    g('cancellation').addEventListener('tap',function () {
		userSvc.getSetUpUserInfo(true).then(function (data) {
			if(data.logoutStatus == 0){
	       		//未申请注销[正常登录状态]
	       		$.openWindow({id:'applicationForCancellation',url:'cancellation/applicationForCancellation.html'});
	       	}else if(data.logoutStatus == 1){
	       		//已申请注销，并在7天注销范围内
	       		$.openWindow({id:'cancellationOfAccounts',url:'cancellation/cancellationOfAccounts.html'});
	       	}else if (data.logoutStatus == 3){
	       		//已申请注销[注销完毕]
	       		
	       	}
		}).catch(function(err) {
			console.error(err.message, err);
		});
    },false);
    
    //退出登录
    var siginOut = function () {
		app.removeLogin();
        //app.appRefresh();
        //app.toLogin();
        $.currentWebview.close();
	};
    
    g('signOut').addEventListener('tap', siginOut,false);
    
	window.addEventListener("checkGestures",checkGestures);
 
	if(mui.os.ios) jel("#checkBar").hide();
	checkGestures();
    checkDownSet();
	
	//登录状态[已登录：显示"注销账户"和"退出登录"]
	var settingReLoad = function (){
		if(app.checkLogin()){
			g('signOut').classList.remove('mui-hidden'); //退出登录显隐
			g('cancellationBox').classList.remove('mui-hidden');
			//获取用户信息，判断该用户所属注销状态
			userSvc.getSetUpUserInfo(true).then(function (data) {
				if(data.logoutStatus == 0){
		       		//未申请注销[正常登录状态]
		       		g('tipsState').classList.add('mui-hidden');
		       	}else if(data.logoutStatus == 1){
		       		//已申请注销，并在7天注销范围内
		       		g('tipsState').classList.remove('mui-hidden');
		       	}else if (data.logoutStatus == 3){
		       		//已申请注销
		       		g('tipsState').classList.add('mui-hidden');
		       	}
	        }).catch(function(err) {
				$.toast(err.message);
				console.error(err.message, err);
			});
		}
	}
	settingReLoad();
	//神策埋点
	function joyTrack(){
		//WIFI自动更新
		jTrack.regEvents('#downSate','joyLinkClick','jtrack_name:WIFI自动更新');
		//推送设置
		jTrack.regEvents('#push','joyLinkClick','jtrack_name:推送设置');
		//意见反馈
		jTrack.regEvents('#feedback','joyLinkClick','jtrack_name:意见反馈');
		//关于查悦
		jTrack.regEvents('#aboutus','joyLinkClick','jtrack_name:关于我们');
		//退出登录
		jTrack.regEvents('#signOut','joyLinkClick','jtrack_name:退出登录');
	}
	$.plusReady(function(){
		document.addEventListener('settingReLoad',settingReLoad,false);
		joyTrack();
	});
}(mui, document));