(function($, doc) {
	$.init();
	$('.mui-scroll-wrapper').scroll();
	var sbkList = document.getElementById('sbkList');
//	var addBtn = document.getElementById('addSbk');
	var addBtn2 = document.getElementById('addSbk2');
	var options = document.getElementById('options');
	var unbind = document.getElementById('unbind');
	var optionsClear = document.getElementById('optionsClear');
	var removeId = 0;

	var getSbkList = function(data){
		var html = '', item;
		for(var i in data){
			item = data[i];
			item.payCityName = geo.getCityNameByCode(item.payCity);
			var styleClass = item.isMainAccount?'fa-check-circle':'fa-circle-o';
			html += [
			'<li class="sbk',item.isMainAccount == 1?'':' second','">',
				'<div class="card-top" aid="',item.id,'">',
//					'<div class="sbk-icon mui-pull-left"><i class="jcon jcon-card"></i></div>',
					'<div class="sbk-user">',
						'<span class="pername">',item.name,'</span>',
						'<span class="mui-pull-right payCityName">',item.securityState||'--','</span>',
					'</div>',
					'<div class="sbk-code">',item.securityAccount,'</div>',
					'<div class="sbk-data mui-clearfix">',
						'<span class="sbkState">',item.payCityName,'人力资源和社会保障局</span>',
						'<span class="mui-pull-right lastRefreshDate">',item.lastRefreshDate.substr(0,10),'</span>',
					'</div>',
				'</div>',
				'<div class="card-set mui-row">',
					'<div class="setDefaultBtn btn mui-col-xs-6" aid="',item.id,'" isMainAccount="',item.isMainAccount,'">',
						'<span class="fa ' + styleClass + '"></span>',
						item.isMainAccount?'默认卡片':'设为默认',
					'</div>', 
				 	'<div class="removeBtn btn mui-col-xs-6" aid="',item.id,'">',
						'<span class="fa fa-trash-o"></span>删除',
					'</div>',
				'</div>',
			'</li>'].join('');
		}
		return html;
	};
	
	var getSecList = function () {
		if(!app.checkLogin()) return;
		shebaoSvc.getSecList({}).then(function (data) {
			if(data.length>0){
				sbkList.innerHTML = getSbkList(data);
			}else{
				sbkList.innerHTML = '<div class="empty-item"></div>';
			}
			addBtn2.style.visibility="visible";
		}).catch(function(err){
			console.error(err.message,err);
		});
	};
	
	getSecList();
	
	$('.sbk-list').on('tap', '.setDefaultBtn', function(){
		var aid = parseInt(this.getAttribute('aid'));
		var isMainAccount = this.getAttribute('isMainAccount');
		if(isMainAccount == '1'){
			$.toast("当前卡片已为默认");
		}else{
			setDefaultCard(aid);
		}
	},false);
	
	$('.sbk-list').on('tap', '.removeBtn', function(){
		$('#options').popover('show');
		g('options').style.top = '50%';
		g('options').style.left = '50%';
		removeId = parseInt(this.getAttribute('aid'));
	},false);
	//保留卡片
	g('saveCard').addEventListener('tap', function(){
		$('#options').popover('hide');
	},false);
	
	var removeCard = function (accountId) {
		shebaoSvc.removeSecurity(accountId).then(function (data) {
			$.toast("解绑成功");
			var user = app.getUser();
            user.securityAcctId = data;
            app.setState('info',user);
            app.fireEvent('main','refreshSecNum');
            app.fireEvent('main','refreshHome');
            app.fireEvent('main','refreshJoy');
            app.fireEvent('sbk','refresh_data');
            $('#options').popover('hide');
		}).catch(function (err) {
			$.toast(err.message);
		});
	};

	var setDefaultCard = function (accountId) {
		plus.nativeUI.showWaiting('正在保存设置...');
		shebaoSvc.changeDefaultAccount(accountId).then(function (data) {
			plus.nativeUI.closeWaiting();
			$.toast("设置默认成功");
            var user = app.getUser();
            user.securityAcctId = accountId;
            app.setState('info',user);
            app.fireEvent('main','refreshHome');
            app.fireEvent('main','refreshJoy');
            app.fireEvent('sbk','refresh_data');
		}).catch(function (err) {
			plus.nativeUI.closeWaiting();
			$.toast(err.message);
			console.error(err.message,err);
		});
	};

	unbind.addEventListener('tap',function(){
		removeCard(removeId);
	});
	
	optionsClear.addEventListener('tap',function(){
		$('#options').popover('hide');
	});
	
	//因改版页面右上角添加社保卡功能去除，固屏蔽该功能
//	addBtn.addEventListener('tap',function(){ app.showSheBaoAdd(); });
	
	addBtn2.addEventListener('tap',function(){ app.showSheBaoAdd(); });
	
	$('.sbk-list').on('tap', '.card-top', function() {
		var sbkid = parseInt(this.getAttribute('aid'));
		app.showSheBaoInfo(sbkid); 
	});
	
	window.addEventListener('refresh_data',function(){
		console.log('refresh secList');
		getSecList();
	},false);
	
})(mui, document);