(function($,win){
	
	$.init();
	
	var calcParams = {
		planSalaryAmt:10000,
		securityAcctId:0,
		fundAcctId:0
	};

	var calcsalary = function(params){
		g("salary").innerHTML = params.planSalaryAmt+"元";
		document.activeElement.blur();
		plus.nativeUI.showWaiting();
		joySvc.reaSalTrial(params).then(function(data){
			plus.nativeUI.closeWaiting();
			creatChart(data);
			creatTable(data);
		}).catch(function(err){
			plus.nativeUI.closeWaiting();
			$.toast(err.message);
			console.error(err.message,err);
		});
	};
	
	var creatChart = function(data){
			var chartPan = document.getElementById('wagesChart');
	 		var chart = echarts.init(chartPan);
			var option = {
			    tooltip : {},
			    legend: { 
			        orient: 'vertical', left:'0%', top:'3%',fontSize:'10px',
			        data: ['个人社保','个人公积金','个人所得税','实发工资']
			    },
			    series : [{
		            name: '工资组成',
		            type: 'pie',
		            avoidLabelOverlap:'true',
		            startAngle:70,
		            radius : '75%',
		            center: ['52%', '50%'],
		            data:[
		                {value:data.securityAmt, name:'个人社保'},
		                {value:data.fundAmt, name:'个人公积金'},
	                    {value:data.taxAmt, name:'个人所得税'},
		                {value:data.realSalaryAmt, name:'实发工资'}
		            ],
		            color:['#E53E46','#F7B62C','#39bfb3','#3EC0CE'],
		            itemStyle: {
		            	emphasis: {
		                    shadowBlur: 10,
		                    shadowOffsetX: 0,
		                    shadowColor: 'rgba(0, 0, 0, 0.5)'
		                },
		                normal:{ 
		                  label:{ 
		                    show:false, 
		                    formatter: '{d}%' //{b}({d}%)
		                  }, 
		                  labelLine :{show:false} 
		                } 
			            
		            }
		       }]
			};
		chart.setOption(option);
	}

	var creatTable = function(data){
  		jscope.bind(g('xq_table'),data,'wage');
  	};

	g('gongzi_box').addEventListener('tap',function(){
		 $('#ybTipBox').popover('show');
	},false);

	g('gongzi').addEventListener('input',function(){
		//this.value = this.value.slice(0,7);
		if(!/^[1-9]\d{0,11}$/.test(this.value)){
			$.toast('<span class="color-red">请输入12位以内的金额数字</span>',{type:'div'});
		}
		if(this.value.length>12){
			this.value = this.value.substr(0,12);
		}
	},false);

	g("ok").addEventListener("tap",function(){
		var gongzi = g("gongzi").value.trim();
		if(/[1-9]\d+/.test(gongzi)){
			$('#ybTipBox').popover('hide');
			calcParams.planSalaryAmt = gongzi;
			calcsalary(calcParams);
		}else{
			g("salary").innerHTML = "";
			$.toast("请输入正确金额",{type:'div'});
		}
	});

  	$.plusReady(function(){
  		var user = app.getUser();
  		if(user){
  			calcParams.securityAcctId=user.securityAcctId||0;
			calcParams.fundAcctId=user.fundAcctId||0;
  		}
  		if(calcParams.securityAcctId){
  			shebaoSvc.getSecInfo(calcParams.securityAcctId).then(function(data){
	  			calcParams.planSalaryAmt = data.payBase;
	  			calcsalary(calcParams);
	  		}).catch(function(errr){
	  			console.error(err.message,err);
	  		})
  		}else{
  			calcsalary(calcParams);
  		}
  		
	});
})(mui,window);