(function($) {
	var topicId = common.utils.queryString('tid'); // topicId  36-45
	var topicScroll = null,topicObj = null;
	var windowWidth = window.innerWidth;
	var default_img = '../images/topic_bg.png'; // 话题默认背景
	var topicType = ['ad','article','minfo','visual','vote']; // 返回类型class名
	// 懒加载
	var Lazyload = $('#feed').imageLazyload({
		placeholder: '../images/lazy-news.png',
		autoDestroy: false
	});
	topicObj = {
		init: function(){
			topicObj.getDetails(topicId);
			topicObj.getFeedList();
			topicObj.setPullRefresh();
		},
		getDetails: function(topicId){
			// 获取话题详情
			newsSvc.getTopicById(topicId).then(function(data){
				if(data){
					g('topic_pic').querySelector('img.topic_bgr').setAttribute('src',data.image ? data.image : default_img);
					g('topic_content').querySelector('.headline').innerHTML = data.title ? '#' + data.title : '暂无';
					g('topic_content').querySelector('.synopsis').innerHTML = data.content ? data.content : '暂无';
					g('topic_content').querySelector('.partInNum').innerHTML = data.partInNum ? data.partInNum : '0';
				}
			}).catch(function(err){
				console.log(err.message,err);
			})
			// 置顶投票
			newsSvc.getFirstHotVote(topicId).then(function(data){
				var el = document.querySelectorAll('.vote-list');
				if(data && Object.keys(data).length > 0){
					$.each(el,function(idx,val){
						val.classList.remove('mui-hidden');
						val.setAttribute('id',data.id);
						val.querySelector('.vote-title').innerHTML = data.title;
						val.querySelector('.vote-left').innerHTML = data.rightContent;
						val.querySelector('.vote-right').innerHTML = data.opposContent;
						val.querySelector('.vote-attend').querySelector('span').innerHTML = data.partNum;
					})
				}else {
					$.each(el,function(idx,val){
						val.classList.add('mui-hidden');
					})
				}
			}).catch(function(err){
				console.log(err.message,err);
			})
		},
		// 获取详情
		getFeedList: function(){
			var slider = $('#feed').slider();
			var index = slider.slideNumber;
			var sliderItem = g('feedGroup').children[index];
			var box = sliderItem.querySelector('.data-box');
			var cbox1 = box.querySelector('.feed-box[data-type="0"]'),cbox2 = box.querySelector('.feed-box[data-type="1"]');
			var tabEl = g('feedTab').children[index];
			var pageNum = sliderItem.getAttribute('pagenum'),pageSize = 10;
				pageNum = pageNum ? parseInt(pageNum)+1 : 1;
			var params = {
				topicId: topicId,
				type: parseInt(index+1),
				pageNum: pageNum,
				pageSize: pageSize
			}
			// feed流
			return newsSvc.getTopicListByTopicId(params).then(function(data){
				topicObj.createFeedList(cbox1,cbox2,data.list);
				Lazyload.refresh(true);
				$(sliderItem.querySelector('.mui-scroll-wrapper')).scroll().refresh();
				sliderItem.setAttribute('data-init','true');
				sliderItem.setAttribute('pagenum',pageNum);
				sliderItem.setAttribute('pagesize',pageSize);
				return data.list && data.list.length || 0;
			}).catch(function(err){
				console.log(err.message,err);
				return 0;
			});
		},
		// 创建feed流
		createFeedList: function(cbox1,cbox2,data){
			$.each(data,function(i,item){
				var feedItem = null;
				var cbox = cbox1.offsetHeight<=cbox2.offsetHeight ? cbox1 : cbox2,
					cbox_type = cbox.getAttribute('data-type');
				feedItem = topicObj.createFeedArt(item);	
				cbox.appendChild(feedItem);
			});
		},
		createFeedArt: function(data){
			var item = document.createElement('div');
			item.className = 'feed-item';
			item.classList.add(topicType[data.topicType]);
			item.setAttribute('data-hide','0');
			item.setAttribute('data-change','0');
			item.setAttribute('data-id',data.id);
			item.setAttribute('type',data.type);
			item.setAttribute('feed-type',topicType[data.topicType]);
			var coverStyle=data.type==2?'<span class="vbtn"></span>':'';
			var isVideo = '0';
			var play_icon = '';
			var img_H = 0;
			if(data.feedImageWidth && data.feedImageHeight && data.feedImageWidth !== 0 && data.feedImageHeight !== 0){
				img_H = topicObj.getImageSize(data.feedImageWidth,data.feedImageHeight);
			}else{
				img_H = '';
			}
			if(data.topicType==1){
				// 文章
				isVideo = data.type==2?'1':'0';
				item.setAttribute('data-video',isVideo);
			}else if(data.topicType==2){
				// 悦头条
				isVideo = [1,3].indexOf(data.type)<0?'0':'1';
				item.setAttribute('data-video',isVideo);
			}else if(data.topicType == 3){
				// 小视频
				play_icon = '<div class="play_icon"><div class="float-btn jcon jcon-bofang"></div></div>';
			}
			if(data.topicType == 4){
				item.innerHTML = [
				 	'<div class="vote-top">',
						'<div class="vote-text">投票</div>',
						'<div class="vote-attend"><span>' + data.partNum + '</span>人参加</div>',
					'</div>',
					'<div class="vote-title">' + data.title + '</div>',
					'<div class="vote-select">',
						'<div class="vote-left vote-cont">' + data.rightContent + '</div>',
						'<div class="vote-compare"><img src="../images/vote-compare.png"/></div>',
						'<div class="vote-right vote-cont">' + data.opposContent + '</div>',
					'</div>'
				].join('');
			}else {
				var zan = '<span class="praise jcon jcon-dianzan" data-type="' + data.topicType + '" aid="'+data.id+'" praised="'+(data.isLike ? 1 : 0)+'">'+(data.agreeCount||'')+'</span><span class="praise_area" data-type="' + data.topicType + '"></span>';
				item.innerHTML = [
					'<a class="tap-box" data-id="',data.id,'" data-type="',data.topicType,'" data-video="',isVideo,'">',
						'<div class="cover"><img height="' + img_H + '" data-lazyload="' + data.feedImage + '" src="../images/lazy-news.png" data-img="' + (data.gifImage ? data.gifImage : data.image) + '"/>',coverStyle,play_icon,'</div>',
						'<div class="title">',data.title,'</div>',
					'</a>',
					'<div class="info">',
						'<span class="author mui-ellipsis">',
							'<img src="',data.headPath,'">',
							'<span class="mui-ellipsis">',data.userName,'</span>',
						'</span>',zan,
						'<b class="c-yellow"></b>',
					'</div>'
				].join('');
			}
			return item;
		},
		// 图片比例
		getImageSize: function(imgW,imgH){
			var imgSize = {
				width:imgW,
				height:imgH,
				ratio: Number(imgH)/Number(imgW), 
				realHeight: Number(windowWidth/2-20)*Number(imgH)/Number(imgW)
			}
	    		return parseInt(imgSize.realHeight);
		},
		pullUp: function(puller){
			topicObj.getFeedList().then(function(len){
				puller.endPullUpToRefresh(len==0);
			}).catch(function(err){
				puller.endPullUpToRefresh();
			});
		},
		setPullRefresh: function(){
			var windowH = document.documentElement.clientHeight;
			$('#feedGroup .mui-scroll').setJPullToRefresh({
				up:{
					offset:windowH/2,
					callback:function(){
						topicObj.pullUp(this);
					}
				}
			});
		}
	}
	$.init();
	$.plusReady(function() {
		var nav_H = imbar.statusbarHeight,
			header_H = imbar.navBarHeight,
			feed_H = parseInt(g('feedTab').offsetHeight),
			windowH = document.documentElement.clientHeight;
		g('topic').style.height = header_H + 'px';
		g('topic').style.paddingTop = nav_H + 'px';
		g('topic').style.opacity = 1;
		g('topic_bg').style.height = header_H + 'px';
		g('topic_bg').style.paddingTop = nav_H + 'px';
		var topic_H = parseInt(g('topic_bg').offsetHeight);
		g('feed').style.height = (windowH - header_H) + 'px';
		g('feedGroup').style.height = (windowH - feed_H - topic_H) + 'px';
		topicScroll = $('#topicScroll').jscroll({
			scrollX: false,
			indicators: false,
			bounce: false,
			child: {
				fixBox: '#feed',
				fixBar: '#feedTab',
				scBox: '#feedGroup',
				scrolls: '#feedGroup .mui-scroll-wrapper',
				active: '#feedGroup .mui-slider-item.mui-active .mui-scroll-wrapper'
			}
		});
		topicObj.init(); // 初始化
		$('#feed').on('scroll','.mui-scroll-wrapper',function(e){
			$('#feed').slider().resetPosition();
			var slider = $('#feed').slider().slideNumber;
			var itemDom = g('feed0').querySelectorAll('.feed-item.visual');
			var scrollY = Math.abs(e.detail.y);
			var default_img = '';
			$.each(itemDom, function(idx,val) {
				if(val.querySelector('img').getAttribute('src') !== Lazyload.options.placeholder){
					checkScroll(val,scrollY);
				}
			});
		},false);
	})
	function checkScroll(itemDom,scrollY) {
	    //滚动条高度+视窗高度 = 可见区域底部高度
	    var visibleBottom = scrollY + document.documentElement.clientHeight * 0.6;
	    //可见区域顶部高度
	    var visibleTop = scrollY;
	    var centerY = itemDom.offsetTop + (itemDom.offsetHeight * 0.5);
	    var show = centerY > visibleTop && centerY < visibleBottom;
	    if (show) {
	        // showing
	        var el = itemDom.querySelector('img'),
	        		gifUrl = el.getAttribute('data-img'),
	        		imgUrl = el.getAttribute('src'),
	        		change = itemDom.getAttribute('data-change');
	        	if(change && change == 1){
	        		return false;
	        	}
	        	el.setAttribute('src',gifUrl);
	        	el.setAttribute('data-img',imgUrl);
	        itemDom.setAttribute('data-change','1');
	        itemDom.setAttribute('data-hide','1');
	    }else{
	        // hidden
	        var el = itemDom.querySelector('img'),
	        		imgUrl = el.getAttribute('data-img'),
	        		gifUrl = el.getAttribute('src'),
	        		data_hide = itemDom.getAttribute('data-hide');
	    	 	if(data_hide && data_hide == 0){
	        		return false;
	        	}
	        	el.setAttribute('src',imgUrl);
	        	el.setAttribute('data-img',gifUrl);
	        	itemDom.setAttribute('data-change','0');
	        	itemDom.setAttribute('data-hide','0');
	    }
	}
	// 滚动导航图片切换
	var pullTop = (function() {
		var funsHeight = g('topic_pic').offsetHeight+10,elH = g('topic_bg').offsetHeight;
		var slideLeft = function(lastY) {
			var absY = Math.abs(lastY);
			var height = lastY < 0 ? absY > funsHeight ? funsHeight : absY : 0,
				topicH = lastY < 0 ? absY > elH ? elH : absY : 0;
			var opacity = height / funsHeight;
			var opacity0 = 1 - opacity;
			var opacity1 = height > 0.5 * elH ? 1 - 2 * (elH - topicH) / elH : 0;
			var opacity2 = height < 0.5 * funsHeight ? 2 * (funsHeight - height) / funsHeight - 1 : 0;
			g('topic_bg').style.opacity = opacity1;
			g('topic_pic').style.opacity = opacity2;
		};
		return {
			funsHeight: funsHeight,
			elH: elH,
			slideLeft: slideLeft
		}
	})();
	// 切换导航
	g('feed').addEventListener('slide',function(){
		var box = g('feedGroup').children[event.detail.slideNumber];
		if(!box.getAttribute('data-init')){
			topicObj.getFeedList();
		}
	},false);
	// 显示导航栏
	g('content').addEventListener('scroll', function(e) {
		if(e.detail.hasHorizontalScroll || e.target != g('content')) return;
		pullTop.slideLeft(e.detail.y);
	}, false)
	// 详情
	$('#feedGroup').on('tap','.feed-item',function(e){
		var name = this.getAttribute('feed-type'),
			id = this.getAttribute('data-id'),
			type = this.getAttribute('type');
		switch (name){
			case 'article':
				// 文章
				if(type == 2){
					// 视频
					$.openWindow("article-video.html?aid=" + id);
				}else{
					// 文章
					$.openWindow("article.html?aid=" + id);
				}
				break;
			case 'minfo':
				// 悦头条
				if(type == 1 || type == 3) {
					$.openWindow({
						url: 'minfo/minfo-video.html?mId=' + id
					});
				} else {
					$.openWindow({
						url: 'minfo/minfo.html?mId=' + id
					});
				}
				break;
			case 'visual':
				// 小视频
				$.openWindow({url: 'visualFrequency.html?visualId=' + id});
				break;
			case 'vote':
				// 投票
				var vm = $.openWindow({url: 'subscriber-vote.html?id=' + id}),
					vmId = plus.webview.getWebviewById(vm.id);
				// 监听页面关闭
				vmId.addEventListener('close',function(){
					topicObj.getDetails(topicId);
				})
				break;
		}
	})
	// 投票详情
	$('#feedGroup').on('tap','.vote-list',function(e){
		e.stopPropagation();
		var id = this.getAttribute('id');
		var vm = $.openWindow("subscriber-vote.html?id="+id),
			vmId = plus.webview.getWebviewById(vm.id);
		// 监听页面关闭
		vmId.addEventListener('close',function(){
			topicObj.getDetails(topicId);
		})
	})
	// 点赞
	$('#feedGroup').on('tap','.feed-item .praise_area',function(e){
		e.stopPropagation();
		if (!app.checkLogin()) {
			app.toLogin(); 
			return;
		}
		var self = this.parentElement.querySelector('.praise'),
			type = self.getAttribute('data-type'),
			aid = self.getAttribute('aid'),
			dir = self.getAttribute('praised') === '1' ? true : false, // 1- 取消点赞  0-点赞
			operateType = dir ? '0' : '1',
			praising = self.getAttribute('praising'),
			num = self.innerHTML == 0 ? 0 : parseInt(self.innerHTML),
			parent = self.parentElement;
		if(praising) return;
		self.setAttribute('praising','1');
		switch(type){
			case '1':
				// 文章
				newsSvc.follow(0, aid, dir).then(function(res){
					getPriseResult(self,dir,parent);
				}).catch(function(err){
					// 已经点赞 
					if ('CO9001' == err.code ) {
						self.classList.add('active');	
						self.setAttribute('praised','1');
		    			//已经取消赞	
					} else if('CO9002' == err.code) {
						self.classList.remove('active');
						self.setAttribute('praised','0');
					}
					self.removeAttribute('praising');
					console.error(err.message,err);
				});
				break;
			case '2':
				// 悦头条
				newsSvc.likeMan(aid,operateType,0).then(function(res){
					getPriseResult(self,dir,parent);
				}).catch(function(err){
					// 已经点赞 
					if ('CO9001' == err.code ) {
						self.classList.add('active');	
						self.setAttribute('praised','1');
		    			//已经取消赞	
					} else if('CO9002' == err.code) {
						self.classList.remove('active');
						self.setAttribute('praised','0');
					}
					self.removeAttribute('praising');
					console.error(err.message,err);
				});
				break;
			case '3':
				// 小视频
				newsSvc.getliked(aid,0,operateType).then(function(res){
					getPriseResult(self,dir,parent);
				}).catch(function(err){
					// 已经点赞 
					if ('90001' == err.code ) {
						self.classList.add('active');	
						self.setAttribute('praised','1');
		    			//已经取消赞
					} else if('90004' == err.code) {
						self.classList.remove('active');
						self.setAttribute('praised','0');
					}
					self.removeAttribute('praising');
					console.error(err.message,err);
				});
				break;
		}
	})
	// 点赞
	var getPriseResult = function(self,dir,parent){
		self.removeAttribute('praising');
		self.setAttribute('praised',dir?'0':'1');
		parent.setAttribute('praised',dir?'0':'1');
		var praiseNum = parseInt(self.innerText||0)+(dir?-1:1);
		self.innerHTML = praiseNum||'';
		var elw = parseInt(self.offsetWidth) <= 15 ? 22 : parseInt(self.offsetWidth),
				el_edge = 10,
				cye_w = parent.querySelector('.c-yellow').offsetWidth;
		parent.querySelector('.c-yellow').style.right = (elw + el_edge - cye_w + 2) + 'px';
		self.classList[dir?'remove':'add']('active');
		setTimeout(function(){
			parent.removeAttribute('praised');
		},2000)
	}
})(mui)