(function($){
	$.init();
	$.oldBack = $.back;
	$.back = $.noop;
	 
	var currBox = {close:$.noop};
	var progress = {
		box:document.getElementById('downloadProgressbar'),
		perTxt:document.getElementById('downloadPerText'),
		downTxt:document.getElementById('downloadSize'),
		totalTxt:document.getElementById('totalSize'),
		perBar:document.getElementById('downloadPerBar'),
		tipTxt:document.getElementById('downloadTipText')
	};
	var prompt = {
		box:document.getElementById('promptBox'),
		title:document.getElementById('promptTitle'),
		body:document.getElementById('promptBody')
	};
	var ani = {
		'zoom-fade-out':function(el,duration){
			el.setSyle({
				transition:'none',
				transform:'translateY(-50%) scale(0.5)',
				opacity:'0',
			});
			el.setSyle({ transition:'all '+(duration/1000)+'s'});
			el.classList.remove('mui-hidden');
			setTimeout(function(){
				el.setSyle({
					transform:'translateY(-50%) scale(1)',
					opacity:'1'
				});
			},10);
		},
		'zoom-fade-in':function(el,duration){
			el.setSyle({
				transform:'translateY(-50%) scale(1)',
				opacity:'0'
			});
		},
		'slide-right-in':function(el,duration){
			el.setSyle({
				transition:'none',
				transform:'translateY(-50%) scale(1)',
				opacity:'1',
				left:'-90%'
			});
			el.setSyle({transition:'all '+(duration/1000)+'s'});
			el.classList.remove('mui-hidden');
			setTimeout(function(){
				el.setSyle({
					transform:'translate(-50%) scale(1)',
					left:'10%'
				});
			},10);
		},
		'slide-right-out':function(el,duration){
			el.setSyle({
				transform:'translateY(-50%) scale(1)',
				left:'100%'
			});
		}
	};
	
	HTMLElement.prototype.setSyle = function(css){
		var addPre = 'transform,transition';
		var el = this;
		$.each(css, function(name,value) {
			if(addPre.indexOf(name)>=0){
				el.style['webkit'+name[0].toUpperCase()+name.substr(1)] = value;
			}
			el.style[name] = value;
		});
	};
	HTMLElement.prototype.show = function(aniStyles){
		aniStyles = $.extend({},{duration:500,type:'zoom-fade-out'},aniStyles);
		this.setAttribute('ani-close',aniStyles.type.replace(/-out|-in/,function(w){
			return w==='-out'?'-in':'-out';
		}));
		//ani[aniStyles.type](this,aniStyles.duration);
		this.classList.remove('mui-hidden');
		this.classList.remove('zoom-fade-out');
		this.classList.add('zoom-fade-in');
	};
	HTMLElement.prototype.close = function(aniStyles){
		var type = this.getAttribute('ani-close')||'zoom-fade-in';
		aniStyles = $.extend({},{duration:500,type:type},aniStyles);
		//ani[aniStyles.type](this,aniStyles,aniStyles.duration);
		var el = this;
		this.classList.remove('zoom-fade-in');
		this.classList.add('zoom-fade-out');
		setTimeout(function(){
			el.classList.add('mui-hidden');
		},aniStyles.duration);
		
	};
	
	window.addEventListener('showPromptBox',function(event){
		$.back = $.oldBack;
		if(event.detail.title){
			prompt.title.innerHTML = event.detail.title;
		}
		if(event.detail.updateLog){
			prompt.body.innerHTML = event.detail.updateLog.replace(/(.+)\n*/g,'<li>$1</li>');
		}
		if(event.detail.btns){
			if(!event.detail.btns.cancleBtn) $.back = $.noop;
			g('promptBtns').innerHTML='';
			$.each(event.detail.btns, function(id,btn) {
				var btnEl = g('promptBtns').appendChild(document.createElement('a'))
				btnEl.id = id;
				btnEl.className=btn.className||'prompt-btn';
				btnEl.innerText = btn.text;
				btnEl.addEventListener('tap',function(){
					$.fire(plus.webview.getLaunchWebview(),btn.callback);
				},false);
			});
		}else{
			g('downloadBtn').addEventListener('tap',function(){
				$.fire(plus.webview.getLaunchWebview(),'updateDownLoad');
			},false);
			g('cancleBtn').addEventListener('tap',function(){
				$.fire(plus.webview.getLaunchWebview(),'updateCancle');
			},false);
		}
		currBox.close();
		currBox = prompt.box;
		currBox.show(event.detail.aniStyles);
	},false);
	window.addEventListener('showProgressBox',function(event){
		$.back = $.noop;
		currBox.close();
		currBox = progress.box;
		currBox.show(event.detail.aniStyles);
	},false);
	window.addEventListener('UpdateProgress',function(event){
		var dsize = event.detail.downloadedSize;
		var total = event.detail.totalSize;
		var unit = 'B',psize=1;
		if(event.detail.tipText) progress.tipTxt.innerText = event.detail.tipText;
		if(total && !progress.totalTxt.innerText){
			if(total>1024*1024){
				unit = 'MB';
				psize = 1024*1024;
			}else if(total>1024){
				unit = 'KB';
				psize = 1024;
			}
			progress.totalTxt.innerText = '/'+(total/psize).toFixed(2)+unit;
		} 
		if(dsize){
			if(dsize>1024*1024){
				unit = 'MB';
				psize = 1024*1024;
			}else if(dsize>1024){
				unit = 'KB';
				psize = 1024;
			}
        	progress.downTxt.innerText='已下载 '+(dsize/psize).toFixed(2)+unit;
		}
		if(total && dsize){
			progress.perBar.classList.remove('progressbar-infinite');
			var per = dsize/total;
			progress.perBar.style.width = (per*100)+'%';
			progress.perTxt.innerText = parseInt(per*100)+'%';
		}else{
			progress.perBar.classList.add('progressbar-infinite');
		}
	},false);

})(mui);