(function($, doc) {
	$.init();
	
	var img;
	var submits = doc.getElementById('submits');
	var reSubmit = doc.getElementById('reSubmit');
	var getCameraBtn = doc.getElementById('getCamera');
	var galleryBtn = doc.getElementById('gallery');
	var addImgBtn = doc.getElementById('addImg');
	var photoBox = doc.getElementById('photoBox');
	var warn = doc.getElementById("warning");
	var closePopover = doc.getElementById('closePopover');
	var backStatus = 0; //返回状态，当提交成功后直接返回不提示
	var qsData = {}; //提交问题的参数
	var num = 0;
	var mask = $.createMask(callback);
	var consultCount = common.utils.queryString('ccount');
	qsData.questionId = common.utils.queryString('qsId');
	 
	function callback() {
		console.log("关闭遮罩");
	}

	doc.getElementById("surplusTime").innerHTML = consultCount;
	
	//统一样式的警告
	function warning(txt) {
		warn.innerHTML = txt;
		warn.style.display = "block";
		setTimeout(function() {
			warn.style.display = "none";
		}, 3000);
	}
	
	submits.addEventListener("tap", submitCheck, false);
	reSubmit.addEventListener("tap", submitCheck, false);

	doc.getElementById("qsCon").addEventListener("input",function(){
		var matchEmoji = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
		if(matchEmoji.test(this.value)){
			$.toast('不支持emoji表情符号！');
			this.value = this.value.replace(matchEmoji,'');
		}
	},false);
	
	function submitCheck() {
		var detail = doc.getElementById("qsCon").value;
		var matchEmoji = /\uD83C[\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F]/g;
		if(matchEmoji.test(detail)){
			warning("不支持emoji表情符号！");
			return false;
		}
		if(detail.length > 500 || detail.length < 10) {
			warning("内容在10~500字之间");
			return false;
		} else {
			qsData.content = detail;
		}
		var files = null,
			imgs = $('#photoBox .picPath');
		if(imgs){
			files = {};
			$.each(imgs,function(i,img){
				files["imageFile"+(i+1)] = img.src;
			});
		}
		postFiles(qsData,files);  
	}
	
	function postFiles(data,files) {
		var waitting = plus.nativeUI.showWaiting();
		bizSvc.zhuiwenZixun(data,files).then(function(res) {
			waitting.close()
			backStatus = 1;
			imgSrc = "";
			doc.getElementById("mask").style.display = "block";
			doc.getElementById("popover").style.display = "block";
			//提交成功时隐藏提交失败的弹框failMask
			doc.getElementById("failMask").style.display = "none";
			app.fireEvent('zixun-detail', 'refreshPage');
		}).catch(function(err) {
			fail();
			waitting.close()
			console.error(err.message, err);
		});
	}
	
	//提交失败
	function fail() {
		doc.getElementById("failMask").style.display = "block";
		doc.getElementById("failPopover").style.display = "block";
	}
	
	doc.getElementById('closePopover').addEventListener("tap", function() {
		backPage();
	}, false);
	
	doc.getElementById("failClose").addEventListener("tap", function() {
		doc.getElementById("failMask").style.display = "none";
		doc.getElementById("failPopover").style.display = "none";
	}, false);
	
	//图片居中
	function AutoResizeImage(maxWidth, maxHeight, objImg){
		var img = new Image();
		img.src = objImg.src;
		var hRatio;
		var wRatio;
		var Ratio = 1;
		img.onload = function() {
			var w = img.width;
			var h = img.height;
			wRatio = maxWidth / w;
			hRatio = maxHeight / h;
			if(maxWidth == 0 && maxHeight == 0) {
				Ratio = 1;
			} else if(maxWidth == 0) { //
				if(hRatio < 1) Ratio = hRatio;
			} else if(maxHeight == 0) {
				if(wRatio < 1) Ratio = wRatio;
			} else if(wRatio < 1 || hRatio < 1) {
				Ratio = (wRatio <= hRatio ? wRatio : hRatio);
			}
			if(Ratio < 1) {
				w = w * Ratio;
				h = h * Ratio;
			}

			if(h > w) {
				//长图
				h = h - 2;
				objImg.height = h;
				objImg.width = w;
				var left = parseInt((68 - w) / 2);
				objImg.style.marginLeft = left + "px";
			}
			if(h < w) {
				w = w - 2;
				objImg.height = h;
				objImg.width = w;
				var top = parseInt((68 - h) / 2);
				objImg.style.marginTop = top + "px";
			}
		}

	}

	function bindEvent(){
		if($(".picPath").length == 0) {
			return false;
		}
		for(var i = 0; i < $(".picPath").length; i++) {
			$(".image-close")[i].addEventListener("tap", function(e) {
				var obj = e.target.parentNode;
				obj.parentNode.removeChild(obj);
			}, false);
			$(".picPath")[i].addEventListener("load", AutoResizeImage("68", "68", $(".picPath")[i]), false);
		}
	}
	
	function compressImg(path,callback){
		var ext = path.toLowerCase().substr(path.toLowerCase().lastIndexOf('.'));
		if(ext==".jpg"||ext==".png"||ext==".jpeg"){
			plus.nativeUI.showWaiting('正在压缩图片...');
			plus.io.resolveLocalFileSystemURL(path, function(entry) {
				//console.log(entry.fullPath);
				entry.file(function(file){
					//console.log(file.name);
					var unitM = 1024 * 1024;
					var mSize = file.size/unitM;
					var qper = mSize>2?2*unitM/file.size:0.92;
					var canvas = document.createElement('CANVAS');
					var ctx = canvas.getContext('2d'); 
					var img = new Image();
					img.crossOrigin = 'Anonymous'; 
					img.onload = function(){ 
						//console.log('imgSrc:',this.src);
						canvas.height = img.height; 
						canvas.width = img.width; 
						ctx.drawImage(img,0,0); 
						var dataURL = canvas.toDataURL('image/jpeg',qper); 
						callback.call(this, dataURL); 
						canvas = null; 
					}; 
					img.src = entry.fullPath;
				},function(e){
					//console.log(e.message);
					warning("读取文件失败！");
				});
			}, function (e) {
				console.log(e.message);
				warning("读取文件失败！");
			});
		}else{
			warning("请选择jpg/png格式的图片");
		}
	}
		
	//拍照
	function captureImage() {
		$('#picture').popover('hide');
		var cmr = plus.camera.getCamera(),
			res = cmr.supportedImageResolutions[0],
			fmt = cmr.supportedImageFormats[0];
		cmr.captureImage(function(path) {
			compressImg(path,function(b64Src){
				var pic = doc.createElement("div");
				pic.setAttribute("class", "qsPhoto");
				pic.innerHTML = "<img class='picPath' src='" + b64Src + "' data-preview-src='' data-preview-group='1' /><span class='image-close'>X<span>";
				photoBox.appendChild(pic);
				backStatus = 1;
				$.previewImage();
				bindEvent();
	    		plus.nativeUI.closeWaiting();
    		});
		},function(error) {
			$.toast("拍照失败请重试");
		}, {
			resolution: res,
			format: fmt
		});
	}
	//从相册中选择图片
	function galleryImgs() {
		$('#picture').popover('hide');
		plus.gallery.pick(function(e) {
			for(var i in e.files){
	    		if(i>2) break;
	    		compressImg(e.files[i],function(b64Src){
	    			var pic = doc.createElement("div");
					pic.setAttribute("class", "qsPhoto");
					pic.innerHTML = "<img class='picPath' src='" + b64Src + "' data-preview-src='' data-preview-group='1' /><span class='image-close'>X<span>";
					photoBox.appendChild(pic);
					backStatus = 1;
					$.previewImage();
					bindEvent();
					plus.nativeUI.closeWaiting();
	    		});
	    	}
		}, function(e) {
			$.toast("取消选择图片");
		}, {
			filter: "image",
			multiple: true
		});
	}
		
	getCameraBtn.addEventListener('tap', captureImage, false);
	galleryBtn.addEventListener('tap', galleryImgs, false);
	
    doc.getElementById('addImg').addEventListener('tap',function(){
		document.activeElement.blur();
		$('#picture').popover('show');
	},false);
	//监听字数变化
	doc.getElementById("qsCon").addEventListener("input", function() {
		var con = doc.getElementById("qsCon").value;
		con = con.replace(/[\r\n]/g, "") //去掉回车换行
		var wordLimit = 500 - parseInt(con.length);
		doc.getElementById("wordLimit").innerHTML = wordLimit;
	}, false);

	var actionBtn = $(".chooseBtn button");
	for(var k = 0; k < actionBtn.length; k++) {
		actionBtn[k].addEventListener("tap", function() {
			if(this.getAttribute("optionType") == 0) {
				backPage();
			} else {
				doc.getElementById("backInfo").style.display = "none";
			}
		}, false);
	}
	
	//监听返回
	var backPage = $.back;
	$.back = function() {
		//检测是否全部为空
		var detail = doc.getElementById("qsCon").value;
		var picLen = $(".picPath").length;
		if(backStatus == 1) {
			//提交成功之后的返回
			var backPageId1 = plus.webview.getWebviewById("zixun-list");
			var backPageId2 = plus.webview.getWebviewById("detail");
			$.fire(backPageId1, 'refreshPage');
			$.fire(backPageId2, 'refreshPage');
			backPage();
			return false;
		}
		if(detail == "" && picLen == 0) {
			backPage();
		} else {
			doc.getElementById("backInfo").style.display = "block";
		}
	};

})(mui, document);