(function($,myStorage,app){
   	function fileMd5(file,callback){
   		var reader = new plus.io.FileReader(); 
	    var spark = new SparkMD5();  
		var seek = 0;
	    reader.onloadend = function(e) { 
	    	console.log(e.target.result);  
	    	var binary = atob(e.target.result.split(',')[1]);
	    	var spark = new SparkMD5();
	        spark.appendBinary(binary);
	        var hash = spark.end();
	        console.log('Hash MD5:'+hash);
	        callback(hash);
	    };
	    reader.readAsDataURL(file);  
   	};
	function checkFile(filePath,callback){
   		plus.io.resolveLocalFileSystemURL(filePath, function (entry) {
           	entry.file(function(file){
				fileMd5(file,function(hash){
					callback(hash);
				});
			},function(err){
				console.log(err.message,err);
	    		callback();
			});
        }, function (err) {
            console.log(err.message,err);
            callback();
        });
   	}
   	
	function removeDir(path,callback){
		callback = callback || $.noop;
		plus.io.resolveLocalFileSystemURL( path, function (entry) {
            entry.removeRecursively();
            callback();
        }, function (error) {
        	callback();
        });
	};
	function delFile(fileUrl) {
		var relativePath = plus.io.convertLocalFileSystemURL(fileUrl);
        plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
            entry.remove();
        });
    }
	function downloader(urls,options,names){
		var dl = this;
		dl._listeners={};
		dl.options = $.extend({path:'_downloads/',timeout:10}, options);
		dl.tasks = {};
		dl.result = {
			taskState:[],
			succeedFiles:[]
		};
		function dlTask(id,url,fName){
			var options = {
				filename:dl.options.path,
				timeout:dl.options.timeout
			};
			if(fName){
				options.filename = options.filename + fName;
			} 
			var obj = this;
			obj.id = id;
		    obj.url = url;
			obj.task = plus.downloader.createDownload(url,options,function(d,status){
		        obj.filename = d.filename;
		        dlTaskComplete(obj,status,d);
	        });
		    obj.task.start();
		}
		function dlTaskComplete(task,state,d){
			dl.result[task.url] = {
				successful:state==200,
				filename:task.filename
			};
			dl.result.taskState.push({
				url:task.url,
				successful:state==200,
				filename:task.filename
			});
			if(state==200){
				dl.result.succeedFiles.push(task.filename);
			}else{
				delFile(task.filename);
			}
			delete dl.tasks[task.id];
			if($.isEmptyObject(dl.tasks)){
				dl.fireEvent('allComplete',dl.result);
			}
		} 
		function createTasks(urls,names){
			var links = typeof urls == 'string'?[urls]:urls;
			if(typeof names == 'string'){
				names = [names];
			}
			$.each(links,function(index,link){
				var fn = '',
					sufix = link.substr(link.lastIndexOf('.'));
				if(!names){
					fn = Date.now();
					fName =  fn+sufix;
				}else if(names==true){
					fn = md5.hex_md5(link);
					fName = fn+sufix;
				}else{
					fn = names[index]||Date.now()+sufix;
					fName = fn;
				}
				dl.tasks[fn] = new dlTask(fn,link,fName);
			});
		}
		dl.createTasks = createTasks;
		if(urls) createTasks(urls,names);
	}
	downloader.prototype.addEventListener = function(type, fn, capture){
		 if (typeof this._listeners[type] === "undefined") {
            this._listeners[type] = [];
        }
        if (typeof fn === "function") {
            this._listeners[type].push(fn);
        }    
        return this;
	};
	downloader.prototype.fireEvent = function(type,data) {
        var arrayEvent = this._listeners[type];
        if (arrayEvent instanceof Array) {
            for (var i=0, length=arrayEvent.length; i<length; i+=1) {
                if (typeof arrayEvent[i] === "function") {
                    arrayEvent[i]({ type: type,data: data});    
                }
            }
        }    
        return this;
    };
	downloader.createDownload = function(urls,options,md5Name){
		return new downloader(urls,options,md5Name);
	};
	downloader.removeDir = removeDir;
	downloader.delFile = delFile;
	window.downloader = downloader;
})(mui,myStorage,app);
 