(function($,app,Q) {
	var request = {};
	var encryptList=[
		'/grab/bindSecurityCard',
		'/grab/bindFundCard',
		'/grab/getTelcode'
	];
	(function(){
		var appjs = document.querySelector('script[src$="/app.js"]');
		var encryptPath = appjs.src.replace('/app.js','/encrypt.js');
		var cryptoPath = appjs.src.replace('/app.js','/lib/crypto/crypto-js.js');
		document.writeln('<script src="'+encryptPath+'"></script>');
		document.writeln('<script src="'+cryptoPath+'"></script>');
	})();
	var getEncryptData = function(url,data){
		var pdata = JSON.stringify(data);
		if(encryptList.indexOf(url.replace(app._baseUrl,''))>=0){
			return JSON.stringify({
				data:jencrypt.encrypt(pdata)
			});
		}else{
			return pdata;
		}
	};
	
	var respone = {
		parseData:parseData,
		successLog:successLog,
		failLog:failLog
	};
	
	request.setting = {
		async:true,
		dataType:'json',
		timeout:60000,
		headers:{
			'Content-Type':'application/json'
		},
		waiting:false
	};
	request.request = function(url,options,setting){
		var deferred = Q.defer();
		var netState = window.plus ? plus.networkinfo.getCurrentType():myStorage.getItem('NetType');
		if(netState==='EMPTY' || netState===1){
			$.toast('网络不可用');
			deferred.reject({code:'0',message:'网络不可用'});
		}else{
			var state = app.getState();
			var cusInfo = app.getDeviceInfo();
			var fextrs = {
				deviceId:cusInfo.deviceId,
				appid:cusInfo.appid,
				appVersion:cusInfo.appVersion,
				resVersion:cusInfo.resVersion,
				os:mui.os.ios?'iOS':'Android'
			};
			if(window.plus) {
				fextrs.appVersion = plus.runtime.version;
				fextrs.netType = plus.networkinfo.getCurrentType();
			}
			if(state.token){
				fextrs.userId = state.info ? ""+state.info.userId : undefined;
				fextrs.token = state.token || undefined;
			}
			setting = $.extend(true,{},request.setting,setting);
			var headers = $.extend({},setting.headers,fextrs);
			var waiting = null;
		    if(setting.waiting && window.plus){
		    		waiting = plus.nativeUI.showWaiting(request.setting.waiting.title);
		    }
		    var postData = options.data;
			var processData = true;
			if(setting.contentType==false){
				postData = options.data;
				processData = false;
				delete headers['Content-Type'];//='multipart/form-data';
			}else if(headers['Content-Type']=='application/x-www-form-urlencoded'){
				postData = options.data;
				processData = true;//为true时自动serialize非字符串data
			}else if(headers['Content-Type']=='application/json'){
				postData = getEncryptData(url,options.data);
				processData = false;
			}
			var startTime = Date.now();
			var reqSetting = {
				data:postData,
				type:options.type,
				dataType:setting.dataType,
				timeout:setting.timeout,
				headers:headers,
				contentType:setting.contentType,
				processData:processData,
				success:function(data){
					if(window.plus) plus.nativeUI.closeWaiting();
					respone.parseData(data,deferred,setting);
					respone.successLog(url,options,headers,startTime,data);
				},
				error:function(xhr,type,errorThrown){
					if(window.plus) plus.nativeUI.closeWaiting();
					//"timeout,error，abort,parsererror，null"
					var msgs = {
						'timeout':'网络错误，连接服务器超时',
						'error':'网络错误，请稍后重试。',//服务器维护中
						'abort':'网络错误，请稍后重试！',//无法连接服务器
						'parsererror':'网络错误，请稍后重试'//网络数据转换错误
					};
					$.toast(msgs[type]);
					deferred.reject({code:xhr.status,message:msgs[type]});
					respone.failLog(url,options,headers,startTime,xhr,type,errorThrown);
				}
			};
			$.ajax(url,reqSetting);
		}
		return deferred.promise;
	};
	request.get = function(url,data,setting){
		var query = $.param(data);
		if(query !== '') {
			url = (url + '&' + query).replace(/[&?]{1,2}/, '?');
		}
		var promise = request.request(url,{type:'get'},setting);
		return promise;
	};
	request.post = function(url,data,setting){
		var promise = request.request(url,{type:'post',data:data},setting);
		return promise;
	};

	function successLog(url,options,headers,startTime,data){
		console.info("====================================================================");
		console.info("START Request==>"+options.type+":"+url);
		console.info(options.type.toUpperCase()=="GET"?"":"data:"+JSON.stringify(options.data));			        
		console.log("header:"+JSON.stringify(headers));					
		console.log("Response:"+JSON.stringify(data));
		console.info("Consume:"+(Date.now()-startTime)+'ms');
		console.info("END Request==>"+options.type+":"+url);
		console.info("====================================================================");
	}
	function failLog(url,options,headers,startTime,xhr,type,errorThrown){
		console.info("====================================================================");
		console.info("START Request==>"+options.type+":"+url);
		console.info(options.type.toUpperCase()=="GET"?"":"data:"+JSON.stringify(options.data));	
		console.log("header:"+JSON.stringify(headers));
		console.info("Error:status:"+xhr.status+',type:'+type+',error:'+errorThrown);
		console.info("Consume:"+(Date.now()-startTime)+'ms');
		console.info("END Request==>"+options.type+":"+url);
		console.info("====================================================================");
	}
	function parseData(data,deferred,setting){
		if(setting.dataType=='json'){
			if (data && (data.err || data.code && data.code!=='000000')) {
				var err = data.err || {code:data.code,message:data.message};
				if(err.code==app.needLoginCode||err.code=='cu6001'){
					var user = app.getUser();
					if(user){
						app.removeLogin(setting&&setting.notToLogin);
						err.message='登录已失效';
						$.toast(err.message);
					}else{
						if(setting&&!setting.notToLogin) app.toLogin();
						err.message='用户未登录';
					}
					deferred.reject(err);
				}else if(err.code.toString().length==3 && err.code.toString().indexOf('5')==0){
					$.toast('服务器异常，请稍候再试');
					deferred.reject(err);
				}else if(err.code=='9999'){
					$.alert(err.message);
				}else{
					deferred.reject(err);
				}
	       	}else if(data && data.data!==undefined){
		    		deferred.resolve(data.data);
		    	}else{
		    		deferred.reject({code:'-1',message:'数据格式错误'});
		    		console.error(JSON.stringify(data));
		    	}
		}else{
	    		deferred.resolve(data);
	    	}
	}

	function getExtName(b64Str){
		var mimeTypes = {
			"text/plain": ".txt",
			"text/css": ".css",
			"text/xml": ".xml",
			"text/html": ".html",
			"text/javascript": ".js",
			"image/jpeg": ".jpg",
			"image/png": ".png",
			"image/gif": ".gif",
			"image/svg+xml": ".svg",
			"image/tiff": ".tiff",
			"application/json": ".json",
			"application/pdf": ".pdf",
			"application/x-shockwave-flash": ".swf",
			"application/octet-stream": ".rar",
			"application/x-zip-compressed": ".zip",
			"audio/x-wav": ".wav",
			"audio/x-ms-wma": ".wma",
			"video/x-ms-wmv": ".wmv",
			"video/mp4": ".mp4"
		};
		var regx = /data:(.*);base64,/;
		var type = b64Str.match(regx)[1];
		return mimeTypes[type]||'';
	}
	function getBlobByBase64Code(b64Str){
		var regx = /data:(.*);base64,/;
		var type = b64Str.match(regx)[1];
        var b64 = b64Str.replace(regx,'');
        var binary = atob(b64);
        var array = [];
        for (var i = 0; i < binary.length; i++) {
            array.push(binary.charCodeAt(i));
        }
        var blob = new Blob([new Uint8Array(array)], {type: type});
        return blob;
	}
	
	request.postAddFiles = function(url,data,files,setting){
		setting = $.extend(true, {contentType:false}, setting);	
		var formData = new FormData();
		for(var k in data){
			formData.append(k,data[k]);
		}
		for(var f in files){
			var file = files[f];
			if(typeof file=='object'){
				formData.append(f,file);
			}else if(typeof file=='string'){
				var now = Date.now();
				var ext = getExtName(file);
				var blob = getBlobByBase64Code(file);
				formData.append(f,blob,now+ext);
			}
		}
		var promise = request.request(url,{type:'post',data:formData},setting);
		return promise;
	}
	request.getImg = function(img,url,type,data){
		if(!url) return console.log('no img resource');
		type = type?type.toUpperCase():'GET';
		if(type=='GET'){
			var queryStr = '';
			for(var n in data){
				queryStr+='&'+n+'='+data[n];
			}
			url=url.indexOf('?')>0 ? url+queryStr.substr(1):url+queryStr;
		}
	    var xhr = new XMLHttpRequest();
	    xhr.open(type, url, true);
	    xhr.responseType = "blob";
	    
	    var state = app.getState();
		var cusInfo = app.getDeviceInfo();
		xhr.setRequestHeader("deviceId", cusInfo.deviceId);
	    	xhr.setRequestHeader("appid", cusInfo.appid);
	    	xhr.setRequestHeader("appVersion", cusInfo.appVersion);
	    	xhr.setRequestHeader("resVersion", cusInfo.resVersion);
		if(window.plus) {
			xhr.setRequestHeader("netType", plus.networkinfo.getCurrentType());
		}
		if(state.info){
			xhr.setRequestHeader("userId", state.info.userId);
			xhr.setRequestHeader("token", state.token);
		}
	    xhr.onload = function() {
	        if (this.status == 200) {
	            var blob = this.response;
	            img.onload = function(e) {
	                window.URL.revokeObjectURL(img.src); 
	            };
	            img.src = window.URL.createObjectURL(blob);
	        }else{
	        	console.error(this.status);
	        }
	    }
	    xhr.send(type=='POST'?data:undefined);
	};
	
	request.getPrivateImgs = function(imgSelector){
		var imgs = document.querySelector(imgSelector||'img[pro-src]');
		for(var img in imgs){
			var src = img.getAttribute('pro-src');
			if(src) request.getImg(img,src);
		}
	};
	
	
	window.request=request;
	return request;
})(mui,app,Q);
