(function($,myStorage,req,Q) {
	var svc = {};
	/**
	 * 获取城市户籍种类
	 * @param {Object} cityCode 城市编码
	 * @returns {Object} {payId: '', payName: ''}
	 */
	svc.getPayHomeType=function(cityCode){
		var url = app._gwCalc + '/calculator/getPayTypeList';
		return req.post(url,{cityCode: cityCode});
	};
	
	/**
	 * 获取社保缴纳详情
	 * @param {Object} cityCode 城市编码
	 * @param {Object} payId  户籍类型
	 * @param {Object} radix  缴费基数
	 * @retrns {Object}
	 *  comTotalNum	公司缴纳总额	
		perTotalNum	个人缴纳总额				
		payTotalNum	总缴纳额				
		cardPayList：
		参数名称	中文名称	类型	长度	是否可为空	备注
		以下为循环体
		accountType	社保保险类型		1：医疗，2：养老，3：失业，4：工伤，5：生育，6：大病
		comNum	公司缴纳金额				
		perNum	个人缴纳金额				
		perRatio	个人缴纳比例				本项保险个人缴纳金额/个人缴纳总金额
		totalNum	本项保险缴纳总金额	
		BigDecimal			公司缴纳金额+个人缴纳金额
	 */
	svc.getPaySecurityDetail=function(cityCode, payId, radix){
		var url = app._gwCalc + '/calculator/getCardPayInfo';
		return req.post(url,{cityCode: cityCode, payId: payId, radix: radix});
	};
	/**
	 * 获取公积金缴纳详情
	 * @param {Object} cityCode 城市编码
	 * @param {Object} radix 缴费基数
	 * comRatio	公司缴纳比例
		perRatio	个人缴纳比例
		comNum	公司缴纳额
		perNum	个人缴纳额
		totaNum	缴纳总金额
	 */
	svc.getPayFundDetail=function(cityCode, radix){
		var url = app._gwCalc + '/calculator/getFundPayInfo';
		return req.post(url,{cityCode: cityCode, radix: radix});
	};
	
	/**
	 * 获取功能列表
	 * id	模块id
		name	模块名称
		introduce	模块简介
		icon	模块图标
		linkUrl	链接地址
		sort	排序编号
	 */
	svc.getFunctionList=function(c){
		var url = app._gwCalc + '/calculator/getModularList';
		return req.get(url);
	};
	
	/**
	 * 计算个人所得税
	 * @param {Object} wags 税前工资
	 * @param {Object} perPayNum 社保公积金缴纳的和
	 */
	svc.getTaxNum =function(wage, perPayNum){
		var url = app._gwCalc + '/calculator/getTaxNum';
		return req.post(url, {wage: wage, perPayNum: perPayNum});
	};
	
	window.calcService = svc;
})(mui,myStorage,request,Q);
