﻿(function(myStorage,app,req,Q) {
	var svc = {};
 
	svc.getSafeCode = function (cityCode) {
		var url = app._baseUrl + '/grab/getSafeCode';
		return req.post(url,{"cityCode":cityCode,"grabType":"1"});
	};
 
	svc.refreshFund = function (code,accountId) {
		var url = app._baseUrl + '/grab/refreshFundCard';
		return req.post(url,{safeCode:code,accountId:accountId},{timeout:0});
	};
 
	svc.analysisFundCard = function (data) {
		var url = app._baseUrl + '/grab/bindFundCard';
		return req.post(url,data,{timeout:0});
	};
	 
	svc.removeFundCard = function (accountId) {
		var url = app._baseUrl + '/grab/unbunding';
		return req.post(url,{cardType:"1",accountId:accountId});
	};
	 
	svc.changeDefaultAccount = function (accountId) {
		var url = app._baseUrl + '/grab/changeDefaultAccount';
		return req.post(url,{cardType:"1",accountId:accountId});
	};
	 
	 
	svc.getFunList = function(data){
		var url = app._baseUrl + '/pool/getFunList';
		return req.post(url,{});
	};
	 
	svc.getFunInfo = function(fundAcctId,update){
		var deferred = Q.defer();
		var data = myStorage.getItem('FunInfo_'+fundAcctId);
		if(!data || update){
			var url = app._baseUrl + '/pool/getFunInfo';
			req.post(url,{fundAcctId:fundAcctId}).then(function(data){
				if(fundAcctId) myStorage.setItem('FunInfo_'+fundAcctId,data);
				deferred.resolve(data);
				return data;
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
		
	};
	
	svc.getSavedFunInfo = function(fundAcctId){
		return myStorage.getItem('FunInfo_'+fundAcctId);
	};
	
	svc.getNewFunPayList = function(fundAcctId){
		var url = app._baseUrl + '/pool/getNewFunPayList';
		return req.post(url,{fundAcctId:fundAcctId});
	};
	 
	svc.getFunAcctDetails = function(fundAcctId){
		var url = app._baseUrl + '/pool/getFunAcctDetails';
		return req.post(url,{fundAcctId:fundAcctId});
	};
	 
    //城市社保卡绑定参数
    svc.getCityConfig = function(code){
    	var url = app._baseUrl + '/grab/getCityConfig';
    	return req.post(url,{cityCode:code,cardType:1});
    };
    svc.getCityDetail = function(code){
    	var url = app._baseUrl + '/user/getCityDetail/'+code;
    	return req.get(url);
    };
    //参保类型和登录问题
	svc.getBindCardInfor = function(cityCode){
		var url = app._baseUrl + '/grab/cityCommon/getAnalysisInfo';
		return req.post(url,{cityCode:cityCode,grapType:"1"})
	};
	
	//[社保官网]用户获取官网发送的短信校验码方法
	svc.getTelcode = function(datasObj){
		var url = app._baseUrl + '/grab/getTelcode';
		return req.post(url,datasObj);
	};
	
	//数据分析-用户操作记录
	svc.TieCardLog = function(cityCode,gradType,type,reminderParaName,paraValue){
		var url = app._baseUrl + '/grab/TieCardLog';
		return req.post(url,{cityCode:cityCode,gradType:gradType,type:type,paraName:reminderParaName,paraValue:paraValue});
	};
	
	window.gjjSvc=svc;
	return svc;
})(myStorage,app,request,Q);
