(function(app,req) {
	
	var svc = {};
	/* 01：养老 02：失业  03：医疗 04：工伤 05：生育  */
	svc.insType = { YLId:"01", SYId:"02", MCId:"03", GSId:"04", BirthId:"05" };
    
    svc.getAIList = function(cityCode){
    	var url = app._baseUrl + '/calc/intelligent/IAList';
    	return req.post(url,{cityCode:cityCode});
    };
	//计算实发工资
	svc.reaSalTrial = function(data){
		var url = app._baseUrl + '/calculator/reaSalTrial';
		return req.post(url,data);
	};
	
	svc.getHuKouType = function (cityCode) {
	    var url = app._baseUrl + '/calculator/getHuKouType/'+ cityCode;
	    return req.get(url);
    };
 
	svc.getTrialFund = function(trialFund){
		var url = app._baseUrl + '/calculator/trialFund';
		return req.post(url,trialFund);
	};
	    
	//社保计算器
	svc.getTrialSecurity = function(dataObj){
		var url = app._baseUrl + '/calculator/trialSecurity';
		return req.post(url,dataObj);
	};
	
	/**
	 * @description 退休后养老工资试算 
	 * @param {Number} sbkid 社保基本信息id
	 * @param {String} insid 险种类型编号
	 */
	svc.retPenTrial = function(sbkid,insid){
		var url = app._baseUrl + '/calculator/retPenTrial';
		return req.post(url,{"securityAcctId":sbkid,"insuranceId":insid});
	};
	
	/**
	 * @description 退休后养老工资试算(new) 
	 * @param {Number} sbkid 社保基本信息id
	 * @param {String} insid 险种类型编号
	 */
	svc.newRetPenTrial = function(sbkid,insid){
		var url = app._baseUrl + '/calculator/newRetPenTrial';
		return req.post(url,{"securityAcctId":sbkid,"insuranceId":insid});
	};
	// 新计算养老金接口
	svc.newGetPension = function(userId,sbkid,type,oldWorkLonger,sex){
		var url = app._baseUrl + '/calc/calculator/getPensionCalculation';
		return req.post(url,{"userId":userId,"securityAcctId":sbkid,"type":type,oldWorkLonger:oldWorkLonger,sex:sex});
	};
	
	/**
	 * @param {Object} data sex:性别，
	 */
	svc.saveRetireInfo = function(data){
		var url = app._baseUrl + '/calculator/saveRetireInfo';
		return req.post(url,data);
	};
	
	svc.isHaveRetireInfo = function(sbkid){
		var url = app._baseUrl + '/calculator/isHaveRetireInfo';
		return req.post(url,{securityAcctId:sbkid});
	};
	
	
	/**
	 * @description 参保险种连续缴纳月份数 
	 * @param {Number} sbkid 社保基本信息id
	 * @param {String} insid 险种类型编号
	 */
	svc.getSecConPayMonths = function(sbkid,insid){
		var url = app._baseUrl + '/pool/getSecConPayMonths';
		return req.post(url,{"securityAcctId":sbkid,"insuranceId":insid});
	};
	
	/**
	 * @description 参保险种缴费状态
	 * @param {Number} sbkid 社保基本信息id
	 * @param {String} insid 险种类型编号
	 */
	svc.getInsIAInfo = function(sbkid,insid){
		var url = app._baseUrl + '/pool/getInsIAInfo';
		return req.post(url, {"securityAcctId":sbkid,"insuranceId":insid});
	};
	
	/**
	 * @description 医保参保定点医院列表
	 * @param {Number} sbkid 社保基本信息id
	 */
	svc.getSecHosList = function(sbkid){
		var url = app._baseUrl + '/pool/getSecHosList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	
    /**
     * @description 医疗支出情况
     * @param {Number} sbkid 社保基本信息id
     */
    svc.getLatYeaHosCosts = function(sbkid){
    	var url = app._baseUrl + '/pool/getLatYeaHosCosts';
    	return req.post(url,{securityAcctId:sbkid});
    };
    
	/**
     * @description 查询医保报销比例情况
     * @param {Number} sbkid 社保基本信息id
     */
    svc.getMedicalExpense = function(sbkid){
    	var url = app._baseUrl + '/pool/getMedicalExpense';
    	return req.post(url,{accountId:sbkid});
    };
    
    /**
     * @description 查询保险指标情况
     * @param {Number} sbkid 社保基本信息id
     */
	svc.getExpenseIndex = function(sbkid){
    	var url = app._baseUrl + '/pool/getExpenseIndex';
    	return req.post(url,{accountId:sbkid});
    };
    
	/**
	 * @description 查询参保险种状态
	 * @param {Number} sbkid 社保基本信息id
	 */
	svc.getInsState = function(sbkid){
		var url = app._baseUrl + '/pool/getInsState';
		return req.post(url, {securityAcctId:sbkid});
	};
	

	// 获取智能应用类型
    svc.getIntelligentTypeList = function(cityCode, type){
		var url = app._baseUrl + '/intelligent/getIntelligentTypeList';
		return req.post(url, {cityCode: cityCode, titlType: type});
	};
	
	/*获取智能应用类型内容
	 * cityCode		城市编码 （不传默认全国）
	 * modularId	是	int	二级标题Id
	 * perType	否	int	人员类型：1职工 2居民。 不传值都查
	 * map	否	json	有变更的模块，传值key为子标题Id ，value为变更版本号
	 * */
    svc.getIntelligentList = function(type,cityCode, modularId, map){
		var url = app._baseUrl + '/calc/intelligent/getIntelligentList';
		return req.post(url, {perType:type,cityCode: cityCode, modularId: modularId, map: map});
	};
	// 获取智能应用分类列表
    svc.getInsList = function(cityCode){
		var url = app._baseUrl + '/calc/intelligent/isHaveIntelligentContext';
		return req.post(url, {cityCode: cityCode});
	};
	
	/* zlh by 2019-10-10 modify */
	/** 获取城市医疗保险额度
	 * @param {int} expenseType 1:门诊2:住院 其他：门诊+住院
	*/
    svc.getMedicExpense = function(cityCode,type, expenseType){
		var url = app._baseUrl + '/calc/intelligent/getMedicExpense';
		return req.post(url, {cityCode: cityCode,perType:type, expenseType: expenseType});
	};
	
	// 获取养老金计算所需参数
    svc.getPensionCalculationParram = function(securityAcctId){
		var url = app._baseUrl + '/calc/calculator/getPensionCalculationParram';
		return req.post(url, {securityAcctId: securityAcctId});
	};
	
	// 养老金计算
    svc.getPensionCalculation = function(data){
		var url = app._baseUrl + '/calc/calculator/getPensionCalculation';
		var json = {
			cityCode: data.cityCode,
			sex: data.sex,
			birthday: data.birthday,
			wageGrowth: data.wageGrowth, //上年工资涨幅
			pensionRadix: data.pensionRadix, //当年养老金基数
			oldWorkLonger: data.oldWorkLonger, //96年前工作年限
			payMonths: data.payMonths, //养老金缴纳月数
			furPayYears: data.furPayYears, //预计未来保险缴纳年限
			accountAmount: data.accountAmount, //个人养老账户金额
			type: 2,
			securityAcctId: data.securityAcctId,
			userId: data.userId
		}
		return req.post(url, json);
	};
	// 养老金视频详情ID 未返回某个ID不展示
	svc.getNounsExplanation = function(cityCode){
		var url = app._baseUrl + '/cons/joyNounsExp/getNounsExplanation';
		return req.post(url, {cityCode: cityCode});
	};
	
	window.joySvc=svc;
	return svc;
})(app,request);
