﻿(function($,myStorage,req,Q) {
	var svc = {};
	//城市社保绑卡参数
    svc.getCityConfig = function(code){
    	var url = app._baseUrl + '/grab/getCityConfig';
    	return req.post(url,{cityCode:code,cardType:0});
    };
	//绑定社保卡
    svc.bindSecurityCard = function (data) {
        var url = app._baseUrl + '/grab/bindSecurityCard';
        return req.post(url,data,{timeout:0});
    };
    //卡片解绑
	svc.removeSecurity = function (accountId) {
		var url = app._baseUrl + '/grab/unbunding';
		return req.post(url,{cardType:"0",accountId:accountId});
	};
	//切换默认账户
	svc.changeDefaultAccount = function (accountId) {
		var url = app._baseUrl + '/grab/changeDefaultAccount';
		return req.post(url,{cardType:"0",accountId:accountId});
	};
    //解析社保数据
	svc.analysisSecurity = function (data) {
		var url = app._baseUrl + '/grab/analysisSecurity';
		return req.post(url,data);
	};
    //刷新社保卡数据
	svc.refreshSecurity = function (code,accountId,phoneCode) {
		var url = app._baseUrl + '/grab/refreshSecurityCard';
		var data = {safeCode:code, accountId:accountId};
		if(phoneCode) data.phoneCode = phoneCode;
		return req.post(url,data,{timeout:0});
	};

    //[社保官网]用户获取官网发送的短信校验码方法
	svc.getTelcode = function(datasObj){
		var url = app._baseUrl + '/grab/getTelcode';
		return req.post(url,datasObj);
	};
	//[社保官网]获取验证码
	svc.getSafeCode = function (cityCode) {
		var url = app._baseUrl + '/grab/getSafeCode';
		return req.post(url,{"cityCode":cityCode,"grabType":"0"});
	};
	//[社保官网]用户注册(激活)
	svc.activateSecurity = function(dataObj){
		var url = app._baseUrl + '/grab/activateSecurity';
		return req.post(url,dataObj);
	};
	//[社保官网]用户修改社保官帐号
	svc.modiPassSecu = function(modiPass){
		var url = app._baseUrl + '/grab/modiPassSecu';
		return req.post(url,modiPass);
	};


	//查询绑定社保卡列表
	svc.getSecList = function(data){
		var url = app._baseUrl + '/pool/getSecList';
		return req.post(url,data);
	};
	//查询社保卡基本信息
	svc.getSecInfo = function(sbkid,update){
		var deferred = Q.defer();
		var data = myStorage.getItem('SecInfo_'+sbkid);
		if(!data || update){
			var url = app._baseUrl + '/pool/getSecInfo';
			req.post(url,{"securityAcctId":sbkid}).then(function(data){
				myStorage.setItem('SecInfo_'+data.id,data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			deferred.resolve(data);
		}
		return deferred.promise;
	};
	svc.getSavedSecInfo = function(sbkid){
		return myStorage.getItem('SecInfo_'+sbkid);
	};
	//查询最新缴费月份和险种明细
	svc.getNewSecPayList = function (sbkid) {
		var url = app._baseUrl + '/pool/getNewSecPayList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//查询社保卡定点医疗机构
	svc.getSecHosList = function(sbkid){
		var url = app._baseUrl + '/pool/getSecHosList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//查询医疗账户和养老账户明细
	svc.getSecAcctDetails = function(sbkid){
		var url = app._baseUrl + '/pool/getSecAcctDetails';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//按条件查询缴费月份和险种明细
	svc.getSecPayListByMonth = function(sbkid,month){
		var url = app._baseUrl + '/pool/getSecPayListByMonth';
		return req.post(url,{"securityAcctId":sbkid,"payMonth":month});
	};
	//查询医保卡就医消费情况
	svc.getMedicalPay = function(sbkid){
		var url = app._baseUrl + '/pool/getMedicalPay';
		return req.post(url,{"accountId":sbkid});
	};
	//查询社保险种连续缴费月数
	svc.getSecConPayMonths = function (sbkid) {
		var url = app._baseUrl + '/pool/getSecConPayMonths';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//查询社保险种连续缴费月数
	svc.getPayMonthsAndState = function (sbkid) {
		var url = app._baseUrl + '/pool/getPayMonthsAndState';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//获取年缴费详情
	svc.getNewYearSecurityPaymentList = function (sbkid) {
		var url = app._baseUrl + '/pool/getNewYearSecurityPaymentList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//获取全部缴费详情
	svc.getAllSecurityPaymentList = function (sbkid) {
		var url = app._baseUrl + '/pool/getAllSecurityPaymentList';
		return req.post(url,{"securityAcctId":sbkid});
	};
	//查询医保卡就医消费情况全部
	svc.getMedicalPayYear = function (sbkid) {
		var url = app._baseUrl + '/pool/getMedicalPayYear';
		return req.post(url,{"accountId":sbkid});
	};
	//名词解释
	svc.getNounsExplanation = function(cityCode){
		var url = app._baseUrl + '/cons/joyNounsExp/getNounsExplanation';
		return req.post(url,{cityCode:cityCode})
	};
	
	//获取功能解释
	svc.getFuncExplanation = function(cityCode){
		var url = app._baseUrl + '/cons/joyNounsExp/getFuncExplanation';
		return req.post(url,{cityCode:cityCode})
	};
	
	//参保类型和登录问题
	svc.getBindCardInfor = function(cityCode){
		var url = app._baseUrl + '/grab/cityCommon/getAnalysisInfo';
		return req.post(url,{cityCode:cityCode,grapType:'0'});
	};
	//激活和修改密码的提示
	svc.getPrompt = function(cityCode){
		var url = app._baseUrl + '/grab/cityCommon/getPromptInfo';
		return req.post(url,{officialCode:cityCode,grapType:'0',infoType:'1'});
	};
	
	//社保服务--代缴分类Tab
	svc.getSecurityProTypeList = function(){
		var url = app._baseUrl + '/sociSecuService/getSecurityProTypeList';
		return req.post(url,{});
	};
	
	//数据分析-用户操作记录
	svc.TieCardLog = function(cityCode,gradType,type,reminderParaName,paraValue){
		var url = app._baseUrl + '/grab/TieCardLog';
		return req.post(url,{cityCode:cityCode,gradType:gradType,type:type,paraName:reminderParaName,paraValue:paraValue});
	};
	
	//[设置-账号注销]用户获取短信校验码方法
	svc.getCancellationTelcode = function(datasObj){
		var url = app._baseUrl + '/u/sendMsg/sendOtpMessage';
		return req.post(url,datasObj);
	};
	
	//[设置-账号注销]验证短信校验码方法
	svc.verificationShortMessageCode = function(datasObj){
		var url = app._baseUrl + '/u/logout/v1/verify';
		return req.post(url,datasObj);
	};
	
	//[设置-账号注销]注销条件验证
	svc.verifyCancellationConditions = function(datasObj){
		var url = app._baseUrl + '/u/logout/v1/apply';
		return req.post(url,datasObj);
	};
	
	//[设置-账号注销]注销剩余时间
	svc.getRemainingTime = function(datasObj){
		var url = app._baseUrl + '/u/logout/v1/info';
		return req.post(url,datasObj);
	};
	
	//[设置-账号注销]终止注销
	svc.terminationOfCancellation = function(datasObj){
		var url = app._baseUrl + '/u/logout/v1/cancel';
		return req.post(url,datasObj);
	};
	
	
	window.shebaoSvc=svc;
	return svc;
})(mui,myStorage,request,Q);
