(function($,app,req) {
	var svc = {};
	
	svc.postSecurityProductList = function(pCityCode,pCategory,pageNum,pageSize){
		var url = app._baseUrl + '/sociSecuService/getSecurityProductList';
		return req.post(url,{
			"pageNum":pageNum||1,
			"pageSize":pageSize||100,
			"pCityCode":pCityCode,
			"pCategory":pCategory
		});
	};
	svc.postSecurityProduct = function(pId){
		var url = app._baseUrl + '/sociSecuService/getSecurityProduct';
		return req.post( url,{"pId":pId} );
	};
	svc.createSecurityOrder = function(productId,name,bodyCode,phoneNum,startMonth,endMonth,bz,count){
		var url = app._baseUrl + '/sociSecuService/createSecurityOrder';
		return req.post( url,{
			"productId": productId,
			"name": name,
			"bodyCode": bodyCode,
			"phoneNum": phoneNum,
			"startMonth": startMonth,
			"endMonth": endMonth,
			"bz": bz,
			"count": count
		});
	};
	svc.createOrder = function(orderPara){
		var url = app._baseUrl + '/sociSecuService/createOrder';
		return req.post( url,orderPara);
	};
	svc.createBuyer = function(buyer){
		var url = app._baseUrl + '/sociSecuService/createSecuOrderAddUser';
		return req.post( url,buyer);
	};
	svc.updateBuyer = function(buyer){
		var url = app._baseUrl + '/sociSecuService/updateOrderUser';
		return req.post( url,buyer);
	};
	
	svc.delBuyer = function(uid,type){
		var url = app._baseUrl + '/sociSecuService/deleteOrderUser';
		return req.post( url,{ordUserId:uid,type:type});
	};
	
	svc.getBuyerList = function(param){
		var url = app._baseUrl + '/sociSecuService/getSecurityOrderBuyer';
		return req.post( url,param);
	};
    
    svc.getOrderUserById = function(id){
    	var url = app._baseUrl + '/sociSecuService/getOrderUserById';
    	return req.post(url,{id:id});
    }

 	svc.uploadCardPhotos = function (files,perId) {
         var url = app._baseUrl + '/sociSecuService/uploadCardPhotos';
 		return req.postAddFiles(url,{
 			typeFile:'5',perId:perId
 		},files);
    }; 

	svc.modifyCardPhotos = function (files,perId) {
         var url = app._baseUrl + '/sociSecuService/modifyCardPhotos';
   		return req.postAddFiles(url,{
   			typeFile:'5',perId:perId
   		},files);
    };   

    svc.getBodyCardPic = function (perId) {
		var url = app._baseUrl + '/sociSecuService/getBodyCardPic/'+perId;
        return req.get(url);
	};
	
	svc.getBuyerStatusList = function (buzzId) {
    	var url = app._baseUrl + '/sociSecuService/getBuyerStatusList';
    	return req.post(url,{buzzId:buzzId});
	};
    
	svc.personReduceApplication = function(buzzId,personId,reduceType){
		var url = app._baseUrl + '/sociSecuService/personReduceApplication';
		return req.post(url,{buzzId:buzzId,personId:personId,reduceType:reduceType});
	};
	
	svc.cancleSecurityOrder = function(id){
		var url = app._baseUrl + '/sociSecuService/cancleSecurityOrder';
		return req.post(url,{buzzId:id});
	};
    //社保订单详情（旧）
	svc.getOrderDetail = function (type,id) {
		var url = app._baseUrl + '/order/getBuzzOrderInfoNew';
		return req.post(url,{'orderType':type,"buzzId":id});
	};
	//社保订单详情（新）
	svc.getOrderDetail_new = function (type,id) {
		var url = app._baseUrl + '/u/order/getBuzzOrderInfoNew';
		return req.post(url,{'orderType':type,"buzzId":id});
	};
	//社保订单列表接口（旧）
	svc.getOrderListByEx = function (pageNum,pageSize,status,type) {
		var url = app._baseUrl + '/order/getOrderListByEx';
		return req.post(url,{
        	pageNum:pageNum,
        	pageSize:pageSize,
        	orderStatus:status,
        	orderType:type
		});
	};
	//社保订单列表接口（新）
	svc.getOrderListByEx_new = function (pageNum,pageSize,status,type) {
		var url = app._baseUrl + '/u/order/getOrderListByEx';
		return req.post(url,{
	    	pageNum:pageNum,
	    	pageSize:pageSize,
	    	orderStatus:status,
	    	orderType:type
		});
	};	
	svc.getSecurityProTypeList = function(){
		var url = app._baseUrl + '/sociSecuService/getSecurityProTypeList';
		return req.get(url);
	};
	
	//用户业务预约记录接口
	svc.getsaveAppoint = function(cityCode,mobile,buzzType){
		var url = app._baseUrl + '/online/buzzAppoint/saveAppoint';
		return req.post(url,{
			cityCode:cityCode,
			mobile:mobile,
			buzzType:buzzType
		});
	};
	
	window.sbSvc=svc;	
	return svc;
})(mui,app,request);