(function($,myStorage,app,req,Q) {
	var svc = {};
	svc.getUserInfo = function(update,notToLogin){
		var deferred = Q.defer();
		var userinfo = app.getUser();
		if(!userinfo || update){
			var url = app._gwUser + '/user/queryUser';
			var deviceInfo = app.getDeviceInfo();
			var location = myStorage.getItem('location');
			var network = myStorage.getItem('NetType');
			var push = app.getSetting('push')?'ON':'OFF';
			var pobj = $.extend({network:network,push:push},deviceInfo,location);
			req.post(url,pobj,{notToLogin:notToLogin}).then(function(data){
				data.headPath=data.headPath||'../images/user-photo.png';
				app.setState('info',data);
				deferred.resolve(data);
				return data;
			}).catch(function(err){
				deferred.reject(err);
			});
		}else{
			userinfo.headPath=userinfo.headPath||'../images/user-photo.png';
			deferred.resolve(userinfo);
		}
		return deferred.promise;
	};
 	svc.sendOptSms = function (mobile,tplId) {
		var url = app._gwUser + '/sendMsg/sendOtpMessage';
		return req.post(url,{"mobile":mobile,"tplId":tplId});
	};
    svc.login = function(data){
		var url = app._gwUser + '/user/userLogin';
		return req.post(url,data);
	};
	svc.msLogin = function (data) {
		var url = app._gwUser + '/user/authCodeLogin';
		return req.post(url,data);
	}
	svc.setPassword = function (data) {
		var url = app._gwUser + '/user/setPassWord';
		return req.post(url,data);
	};
	svc.modifyPassWord = function (data) {
		var url = app._gwUser + '/user/modifyPassWord';
		return req.post(url,data);
	};
    svc.setUsername = function (uname) {
        var url = app._gwUser + '/user/modifyUserName';
        return req.post(url,{userName:uname});
    };
    // 保存简介
    svc.setIntroduce = function (intro) {
        var url = app._gwUser + '/user/modifyIntroduce';
        return req.post(url,{introduce:intro});
    };
    svc.modifyUserHead = function (filePath,success,fail) {
        success = success || $.noop;
        fail = fail || $.noop;
        var url = app._gwUser + '/user/modifyUserHead';
        var task = plus.uploader.createUpload( url, {method:'POST'}, function ( t, status ) { // 上传完成
            if ( status == 200 ) {
                var data = JSON.parse(t.responseText);
                if(data.err)
                    fail(data.err);
                else
                    success(data.data);
            } else {
                fail({err:status,message:'上传文件出错'});
            }
        });
        
        var user = app.getUser();
		var cusInfo = app.getDeviceInfo();
        task.setRequestHeader('appid',cusInfo.appid);
        task.setRequestHeader('appVersion',cusInfo.appVersion);
        task.setRequestHeader('deviceId',cusInfo.deviceId);
        task.setRequestHeader('resVersion',cusInfo.resVersion);
        task.setRequestHeader('netType',plus.networkinfo.getCurrentType());
        task.setRequestHeader('userId',user.userId.toString());
        task.setRequestHeader('token',user.token);
        task.addFile( filePath, {key:"imageFile"} );
        task.addData("typeFile", "04" );
        task.start();
    };   
	svc.modifyPortrait = function (file) {
        var url = app._gwUser + '/user/modifyUserHead';
 		return req.postAddFiles(url,{
 			typeFile:'04'
 		},{
 			imageFile:file
 		});
    };   
	svc.backPassWord = function (data) {
		var url = app._gwUser + '/user/backPassWord';
		return req.post(url,data);
	};

	//用户激活
	svc.userActiveLog = function () {
		var data = {};
		var location = myStorage.getItem('location')||{};
		var city = myStorage.getItem('city')||{};
		
		data.launcher = plus.runtime.launcher;
		data.netType = plus.networkinfo.getCurrentType();
		
		data.activeStatus = myStorage.getItem('activeStatus')||0;
		data.getuiType = app.getSetting('push')?1:0;
		data.resVersion = myStorage.getItem('resver');
		data.cityId = city.cityCode;
		
		data.appId = plus.runtime.appid;
		data.appVersion = plus.runtime.version;
		data.origin = plus.runtime.origin;
		data.innerVersion = plus.runtime.innerVersion;
		data.deviceId = plus.device.uuid;
	 	data.deviceImei = plus.device.imei;
	 	data.deviceVendor = plus.device.vendor;
		data.deviceModel = plus.device.model;
		data.os = plus.os.name;
		data.osVersion = plus.os.version;
		data.osLanguage = plus.os.language;
		data.idfa = mui.os.ios?app.getIOSIdfa():'';
		data.idfv = mui.os.ios?app.getIOSIdfv():'';
		data.androidId =  mui.os.android?app.getAndroidID():'';
		data.androidDeviceId =  mui.os.android?app.getAdrDeviceId():'';
		data.channel = app.getChannel(); 
		data.geTuiId = '';
		try{
			var gtInfo = plus.push.getClientInfo();
			data.geTuiId = gtInfo.clientid;
		}catch(e){
			
		}
		if(location.address){
			data.country = location.address.country||'';
			data.provice = location.address.province||'';
			data.cityCode =	location.address.city||'';
			data.townCode = location.address.district||'';
			data.rowAdd = location.address.street||'';
			data.houseNummer = location.address.streetNumber||'';
			data.poiName = location.address.poiName||'';
			data.postalCode = location.address.postalCode;
			if(data.cityCode){
				city = geo.getCityByName(data.cityCode);
				data.cityId = city.cityCode;
			}
		}
		data.coords = location.coords?'{latitude:'+location.coords.latitude+',longitude:'+location.coords.longitude+'}':'';
		data.address = location.addresses||'';
	 	data.coordsType = location.coordsType||'';
		data.timestamp = Date.now();
		
        var url = app._gwUser + '/user/userActiveLog';
	    	return req.post(url,data).then(function(data){
	    		if(data.activeStatus){
	    			myStorage.setItem('activeStatus',1);
	    		}
	    	}).catch(function(err){
	    		console.error(err.message,err);
	    	});
    };
	//用户中心第三方登录
	svc.oauthLogin = function(data){
		var url = app._gwUser + '/thirdLogin/thirdLogin';
		return req.post(url,data);
	};
	svc.oauthLoginNoUser = function(data){
		var url = app._gwUser + '/thirdLogin/thirdLoginNoUser';
		return req.post(url,data);
	};
	svc.oauthBind = function(oauth){
		var url = app._gwUser + '/thirdLogin/bindOauth';
		return req.post(url,oauth);
	};
	svc.oauthUnbind = function (type) {
		var url = app._gwUser + '/thirdLogin/unBindOauth';
		return req.post(url,{thirdType:type});
	};

	//微信登录
	var _wxAppId = 'wx238436ed4b218b80';
	svc.wxLogin = function(data){
		var url = app._gwWx + '/user/appLogin';
		if(data.appid) {
			data.joyId = data.appid;
			data.appid = undefined;
		}
		var postData = $.extend(true,{'appId':_wxAppId},data);
    	return req.post(url,postData);
	};
	svc.wxGetBindMessageCode = function(num){
		var url = app._gwWx + '/user/getBindMessageCode';
    	return req.post(url,{'phone':num});
	};
	svc.wxUserBind = function(data){
		var url = app._gwWx + '/user/userBind';
		if(data.appid) {
			data.joyId = data.appid;
			data.appid = undefined;
		}
		data.phone = data.mobile;
		data.code = data.rcode;
		data.mobile = undefined;
		data.rcode = undefined;
		
		var postData = $.extend(true,{'appId':_wxAppId},data);
    	return req.post(url,postData);
	};
	svc.wxLoginBind = function(data){
		var url = app._gwWx + '/user/loginBind';
		if(data.appid) {
			data.joyId = data.appid;
			data.appid = undefined;
		}

		var postData = $.extend(true,{'appId':_wxAppId},data);
    		return req.post(url,postData);
	};
	
	svc.wxUserUnbind = function(type){
		var url = app._gwWx + '/user/appUserUnbind';
    		return req.post(url,{'thirdType':type});
	};
	
	svc.checkOldMobile = function(mobile){
		var url = app._gwUser + '/user/checkOldMobile';
    		return req.post(url,{'mobile':mobile});
	};
	svc.modifyMobile = function(mobile,rcode){
		var url = app._gwUser + '/user/modifyMobile';
    		return req.post(url,{'mobile':mobile,'rcode':rcode});
	};

	svc.alipay = function(appid){
	    	var url = app._gwUser + '/thirdLogin/getSign';
	    	var cp_timestamp = new Date().getTime().toString();
	    	var jsonP = {"appId":appid,"authType":"AUTHACCOUNT","targetId":cp_timestamp};
    	    return req.post(url,jsonP);
	};

    svc.getAlipayInfo = function(appid,authCode){
        var url = app._gwUser + '/thirdLogin/getUserInfo';
		var jsonP = {"appId":appid,"authCode":authCode};
    	    return req.post(url,jsonP);
    };
	svc.getAlipayService = function(){
		var alipayInfo = plus.AlipayLoginUtil?plus.AlipayLoginUtil.getAlipayInfo():null;
		if(alipayInfo){
			alipayInfo.login = function(success,fail){
				svc.alipay(alipayInfo.appid).then(function(data) {
					alipayInfo.authResult = data;			
					plus.AlipayLoginUtil.doAlipayLogin(data.result, function(successMsg) {
						alipayInfo.authCode = successMsg.message;
						success(successMsg.message);
					}, function(errMsg) {
						fail(errMsg);
					});
				}).catch(function(err) {
					fail(err);
				});
			};
			alipayInfo.getUserInfo = function(success,fail){
				 svc.getAlipayInfo(alipayInfo.appid,alipayInfo.authCode).then(function(data) {
				 	mui.extend(alipayInfo,{userInfo:data});
					success(alipayInfo);
				 }).catch(function(err) {
				 	 fail(err);
				 });
			};
		}
		return alipayInfo;
	};
	
	// 我的足迹
	svc.getMyRecords = function(record){
		console.log(record)
		var url = app._baseUrl + '/u/personCenter/getMyRecords';
		return req.post(url,{userId:record.userId,pageNum:record.pageNum,pageSize:record.pageSize,type:record.type,lon:record.lon,lat:record.lat})
	}
	// 注销用户状态信息
	svc.getSetUpUserInfo = function(){
		var url = app._baseUrl + '/u/user/queryUser';
		return req.post(url,{});
	}
    
	window.userSvc=svc;	
})(mui,myStorage,app,request,Q);
