(function($,myStorage,app){
	
	var updater = {
		appStoreUrl:'https://itunes.apple.com/us/app/id1136573266',
		androidUrl:'market://details?id=com.joyshebao.joy',
		checkUrl:app._gwUser + "/system/versionInfoNew",
		data:{},
		get currAppVersion(){
			return myStorage.getItem('appver');
		},
		get currVersion(){
			return myStorage.getItem('resver');
		},
		showView:function(newVersion,manual){
			if(manual){
				if(mui.os.ios) {
		       		createIosView();
		       	}else{
		       		createAndroidView();
		       	}
			}else{
				var tipVer = myStorage.getItem('updateTipVer');
				if(tipVer!=newVersion){
					if(mui.os.ios) {
			       		createIosView();
			       	}else{
			       		createAndroidView();
			       	}
		       		myStorage.setItem('updateTipVer',newVersion);
				}
			}
			
		}
	};

	function formatData(data){
		if(!data||!data.appVersion) return null;
		data.versionDescribe=data.versionDescribe||'';
		return {
			newVersion:data.appVersion,
			lowestVersion:data.lowestVersion,
			isForceUpdate:updater.currVersion<data.lowestVersion,
			updateForce:data.updateForce,
			downloadAddress:data.downloadAddress,
			hash:data.hash,
			updateLogs:data.versionDescribe.replace(/\\n/g,'\n')
		};
	}

	function createAndroidView(){
		var nw = plus.webview.getWebviewById('update');
		if(nw) nw.close('none');
		nw = plus.webview.create('_www/view/update.html','update',{
      		top:'0px',left:'0px',height:'100%',width:'100%',zindex:998,background:'transparent'
      	});
      	nw.addEventListener('loaded',function(){
      		window.addEventListener('updateDownLoad',downLoadHandler,false);
   			window.addEventListener('updateCancle',cancleHandler,false);
      		updater.showPrompt();
      	},false);
		nw.addEventListener('close',function(){
      		window.removeEventListener('updateDownLoad',downLoadHandler,false);
   			window.removeEventListener('updateCancle',cancleHandler,false);
      	},false);
      	nw.show();
      
		updater.close = function () {
       		nw.evalJS('document.body.style.background="rgba(0,0,0,0)";');
       		setTimeout(function(){
       			nw.close('zoom-fade-in');
       		},50);
        };
        updater.showPrompt = function (aniStyles) {
	        	var ctitle = "发现新版本"+updater.data.newVersion;
	        	var updateLog = updater.data.updateLogs;
	        	var btns = {
	        		'downloadBtn':{text:'立即更新',callback:'updateDownLoad'},
	        		'cancleBtn':{text:'暂不更新',callback:'updateCancle'}
	    		};
	        	if(updater.data.isForceUpdate){
	        		updateLog+='\n<p style="color:#ff0000; margin-top:10px">当前版本过旧，请更新后使用</p>';
	        		btns = {'downloadBtn':{text:'立即更新',callback:'updateDownLoad'}};
	        	}
			$.fire(nw,'showPromptBox',{
				title:ctitle,
				updateLog:updateLog,
				ani:aniStyles,
				btns:btns
			});
        };
        updater.showProgressBar = function (aniStyles) {
			$.fire(nw,'showProgressBox',{ani:aniStyles});
        };
        updater.update = function (options) {
			$.fire(nw,'UpdateProgress',options);
        };
		
		var downLoadHandler = function(e){
      		if(updater.data.updateForce==3){
	            plus.runtime.openURL(updater.data.downloadAddress);
	        }else{
		        	var netType = plus.networkinfo.getCurrentType();
		        	if(netType===4||netType===5||netType===6){
		        		plus.nativeUI.confirm('正在使用流量上网，是否继续更新？', function(event){
		        			if (0==event.index) {
		        				downWgt();
		        			}else{
		        				cancleHandler();
		        			}
		        		},'更新',['继续下载','取消下载']);
		        	}else{
		        		downWgt();
		        	}
	        }
		};
		var cancleHandler = function(e){
			updater.close();
   			if(!updater.data.isForceUpdate) return;
	    		if(mui.os.ios){
	    			(function showTooOld(){
	    				plus.nativeUI.alert('当前版本已不可用,请前往AppStore更新！',function(){
	    					plus.runtime.openURL(updater.appStoreUrl);
	    					showTooOld();
	    				},'版本过旧');
	    			})();
	    		}else{
	    			(function showTooOldA(){
	    				plus.nativeUI.alert('当前版本已不可用,请前往应用市场更新！',function(){
	    					plus.runtime.openURL(updater.androidUrl);
	    					showTooOldA();
	    				},'版本过旧');
	    			})();
	    		}
		};
	}
	function createIosView(){
		var nw = plus.webview.getWebviewById('update'); 
		if(nw) nw.close('none');
       	updater.close = function () {
       		nw.evalJS('document.body.style.background="rgba(0,0,0,0)";');
       		setTimeout(function(){
       			nw.close('zoom-fade-in');
       		},50);
        };
        updater.showPrompt = function (aniStyles) {
	        	var ctitle = "发现新版本";
	        	var updateLog = updater.data.updateLogs;
	        	var btns = {
	        		'downloadBtn':{text:'马上更新',callback:'updateDownLoad'},
	        		'cancleBtn':{text:'以后再说',callback:'updateCancle'}
	    		};
	        	if(updater.data.isForceUpdate){
	        		updateLog+='\n<p style="color:#ff0000; margin-top:10px">当前版本过旧，请更新后使用</p>';
	        		btns = {'downloadBtn':{text:'立即更新',callback:'updateDownLoad'}};
	        	}
			$.fire(nw,'showPromptBox',{
				title:ctitle,
				updateLog:updateLog,
				ani:aniStyles,
				btns:btns
			});
        };
		nw = plus.webview.create('_www/view/update-new.html','update',{
      		top:'0px',left:'0px',height:'100%',width:'100%',zindex:998,background:'transparent'
      	});
      	nw.addEventListener('loaded',function(){
      		window.addEventListener('updateDownLoad',downLoadHandler,false);
   			window.addEventListener('updateCancle',cancleHandler,false);
      		updater.showPrompt();
      	},false);
		nw.addEventListener('close',function(){
      		window.removeEventListener('updateDownLoad',downLoadHandler,false);
   			window.removeEventListener('updateCancle',cancleHandler,false);
      	},false);
      	nw.show();

		var downLoadHandler = function(e){
			plus.runtime.openURL(updater.appStoreUrl);
      		updater.close();
		};
		var cancleHandler = function(e){
			updater.close();
   			if(!updater.data.isForceUpdate) return;
	    		(function showTooOld(){
    				plus.nativeUI.alert('当前版本已不可用,请前往AppStore更新！',function(){
    					plus.runtime.openURL(updater.appStoreUrl);
    					showTooOld();
    				},'版本过旧');
    			})();
		};
      	
	}
	 
   	function fileMd5(file,callback){
   		var reader = new plus.io.FileReader(); 
	    var spark = new SparkMD5();  
		var seek = 0;
	    reader.onloadend = function(e) { 
		    //	console.log(e.target.result);  
		    	var binary = atob(e.target.result.split(',')[1]);
		    	var spark = new SparkMD5();
	        spark.appendBinary(binary);
	        var hash = spark.end();
	        console.log('Hash MD5:'+hash);
	        callback(hash);
	    };
	    reader.readAsDataURL(file);  
   	};
	function checkFile(filePath,callback){
   		plus.io.resolveLocalFileSystemURL(filePath, function (entry) {
           	entry.file(function(file){
				fileMd5(file,function(hash){
					callback(hash);
				});
			},function(err){
				console.log(err.message,err);
	    			callback();
			});
        }, function (err) {
            console.log(err.message,err);
            callback();
        });
   	}
   	
	function downWgt(quiet){
		//下个版本 如果更新包存在则不重复下载  用MD5 校验文件；
        updater.showProgressBar();
        var path = '_doc/update/';
        var fileName = updater.data.newVersion+['.wgtu','.wgt','.apk'][updater.data.updateForce];
        var down = function(){
			var dtask=plus.downloader.createDownload(updater.data.downloadAddress, {
        			filename:path+fileName,timeout:40}, function(d,status){
		        if ( status == 200 ) {
		            console.log("下载升级文件成功："+d.filename);
		            updater.update({
		            	downloadedSize:d.downloadedSize,
	                	totalSize:d.totalSize,
	                	tipText:'下载完成，准备安装升级...'
		            });
		           setTimeout(function(){
		            	updater.close();
		            	installWgt(d.filename);
		            },300);
		        } else {
		            console.log("下载升级文件失败！");
		            if(!quiet){
		            	plus.nativeUI.alert("下载升级文件失败！",function () {
	                    	updater.showPrompt();
	                	});
		            }
		        }
	        });
	        console.log("开始下载升级文件："+updater.data.downloadAddress);
	        updater.update({tipText:'开始获取资源文件...'});
	        dtask.start();
		    dtask.addEventListener("statechanged", function(task,status){
		    	if(task.state==2){
		    		updater.update({tipText:'正在下载资源文件...'});
					updater.update({
	                	downloadedSize:task.downloadedSize,
	                	totalSize:task.totalSize
	                });
				}
				if(task.state==3){
					var per = parseInt(task.downloadedSize/task.totalSize*100);
	                updater.update({
	                	downloadedSize:task.downloadedSize,
	                	totalSize:task.totalSize
	                });
				}
		    });
        };
		updater.update({tipText:'正在校验本地文件...'});
        
        checkFile(path+fileName,function(hashCode){
	        	if(hashCode && hashCode.toUpperCase()===updater.data.hash.toUpperCase()){
	        		updater.close();
	    			installWgt(path+fileName,quiet);
	        	}else{
	        		removeDir(path,function(){
			        	down();
	        		});
	        	}
        });
	}
	function installWgt(path,quiet){
        console.log("开始安装升级文件："+path);
	    if(!quiet) plus.nativeUI.showWaiting("安装升级文件...");
        plus.runtime.install(path,{force:true},function(info){
        	if(/\.apk$/.test(path)) return;
            console.log("安装升级文件成功！");
            installSuccess(path);
	        plus.nativeUI.closeWaiting();
	        myStorage.setItem('resver',info.version);
			if(!quiet) plus.nativeUI.alert("应用资源更新完成！",function(){
	           plus.runtime.restart();
	        });
	        
	    },function(e){
	        plus.nativeUI.closeWaiting();
	        console.log("安装升级文件失败["+e.code+"]："+e.message);
	        if(!quiet) plus.nativeUI.alert("安装升级文件失败["+e.code+"]："+e.message);
	    });
	}
	
	function downWgtu(){
		var path = '_doc/update/';
		var fileName = updater.data.newVersion+['.wgtu','.wgt','.apk'][updater.data.updateForce];
		var down = function(){
			var dtask=plus.downloader.createDownload(updater.data.downloadAddress, {
        		filename:path,timeout:40}, function(d,status){
		        if ( status == 200 ) {
		            console.log("下载升级文件成功："+d.filename);
		            installWgtu(d.filename); // 安装wgt包
		        } else {
		            console.log("下载升级文件失败！");
		        }
	        });
	        console.log("开始下载升级文件："+updater.data.downloadAddress);
		    dtask.start();
		}
        removeDir(path,function(){
        	down();
        });
	}
	function installWgtu(path){
        console.log("开始安装升级文件："+path);
        plus.runtime.install(path,{force:true},function(info){
            console.log("安装升级文件成功！");
            installSuccess(path);
	        myStorage.setItem('resver',info.version);
	        $.toast('自动修复成功');
	    },function(e){
	        console.log("安装升级文件失败["+e.code+"]："+e.message);
	    });
	}
	
	function removeDir(path,callback){
		plus.io.resolveLocalFileSystemURL( path, function (entry) {
            entry.removeRecursively();
            callback();
       }, function (error) {
        	callback();
        });
	};
	
	function installSuccess(path) {
        console.log("删除更新包文件："+path);
       	var dir = '_doc/update/';
        plus.io.resolveLocalFileSystemURL( dir, function (entry) {
            console.log("删除更新包文件："+path+" 成功");
            //entry.remove();
            entry.removeRecursively();
        }, function (error) {
            console.log("删除更新包文件："+path+" 失败");
        });
    }
    
    function promptUpdate(data,manual) {
	    	updater.data = data;
	    	//var showPrompt = mui.os.android&&data.updateForce!=0;
	    	var showPrompt = data.updateForce!=0;
	    	if(data.updateForce!=0) {
	    		myStorage.setItem('newVersion',data.newVersion);
	    	}
		if(showPrompt){
			updater.showView(data.newVersion,manual);
        }else{
			var autoDownload = app.getSetting('autoUpdateInWifi')&&plus.networkinfo.getCurrentType()===3;
			if(data.updateForce===0){
				downWgtu();
			}else if(autoDownload){
			 	downWgt(true);
			}
        }
    }

	function checkVersion(callback,manual){
		callback = callback || mui.noop;
		var currVersion = updater.currVersion||updater.currAppVersion;
		request.post(updater.checkUrl,{
			appVersion:currVersion,
			system:plus.os.name,
			appid:plus.runtime.appid
		}).then(function(data){
		 	data = formatData(data) || {
				newVersion:currVersion,
				lowestVersion:'1.0.0',
				downloadAddress:'',
				updateForce:2,
				isForceUpdate:false,
				hash:'',
				updateLogs:''
			};
			callback(data.newVersion === currVersion||data.newVersion === updater.currAppVersion);
			if(data.newVersion > currVersion){
				console.log('发现新版本：'+data.newVersion);
				promptUpdate(data,manual);
			}else{
				myStorage.removeItem('newVersion');
			}
		}).catch(function(err){
			$.toast('连接版本服务器失败');
			console.error(err.message,err);
		});


	}
	
	var obj = {};
	obj.checkVersion = checkVersion;
	obj.fileMd5 = fileMd5;
	obj.checkFile = checkFile;
   	
	window.update = obj;
	
})(mui,myStorage,app);
