(function($,joyPlayer){
	var splayer = null;
	var playerId = 'joyPlayer_'+Date.now();
	var isPageFullscreen = false;
	var mwInt = null;
	
	function g(id){
		return document.getElementById(id); 
	}
	function getFormatTime(total){
		var time = [],hour,minute,seconds;
		if(total>3600){
			hour = Math.floor(total/3600);
			time.push(hour<10?'0'+hour:''+hour);
			total = total%3600;
		} 
		minute = Math.floor(total/60);
		time.push(minute<10?'0'+minute:''+minute);
		seconds = Math.floor(total%60);
		time.push(seconds<10?'0'+seconds:''+seconds);
		return time.join(':');
	};
	function getThisPosition(node) {
        var left = node.offsetLeft;
        var top = node.offsetTop;
        return {"left": left, "top": top};
    }
	function getPosition(node) {
        var left = node.offsetLeft; //获取元素相对于其父元素的left值var left
        var top = node.offsetTop;
        current = node.offsetParent; // 取得元素的offsetParent
        while(current != null) {//一直循环直到根元素
            left += current.offsetLeft;　　
            top += current.offsetTop;　　
            current = current.offsetParent;　　
        }
        return {"left": left, "top": top};
    }
	function getNetType(){
		var netype = 'UNKNOW';
		if(window.plus){
			var intype = plus.networkinfo.getCurrentType();
			netype = ['UNKNOW','EMPTY','ETHERNET','WIFI','CELL2G','CELL3G','CELL4G'][intype]||netype; 
		}else if(navigator.connection){
			netype = navigator.connection.type;
		}else{
			var saveType = localStorage.getItem('NetType');
			try{
				netype = JSON.parse(saveType).data;
			}catch(e){
				
			}
		}
		return netype;
	}
	function isCellular(){
		var netype = getNetType().toLowerCase();
		return /^cell/.test(netype);
	}
	
	function output(str){
		console.warn('%c '+str,'color:blue');
	}
	
	function jplayer(id,options){
		var player = this;
		options = options || {};
		player.parent = options.parent||document.body;
		player.options = options;
		player.id = id;
		player.isFullscreen = false;
		player.outRange = options.outRange || 1;//1-remove,2-pause,3-none
		player.box = null;
		player.cellTips = null;
		player.shareBox = null;
		
		player.videoBox = null;
		player.video = null;
		player.titleBar = null;
		player.ctrlBar = null;
		player.floatCover = null;
		
		var ifSeeking = false,
			seekBefore = true,
			barOut=null;

		function createPlayer(options){
			var box = document.createElement('div');
			var uuid = Date.now();
			player._uuid = uuid;
			box.id=uuid;
			box.className='video-box';
			
			var titleBarHtml = [
				'<div class="video-nav ani out">',
					'<a class="back-btn mui-icon mui-icon-left-nav mui-pull-left color-white"></a>',
					'<h1 class="mui-title mui-ellipsis"></h1>',
				'</div>'].join(''),
				controllBarHtml = [
				'<div class="video-bar ani out">',
					'<span class="played">00:00</span>',
					'<div class="progress">',
						'<div class="video-progress">',
							'<div class="bar"></div><em class="hdl"></em>',
						'</div>',
					'</div>',
					'<span class="duration">00:00</span>',
					'<div class="full-btn"><span class="fa fa-expand"></span></div>',
				'</div>'].join(''),
				floatCoverHtml = '<div class="float-cover out"></div>',
				floatBtnHtml = '<div class="float-btn fa fa-play out"></div>';
		    	
		    box.innerHTML = [
		    	titleBarHtml,
		    	'<video webkit-playsinline="" playsinline="">',
		    		'您的手机不支持播放 HTML5 video',
		    	'</video>',
		    	controllBarHtml,
		    	floatCoverHtml, 
		    	floatBtnHtml
	    	].join('');
			
			player.box.appendChild(box);
			player.videoBox = box;
			player.video = box.querySelector('video'),
			player.titleBar = box.querySelector('.video-nav');
			player.ctrlBar = box.querySelector('.video-bar');
			player.floatBtn = box.querySelector('.float-btn');
			player.floatCover = box.querySelector('.float-cover');
			
	
			var rate = 0,
		    	seekLeft = '0%',
		    	currPoint = null,
		    	pbox = box.querySelector('.video-progress'),
		    	seekBar = box.querySelector('.video-progress .bar')
		    	seekHdl = box.querySelector('.video-progress .hdl');

		    player.video.addEventListener('loadedmetadata',function(){
		    	output('jplayer=>loadedmetadata,duration:'+player.video.duration);
				var duration = getFormatTime(player.video.duration);
				player.ctrlBar.querySelector('.duration').innerText = duration;
				readRate();
				
				var errDiv = player.box.querySelector('.load-err');
				if(errDiv) errDiv.remove();
				
			},false);
			player.video.addEventListener('loadstart',function(){
				output('jplayer=>loadstart');
			},false);
			
			player.video.addEventListener('waiting',function(){
				output('jplayer=>waiting');
				player.buffering = true;
				player.floatBtn.classList.add('buffering');
				player.floatBtn.classList.remove('out');
				player.floatCover.classList.remove('out');
			},false);
			
			player.video.addEventListener('loadeddata',function(){
				output('jplayer=>loadeddata');
			},false);
			player.video.addEventListener('canplay',function(){
				output('jplayer=>canplay');
				player.buffering = false;
				var vbox = g(player._uuid);
				if(!vbox) this.pause();
			},false);
			player.video.addEventListener('canplaythrough',function(){
				output('jplayer=>canplaythrough');
				player.buffering = false;
				var vbox = g(player._uuid);
				if(!vbox) this.pause();
			},false);
			
			player.video.addEventListener('play',function(){
				output('jplayer=>play');
			},false);
			player.video.addEventListener('playing',function(){
				output('jplayer=>playing');
				barOut = setTimeout(hideBar,1500);
				setPlayState('play');
			},false);
			player.video.addEventListener('pause',function(){
				output('jplayer=>pause');
				hideBar();
				setPlayState('pause');
			},false);
			
			player.video.addEventListener('ended',function(){
				output('jplayer=>ended');
				if(player.isFullscreen) setFullscreen(false);
				hideBar();
				clearRate();
				showShare();
			},false);
			
			player.video.addEventListener('timeupdate',function(){
				if(player.video.readyState==4){
					saveRate();
					changeProgress();
				}
			},false);
			
			player.video.addEventListener('seeking',function(){
				output('jplayer=>seeking');
				player.buffering = true;
				player.floatBtn.classList.add('buffering');
				player.floatBtn.classList.remove('out');
				player.floatCover.classList.remove('out');
			},false);
			
			player.video.addEventListener('seeked',function(){
				output('jplayer=>seeked');
				player.floatBtn.classList.remove('buffering');
				player.floatBtn.classList.add('out');
				player.floatCover.classList.add('out');
				seekBar.style.width = player.playedLeft;				
				if(!seekBefore){
					if(player.video.paused) player.video.play();
				}else{
					if(!player.video.paused)  player.video.pause();
				}
			},false);
			player.video.addEventListener('stalled',function(){
				output('jplayer=>stalled');
				//当浏览器尝试获取媒体数据，但数据不可用时触发
			},false); 
			player.video.addEventListener('error',function(e){
				output('jplayer=>error');
				setTimeout(hideBar,5);
				showError();
			},false);

			player.video.addEventListener('tap',function(e){
				showBar();
				e.stopPropagation();
			},false);
			player.video.addEventListener('doubletap',function(e){
				toggleScreen();
				e.stopPropagation();
			},false);

			$(player.titleBar).on('tap','.back-btn',function(){
				$.back();
			});
			
			
			box.addEventListener('tap',function(e){
				e.preventDefault();
				e.stopPropagation();
			},false);
    		box.addEventListener('touchstart',function(e){
				if(!ifSeeking){
					var x = e.touches[0].pageX || e.touches[0].clientX;
					var y = e.touches[0].pageY || e.touches[0].pageY;
					currPoint = {x:x,y:y};
				}
			},false);
    		box.addEventListener("touchmove", function(e) {
				var x = e.touches[0].pageX || e.touches[0].clientX;
				var y = e.touches[0].pageY || e.touches[0].pageY;
				if(ifSeeking) {
					var barLeft = getThisPosition(pbox).left,
				    	hdlLeft = x - barLeft;
				    if(hdlLeft >= pbox.offsetWidth) hdlLeft = pbox.offsetWidth;
				    if(hdlLeft < 0) hdlLeft = 0;
				    rate = hdlLeft/pbox.offsetWidth;
				    seekLeft = (rate*100)+'%'; 
				    seekHdl.style.left = seekLeft;
				    e.stopPropagation();
				}else if(currPoint){
					//TODO:手势改变音量,亮度,进度
				}
    		},false);
    		box.addEventListener("touchend", function(e) {
                if(ifSeeking){
                	seek(rate);
               		player.playedLeft = seekLeft;
	                ifSeeking = false; 
	                player.ctrlBar.querySelector('.video-progress .hdl').classList.remove('active');
	                e.stopPropagation();
               	}else{
               		//TODO:手势改变音量,亮度,进度
               		currPoint = null;
               	}
    		},false);
    		
			$(player.ctrlBar).on('touchstart','.video-progress .hdl',function(){
				setTimeout(function(){
					clearTimeout(barOut);
					player.floatBtn.classList.add('out');
				},0);
				this.classList.add('active');
				seekBefore = player.video.paused;
				seekLeft = player.playedLeft;
				ifSeeking = true;
				return false;
			},false);
            $(player.ctrlBar).on('touchstart','.progress',function(e){
            	setTimeout(function(){
					clearTimeout(barOut);
					player.floatBtn.classList.add('out');
				},0);
				
            	var x = e.touches[0].pageX || e.touches[0].clientX;
                var barLeft = getThisPosition(pbox).left,
                	hdlLeft = x - barLeft;
                if(hdlLeft >= pbox.offsetWidth) hdlLeft = pbox.offsetWidth;
                if(hdlLeft < 0) hdlLeft = 0;
                rate = hdlLeft/pbox.offsetWidth;
                seekLeft = (rate*100)+'%';
                seekHdl.style.left = seekLeft;
                
                ifSeeking = true;
                seekBefore = player.video.paused;
				seekLeft = player.playedLeft;
                return false;
			},false);
			$(player.ctrlBar).on('tap','.full-btn',function(){
				if(!player.isFullscreen){
					setFullscreen(true);
				}else{
					//player.video.pause();
					setFullscreen(false);
				}
				return false;
			});
			
			$(box).on('tap','.float-btn',function(){
				player.video[player.video.paused?'play':'pause']();
				hideBar();
				return false;
			});
			$(box).on('tap','.float-cover',function(){
				hideBar();
				return false;
			});
			
			
			initState(options);
			$.plusReady(function(){
				isPageFullscreen = plus.navigator.isFullscreen();
			});
		}
		
		function destroyPlayer(){
 			clearTimeout(barOut);
			player.video.pause();
			player.video.remove();
			player.videoBox.remove();
			player.box.remove();
			splayer = null;
		}

		function saveRate(){
			var videoState = {
				src:player.video.src,
				rate:player.video.currentTime
			};
			localStorage.setItem('jPlayer',JSON.stringify(videoState));
		}
		function readRate(){
			var videoState = localStorage.getItem('jPlayer');
			if(videoState){
				videoState = JSON.parse(videoState);
				if(videoState.src == player.video.src){
					seekBefore = false;
					player.video.currentTime = videoState.rate;
					output('jplayer=>load rate:'+videoState.rate);
				}
			}
		}
		function clearRate(){
			localStorage.removeItem('jPlayer');
		}
		function changeProgress(){
			var currentTime = getFormatTime(player.video.currentTime),
				per = player.video.currentTime/player.video.duration;
				pbar = player.ctrlBar.querySelector('.video-progress .bar'),
				phdl = player.ctrlBar.querySelector('.video-progress .hdl'),
				left = (per*100)+'%';
			player.playedTime = currentTime;
			if(!ifSeeking){
				player.playedLeft = left;
				pbar.style.width = left;
				phdl.style.left = left;
			}
			player.ctrlBar.querySelector('.played').innerText = currentTime;
		}
		
		function initState(options){
			player.playedTime = '00:00';
			player.playedLeft = '0%';
			player.allowCellPlay = false;
			player.options = options||{};
			player.options.rect = player.options.rect || {top:0,right:0,bottom:0,left:0};
			
			player.parent = options.parent;
			player.video.poster = options.poster||'#000';
			player.titleBar.querySelector('h1').innerText=options.title||'';
			player.titleBar.classList[options.title?'remove':'add']('hidden');
			player.titleBar.classList[options.followTitle?'add':'remove']('follow-title');
			
			var pbar = player.ctrlBar.querySelector('.video-progress .bar');
			var phdl = player.ctrlBar.querySelector('.video-progress .hdl');
			pbar.style.width = '0%';
			phdl.style.left = '0%';
				
			var errDiv = player.box.querySelector('.load-err');
			if(errDiv) errDiv.remove();
			var shareDiv = player.box.querySelector('.vshare');
			if(shareDiv) shareDiv.remove();
		}
		function setPlayState(state){
			//['pause','play','ended']
			if(state==='play'){
				player.floatBtn.classList.add('fa-pause');
				player.floatBtn.classList.remove('buffering');
				player.floatBtn.classList.remove('fa-play');
				
				player.floatCover.classList.add('out');
				player.floatBtn.classList.add('out');
			}
			if(state==='pause'){
				player.floatBtn.classList.remove('fa-pause');
				player.floatBtn.classList.add('fa-play');

				player.titleBar.classList.remove('out');
				player.ctrlBar.classList.remove('out');
				
				player.floatCover.classList.remove('out');
				player.floatBtn.classList.remove('out');
			}
		}
		function hideBar(){
			clearTimeout(barOut);
			player.titleBar.classList.add('out');
			player.ctrlBar.classList.add('out');
			player.floatCover.classList.add('out');
			player.floatBtn.classList.add('out');
		}
		function showBar(first){
			clearTimeout(barOut);
			player.titleBar.classList.remove('out');
			player.ctrlBar.classList.remove('out');
			player.floatCover.classList.remove('out');
			if(!first) player.floatBtn.classList.remove('out');
			if(!player.video.paused && !player.buffering){
				barOut = setTimeout(function(){
	    			player.titleBar.classList.add('out');
	    			player.ctrlBar.classList.add('out');
	    			player.floatCover.classList.add('out');
	    			player.floatBtn.classList.add('out');
	    		},2500);
			}
		}
		
		function update(options){
			player.video.pause();
			initState(options);
			if(player.parent==document.body){
				setFullscreen(true);
			}else{
				options.parent.style.position="relative";
			}
			player.parent.appendChild(player.box);
		}
		
		function loadVideo(src){
			player.video.src = src;
			player.video.load();
			player.video.play();
		}
		
		function setVolume(val){
			player.video.volume = val;
		}
		function seek(rate){
			var etime = rate * player.video.duration;
			etime = etime>=player.video.duration ? player.video.duration-0.1 : etime;
			player.video.currentTime = etime;
		};
		
		function showError(){
			var errBox = player.box.querySelector('.load-err');
			if(errBox) return;
			errBox = document.createElement('div');
			errBox.className='load-err';
			errBox.innerHTML = '<span class="fa fa-rotate-left">视频加载失败,点击重试</span>';
			player.box.appendChild(errBox);
			errBox.addEventListener('tap',function(e){
				errBox.remove();
				loadVideo(player.options.src);
				e.stopPropagation();
			},false);
		}
		function showCellTips(){
			var cellTips = player.box.querySelector('.cell-tips');
			if(cellTips) return;
			cellTips = document.createElement('div');
			cellTips.className='cell-tips';
			var tipBox = document.createElement('div');
			tipBox.className='tips-box';
			tipBox.innerHTML = '<p>正在使用流量上网,是否继续播放?</p>';
			var btnCellPlay = document.createElement('a');
			btnCellPlay.className = 'btn-cell-play'
			btnCellPlay.innerText='继续播放';
			
			cellTips.appendChild(tipBox);
			tipBox.appendChild(btnCellPlay);
			player.box.appendChild(cellTips);
			btnCellPlay.addEventListener('tap',function(e){
				cellTips.remove();
				loadVideo(player.options.src);
				e.stopPropagation();
			},false);
			cellTips.addEventListener('tap',function(e){
				e.stopPropagation();
			},false);
		}
		function showShare(){
			if(!player.options.shareMsg) return;
			var shareBox = player.box.querySelector('.vshare');
			if(!shareBox){
				shareBox = document.createElement('div');
				shareBox.className='vshare';
				shareBox.innerHTML=[
					'<div class="txt"> 分享到 </div>',
					'<div class="icons">',
						'<a share="weixin" ex="WXSceneSession" class="weixin icon-item"><i class="mui-icon jcon jcon-weixin"></i><span>微信好友</span></a>',
						'<a share="weixin" ex="WXSceneTimeline" class="pengyouquan icon-item"><i class="mui-icon jcon jcon-pengyou"></i><span>朋友圈</span></a>',
						'<a share="qq" class="qq icon-item"><i class="mui-icon jcon jcon-qq"></i><span>QQ好友</span></a>',
						'<a share="sinaweibo" class="weibo icon-item"><i class="mui-icon jcon jcon-weibo"></i><span>新浪微博</span></a>',
					'</div>',
					'<a class="jcon jcon-replay replay"> 重播</a>',
				].join('');
				player.box.appendChild(shareBox);
				$('#'+player.box.id+' .vshare').on('tap','.icon-item',function(){
					var svcName = this.getAttribute('share');
					var ex = this.getAttribute('ex');
					var successCB = player.options.shareMsg.successCB;
					var errorCB = player.options.shareMsg.errorCB;
					share.goShare(svcName,ex,player.options.shareMsg,successCB,errorCB);
					return false;
				});
				$('#'+player.box.id+' .vshare').on('tap','.replay',function(){
					shareBox.classList.add('out');
					player.video.play();
					return false;
				});
				shareBox.addEventListener('tap',function(e){
					e.stopPropagation();
				},false);
			}
			shareBox.classList.remove('out');
		}
		
		
		function fullScreenEl(el) {
		    if (el.requestFullscreen) {
		        el.requestFullscreen();
		    } else if (el.mozRequestFullScreen) {
		        el.mozRequestFullScreen();
		    } else if (el.webkitRequestFullScreen) {
		        el.webkitRequestFullScreen();
		    }
		}
		
		function fullScreenElQuit() {
			if (document.exitFullscreen) {
			    document.exitFullscreen();
			} else if (document.mozCancelFullScreen) {
			    document.mozCancelFullScreen();
			} else if (document.webkitExitFullscreen) {
			    document.webkitExitFullscreen();
			}
		}
		
		var oif,oio,fullscreenBefore;
		function requestFullscreenBack(){
			var fullBtn = player.ctrlBar.querySelector('.full-btn span');
			plus.screen.lockOrientation('landscape');
			if(imbar && imbar.isIphoneX){
				var ixVideoBox = document.querySelector('.iphonex-video-box');
				if(!ixVideoBox){
					ixVideoBox = document.createElement('div');
					ixVideoBox.className = 'iphonex-video-box';
					document.body.appendChild(ixVideoBox); 
				}
				ixVideoBox.classList.remove('hidden');
				ixVideoBox.appendChild(player.box);
			}else{
				document.body.appendChild(player.box);
			}
			
			player.box.classList.add('full-screen');
			fullBtn.classList.remove('fa-expand');
			fullBtn.classList.add('fa-compress');
			if(!fullscreenBefore && player.video.paused) player.video.play();
			if(!isPageFullscreen){
				plus.navigator.setFullscreen(true);
			}
		};
		function quitFullscreenBack(){
			var fullBtn = player.ctrlBar.querySelector('.full-btn span');
			if(player.parent!=document.body){
				player.parent.appendChild(player.box);
			}else{
				player.box.classList.add('hidden');
			}
			var ixVideoBox = document.querySelector('.iphonex-video-box');
			if(ixVideoBox) ixVideoBox.classList.add('hidden');
			player.box.classList.remove('full-screen');
			fullBtn.classList.add('fa-expand');
			fullBtn.classList.remove('fa-compress');
			if(!fullscreenBefore && player.video.paused) player.video.play();
			player.isFullscreen = false;
			setTimeout(function(){
				$.fire($.currentWebview,'videoQuitFullScreen',{container:player.box});
			},100);
		};
		
		var ow = screen.availWidth,
			oh = screen.availHeight;
		function orientationchange(){
			output('webview:'+plus.screen.resolutionWidth+','+plus.screen.resolutionHeight);
			output('window:'+screen.availWidth+','+screen.availHeight);
			if(player.requestScreenChange=='1'){
				if(/MEIZU M6/gi.test(navigator.userAgent)){
					requestFullscreenBack();
					setTimeout(function() {
						mui.currentWebview.setStyle({width:'100%',height:'100%'});
					},100);
				}else{
					requestFullscreenBack();
				}
			}else if(player.requestScreenChange=='0'){
				if(/MEIZU M6/gi.test(navigator.userAgent)){
					quitFullscreenBack();
					setTimeout(function() {
						mui.currentWebview.setStyle({width:'100%',height:'100%'});
					},100);
				}else{
					quitFullscreenBack();
				}
			}
			player.requestScreenChange ='-1';
		}
		function setFullscreen(state){
			fullscreenBefore = player.video.paused;
			player.requestScreenChange = state?'1':'0';
			clearTimeout(oif);
			clearTimeout(oio);
			
			var fullscreen = function(){
				var orientation = mui.os.android ? 'landscape-primary':'landscape-secondary';
				if(/MEIZU M6/gi.test(navigator.userAgent)){
					//domRoate(state);
					player.video.pause();
					setTimeout(function(){
						plus.screen.lockOrientation(orientation);
						mui.currentWebview.setStyle({width:oh+'px'});
					},1);
				}else{
					plus.screen.lockOrientation(orientation);
				}
				if(!window.onorientationchange){
					oif = setTimeout(function(){
						requestFullscreenBack()
					},210);
				}
				$._jplayerSaveBack = $.back;
				$.back = function(){
					player.setFullscreen(false);
				};
				player.isFullscreen = true;
				$.fire($.currentWebview,'videoFullScreen',{container:player.box});
			};
			
			var quitFullscreen = function(){
				if(/MEIZU M6/gi.test(navigator.userAgent)){
					//domRoate(state);
					player.video.pause();
					setTimeout(function(){
						plus.screen.lockOrientation('portrait-primary');
						mui.currentWebview.setStyle({height:oh+'px'});
					},1);
				}else{
					plus.screen.lockOrientation('portrait-primary');
				}
				if(!window.onorientationchange){
					oio = setTimeout(function(){
						quitFullscreenBack()
					},210);
				}
				if(!isPageFullscreen) plus.navigator.setFullscreen(false);
				$.back = $._jplayerSaveBack;
			};

			if(state){
				fullscreen();
			}else{
				quitFullscreen();
			}
			
		}
		function toggleScreen(){
			setFullscreen(!player.isFullscreen);
		}

		function play(first){
			if(first){
				if(isCellular()) {
					showCellTips();
				}else{
					showBar(true);
					loadVideo(player.options.src);
				}
			}else{
				player.video.play();
			}
		}
		function playing(){
			player.video[player.video.paused?'play':'pause']();
		}
		function pause(){
			player.video.pause();
		};
		function stop(){
			destroyPlayer();
		};
		
		(function init(){
			var box = document.createElement('div');
			box.id=id;
			box.className='video-top';
			player.box = box;
			if(player.parent==document.body){
				setFullscreen(true);
			}else{
				options.parent.style.position="relative";
			}
			player.parent.appendChild(box);
			createPlayer(options);
		})();
		
		
		player.toggleScreen = toggleScreen;
		player.setFullscreen = setFullscreen;
		player.play = play;
		player.playing = playing;
		player.pause = pause;
		player.stop = stop;
		player.setVolume = setVolume;
		player.saveRate = saveRate;
		player.readRate = readRate;
		player.clearRate = clearRate;
		player.loadVideo = loadVideo;
		player.update = update;
		player.orientationchange = orientationchange;
	}

	$.options.gestureConfig.doubletap = true;
 
	function outRect(){
		var box = g(playerId);
		if(!box) {
			splayer = null;
			stopMoitor();
			output('video-box is not found'); 
			return;
		}
		var player = getPlayer();
		if(!player) return;
		if(!player.isFullscreen){
			var boxRect = player.box.getBoundingClientRect();
			var currSW = document.documentElement.clientWidth;
			var currSH = screen.availHeight;
			var isOutRect = boxRect.width === 0 || 
				boxRect.height === 0 ||
				boxRect.right <= player.options.rect.left ||
				boxRect.left >= currSW - player.options.rect.right ||
				boxRect.bottom <= player.options.rect.top + 24 ||
				boxRect.top >= currSH - (player.options.rect.bottom+24);
			if(isOutRect){
				if(player.outRange==1){
					player.stop();
					stopMoitor();
					output('destroy by outside');
				}else if(player.outRange==2){
					player.pause();
					stopMoitor();
					output('pause by outside');
				}
			}
			var topView = window.plus && plus.webview.getTopWebview();
			var isBehind =  topView && topView.__uuid__ !==plus.webview.currentWebview().__uuid__;
			if(isBehind){
				if(player.outRange==1){
					player.stop();
					stopMoitor();
					output('destroy by behind');
				}else if(player.outRange==2){
					player.pause();
					stopMoitor();
					output('pause by behind');
				}
			}
		}
	}
	function appPause(){
		var player = getPlayer();
		if(!player) return;
		if(!player.video.paused){
			player.autoPaused = true;
			player.video.pause();
		}
	}
	function appResume(){
		var player = getPlayer();
		if(!player) return;
		if(player.autoPaused){
			player.autoPaused = false;
			player.video.play();
		}
	}
	function netChange(){
		var player = getPlayer();
		if(!player) return;
		if(isCellular()){
			if(player.video.paused) return;
			player.video.pause();
		}
	}
	
	function orientationchange(){
		output("orientationchange=>"+window.orientation);
		var player = getPlayer();
		if(!player) return;
		splayer.orientationchange();
	}
	function deviceorientation(e){
		output("deviceorientation=>("+e.alpha+",",e.beta+","+e.gamma+")");
	}

	function startMonitor(){
		clearInterval(mwInt);
		mwInt = setInterval(outRect,500);
		window.addEventListener('scroll',outRect,false);
		document.addEventListener('pause', appPause,false);
		document.addEventListener('resume', appResume,false);
		document.addEventListener('netchange', netChange,false);

		window.addEventListener('orientationchange',orientationchange,false);
		
		if(window.DeviceOrientationEvent){
			//TODO: 根据重力感应方向  手机旋转时自动全横屏
			//window.addEventListener('deviceorientation',deviceorientation,false);
		}else{
			output('not support mobile event');
		}
		output('Monitor watch video 1');
	}
	function stopMoitor(){
		clearInterval(mwInt);
		window.removeEventListener('scroll',outRect,false);
		window.removeEventListener('orientationchange',orientationchange,false);
		document.removeEventListener('pause', appPause,false);
		document.removeEventListener('resume', appResume,false);
		document.removeEventListener('netchange', netChange,false);
		output('Monitor stop watch 1');
	}
	function MonitorDom(){
		var watchEl = document.body;
		function removeHandler(evt){
    		if(evt.target.id = playerId){
    			stopMoitor();
    			output('DOMNodeModified EventHandler find video removed');
    		}
    	}
		function observerCall(mutations,observer){
			mutations.forEach(function(mutation) {
			    for (var i = 0; i < mutation.removedNodes.length; i++){
			    	var theNode = mutation.removedNodes[i];
			    	if(theNode.id && theNode.id==playerId){
			    		stopMoitor();
			    		output('observer find video removed');
			    		break;
			    	}
			    }
			});
		}
	    var MutationObserver = MutationObserver || WebKitMutationObserver;
	    if(MutationObserver){
	        var MutationObserverConfig={
	            childList: true
	        };
	        var observer=new MutationObserver(observerCall);
	        observer.observe(watchEl,MutationObserverConfig);
	        output('MutationObserver watch video-box');
	    }else if(el.addEventListener){
	        watchEl.addEventListener("DOMNodeRemoved", removeHandler, false);
	        output('DOMNodeModified watch video-box');
	    }else{
	    	output('unsupported browser MutationObserver');
	    }
	}
	
	function startMonitorMin(){
		clearInterval(mwInt);
		mwInt = setInterval(outRect,500);
		window.addEventListener('scroll',outRect,false);
		output('Monitor watch video 0');
	}
	function stopMoitorMin(){
		clearInterval(mwInt);
		window.removeEventListener('scroll',outRect,false);
		output('Monitor stop watch 0');
	}
	window.addEventListener('videoFullScreen',function(e){
		output('videoFullScreen');
		stopMoitorMin();
	},false);
	window.addEventListener('videoQuitFullScreen',function(e){
		output('videoQuitFullScreen');
		startMonitorMin();
	},false);
	
	function getSPlayer(options){
		if(splayer){
			splayer.update(options);
			return splayer;
		}
		stopMoitor();
		splayer = new jplayer(playerId,options);
		startMonitor();
		return splayer;
	}
	function getSPlayer1(options){
		if(splayer){
			splayer.stop();
			stopMoitor();
			splayer = null;
		}
		var vbox = g(playerId);
		if(vbox) vbox.remove();
		splayer = new jplayer(playerId,options);
		startMonitor();
		return splayer;
	}
	function getPlayer(){
		var vbox = g(playerId);
		if(!vbox || !splayer){
			if(splayer){
				splayer.stop();
				stopMoitor();
			}
			splayer = null;
		}
		return splayer;
	}
	
	joyPlayer.stopMoitor = stopMoitor;
	joyPlayer.getPlayer = function(){
		return getPlayer();
	};
	joyPlayer.playing = function(){
		var player = getPlayer();
		if(player) player.playing();
	};
	joyPlayer.pause = function(){
		var player = getPlayer();
		if(player) player.pause();
	};
	joyPlayer.play = function(src,parent,title,poster,rect){
		if(arguments.length==0){
			var player = getPlayer();
			if(player) player.play();
			return;
		}
		if(typeof src==='string'){
			getSPlayer({
				src:src,
				parent:parent,
			 	title:title,
			 	poster:poster,
			 	rect:rect
			}).play(true);
		}else if(typeof src==='object'){
			getSPlayer(src).play(true);
		}
	};
	
	//MonitorDom();
	
})(mui,window.joyPlayer={});
