var custom;
new Vue({
	el: "#body",
	data: {
		pageData: '9',
		ai: '',
		hostName: app._customURL,
		updateImgUrl: '',
		isLeavemsg: false
	},
	created: function() {
		var This = this;
		var imBarH = myStorage.getItem('immersedBar').statusbarHeight || 0;
		document.querySelector('.mui-bar').style.paddingTop = imBarH + 'px';
		document.querySelector('.mui-bar').style.height = (40 + imBarH) + 'px';
		mui.plusReady(function(){
			This._getPageData();
		})
		custom = new Custom();
		custom.refresh = this._getPageData;
		window.addEventListener('refresh_data', function(){
			This._getPageData();
		});
	},
	mounted: function(){
		var self = this;
		mui('.mui-scroll-wrapper').scroll({
			deceleration: 0.0005 //flick 减速系数，系数越大，滚动速度越慢，滚动距离越小，默认值0.0006
		});
		mui('body').on('tap', '#consult', function() {
			if (!app.checkLogin()) {
				return app.toLogin();
			}
			mui.openWindow({url:'_www/view/login-zixun.html'});
		}, false);
		mui('body').on('tap', '.hot-ask li', function(){
			custom.sendMessageText(this.innerHTML);
		});
		mui('body').on('tap', '.other-link a', function(e){
			switch (this.dataset.key) {
				case '问题库':
					if (window.plus) {
						custom.openCreateWebview('./repository.html?id=' + self.pageData.aiid + '&time=' + Date.now());
					} else {
						custom.openCreateWebview(location.origin + '/im/view/repository.html?id=' + self.pageData.aiid + '&time=' + Date.now())
					}
				break;
				case '人工客服':
				var pageData = self.pageData;
				custom.output('<div class="text-center"><span class="tips-text" id="connect-message">正在为您接入客服系统...</span></div>' , 'connect-message');
				isPersonOnline(self.initParam).then(function(res){
					if (res.check) {
						custom.trySocket((pageData.schema || 'http') + '://'+ pageData.hostname +':' + 
					pageData.port + '/im/user');		
					} else {
						custom.output('<div class="text-center"><span class="tips-text" id="connect-message">' + res.cue + '</span></div>' , 'connect-message');
					}
				}).catch(function(){
					custom.output('<div class="text-center"><span class="tips-text" id="connect-message">连接失败，请重试</span></div>' , 'connect-message');
				})
				
				break;
				case '问题咨询':
					custom.listenerOpenWindow('问题咨询');
				break;
			}
			
		});
		mui('body').on('tap', '.unresolve', function(e){
			custom.unresolved(e);
		});
		mui('body').on('tap', '.resolve', function(e){
			custom.resolved(e);
		});
		document.addEventListener('add_ask', function(res){
			if (res.detail) {
				custom.sendMessage(res.detail);
			}
		});
		mui.plusReady(function(){
			mui.currentWebview.setStyle({
				softinputMode:"adjustResize",
				'popGesture': 'none'
			});
		})
	},
	methods: {
		_getPageData: function(platform){
			var info = app.getState();
			var userData = app.getUser() || {};
			var deviceId = plus.device.uuid;
			var oFingerprint = new Fingerprint({deviceId: deviceId});
			var userId = oFingerprint.get();
			if (userData.userId) {
				userId = userData.userId;
			}
			var This = this;
			init({
				userid: userId,
				cid: userData.userId || '',
				deviceid: deviceId,
//				skill: '4028815c6b26ed4b016b40617bd92af5', 
				
			}).then(function(res) {
				var pageData = res.pageData;
				This.isLeavemsg = res.page == 'leavemsg'; 
				if ('' === This.ai) {
					This.ai = res.page === 'immobile' ? false : true;
				}
				if (This.isLeavemsg) {
					return custom.output('<div class="text-center"><span class="tips-text" id="connect-message">' + pageData.inviteData.lvtipmsg + '</span></div>' , 'connect-message');
				} 
				This._initScoket(pageData, userId);
				This._initData(pageData, userId);
				This._showTips();
				This.initParam = {
					appid: pageData.appid,
					orgi: pageData.orgi,
					agent: pageData.agent || '',
					skill: pageData.skill || '',
				};
				
			})
		},
		_initView: function(){
			var This = this;
			var imBarH = myStorage.getItem('immersedBar').statusbarHeight;
			This.$refs.chatContent.style.paddingTop = (40 + imBarH) + 'px';
		},
		_showTips: function(){
			var isFirst = localStorage.getItem('first');
			if (!isFirst) {
				 $('.view').fadeIn(0);
				 localStorage.setItem('first', true);
			};	
			$('.view').on('click', '', function(){
				$('.view').fadeOut();
			})
		},
		_initData: function(pageData, appid){
			var self = this;
			if (pageData.chatMessageList && pageData.chatMessageList.content) {
				pageData.chatMessageList.content = pageData.chatMessageList.content.reverse();
				pageData.chatMessageList.content = pageData.chatMessageList.content.map(function(chatMessage){
					if (chatMessage.msgtype == 'json') {
						chatMessage.message = custom.outputJsonToHtml(chatMessage.message)
					}
					var emoticonsRE = /kindeditor/;
					if (!/http/.test(chatMessage.message) && emoticonsRE.test(chatMessage.message)) {
						chatMessage.message = chatMessage.message.replace(/\/im\/js\/kindeditor\/plugins\/emoticons\/images\/([0-9]*\.png)/g, function($1,$2){
							$1 = './img/emoticons/' + $2;
							return $1;
						});
					}
					var imgRE = /(\/res)/g;
					if (!/http/.test(chatMessage.message) && imgRE.test(chatMessage.message)) {
						chatMessage.message = chatMessage.message.replace(imgRE, function($1, $2){
							$1 = app._customURL + $1;
							return $1;
						})
					}
					return chatMessage;
				})
			};
			this.pageData = pageData;
			custom.initView();
			custom.initFN();
			custom.pageData = pageData;
			// custom.loadedImgScrollToBottom();
		},
		_initScoket:function(pageData, appid){
			var self = this;
			custom.initData(pageData.appid, appid, pageData.username, 
				pageData.cid, pageData.deviceid, pageData.sessionid, pageData.orgi, pageData.aiid, pageData.inviteData.consult_dialog_headimg ? 
			'/res/image.html?id=' + pageData.inviteData.consult_dialog_headimg : '/images/agent.png', 
			pageData.inviteData.name || '查悦客服',
			pageData.headimgurl || './img/user.jpg');
			custom.pageData = pageData;
			custom.connectSuccess = function(isAi){
				self.ai = isAi;
			};
			custom.isSocket = false;
			!self.isLeavemsg && custom.initSocketConnect((pageData.schema || 'http') + '://'+ pageData.hostname +':' + 
			pageData.port + (self.ai ? '/im/ai' : '/im/user'));
			custom.pushHotList = function(){
				getHotList({orgi: pageData.orgi, aiid: pageData.aiid}, function(res){
					var html = ['<div class="align-left">'+
							'<img class="header-photo" src="' + 
							(pageData.inviteData.consult_dialog_headimg ? self.hostName + ('/res/image.html?id=' + pageData.inviteData.consult_dialog_headimg) : '../img/agent.png') + '" />',
							'<dl><dd class="msg hot-ask"><div class=""><h2>猜你想问</h2><ul>',
							'</ul></div></dd></dl></div>'];
					var lis = '';
					res.hotTopics.forEach(function(val,i){
						lis += '<li>' + val.title + '</li>'
					})
					html.splice(2, 0, lis);
					custom.output(html.join(''));
				})
			};
			custom.activeMessage = function(){
				setTimeout(function(){
					if (!window.plus) {
						message = localStorage.getItem('title');
						message != 'isreload' && custom.sendMessage(message);
						localStorage.removeItem('title');	
					}
				}, 900)
			};
			custom.resolved = function (e){
				if ($(e.target).attr('disabled')) return;
				$(e.target).parent().find('span').css('color', '#999').attr('disabled', true);;
				$(e.target).css('color', '#fbb144');
			}
			custom.unresolved = function (e){
				if ($(e.target).attr('disabled')) return;
				$(e.target).parent().find('span').css('color', '#999').attr('disabled', true);;
				$(e.target).css('color', '#fbb144');
				custom.output(custom.insertMessage({callType: "out", message: "问题难住小E啦！您可以先尝试到下方问题库寻找答案，或者转接人工客服小姐姐咨询哈~", messageType: "text", otherCustom: true}) , "chat-block");
				custom.output(custom.appendQuickEntry());
				e.preventDefault();
				e.stopPropagation();
			};
		},
		insertImg: function(e){
			custom && custom.insertImg(e.index);
		},
		sendMessage: function(){
			custom && custom.sendMessage();
		},
		galleryImage: function() {
			var This = this;
			document.activeElement.blur();
			setTimeout(function(){
				localFile.galleryImage(zipHandler);
				// 图片上传
				function zipHandler(url) {
					if (window.plus) {
						plus.nativeUI.showWaiting('图片上传中...');
					} else {
						$('.toast-loading').show();
					}
					localFile.zipImage(url, function(zipUrl, imageData){
						if (imageData.size > 1024 * 1024 * 5) {
							if(window.plus) plus.nativeUI.closeWaiting();
							return mui.alert('图片不能大于5M','提示', ['确定'], function(){}, 'div');
						}
						updateImg(zipUrl, {'orgi': This.initParam.orgi}, function(res){
							custom.sendMessageText(null, res.mediaMessage);
						})
						$('.toast-loading').hide();
					});
				}	
			}, 300)
		},
		defaultHanlder: function(){}
	}
})