window.localFile = {};
/*
 * 拍照
 * @param {Function} callback 拍照成功后的回调函数
 */
function captureImage(callback) {
	mui.plusReady(function() {
		var cmr = mui.camera.getCamera();
		var fmt = cmr.supportedImageFormats[0];
		var res = cmr.supportedImageResolutions[0];
		var path = '_doc/camera/';
		cmr.captureImage(function(path) {
				callback(path);
			},
			function(error) {
				console.log("Capture image failed: " + error.message);
			}, {
				fileName: path,
				resolution: res,
				format: fmt
			}
		);
	})

}

/*
 * 相册选择
 * @param {Function} callback 选择照片成功后的回调函数
 */
function galleryImage(callback) {
	// 从相册中选择图片
	mui.plusReady(function() {
		plus.gallery.pick(function(path) {
			callback(path);
		}, function(e) {
			console.log("取消选择图片", JSON.stringify(e));
		}, {
			filter: "image"
		});
	})
}

/**
 * 压缩图片
 * @param {Object} options 图片压缩的参数
 * @param {String} sourcesUrl 被压缩的图片地址
 * @param {Function} callback
 */
function zipImage(sourcesUrl, callback) {
	var saveZipPath = "_doc/" + Date.now() + ".png";
	var zipOptions = {
		src: sourcesUrl,
		dst: saveZipPath,
		format: "png",
		overwrite:true,
		quality: 50
	};
	console.log(zipOptions)
	plus.zip.compressImage(zipOptions, function(res) {
		callback(saveZipPath, res);
	}, function() {
		callback(sourcesUrl);
	});
}
/**
 * 图片转换成base64
 * @param {Object} imageUrl
 * @param {Function} callback
 */
function convertImageToBase64(imageUrl, callback) {
	var oCanvas = document.createElement('canvas');
	var ctx = oCanvas.getContext('2d');
	var oImg = null;
	mui.plusReady(function() {
		imageUrl = plus.io.convertLocalFileSystemURL(imageUrl);
		console.log(imageUrl);
		getImage(imageUrl, getBase64)
	})

	function getImage(imageUrl, callback) {
		oImg = document.createElement('img');
		oImg.onload = callback;
		oImg.src = imageUrl;
	}

	function getBase64() {
		oCanvas.width = oImg.width;
		oCanvas.height = oImg.height;
		console.log(oImg)
		ctx.drawImage(this, 0, 0);
		callback(oCanvas.toDataURL());
		oCanvas.remove();
		oCanvas = null;
		oImg = null;
	}
}
localFile.captureImage = captureImage;
localFile.galleryImage = galleryImage;
localFile.zipImage = zipImage;
localFile.convertImageToBase64 = convertImageToBase64;
