	
mui.init({swipeBack:true});
new Vue({
	el: "#body",
	data: {
		repositoryList: [],
		repositoryChildList: [],
		index: 0,
		loading: 'start'
	},
	created: function() {
		var This = this;
		this._initContentView();
		this._initData();
		
	},
	mounted: function() {
		var This = this;
		mui('.mui-scroll-wrapper').scroll();
		mui('.repository-right .mui-scroll').pullToRefresh({
			up: {
				auto: false,
				contentrefresh : "正在加载...",//可选，正在加载状态时，上拉加载控件上显示的标题内容
		      	contentnomore:'没有更多内容了',//可选，请求完毕若没有更多数据时显示的提醒内容；
				callback: function(){
					This.oUp = this;
					This._getRepositoryChild();
				}
			}
		})
	},
	methods: {
		changeItem: function(e){
			var index = e.index;
			this.index = index;
			if (this.oUp) {
				this.oUp.refresh(true);
				this.oUp.endPullUpToRefresh(false);
			}
			this._getRepositoryChild(e);
			mui('.repository-right').scroll().scrollTo(0,0);
		},
		askHandler: function(e){
			if (window && window.plus) {
				var opener = plus.webview.currentWebview().opener();
				mui.fire(opener, 'add_ask', e.title);
				mui.back();
			} else {
				localStorage.setItem('title', e.title);
				history.back();
			}
		},
		_getRepositoryChild: function(e){
			var This = this;
			if ($.isPlainObject(e)) {
				this.pageNo = 1;
				this.id = e.id;
				this.loading = 'start';
			} else {
				this.pageNo += 1;
			}
			getRepositorySmallList({id: this.id, pageNo: this.pageNo, pageSize: 20}, function(res){
				res = res.topics;
				if (1 == This.pageNo) {
					This.repositoryChildList =  res.list;
					This.loading = 'end';
					if (res.list.length < 20) {
						$('.mui-pull-bottom-tips').hide();
					} else {
						$('.mui-pull-bottom-tips').show();
					}
				} else {
					if (res.pageCount >= This.pageNo) {
						This.repositoryChildList = This.repositoryChildList.concat(res.list);    
					}
				}
				return This.oUp && This.oUp.endPullUpToRefresh(res.pageCount <= This.pageNo);
			}, function(err){
				this.loading = 'fail';
				This.oUp && This.oUp.endPullUpToRefresh(false);
			});
		},
		_initContentView: function(){
			var statusBarH = imbar.statusbarHeight;
			var iH = 44 + Number(statusBarH || 0);
			var isMin = window.__wxjs_environment === 'miniprogram' || navigator.userAgent.indexOf('AlipayClient') > -1;
			$('.mui-bar').css({
				paddingTop: statusBarH,
				height: iH
			});
			if (isMin) {
				$('.mui-bar').hide();
			}
			$('.mui-content').css({
				top: isMin ? 0 : iH
			});
		},
		_initData: function(){
			var This = this;
			var id = this.queryString(location.search.substr(1)).id;
			getRepositoryList({id: id}, function(res){
				This.repositoryList = res.typeList;
				This._getRepositoryChild(This.repositoryList[0]);
			}, function(err){
				
			});
		},
		queryString: function(str){
			var arr = str.split('&');
			var result = {};
			for (var i = 0; i < arr.length; i ++) {
				var index = arr[i].indexOf('=');
				result[arr[i].substring(0, index)] = arr[i].substr(index+1);
			}
			return result;
		}
	}
});