var baseUrl = app._customURL +'/api';
function isPersonOnline(data){
	var baseUrl = app._customURL + '/im/chat/check/agent';
	return request.post(baseUrl, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}});
}
function init(data){
	var baseUrl = app._customURL + '/im/chat/1cgFdt/init';
	return request.post(baseUrl, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}});
}
function takeScore(data, orgi){
	var baseUrl = app._customURL + '/im/satis.html?orgi=' + orgi;
	return request.post(baseUrl, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}});
}
function updateImg(filePath, data, success, fail) {
        success = success || $.noop;
        fail = fail || $.noop;
        var task = plus.uploader.createUpload( app._customURL + '/im/chat/media/upload', {method:'POST'}, function ( t, status ) { // 上传完成
            if ( status == 200 ) {
                var data = JSON.parse(t.responseText);
                if(data.err)
                    fail(data.err);
                else
                    success(data.data);
                plus.nativeUI.closeWaiting()    
            } else {
                fail({err:status,message:'上传文件出错'});
                plus.nativeUI.closeWaiting()
            }
        });
        
        var user = app.getUser();
        for (var i in data) {
        	task.addData(i, data[i]);
        }
        task.addFile( filePath, {key:"imgFile"} );
        task.start();
    
};
/**
 * 获取热门问题
 * @param {Object} data
 * @param {Object} success
 * @param {Object} fial
 */
function getHotList(data, success, fial){
	var url =   app._customURL + '/im/knowledge/' + data.orgi + '/' + data.aiid + '/hot/topics';
	var storageData = getStorageItem("hot_list_" + data.id, 2);
	if (storageData) {
		return success(storageData);
	}
	request.get(url, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}}).then(function(res){
		setStorageItem("hot_list_" + data.id, res);
		success(res);
	});
};
/**
 * 获取问题类下的分类列表
 * @param {Object} data
 * @param {Object} success
 * @param {Object} fial
 */
function getRepositorySmallList(data, success, fial){
	var url =  serialzieGetParam( app._customURL + '/im/knowledge/type/' + data.id, data);
	var secret = JSON.stringify(data);
	var storageData = getStorageItem(secret, 4);
	if (storageData) {
		return success(storageData);
	}
	request.get(url, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}}).then(function(res){
		setStorageItem(secret, res);
		success(res);
	});
};
/**
 * 获取问题库大分类
 * @param {Object} data
 * @param {Object} success
 * @param {Object} fial
 */
function getRepositoryList(data, success, fial){
	var url =  app._customURL + '/im/knowledge/typeList/' + data.id;
	var secret = JSON.stringify(data);
	var storageData = getStorageItem(secret);
	if (storageData) {
		return success(storageData);
	}
	request.get(url, data, {headers: {'Content-Type':'application/x-www-form-urlencoded'}}).then(function(res){
		setStorageItem(secret, res);
		success(res);
	});
};
// 获取智能应用列表
function getIntelligent(data, success, fial){
	var url =  app._baseUrl + '/intelligent/isHaveIntelligentContext';
	var storageData = getStorageItem("intelligent_" + data.cityCode);
	if (storageData) {
		return success(storageData);
	}
	request.post(url, data).then(function(res){
		setStorageItem("intelligent_" + data.cityCode, res);
		success(res);
	});
};
// 智能应用静态的列表
function getIAList(data, success, fial){
	var url =  app._baseUrl + '/calculator/IAList';
	var storageData = getStorageItem("AIList_" + data.cityCode);
	if (storageData) {
		return success(storageData);
	}
	request.post(url, data).then(function(res){
		setStorageItem("AIList_" + data.cityCode, res);
		success(res);
	});
};
// 获取社保卡详情
function getSecurityInfoById(data, success, fial){
	var url = app._baseUrl + '/security/getSecInfo';
	var storageData = getStorageItem("SecInfo_" + data.securityAcctId);
	if (storageData) {
		return success(storageData);
	}
	request.post(url, data).then(function(res){
		setStorageItem("SecInfo_" + data.securityAcctId, res);
		success(res);
	}).catch(function(err){
		fial(err);
	});
};
// 获取保险列表类型
function getInsTypeInfoNew(success, fial){
	var url = app._baseUrl + '/commercialIns/getInsTypeInfoNew';
	var storageData = getStorageItem("insurance");
	if (storageData) {
		return success(storageData);
	}
	request.get(url, null).then(function(res){
		setStorageItem("insurance", res);
		success(res);
	}).catch(function(err){
		fial(err)
	})
};
function serialzieGetParam(url, data){
	var searchRE = /\?/i;
	if (!searchRE.test(url)) {
		url += '?';
	}
	for (var i in data) {
		url += (i + '=' + data[i]) + '&'
	}
	return url.slice(0, -1);
}
/**
 * 存储数据
 * @param {Object} key 数据的key
 * @param {Object} value 数据内容
 */

function setStorageItem(key, value){
	var data = {
		time: Date.now(),
		content: {},
	}
	data.content[key] = value;
	try {
		return localStorage.setItem(key, JSON.stringify(data));
	} catch (e) {
		return null;
	}

}
/**
 * 取数据
 * @param {Object} key 存储的key
 * @param {Object} times 小时 ； 按时间查询数据，在时间范围内取缓存数据，否则返回为空
 */
function getStorageItem(key, times){
	if (!times) {
		times = 0;
	}
	var result = localStorage.getItem(key);
	try {
		result = JSON.parse(result);
		var nowTime = Date.now();
		if (nowTime - result.time < times *60*60*1000 ) {
			return result.content[key];
		} else {
			return null;
		}
	} catch (e) {
		return null;
	}
	return result;
}