(function($) {
	$.init({
		gestureConfig: {
			drag: true,
			gesturechange: true,
			pinch: true,
			doubletap: true
		}
	});
	window.cropper = null;
	var cropType;
	var options = {
		imageBox: '.imageBox',
		thumbBox: '.thumbBox',
		spinner: '.spinner'
	};
	var types = {
		idcard: {
			width: 800,
			height: 504,
			outType: 'image/jpeg'
		}, //400,252{width:85.6,height:54,util:'mm'},
		portrait: {
			width: 200,
			height: 200
		},
		normal: {
			width: 200,
			height: 200,
			outType: 'image/jpeg'
		}
	};
	var showTools = true;
	var initedBar = false;
	var initUI = function(args) {
		if(imbar) {
			gel('.tip').style.top = (imbar.navBarHeight + 20) + 'px';
			initedBar = true;
		}

		if(args.outType) options.outType = args.outType;
		if(args.cw && args.ch) {
			options.cropWidth = args.cw;
			options.cropHeight = args.ch;
		} else {
			cropType = types[args.type || 'normal'];
			var boxWidth = gel(options.thumbBox).offsetWidth;
			var sheight = cropType.height * boxWidth / cropType.width;
			gel(options.thumbBox).style.paddingBottom = '0px';
			gel(options.thumbBox).style.height = sheight + 'px';
			if(cropType.outType) options.outType = cropType.outType;
			if(cropType.util == 'mm') {
			    options.cropWidth = cropType.width * 96 / devicePixelRatio / 25.4;
			    options.cropHeight = cropType.height * 96 / devicePixelRatio / 25.4;
			} else {
			    options.cropWidth = cropType.width;
			    options.cropHeight = cropType.height;
			}
		}
	};

	(function() {
		var args = {},
			width = queryString('w'),
			height = queryString('h'),
			title = queryString('title'),
			tools = queryString('tools');
		args.type = queryString('type');
		args.outType = queryString('out');
		if(tools == '0') showTools = false;
		if(!showTools) gel('#tools').classList.add('mui-hidden');
		if(title) gel('#header .mui-title').innerHTML = title;
		if(width && height && !isNaN(width) && !isNaN(height)) {
			args.width = parseInt(width);
			args.height = parseInt(height);
		}

		initUI(args);
	})();

	$.plusReady(function() {
		if(!initedBar) {
			gel('.container').style.top = imbar.navBarHeight + 'px';
		}

		if(cropType.util == 'mm') {
			options.cropWidth = cropType.width * plus.screen.dpiX / devicePixelRatio / 25.4;
			options.cropHeight = cropType.height * plus.screen.dpiY / devicePixelRatio / 25.4;
		}

		if($.currentWebview.title) {
			gel('#header .mui-title').innerHTML = $.currentWebview.title;
		}
		if($.currentWebview.tipMessage) {
			gel('#tip .tip-info').innerHTML = $.currentWebview.tipMessage;
			gel('#tip').classList.remove('mui-hidden');
			toggle();
			$('#tip').on('tap', 'i', function() {
				toggle();
			});

			function toggle() {
				var info = gel('#tip .tip-info');
				var isShow = info.classList.contains('show');
				info.classList[isShow ? 'remove' : 'add']('show');
				if(isShow) {
					gel('#tip i').classList.add('mui-icon-info');
					gel('#tip i').classList.remove('mui-icon-close');
				} else {
					gel('#tip i').classList.add('mui-icon-close');
					gel('#tip i').classList.remove('mui-icon-info');
				}
			}
		}

		if($.currentWebview.maxZoom) {
			options.maxZoom = $.currentWebview.maxZoom;
		}
		if($.currentWebview.minZoom) {
			options.minZoom = $.currentWebview.minZoom;
		}
		if($.currentWebview.outType) {
			options.outType = $.currentWebview.outType;
		}
		if($.currentWebview.scale==false) {
            options.scale = false;
        }else{
            options.scale = true;
        }
		var origin = ($.currentWebview.origin || 'gallery').toLocaleLowerCase();
		if(origin == 'camera') {
			fromCamera();
		} else {
			fromGallery();
		}

		gel('#formGallery input').classList.add('mui-hidden');
		gel('#formCamera input').classList.add('mui-hidden');

		gel('#formGallery').addEventListener('tap', function() {
			fromGallery();
		}, false);
		gel('#formCamera').addEventListener('tap', function() {
			fromCamera();
		}, false);

		function fromGallery() {
			plus.gallery.pick(function(path) {
				options.imgSrc = path;
				cropper = new cropbox(options);
				created();
			}, function(err) {
				if(err.code == 12) $.toast('已取消选择');
				if(!showTools) $.back();
			}, {
				filter: "image"
			});
		}

		function captureImage() {
			var cmr = plus.camera.getCamera(2);
			cmr.captureImage(function(path) {
				options.imgSrc = plus.io.convertLocalFileSystemURL(path);
				cropper = new cropbox(options);
				created();
			}, function(err) {
				$.toast('已取消拍摄');
				if(!showTools) $.back();
			});
		}

		function goAppSettings() {
			plus.PermissionUtil.requestSetting(function(data) {
				fromCamera();
			});
		}

		function checkPermission() {
			var pp = plus.PermissionUtil.permissionState('CAMERA');
			if(pp == 'authorized') {
				captureImage();
			} else {
				plus.PermissionUtil.requestPermission('CAMERA', function(data) {
					captureImage();
				}, function(err) {
					var code = err.code == 0 ? 0 : 1;
					var message = [
						'开启“相机”权限才能进行拍照，\n是否继续开启？',
						'开启“相机”权限才能进行拍照，' +
						'\n点击“设置”-“权限”-打开“相机”权限。' +
						'\n最后点击两次后退按钮，即可返回。'
					][code];
					var btns = [
						['取消', '开启'],
						['取消', '设置']
					][code];
					var okBack = [fromCamera, goAppSettings][code];
					mui.confirm(message, '帮助', btns, function(e) {
						if(e.index == 1) {
							okBack();
						} else {
							mui.back();
						}
					});
				});
			}
		}

		function fromCamera() {
			if(plus.PermissionUtil) {
				checkPermission();
			} else {
				captureImage();
			}
		}

	});

	gel('input[type="file"]').addEventListener('change', function() {
		if(this.files.length == 0) return;
		var reader = new FileReader();
		reader.onload = function(e) {
			options.imgSrc = this.result;
			cropper = new cropbox(options);
			created();
		}
		reader.readAsDataURL(this.files[0]);
		this.files = null;
	});

	function created() {
		gel('#cropBtn').addEventListener('tap', function() {
			var img = cropper.getDataURL();
			if(window.plus) {
				var pvw = mui.currentWebview.opener();
				$.fire(pvw,'cropComplete',{b64:img});
				$.back();
			} else {
				gel('.cropped').classList.add('active');
				gel('.cropped').innerHTML += '<img src="' + img + '">';
			}
		}, false);

		/*gel('#cropBtn').addEventListener('click', function(){
			var img = cropper.getDataURL();
			gel('.cropped').classList.add('active');
			gel('.cropped').innerHTML += '<img src="'+img+'">';
		},false);*/

		gel('#btnZoomIn').addEventListener('click', function() {
			var txtPer = gel('#txtPer').value.trim();
			var per = isNaN(txtPer) ? 0 : parseFloat(txtPer);
			cropper.zoomIn(per);
		});

		gel('#btnZoomOut').addEventListener('click', function() {
			var txtPer = gel('#txtPer').value.trim();
			var per = isNaN(txtPer) ? 0 : parseFloat(txtPer);
			cropper.zoomOut(per);
		})

		var timeOutEvent, timeIntEvent;

		function stopZoom(e) {
			clearInterval(timeIntEvent);
			clearTimeout(timeOutEvent);
		}
		gel('#btnZoomIn').addEventListener('touchstart', function(e) {
			timeOutEvent = setTimeout(function() {
				timeIntEvent = setInterval(function() {
					var txtPer = gel('#txtPer').value.trim();
					var per = isNaN(txtPer) ? 0 : parseFloat(txtPer);
					cropper.zoomIn(per);
				}, 100);
			}, 500);
		});
		gel('#btnZoomIn').addEventListener('touchend', stopZoom);
		gel('#btnZoomIn').addEventListener('touchcancel', stopZoom);

		gel('#btnZoomOut').addEventListener('touchstart', function(e) {
			timeOutEvent = setTimeout(function() {
				timeIntEvent = setInterval(function() {
					var txtPer = gel('#txtPer').value.trim();
					var per = isNaN(txtPer) ? 0 : parseFloat(txtPer);
					cropper.zoomOut(per);
				}, 100);
			}, 500);
		});
		gel('#btnZoomOut').addEventListener('touchend', stopZoom);
		gel('#btnZoomOut').addEventListener('touchcancel', stopZoom);

	}

	function gel(selector) {
		return document.querySelector(selector);
	}

	function queryString(name, url) {
		url = url || location.search.substr(1);
		var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
		var matchs = url.match(reg);
		if(matchs !== null) return matchs[2];
		return null;
	}

	function getDPI() {
		var dpi = {};
		if(window.screen.deviceXDPI != undefined) {
			dpi.dpiX = window.screen.deviceXDPI;
			dpi.dpiY = window.screen.deviceYDPI;
		} else {
			var tmpNode = document.createElement("DIV");
			tmpNode.style.cssText = "width:1in;height:1in;position:absolute;left:0px;top:0px;z-index:99;visibility:hidden";
			document.body.appendChild(tmpNode);
			dpi.dpiX = parseInt(tmpNode.offsetWidth);
			dpi.dpiY = parseInt(tmpNode.offsetHeight);
			tmpNode.parentNode.removeChild(tmpNode);
		}
		return dpi;
	}

})(mui);