(function($,crop){
	var _listeners = [];
	var vw;
	crop.title = '';
	/**
	 * @description 显示图片剪切组件
	 * @param {String} origin 获取图片方式 'camera'、'gallery'
	 * @param {String} type 预设尺寸类型和width、height排斥
	 * 'normal:200x200'、'portrait:100x100'、'idcard:243x153',
	 * @param {Number} width 剪切后的宽度， 设置宽后 type失效
	 * @param {Number} height 剪切后的高度， 设置高后 type失效
	 */
	crop.show = function(origin,type,width,height){
		//url, id, styles, extras
		if(vw) vw.close('none');
		var url = '_www/view/crop/crop.html?t='+Date.now();
		if(type) url +='&type='+type;
		if(width) url +='&width='+width;
		if(height) url +='&height='+height;
		vw = $.openWindow({
			id:'cropBox',
			url:url,
			styles:{
				hardwareAccelerated:true
			},
			extras:{
				title:crop.title,
				tipMessage:crop.tipMessage,
				origin:origin
			}
		});
	};
	
	/**
	 * @param {Object} options {
	 * title:标题,	
	 * type:预设类型,
	 * origin:图片来源,	
	 * cropWidth:剪切宽度,
	 * cropHeight:剪切高度,
	 * maxZoom:最大倍数,
	 * minZoom:最小倍数
	 * outType:输出图片类型
	 * }
	 */
	crop.showEx = function(options){
		if(vw) vw.close('none');
		options = options||{}
		var url = '_www/view/crop/crop.html?t='+Date.now();
		if(options.type) url +='&type='+options.type;
		if(options.cropWidth) url +='&width='+options.cropWidth;
		if(options.cropHeight) url +='&height='+options.cropHeight;
		vw = $.openWindow({
			id:'cropBox',
			url:url,
			styles:{
				hardwareAccelerated:true
			},
			extras:options
		});
	};
	crop.addEventListener = function(type, fn, capture){
		 if (typeof _listeners[type] === "undefined") {
            _listeners[type] = [];
        }
        if (typeof fn === "function") {
            _listeners[type].push(fn);
        }
	};
	var fireEvent = function(type,data) {
        var arrayEvent = _listeners[type];
        if (arrayEvent instanceof Array) {
            for (var i=0, length=arrayEvent.length; i<length; i+=1) {
                if (typeof arrayEvent[i] === "function") {
                    arrayEvent[i]({ type: type, detail: data});    
                }
            }
        }
    };
	document.addEventListener('cropComplete',function(event){
		fireEvent('complete',event.detail);
	},false);
	
})(mui,window.crop={})
