(function($){
	var startTime = Date.now();
	var hasNewData = false;
	var saveType = 'IndexDB';//Storage，IndexDB

	var moduleConfig ={
		'300100':{title:'公积金缴存指南'},
		'300200':{title:'公积金提取指南'},
		'300300':{title:'公积金贷款指南'}
	};
	var plugins={
		1:'imgCon/index.js',
		2:'content/index.js',
		3:'chart/index.js',
		4:'medical-2/index.js',
		5:'hospitals/index.js',
		6:'statebar/index.js',
		7:'retPenTrial/index.js',
		8:'reimburse/index.js'
	};
	
	window.config = getConfig();
	loadStyle();
	
	
	function loadStyle(){
		var css = common.utils.queryString('css');
		if(css) g('mainStyle').href = decodeURIComponent(css);
	}
	 
	Object.defineProperty(config, "storageId", {
        get: function () { return config.cityCode + config.modularId+config.perType }
    });
    
	function getConfig(){
		var modularId = common.utils.queryString('mcode')||'100100';
		var fundId = common.utils.queryString('fundid');
		var city = app.getCity()||{cityName:'北京',cityCode:'110000'};
		var module = moduleConfig[modularId];
		var config = {};
		config.user = null;
		config.funInfo = null;
		config.cityCode = city.cityCode;
		config.modularId = modularId;
		config.type = module.statusType;
		config.titleName = module.title;
		config.perType = 1;
		config.storeName='joyData';
		
		if(app.checkLogin()){
			config.user = app.getUser();
			fundId = fundId||config.user.fundAcctId;
			config.funInfo = myStorage.getItem('FunInfo_'+fundId);
			if(config.funInfo) config.cityCode = config.funInfo.payCity;
		}else{
			config.user = null;
			config.funInfo = null;
		}
		//config.storageId = config.cityCode + config.modularId+config.perType;
		
		g('mTitle').innerHTML = config.titleName;
		return config;
	}
	function render(data){
		//4:medical,5:hospitals,6:statebar,7:retPenTrial
		$.each(data, function(i,mo) {
			var sliderItem = createSliderItem(mo);
			var conList = $.isArray(mo.contentList)?mo.contentList:[mo.contentList];
			$.each(conList, function(j,con) {
				var box;
				if(con.type==2){
					box = createEBox(sliderItem.con,con);
					box.innerHTML = con.content;
				}else{
					box = createBlockBox(sliderItem.con,con);
					require(plugins[con.type], function(co) {
						co.show(box,con);
					});
				}
				if(i==data.length-1&&j==conList.length-1){
					console.log('Time:'+(Date.now()-startTime));
					saveData(data);
				}
			});
		});
		
		jel(".mui-slider-item").css("min-height",(document.documentElement.offsetHeight-g("slider").offsetTop-40)+"px");
		$('#sliderGroup .mui-scroll-wrapper').scroll({indicators: true,bounce:false});
		g('sliderCtrl').children[0].classList.add('mui-active');
		g('sliderGroup').children[0].classList.add('mui-active');
		var slider = $('#slider').slider();
		slider.refresh();
        slider.gotoItem(0,0);
		//mui.previewImage();
		function createSliderItem(idata){
			/*<a class="mui-control-item fenlei-item mui-active" href="#item1mobile">贷款条件</a>*/
			/*<div id="item1mobile" class="mui-slider-item mui-control-content mui-active">*/
			var si = document.createElement('a');
			si.className='mui-control-item fenlei-item';
			si.setAttribute('href','#M'+idata.titleId);
			si.innerHTML = idata.titleName
			g('sliderCtrl').appendChild(si);
			var con = document.createElement('div');
			con.className='mui-slider-item mui-control-content';
			con.setAttribute('id','M'+idata.titleId);
			si.setAttribute('version',idata.version);
			con.innerHTML = '<div class="mui-scroll-wrapper">'
				+ '<div class="mui-scroll slider-scroll"></div></div>';
			g('sliderGroup').appendChild(con);
			return {
				ctrl:si,
				con:con.querySelector('.slider-scroll')
			};
		}
		function createEBox(content,mo){
			var box = document.createElement('div');
			box.className='ebox';
			box.setAttribute('type',mo.type);
			box.setAttribute('mtype',mo.mType);
			content.appendChild(box);
			return box;
		}
		function createBlockBox(content,mo){
			var box = document.createElement('div');
			box.className='block';
			box.setAttribute('type',mo.type);
			box.setAttribute('mtype',mo.mType);
			box.innerHTML = [
				'<div class="block-hd',mo.isShow?'':' mui-hidden','">', mo.titleName,'</div>',
				'<div class="block-bd"></div>'
				].join('');
			content.appendChild(box);
			return box.querySelector('.block-bd');
		}
	}
	function getStoreData(data,callback){
		if(!hasNewData) return;
		var storeData = {id:config.storageId,content:data };
		callback(storeData);
	}
	function saveData(data){
		if(saveType=='Storage'){
			$.plusReady(function(){
				getStoreData(data,function(storeData){
					if(storeData) myStorage.setItemPlus(config.storeName+'_'+config.storageId,storeData);
				});
			});
		}else{
			getStoreData(data,function(storeData,storeImgs){
				if(storeData) jdb.saveData(config.storeName, storeData, 'id');
			});
		}
	}
		
	function getOldItem(oldData,titleId){
		for(var i in oldData){
			if(oldData[i].titleId==titleId) 
				return oldData[i];
		}
	}
	function updateData(res,callback){
		var netState = window.plus&&plus.networkinfo.getCurrentType()||myStorage.getItem('NetType');
		var oldData = res&&res.content||{};
		if(netState===1||netState==='EMPTY'){
			if(!res){
				g('content').innerHTML='<div style="text-align:center;padding:45% 0">'
					+'<img style="width:120px; margin-right:15px;opacity: 0.5;" src="../../images/empty.png">'
					+'<p style="margin-top:10px">无网络连接,暂无内容显示</p>'
				+'</div>';
			}else{
				callback(oldData);
			}
		}else{
			var sendMap = {};
			$.each(oldData, function(i, val){
				sendMap[val.titleId] = val.version;
			});
			//, sendMap
			joySvc.getIntelligentList(config.perType,config.cityCode, config.modularId, sendMap).then(function(data){
				var newData = data.map(function(val, i){
					var oldItem = getOldItem(oldData,val.titleId);
					if(!oldItem || val.version!=oldItem.version){
						hasNewData = true;
						return val;	
					}else{
						return oldItem;	
					}
				});
				callback(newData);
			}).catch(function(err){
				callback(oldData);
				console.log(err)
			});
		}
	}
	function getDataFromIndexDB(callback){
		jdb.getData(config.storeName, config.storageId).then(function(res){
			updateData(res,callback)
		}).catch(function(err){
			console.log(err)
		});
	}
	function getDataFromStorage(callback){
		$.plusReady(function(){
			var data = myStorage.getItemPlus(config.storeName+'_'+config.storageId);
			updateData(data,callback);	
		});
	}
	function getData(){
		if(saveType=='Storage'){
			getDataFromStorage(function(data){
				render(data);
			});
		}else{
			getDataFromIndexDB(function(data){
				render(data);
			});
		}
	}
	
	$.init({
		swipeBack:true,
	    gestureConfig:{
	    		doubletap: true
	    }
	});
	$('.mui-scroll-wrapper').scroll({
		bounce:false
	});
 	$.ready(function(){
 		getData(); 
 		
// 		$('#mTitle').on('tap','.xtab span',function(){
// 			config.perType = parseInt(this.getAttribute('type'));
// 			jel('.xtab span').removeClass('active');
// 			jel('.xtab-con').removeClass('active');
// 			jel('#xtab'+config.perType).addClass('active');
// 			this.classList.add('active');
// 			var isRender = jel('#xtab'+config.perType).attr('render');
// 			if(!isRender) getData();
// 		});
 		
		window.addEventListener('refresh_data',function(){
			window.config = getConfig();
			console.log('window.config:',window.config);
		},false);
 	});
 	
})(mui);
