(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.hospitals = factory();
    }
}(function(){
 	var bar = {};
	function setData(data){
		var index = 0;
		var hospitals = [];
		mui.each(data,function (i,hos) {
			if(hos.hospital){
				hos.index = ++index;
				hospitals.push(hos);
			}
		});
		var hospitalPan = g('hospitals');
		jscope.bind(hospitalPan,{hospitals:hospitals});
		mui('#hospitals .yiyuan .info[index]').each(function () {
			var index = this.getAttribute('index');
			this.style.width = (this.offsetWidth + index * 20) + 'px';
		});
	}
 	function getData(sbkid){
 		var storeName = 'hospitalList';
 		jdb.getData(storeName,sbkid).then(function(data){
			if(data) setData(data.list);
		}).catch(function(err){
			console.log(err);
		});
		setTimeout(function(){
			joySvc.getSecHosList(sbkid).then(function(data){
				setData(data);
				jdb.saveData(storeName,{id:sbkid,list:data},'id');
			}).catch(function(err){
				console.error(err.message,err);
			});
		},50);
 	}
	 
	function initUI(){
		var templateUrl = 'hospitals/tpl.html';
		mui.ajax(templateUrl,{
			dataType:'html',
			async:true,           
			success:function(html){
				bar.box.innerHTML = html;
				setState(); 
			}
		});
	}
	
	function setState(){
		var user = config.user;
		// 为了兼容UI的调整
		var oBox = g('hosList').parentNode.parentNode;
		if(user && user.securityAcctId){
			oBox.classList.remove('mui-hidden');
			getData(user.securityAcctId);
		}else{
			oBox.classList.add('mui-hidden');
		} 
	}
	function loadStyles(){
		var styles =['hospitals/css.css'];
		createStyles(styles);
	}
	function formatData(data){
		try{
			data = data.content||'{}';
			return JSON.parse(data);
		}finally{
			return {}
		}
	}
	
	bar.name='hospitals';
	bar.setState = setState;
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
	};
	//loadStyles();
	window.addEventListener('refresh_data',function(){
		bar.setState();
	},false);
	
	return bar;
}));
	