(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.imgCon = factory();
    }
}(function(){
 	var bar = {};
	
	function initUI(){
		bar.box.innerHTML = bar.data;
	}
	function formatData(data){
		var attrs = isEmpty(data.content) ? 'data-preview-src="" data-preview-group="1"' : '';
		return '<img ' + attrs +' alt="'+data.contextRemarks+'" src="'+data.url+'">';
	}
	function isEmpty(str){
		var emptyRE = /\S/;
		return !emptyRE.test(str);
	}
	bar.name='imgCon';
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
		bar.box.addEventListener('tap', function(){
			if (isEmpty(data.content)) return;
			app.openUrl(data.content);
		})
	};
	
	return bar;
}));
	