(function($){
	var startTime = Date.now();
	var hasNewData = false;
	var saveType = 'IndexDB';//Storage，IndexDB
	//YLId:"01", SYId:"02", MCId:"03", GSId:"04", BirthId:"05"
	/* 01：养老 02：失业  03：医疗 04：工伤 05：生育  */
	var moduleConfig ={
		'100100':{statusType:'01',title:'医疗保险',juming:true},
		'100200':{statusType:'05',title:'生育保险',juming:false},
		'100300':{statusType:'',title:'工伤保险',juming:false},
		'100400':{statusType:'01',title:'养老保险',juming:true},
		'100500':{statusType:'02',title:'失业保险',juming:false},
		'200100':{statusType:'',title:'工作居住证',juming:false},
		'200200':{statusType:'02',title:'买房',juming:false},
		'200300':{statusType:'01',title:'买车',juming:false},
		'200400':{statusType:'01',title:'子女上学',juming:false},
	};
	var plugins={
		1:'imgCon/index.js',
		2:'content/index.js',
		3:'chart/index.js',
		4:'medical-2/index.js',
		5:'hospitals/index.js',
		6:'statebar/index.js',
		7:'retPenTrial/index.js',
		8:'reimburse/index.js',
		9:'insurance/index.js',
		10:'reimburse-2/index.js' // 新报销规则页面
	};
	
	window.config = getConfig();
	loadStyle();
	
	
	function loadStyle(){
		var css = common.utils.queryString('css');
		if(css) g('mainStyle').href = decodeURIComponent(css);
	}
	Object.defineProperty(config, "storageId", {
        get: function () { return config.cityCode + config.modularId+config.perType }
    });
	function getConfig(){
		var modularId = common.utils.queryString('mcode')||'100100';
		var cityCode = common.utils.queryString('cityCode');
		var city = cityCode ? {cityCode:cityCode} : {cityName:'北京',cityCode:'110000'};
		var module = moduleConfig[modularId];
		var config = {};
		config.user = null;
		config.secInfo = null;
		config.cityCode = city.cityCode;
		config.modularId = modularId;
		config.type = module.statusType;
		config.titleName = module.title;
		config.perType = 1;
		config.storeName='joyData';
		// 又根据需求恢复 未绑卡用户显示为全国 zhanglianghua by 2019-10-22 begin
		if(modularId=='100400'){
			//未绑卡用户 养老保险显示内容为全国配置
			config.cityCode='000000';
		}
		// zhanglianghua by 2019-10-22 end
		if(app.checkLogin()){
			config.user = app.getUser();
			config.secInfo = myStorage.getItem('SecInfo_'+config.user.securityAcctId);
			if(config.secInfo && config.secInfo.payCity) 
			config.cityCode = config.secInfo.payCity;
		}else{
			config.user = null;
			config.secInfo = null;
		}
		config.storageId = config.cityCode + config.modularId + config.perType;
		
		if(!module.juming){
			g('mTitle').innerHTML = config.titleName;
		} else{
			// 登录之后显示计算器
			if(module.title === '养老保险'){
				var el = mui('.xtab')[0].querySelector('.active'),
					type = el ? el.getAttribute('type') : '',
					act_left = "",
					act_right = "";
				if(type == '2'){
					act_right = "active";
				}else {
					act_left = "active";
				}
				g('mTitle').innerHTML = '<div class="xtab" id="pension"><span class="' + act_left + '" type="1">养老保险</span><span class="' + act_right + '" type="2">养老金计算</span></div>';
			}
		}
		return config;
	}
	function render(data){
		mui.hideLoading();
		//4:medical,5:hospitals,6:statebar,7:retPenTrial
		var perType = '';
		$.each(data, function(i,mo) {
			perType = mo.perType ? mo.perType : config.perType;
		});
		var content = g('xtab'+perType);
		var conbox = content.querySelector('.xtab-con');
		conbox.innerHTML = '';
		$.each(data, function(i,mo) {
			var block = createTitleBox(conbox,mo);
			var conList = $.isArray(mo.contentList)?mo.contentList:[mo.contentList];
			$.each(conList, function(j,con) {
				var box = createConBox(block,con);
				// 新报销页面，数据 content 里面有特殊数据
				if (con.type == 8 && con.content) {
					con.type = 10;
				}
				require(plugins[con.type], function(co) {
					co.show(box,con);
				});
			});
		});
		saveData(data);
		content.setAttribute('render','1');
		mui.previewImage();
		function createConBox(content,con){
			var box = document.createElement('div');
			box.className='con-type';
			box.setAttribute('con-type',con.type);
			box.setAttribute('content',con.content);
			content.querySelector('.block-bd').appendChild(box);
			return box;
		}
		// 标题
		function createTitleBox(content,mo){
			var box = document.createElement('div');
			box.id = mo.titleId;
			box.className='block';
			box.setAttribute('version',mo.version);
			box.innerHTML = [
				'<div class="block-hd',mo.isShow?'':' mui-hidden','">', '<h2><span>', mo.titleName,'</span></h2></div>',
				'<div class="block-bd"></div>'
				].join('');
			content.appendChild(box);
			return box;
		}
	}
	function getStoreData(data,callback){
		if(!hasNewData) return;
		var storeData = {id:config.storageId,content:data };
		callback(storeData);
	}
	function saveData(data){
		if(saveType=='Storage'){
			$.plusReady(function(){
				getStoreData(data,function(storeData){
					if(storeData) myStorage.setItemPlus(config.storeName+'_'+config.storageId,storeData);
				});
			});
		}else{
			getStoreData(data,function(storeData,storeImgs){
				if(storeData) jdb.saveData(config.storeName, storeData, 'id');
			});
		}
	}
		
	function getOldItem(oldData,titleId){
		for(var i in oldData){
			if(oldData[i].titleId==titleId) 
				return oldData[i];
		}
	}
	function updateData(res,callback){
		$.showLoading('加载中...', 'div');
		var netState = window.plus&&plus.networkinfo.getCurrentType()||myStorage.getItem('NetType');
		var oldData = res&&res.content||{};
		if(netState===1||netState==='EMPTY'){
			if(!res){
				g('content').innerHTML='<div style="text-align:center;padding:45% 0">'
					+'<img style="width:120px; margin-right:15px;opacity: 0.5;" src="../../images/empty.png">'
					+'<p style="margin-top:10px">无网络连接,暂无内容显示</p>'
				+'</div>';
			}else{
				callback(oldData);
			}
		}else{
			var sendMap = {};
			$.each(oldData, function(i, val){
				sendMap[val.titleId] = val.version;
			});
			
			//, sendMap
			joySvc.getIntelligentList(config.perType,config.cityCode, config.modularId, sendMap).then(function(data){
				var newData = data.map(function(val, i){
					var oldItem = getOldItem(oldData,val.titleId);
					if(!oldItem || val.version!=oldItem.version){
						hasNewData = true;
						return val;	
					}else{
						return oldItem;	
					}
				});
				callback(newData);
			}).catch(function(err){
				callback(oldData);
				console.log(err)
			});
		}
	}
	function getDataFromIndexDB(callback){
		jdb.getData(config.storeName, config.storageId).then(function(res){
			updateData(res,callback)
		}).catch(function(err){
			console.log(err)
		});
	}
	function getDataFromStorage(callback){
		$.plusReady(function(){
			var data = myStorage.getItemPlus(config.storeName+'_'+config.storageId);
			updateData(data,callback);	
		});
	}
	function getData(){
		if(saveType=='Storage'){
			getDataFromStorage(function(data){
				render(data);
			});
		}else{
			getDataFromIndexDB(function(data){
				render(data);
			});
		}
	}
	
	$.init({
		swipeBack:false,
	    gestureConfig:{
	    		doubletap: true
	    }
	});
	$('.mui-scroll-wrapper').scroll({
		bounce:false
	});
	var oldBack = mui.back;
 	$.ready(function(){
		$.showLoading('加载中...', 'div');
 		getData(); 
 		jel('.xtab-item').css('top',imbar.navBarHeight+'px');
 		$('#mTitle').on('tap','.xtab span',function(){
 			config.perType = parseInt(this.getAttribute('type'));
 			jel('.xtab span').removeClass('active');
 			jel('.xtab-item').removeClass('active');
 			jel('#xtab'+config.perType).addClass('active');
 			this.classList.add('active');
 			var isRender = jel('#xtab'+config.perType).attr('render');
 			if(!isRender) getData();
 		});
 		
		window.addEventListener('refresh_data',function(){
			window.config = getConfig();
			getData();
			mui.back = function(){
				var opener = plus.webview.currentWebview().opener();
				oldBack();
				opener.fire('refresh_data');
			}
		},false);
 	});
 	
})(mui);
