(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.medical = factory();
    }
}(function(){
	var cityCode = '';
 	var bar = {};
 	var insObj = null;
 	// 信息
 	insObj = {
 		"trial_sqgz": {
 			title: '当年养老金基数-税前工资:',
 			content: '养老金基数和退休后的养老金高低有着直接关系，养老金基数越高，每月缴纳的养老保险费用就越高，将来的养老金就越高。',
 			video_title: '当前养老金基数是什么?',
 			inquiry: '养老金基数查询'
 		},
 		"trial_gznx": {
 			title: '96年前工作年限:',
 			content: '96年以前的养老保险统计年限叫做视同工龄只有档案认可的工作年限才被认作视同工龄，视同工龄年限越高，退休后的养老金就越多。',
 			video_title: '96年前工作年限是什么?',
 		},
 		"trial_jnys": {
 			title: '养老保险缴纳月数:',
 			content: '在您退休前养老保险缴纳月数越多，您将来退休时养老金就会越多，每多缴纳一年养老保险您退休时养老金将会增长2-5%。',
 			video_title: '养老保险缴纳月数是什么?',
 			inquiry: '养老保险缴纳月数查询'
 		},
 		"trial_ylbx": {
 			title: '个人养老保险账户金额:',
 			content: '您缴纳每个月的养老保险都会有20-40%进入您的个人养老保险账户，在您退休时，养老保险账户钱越多，您将来的养老金就越多。',
 			video_title: '个人养老保险账户是什么?',
 			inquiry: '个人养老保险账户金额查询'
 		}
 	}
	function initUI(){
		var templateUrl = 'insurance/tpl.html?a='+Math.random(0,100);
		mui.ajax(templateUrl,{
			dataType:'html',
			async:true,
			success:function(html){
				bar.box.innerHTML = html;
				mui('.mui-scroll-wrapper').scroll({
					bounce: false,
					indicators: false,
					deceleration: mui.os.ios ? 0.003 : 0.0009
				});
				document.body.appendChild(g('participantsBox'));
				// 获取社保人信息
				getsecurityinfo();
				// 获取 是否能查看视频
				getPensionInfo();
				// 选择城市
				g('pick-city').addEventListener('tap',function(){
					mui.openWindow('../pick-city.html?workType=0');
				},false)
				var currentDate = new Date(),
					year = currentDate.getFullYear(),
					month = currentDate.getMonth(),
					currentDay = currentDate.getDate(),
					beginDate = year - 60;
				// 选择出生日期
				g('pick-date').addEventListener('tap',function(){
					mui(".mui-table-view-cell").each(function() {
						this.classList.remove('err_tips')
					});
					mui("input.mui-input-clear").each(function() {
						this.blur();
					});
					setTimeout(function(){
						mui('#tipsbox')[0].classList.remove('mui-hidden');
					},400)
					var dtPicker = new mui.DtPicker({type:'date',labels:['年','月','日'],beginDate: new Date(beginDate,month),endDate: new Date(year,month,currentDay)}); 
				    dtPicker.show(function (selectItems) {
				        g('date-info').innerHTML = selectItems.value;
				    })
				    mui('.mui-backdrop')[0].addEventListener('tap',function(){
						setTimeout(prohibitInp,400)
						dtPicker.dispose(); //释放
					},false)
				    mui("body").on("tap",".mui-dtpicker-header > button",function(){
						setTimeout(prohibitInp,400)
						dtPicker.dispose(); //释放
					});
				},false)
				mui("input.mui-input-clear").each(function(){
					var el = this;
					el.addEventListener('focus',function(){
						var parent = el.parentElement.parentElement.parentElement;
						parent.classList.remove('err_tips')
					},false)
				})
				
				//选择城市监听
				window.addEventListener('changeCity', changeCity ,false);
				
				// 信息详情
				mui('.insurance').on('tap','li .doubt',function(e){
					e.stopPropagation();
					mui("input.mui-input-clear").each(function() {
						this.blur();
					});
					var type = this.parentElement.getAttribute('data-type'),
						aid = this.getAttribute('aid');
					var data = insObj[type];
					g('pension-info').querySelector('.title').innerHTML = data.title;
					g('pension-info').querySelector('.pension-cont').innerHTML = data.content;
					g('pension-info').querySelector('.pension-box').innerHTML = data.video_title;
					g('pension-info').querySelector('.pension-inquiry').classList[!!data.inquiry ? 'remove' : 'add']('mui-hidden');
					g('pension-info').querySelector('.pension-inquiry').innerHTML = !!data.inquiry ? data.inquiry : '';
					g('pension-info').querySelector('.pension-video').setAttribute('aid',aid);
					mui('#participantsBox')[0].classList.remove('mui-hidden');
					mui('#tipsbox')[0].classList.remove('mui-hidden');
				})
				// 关闭详情弹框
				g('closeBtn').addEventListener('tap',function(){
					mui('#participantsBox')[0].classList.add('mui-hidden');
					setTimeout(prohibitInp,400)
				},false)
				g('participantsBox').addEventListener('tap',function(e){
					if(e.target.id !== 'participantsBox') return false;
					mui('#participantsBox')[0].classList.add('mui-hidden');
					setTimeout(prohibitInp,400)
				},false)
				// 查看视频讲解
				mui('#pension-info .pension-video')[0].addEventListener('tap',function(){
					var id = this.getAttribute('aid');
					mui.openWindow({url:"../article-video.html?aid=" + id,id:"article-video"})
				},false);
				// 查询
				mui('#pension-info .pension-inquiry')[0].addEventListener('tap',function(){
					// 没绑卡-绑卡页面  绑卡-卡片详情  多张卡-默认卡
					if(!app.checkLogin()){
						app.toLogin();
						return;
					}
					var user = app.getUser();
					var secId = user.securityAcctId,pageId = '';
					if(secId){
						// 绑卡
						mui.openWindow({url:'_www/view/sbk-info.html?id='+user.securityAcctId,id:"sbkinfo"+Math.random(0,20).toFixed(2)});
					}else {
						// 未绑卡
						app.showSheBaoAdd();
					}
				},false);
				// 计算结果
				g('computedResult').addEventListener('tap',function(){
					var checked = calcuCheck();
					if(checked){
						mui.plusReady(function(){
							calculation();
						})
					}
				},false)
				// 更新数据
				window.addEventListener('refresh_data',function(){
					getsecurityinfo();
				})
				// 监听键盘
				var clientH = window.innerHeight;
    				window.onresize = function(){
    					if(mui.os.android){
    						if(clientH === window.innerHeight){
    							var inputNum = mui('input.mui-input-clear');
    							mui.each(inputNum,function(idx,val){
    								val.blur();
    							})
    						}
    					}
    				}
			}
		});
	}
	function formatData(data){
		try{
			data = data.content||'{}';
			return JSON.parse(data);
		}finally{
			return {};
		}
	}
	bar.name='insurance';
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
	};
	function dynamicLoadCss(url) {
        var head = document.getElementsByTagName('head')[0];
        var link = document.createElement('link');
        link.type='text/css';
        link.rel = 'stylesheet';
        link.href = url;
        head.appendChild(link);
    }
	var styles ='insurance/css.css?a='+Math.random(0,100);
	dynamicLoadCss(styles);
	// 切换城市
	var changeCity = function(e){
		if(e.detail){
			// 设置城市
			g('cityName').innerHTML = e.detail.cityName;
			g('cityName').setAttribute('citycode',e.detail.cityCode);
			cityCode = e.detail.cityCode;
		}
	}
	// 获取社保人信息
	var getsecurityinfo = function(){
		var city = app.getCity() || {cityName: "北京", cityCode: "110000"};
		if(app.checkLogin()){
			// 登录
			var user = app.getUser();
			var secId = user.securityAcctId;
			if(secId){
				mui('#participantsBox')[0].classList.add('mui-hidden');
				prohibitInp();
				joySvc.getPensionCalculationParram(secId).then(function(res){
					if(res && !mui.isEmptyObject(res)){
						if(res.sex) mui('input.sex-check[data-type="'+ res.sex +'"]')[0].setAttribute('checked','checked');
						mui('span.select-box[data-param="cityName"]')[0].innerHTML = res.cityName ? res.cityName : '北京';
						mui('span.select-box[data-param="cityName"]')[0].setAttribute('cityCode',res.cityCode ? res.cityCode : '110000');
						mui('span.select-box[data-param="birthday"]')[0].innerHTML = res.birthday ? res.birthday : '请选择';
						//mui('input.mui-input-clear[data-param="wageGrowth"]')[0].value = res.wageGrowth || res.wageGrowth == 0 ? res.wageGrowth : '';
						mui('input.mui-input-clear[data-param="pensionRadix"]')[0].value = res.pensionRadix || res.pensionRadix == 0 ? res.pensionRadix : '';
						//mui('input.mui-input-clear[data-param="oldWorkLongerd"]')[0].value = res.oldWorkLongerd || res.oldWorkLongerd == 0 ? res.oldWorkLongerd : '';
						mui('input.mui-input-clear[data-param="payMonths"]')[0].value = res.payMonths || res.payMonths == 0 ? res.payMonths : '';
						//mui('input.mui-input-clear[data-param="furPayYears"]')[0].value = res.furPayYears || res.furPayYears == 0 ? res.furPayYears : '';
						mui('input.mui-input-clear[data-param="accountAmount"]')[0].value = res.accountAmount || res.accountAmount == 0 ? res.accountAmount : '';
					}
				}).catch(function(err){
					
				})
			}else {
				mui('span.select-box[data-param="cityName"]')[0].innerHTML = city.cityName ? city.cityName : '北京';
				mui('span.select-box[data-param="cityName"]')[0].setAttribute('cityCode',city.cityCode ? city.cityCode : '110000');
			}
		}else {
			mui('span.select-box[data-param="cityName"]')[0].innerHTML = city.cityName ? city.cityName : '北京';
			mui('span.select-box[data-param="cityName"]')[0].setAttribute('cityCode',city.cityCode ? city.cityCode : '110000');
		}
	}
	var getPensionInfo = function(){
		var cityCode = g('cityName').getAttribute('citycode') || '110000';
		joySvc.getNounsExplanation(cityCode).then(function(res){
			if(res){
				var pensionInfo = document.querySelectorAll('.mui-pull-left');
				mui.each(res,function(idx,val){
					mui.each(pensionInfo,function(index,value){
						var data_type = value.getAttribute('data-type');
						if(data_type !== '' && data_type == idx){
							value.querySelector('span.doubt').classList.remove('mui-hidden');
							value.querySelector('span.doubt').setAttribute('aid',val);
							return false;
						}
					})
				})
			}
		},function(err){
			console.log(err);
		})
	}
	// 校验数据
	var calcuCheck = function(){
		var inputText = mui('input.mui-input-clear');
		var check = true;
		var reg = /^\d{4}-\d{2}-\d{2}$/g;
		if(reg.test(g('date-info').innerHTML)){
			mui("input.mui-input-clear").each(function() {
				var type = this.getAttribute('data-type'),
					tips = this.getAttribute('data-name'),
					parentNode = this.parentElement.parentElement.parentElement;
				//若当前input为空，则alert提醒 
				if(!this.value || this.value.trim() == "") {
				    mui.toast(tips + "格式错误");
				    parentNode.classList.add('err_tips');
				    check = false;
				    return false;
				}
			});
			if(check){
				mui("input.mui-input-clear").each(function() {
					var type = this.getAttribute('data-type'),
						tips = this.getAttribute('data-name'),
						parentNode = this.parentElement.parentElement.parentElement;
					if(type == 'base'){
						// 基数 小数点2位
						var reg = /^(\-)?(\d+)(\.\d\d?)?$/;
						if(!reg.test(this.value)){
							mui.toast(tips + "最多只能输入小数点后两位");
							parentNode.classList.add('err_tips');
						    check = false;
						    return false;
						}
					}else if(type == 'year'){
						// 年限 小数点1位
						var reg = /^(\-)?(\d+)(\.\d)?$/;
						if(!reg.test(this.value)){
							mui.toast(tips + "最多只能输入小数点后一位");
							parentNode.classList.add('err_tips');
						    check = false;
						    return false;
						}
					}else {
						// 月数 整数
						var reg = /^\d+$/;
						if(!reg.test(this.value)){
							mui.toast(tips + "只能输入整数");
							parentNode.classList.add('err_tips');
						    check = false;
						    return false;
						}
					}
				});
			}
		}else {
			var parentNode = g('date-info').parentElement.parentElement.parentElement;
			mui.toast("出生日期不允许为空");
			parentNode.classList.add('err_tips');
		    check = false;
		}
		
		return check;
	}
	// 获取计算结果
	var calculation = function(){
		var calculationBol = true;
		if(!calculationBol){
			return false;
		}
		var wait = plus.nativeUI.showWaiting();
		var userInfo = app.getUser() || {},
			cityCode = g('cityName').getAttribute('citycode') || '110000',
			sex = getRadioRes('sex-check'),
			birthday = g('date-info').innerHTML,
			wageGrowth = parseFloat(mui('input[data-param="wageGrowth"]')[0].value),
			pensionRadix = parseFloat(mui('input[data-param="pensionRadix"]')[0].value),
			oldWorkLonger = parseFloat(mui('input[data-param="oldWorkLongerd"]')[0].value),
			payMonths = parseFloat(mui('input[data-param="payMonths"]')[0].value),
			furPayYears = parseFloat(mui('input[data-param="furPayYears"]')[0].value),
			accountAmount = parseFloat(mui('input[data-param="accountAmount"]')[0].value);
		var data = {
			cityCode: cityCode,
			sex: sex,
			birthday: birthday,
			wageGrowth: wageGrowth, //上年工资涨幅
			pensionRadix: pensionRadix, //当年养老金基数
			oldWorkLonger: oldWorkLonger, //96年前工作年限
			payMonths: payMonths, //养老金缴纳月数
			furPayYears: furPayYears, //预计未来保险缴纳年限
			accountAmount: accountAmount, //个人养老账户金额
			type: 2,
			securityAcctId: userInfo.securityAcctId || '',
			userId: userInfo.userId || ''
		}
		calculationBol = false;
		joySvc.getPensionCalculation(data).then(function(res){
			calculationBol = true;
			if(res){
				wait.close();
				var furRetireYear = res.furRetireYear ? res.furRetireYear : 0, //距离退休的年龄
					furPayYears = res.furPayYears ? res.furPayYears : 0, // 已经缴纳养老金年数
					retirePension = res.retirePension ? res.retirePension : 0; // 退休时工资
				mui.openWindow({url:'insurance/calculation.html?cityCode=' + cityCode + '&furRetireYear=' + furRetireYear + '&furPayYears='+ furPayYears +'&retirePension='+ retirePension +'&a='+Math.random(0,100), id:'calculation'+Math.random(0,20).toFixed(2)})
			}
		}).catch(function(err){
			wait.close();
			mui.toast(err.message);
		})
	}
	// 输入框禁止选中
	function prohibitInp(){
		mui('#tipsbox')[0].classList.add('mui-hidden');
	}
	// 获取性别
	function getRadioRes(className) {
		var rdsObj = document.getElementsByClassName(className);
		var chackVal = null;
		for(i = 0; i < rdsObj.length; i++) {
			if (rdsObj[i].checked) {
				chackVal = parseInt(rdsObj[i].getAttribute('data-type'));
			}
		}
		return chackVal;
	}
    
	return bar;
}));