(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.medical = factory();
    }
}(function(){
 	var bar = {};
	function setData(sbkid,data){
		if(isNaN(data.expPercent)){
			jel('.itxt-none').removeClass('mui-hidden');
			jel('.itxt-up').addClass('mui-hidden');
			jel('.itxt-down').addClass('mui-hidden');
		}else{
			jel('.itxt-none').addClass('mui-hidden');
			jel('.itxt-up').removeClass('mui-hidden');
			jel('.itxt-down').removeClass('mui-hidden');
			var per = data.expPercent;
			if(per>0.5){
				jel('.section:nth-child(1) .cover').css('-webkit-transform','rotate(180deg)');
				jel('.section:nth-child(1) .cover').css('transform','rotate(180degdeg)');
				jel('.section:nth-child(2) .cover').css('-webkit-transform','rotate('+(per*360-180)+'deg)');
				jel('.section:nth-child(2) .cover').css('transform','rotate('+(per*360-180)+'deg)');
			}else{
				jel('.section:nth-child(1) .cover').css('-webkit-transform','rotate('+(per*360)+'deg)');
				jel('.section:nth-child(1) .cover').css('transform','rotate('+(per*360)+'deg)');
			}
			var countup = new CountUp("expPercent", 0, per*100, 0, 1).start();
			g('payTotal').innerText='医疗费用  ¥'+data.payTotal;
			g('medExpense').innerHTML='报销费用  ¥'+data.medExpense;
		}
	}
 	function getData(sbkid){
 		var storeName = 'medical';
 		jdb.getData(storeName,sbkid).then(function(data){
 			if (!data) return;
			setData(sbkid,data);
		}).catch(function(err){
			console.error(err.message,err);
		});
		setTimeout(function(){
			joySvc.getMedicalExpense(sbkid).then(function(data){
				setData(sbkid,data);
				data.id = sbkid;
				jdb.saveData(storeName,data,'id');
			}).catch(function(err){
				console.error(err.message,err);
			});
		},50);
 	}
	function initPie(){
		var num1 = 88;
		for(var i=0;i<num1/2;i++){
			var li = document.createElement('li');
			li.style.webkitTransform='rotate('+(i*360/num1)+'deg)';
			li.style.transform='rotate('+(i*360/num1)+'deg)';
			g('markb').appendChild(li);
		}
		var num2 = 24;
		for(var i=0;i<num2/2;i++){
			var li = document.createElement('li');
			li.style.webkitTransform='rotate('+(i*360/num2)+'deg)';
			li.style.transform='rotate('+(i*360/num2)+'deg)';
			g('marks').appendChild(li);
		}
	}
	function initUI(){
		var templateUrl = 'medical/tpl.html';
		mui.ajax(templateUrl,{
			dataType:'html',
			async:true,           
			success:function(html){
				bar.box.innerHTML = html;
				setState();
				setTimeout(function(){
					initPie();
				},10);
				
				g('tbar').addEventListener('tap', function() {
					mui.openWindow({url:'_www/view/insurances.html'});
				});
				g('bbar').addEventListener('tap', function() {
					if(app.checkLogin()){
						app.showSheBaoAdd();
					}else{
						app.toLogin();
					}
				});
				g('detail').addEventListener('tap', function() {
					var secInfo = config.secInfo;
					if(secInfo && secInfo.barPayType!==0){
						app.showSheBaoInfo(secInfo.id,{"showTab":3});
					}else{
						mui.alert('您参保的城市暂未开通');
					}
				});
				g('analyze').addEventListener('tap', function() {
					mui.openWindow({url:'medical/yiliao-analyze.html', id:'yiliao-analyze'});
				});
			}
		});
	}
	function setState(){
		var user = config.user;
		if(user && user.securityAcctId){
			g('bbar').classList.add('mui-hidden');
			g('chart').classList.remove('mui-hidden');
			g('tbar').classList.remove('mui-hidden');
			getData(user.securityAcctId);
		}else{
			g('bbar').classList.remove('mui-hidden');
			g('chart').classList.add('mui-hidden');
			g('tbar').classList.add('mui-hidden');
		} 
	}
	function loadStyles(){
		var styles =['medical/css.css'];
		createStyles(styles);
	}
	function formatData(data){
		try{
			data = data.content||'{}';
			return JSON.parse(data);
		}finally{
			return {};
		}
	}
	
	bar.name='medical';
	bar.setState = setState;
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
		
	};
	//loadStyles();
	window.addEventListener('refresh_data',function(){
		bar.setState();
	},false);
		
	return bar;
}));
	