(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.medical = factory();
    }
}(function(){
 	var bar = {};
	function setData(data){
		var mzbx = bar.box.querySelector('.mzbx .num pre');
		var zybx = bar.box.querySelector('.zybx .num pre');
		mzbx.innerHTML = data.expenseMaxMz;
		zybx.innerHTML = data.expenseMaxZy;
	}
 	function getData(){
 		var storeName = 'reimburse';
 		jdb.getData(storeName,config.cityCode).then(function(data){
 			if (!data) return;
			setData(data);
		}).catch(function(err){
			console.error(err.message,err);
		});
 		setTimeout(function(){
			joySvc.getMedicExpense(config.cityCode,config.perType).then(function(data){
				setData(data);
				data.cityType = config.cityCode+config.perType;
				jdb.saveData(storeName,data,'cityType');
			}).catch(function(err){
				console.error(err.message,err);
			});
		},50);
 	}
 
	function initUI(){
		var templateUrl = 'reimburse/tpl.html';
		mui.ajax(templateUrl,{
			dataType:'html',
			async:true,           
			success:function(html){
				bar.box.innerHTML = html;
				mui(bar.box).on('tap','.lkbox a',function(){
					mui.openWindow(this.getAttribute('href'));
				});
			    getData();
			}
		});
	}

	function loadStyles(){
		var styles =['reimburse/css.css'];
		createStyles(styles);
	}
	function formatData(data){
		try{
			data = data.content||'{}';
			return JSON.parse(data);
		}finally{
			return {};
		}
	}
	
	bar.name='reimburse';
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
	};
	//loadStyles();
		
	return bar;
}));
	