(function (factory) {
    if (typeof exports === 'object') {
        // Node/CommonJS
        module.exports = factory();
    } else if (typeof define === 'function' && define.amd) {
        // AMD 
        define(factory);
    } else {
        // Browser globals (with support for web workers)
        var glob;
        try {
            glob = window;
        } catch (e) {
            glob = self;
        }
        glob.retPenTrial = factory();
    }
}(function(){
	var bar = {};
 	function formser(form) {
 		var form = document.getElementById(form);
 		var arr = {};
 		for(var i = 0; i < form.elements.length; i++) {
 			var feled = form.elements[i];
 			switch(feled.type) {
 				case undefined:
 				case 'button':
 				case 'file':
 				case 'reset':
 				case 'submit': break;
 				case 'checkbox':
 				case 'radio':
 					if(!feled.checked) {
 						break;
 					}
 				default:
 					if(arr[feled.name]) {
 						arr[feled.name] = arr[feled.name] + ',' + feled.value;
 					} else {
 						arr[feled.name] = feled.value;
 					}
 			}
 		}
 		return arr;
 	}
 	function setData(sbkid,data){
	    bar.addressPan.innerHTML=data.cityName; //城市
		bar.dayPan.innerHTML=data.furRetireDays+'天'; //距退休天数
		bar.chaPan.innerHTML=data.to15RetireYear+'年'; //距15年养老金差的年限
		bar.salaryPan.innerHTML=data.realAvgSocialWage+'元'; //预计退休时月平均工资
		bar.yljinPan.innerHTML='<em>' + data.retirePension+'</em>元'; // 预计退休后，每月可领养老金
        bar.hblPan.innerHTML='<em>' + data.retirePensionPer+'</em>%'; // 投资回报率
	}
 	function calculate(sbkid,saveData){
 		var storeName = 'retPenTrial';
 		var userId = config.user.userId,
 			type = 1,
 			sex = saveData ? (parseInt(saveData.sex) - 1) : null,
 			oldWorkLonger = saveData ? saveData.interestPayYears : 0;
 		joySvc.newGetPension(userId,sbkid,type,oldWorkLonger,sex).then(function(data){
			setData(sbkid,data);
			jdb.saveData(storeName,data,'securityAcctId');
		}).catch(function(err){
			console.error(err.message,err);
		});
 	}
 	function getData(sbkid){
 		var storeName = 'retPenTrial';
 		jdb.getData(storeName,sbkid).then(function(data){
			if(data) setData(sbkid,data);
		}).catch(function(err){
			console.error(err.message,err);
		});
		setTimeout(function(){
			calculate(sbkid);
		},50);
 	}
	function savcBcInfo(sbkid){
		var saveData = formser('recalculate');
		if(!/\d*/.test(saveData.interestPayYears)){
			return mui.alert('工龄格式错误！');
		}
		saveData.securityAcctId = sbkid;
		saveData.specialJobType = '0';
		joySvc.saveRetireInfo(saveData).then(function(data){
			 mui.alert('保存成功，马上重新计算！',function(){
			 	jdb.saveData('retireInfoState',{
			 		isHave:1,
			 		securityAcctId:sbkid
			 	},'securityAcctId');
			 	calculate(sbkid,saveData);
			 },'div');
		}).catch(function(err){
			console.error(err.message,err);
		});
	}
	function hasRetireInfo(sbkid){
		var storeName = 'retireInfoState';
 		jdb.getData(storeName,sbkid).then(function(data){
 			var retireBox = bar.box.querySelector('.fill-box');
			if(!data){
				joySvc.isHaveRetireInfo(sbkid).then(function(data){
					if(data.isHave==0){
						mui('#ylbcBox').popover('show');
					}
					jdb.saveData(storeName,data,'securityAcctId');
				}).catch(function(err){
					console.error(err.message,err);
				});
			}
		}).catch(function(err){
			console.error(err.message,err);
		});
	}
	
	function initUI(){
		var templateUrl = 'retPenTrial/tpl.html';
		mui.ajax(templateUrl,{
			dataType:'html',
			async:true,           
			success:function(html){
				bar.box.innerHTML = html;
				bar.addressPan = bar.box.querySelector('.data-city');
				bar.dayPan = bar.box.querySelector('.data-days');
				bar.chaPan = bar.box.querySelector('.data-years');
				bar.salaryPan = bar.box.querySelector('.data-wage');
			    bar.yljinPan = bar.box.querySelector('.data-estimate');
			    bar.hblPan = bar.box.querySelector('.data-payback'); 
			    
			    document.body.appendChild(g('ylbcBox'));
			    setState();
			    
			    mui('.pension').on('tap', '.add-btn', function(){
					mui('#ylbcBox').popover('show');
				});
				
				mui('.pension').on('change', '.sex input', function(){
					bar.box.querySelector('.pension')
						.querySelector('.ldda')
						.classList[this.value=='2'?'remove':'add']('mui-hidden');
				});
				mui('.bubble-box').on('tap','.estimate',function(){
					this.classList.remove('zoom');
					document.querySelector('.payback').classList.remove('zoom');
				});
				mui('.bubble-box').on('tap','.payback',function(){
					this.classList.add('zoom');
					document.querySelector('.estimate').classList.add('zoom');
				});
				
				
				g('saveBcBtn').addEventListener('tap', function(){
					savcBcInfo(parseInt(config.user.securityAcctId));
				},false);
				
			}
		});
	}
	function setState(){
		var user = config.user;
		if(user && user.securityAcctId){
			bar.box.querySelector('.pension').classList.remove('mui-hidden');
			hasRetireInfo(user.securityAcctId);
			getData(user.securityAcctId);
		}else{
			bar.box.querySelector('.pension').classList.add('mui-hidden');
		} 
	}
	
	function loadStyles(){
		var styles =['retPenTrial/css.css'];
		createStyles(styles);
	}
	function formatData(data){
		try{
			data = data.content||'{}';
			return JSON.parse(data);
		}finally{
			return {};
		}
	}
	
	bar.name='retPenTrial';
	bar.setState = setState;
	bar.show = function(el,data){
		bar.box = el;
		bar.data = formatData(data);
		initUI();
	};
	//loadStyles();
	window.addEventListener('refresh_data',function(){
		bar.setState();
	},false);
	
	return bar;
}));
	