(function($,doc,messageCenterSvc) {
	$('.mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: false,
		deceleration:mui.os.ios?0.003:0.0009
	});
	
	//获取所有未读消息数量
	var unreadMessageNum = function (){
		messageCenterSvc.getUnreadMessageNum().then(function(data) {
			g('messageNum').innerHTML = data;
			g('clearMsg').setAttribute('data-messageNum',data);
		}).catch(function(err) {
			$.toast(err.message);
		});
	}
	//获取消息标记已读
	var getMessageReaded = function (msgTypeId){
		messageCenterSvc.getMessageReaded(msgTypeId).then(function(data) {
			unreadMessageNum();
			getIndexMesList();
		}).catch(function(err) {
			$.toast(err.message);
		});
	}
	//X轴数据处理
	var messageCenterX = function (data){
		var messageRow = document.getElementById('gridTab');
		var html = '';
		$.each(data, function(i,item) {
			var unReadCount = item.unReadCount > 99 ? '99+' : item.unReadCount;
			var unreadNum = item.unReadCount == null ? 0 : item.unReadCount;
			var muiHidden = unReadCount == 0 ? 'mui-hidden':'';
			html += '<a class="mui-table-view-cell mui-media mui-col-xs-4" data-unReadCount="'+unreadNum+'" data-name="'+item.msgTypeName+'" data-msgTypeId="'+item.msgTypeId+'" data-href="'+item.transitionUrl+'"><dl>';
			html += '<dt><img src="' + item.logoUrl + '"/><span id="orderMsg" class="red_num '+muiHidden+'">'+ unReadCount +'</span></dt>';
			html += '<dd>'+item.msgTypeName+'</dd>';
			html += '</dl></a>';
		});
		messageRow.innerHTML = html;
	}
	//Y轴数据处理
	var messageCenterY = function (data){
		var messageInfoRow = document.getElementById('messageInfo');
		var html = '';
		$.each(data, function(i,item) {
			var unReadCount = item.unReadCount > 99 ? '99+' : item.unReadCount;
			var unreadNum = item.unReadCount == null ? 0 : item.unReadCount;
			var numMuiHidden = unReadCount == null ? 'mui-hidden' : '';
			var createTimeMuiHidden = item.createTime == null ? 'mui-hidden' : '';
			var titleMuiHidden = item.title == null ? 'mui-hidden' : '';
			var styleMiddle = item.title == null ? 'style_middle' : '';
			html +=	'<a data-msgTypeId="'+item.msgTypeId+'" data-title="'+item.msgTypeName+'" data-name="'+item.msgTypeName+'" data-unReadCount="'+unreadNum+'" data-href="'+item.transitionUrl+'"><li><dl>';
			html +=	'<dt><img src="'+item.logoUrl+'"/><span class="red_num list_message_num '+numMuiHidden+'">'+unReadCount+'</span></dt>';
			html +=	'<dd class="dl_style">';
			html +=	'<div class="content_div">';
			html +=	'<h6 class="'+styleMiddle+'">'+item.msgTypeName+'</h6>';
			html +=	'<p class="'+titleMuiHidden+'">'+item.title+'</p>';
			html +=	'</div>';
			html +=	'<span class="show_time '+createTimeMuiHidden+'">'+ item.createTime +'</span>';
			html +=	'</dd></dl></li></a>';
		});
		messageInfoRow.innerHTML = html;
	}
	//获取首页消息列表
	var getIndexMesList = function (){
		messageCenterSvc.getIndexMesList().then(function(data) {
			var dataX = data.x;
			var dataY = data.y || [];
			messageCenterX(dataX);
			messageCenterY(dataY);
		}).catch(function(err) {
			$.toast(err.message);
		});
	}
	
	//清理未读消息按钮[小刷子]
	g('clearMsg').addEventListener('tap',function(){
		getMessageReaded(null);
	},false);
	
	var appCheckLogin = function(){
		if(!app.checkLogin()){
			app.toLogin();
		}
	}
	
	//订单通知、咨询评论、系统通知
	$('#gridTab').on('tap','a',function(){
		var urlAll = this.getAttribute('data-href');
		var msgTypeId = this.getAttribute('data-msgTypeId');
		var url = urlAll.split('/');
		var ids = url[url.length-1].split('.html');
		var id,urlLink;
		if(!(ids[0] == 'systemNotification')){
			if(!app.checkLogin()){
				return app.toLogin();
			}
		}
		switch (ids[0]){
			case 'my-self':
				//社保、公积金订单
				id = 'topHandSelf';
				urlLink = '../my-self.html';
				getMessageReaded(msgTypeId);
				break;
			default:
				id = ids[0];
				urlLink = url[url.length-1]+'?msgTypeId='+msgTypeId;
				break;
		}
		$.openWindow({id: id,url: urlLink});
		var currentPageId = plus.webview.getWebviewById(id);
		currentPageId.addEventListener('close', function() {
			unreadMessageNum();
			getIndexMesList();
		});
	},false);
	//Y轴列表跳转
	$('#messageInfo').on('tap','a',function(){
		var urlAll = this.getAttribute('data-href');
		var msgTypeId = this.getAttribute('data-msgTypeId');
		var title = this.getAttribute('data-title');
		var url = urlAll.split('/');
		var ids = url[url.length-1].split('.html');
		var id,urlLink;
		switch (ids[0]){
			case 'order-list':
				if(url[url.length-2] == 'order'){
					//医疗订单
					id = 'orders';
					urlLink = '../o2o/order/order-list.html';
					getMessageReaded(msgTypeId);
				}else {
					//社保、公积金订单
					id = 'orders';
					urlLink = '../order-list.html';
					getMessageReaded(msgTypeId);
				}
				break;
			case 'bx-order-list':
				//保险订单
				id = 'insurance';
				urlLink = '../bx-order-list.html';
				getMessageReaded(msgTypeId);
				break;
			case 'holidayNotice':
				//放假通知
				id = 'holidayNotice';
				urlLink = 'systemNotification/holidayNotice.html';
				return appCheckLogin();
				break;
			case 'notificationOfActivities':
				//活动通知
				id = 'notificationOfActivities';
				urlLink = 'systemNotification/notificationOfActivities.html';
				return appCheckLogin();
				break;
			case 'noticeOfSocialSecurityUpdate':
				//社保更新通知
				id = 'noticeOfSocialSecurityUpdate';
				urlLink = 'systemNotification/noticeOfSocialSecurityUpdate.html';
				return appCheckLogin();
				break;
			case '1cgFdt':
				//在线客服
				id = 'kefu';
				urlLink = '../chat.html';
				getMessageReaded(msgTypeId);
				break;
			case 'notice':
				//通知
				id = 'notice';
				urlLink = url[url.length-2] + '/' + url[url.length-1]+'?msgTypeId='+msgTypeId+'&title='+encodeURIComponent(title);
				break;
			default:
				id = ids[0];
				urlLink = url[url.length-1];
				break;
		}
		if(!(ids[0] != 'notice' || ids[0] != 'holidayNotice' || ids[0] != 'notificationOfActivities' || ids[0] != 'noticeOfSocialSecurityUpdate')){
			unreadMessageNum();
			getIndexMesList();
		}
		$.openWindow({id: id,url: urlLink});
		var currentPageId = plus.webview.getWebviewById(id);
		currentPageId.addEventListener('close', function() {
			plus.navigator.setStatusBarStyle('light');
			unreadMessageNum();
			getIndexMesList();
		});
	},false);
	
	unreadMessageNum();
	getIndexMesList();
	//神策埋点
	function joyTrack(){
		//消息中心清理刷埋点
		jTrack.regEvents('#clearMsg','joyMsgClearClick','jtrack_name:清除未读消息,jtrack_msgcount:attr.data-messageNum');
		//消息分类点击X
		jTrack.regEventsLive('#gridTab','a','joyMsgCateClick','jtrack_msgcate_name:attr.data-name,jtrack_msgcate_id:attr.data-msgtypeid,jtrack_msgcount:attr.data-unReadCount');
		//消息分类点击Y
		jTrack.regEventsLive('#messageInfo','a','joyMsgCateClick','jtrack_msgcate_name:attr.data-name,jtrack_msgcate_id:attr.data-msgtypeid,jtrack_msgcount:attr.data-unReadCount');
	}
	$.plusReady(function(){
		document.addEventListener('unreadMessageNum',unreadMessageNum,false);
		document.addEventListener('getIndexMesList',getIndexMesList,false);
		//获取手机顶部高度，适配例iphoneX带有status bar高度
		if(imbar.isImmersedStatusbar){
			g('headerTop').querySelector('.mui-bar-nav').style.height =  imbar.navBarHeight+'px';
			g('headerTop').querySelector('.mui-bar-nav').style.paddingTop = imbar.statusbarHeight+'px';
			g('headerTop').querySelector('.unread_message').style.paddingTop = g('headerTitle').offsetHeight+'px';
		}
		joyTrack();
	});
	
	
	window.addEventListener('refresh_data',function(){
		unreadMessageNum();
		getIndexMesList();
	},false);
	
})(mui,document,messageCenterSvc);
