(function($,doc,messageCenterSvc) {
	var pageId,currentPageId;
	$('.mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: false,
		deceleration:mui.os.ios?0.003:0.0009
	});
	//获取消息标记已读
	var getMessageReaded = function (msgTypeId){
		messageCenterSvc.getMessageReaded(msgTypeId).then(function(data) {
			getOrderMessage();
		}).catch(function(err) {
			$.toast(err.message);
		});
	}
	//获取地址栏参数
	function getQueryVariable (variable) {
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
	}
	//订单通知消息列表数据处理
	var orderMessageList = function (data){
		var messageInfoRow = document.getElementById('messageInfo');
		var html = '';
		if(data.length>0){
			$.each(data, function(i,item) {
				var unReadCount = item.unReadCount > 99 ? '99+' : item.unReadCount;
				var unreadNum = item.unReadCount == null ? 0 : item.unReadCount;
				var numMuiHidden = unReadCount == null ? 'mui-hidden' : '';
				var createTimeMuiHidden = item.createTime == null ? 'mui-hidden' : '';
				var titleMuiHidden = item.title == null ? 'mui-hidden' : '';
				var styleMiddle = item.title == null ? 'style_middle' : '';
				html +=	'<a data-msgTypeId="'+item.msgTypeId+'" data-unReadCount="'+unreadNum+'" data-href="'+item.transitionUrl+'">';
				html +=	'<li><dl>';
				html +=	'<dt><img src="'+item.logoUrl+'"/><span class="red_num list_message_num '+numMuiHidden+'">'+unReadCount+'</span></dt>';
				html +=	'<dd class="dl_style">';
				html +=	'<div class="content_div">';
				html +=	'<h6 class="'+styleMiddle+'">'+item.msgTypeName+'</h6>';
				html +=	'<p class="'+titleMuiHidden+'">'+item.title+'</p>';
				html +=	'</div>';
				html +=	'<span class="show_time '+createTimeMuiHidden+'">'+item.createTime+'</span>';
				html +=	'</dd></dl></li></a>';
			});
		}else {
			html += '<div id="noComment" class="noContent">';
			html += '<img src="../../images/mynodatabg.png">';
			html += '<p>暂无内容</p>';
			html += '</div>';
		}
		messageInfoRow.innerHTML = html;
	}
	//获取子类消息数据列表
	var getOrderMessage = function (){
		var msgTypeIdData = getQueryVariable('msgTypeId');
		messageCenterSvc.getMesList(msgTypeIdData).then(function(data) {
			orderMessageList(data);
		}).catch(function(err) {
			$.toast(err.message);
		});
	}
	
	
	//子类页面跳转
	$('#messageInfo').on('tap','a',function(){
		var urlAll = this.getAttribute('data-href');
		var msgTypeId = this.getAttribute('data-msgTypeId');
		var url = urlAll.split('/');
		var ids = url[url.length-1].split('.html');
		var id,urlLink;
		switch (ids[0]){
			case 'order-list':
				if(url[url.length-2] == 'order'){
					//医疗订单
					id = 'tijian-order-list';
					urlLink = '../o2o/order/order-list.html';
				}else {
					//社保、公积金订单
					id = 'orders';
					urlLink = '../order-list.html';
				}
				break;
			case 'bx-order-list':
				//保险订单
				id = 'insurance';
				urlLink = '../bx-order-list.html';
				break;
			default:
				id = ids[0];
				urlLink = url[url.length-1];
				break;
		}
		getMessageReaded(msgTypeId);
		$.openWindow({id: id,url: urlLink+'?msgTypeId='+msgTypeId});
		plus.navigator.setStatusBarStyle('light');
		// 监听页面关闭
		pageId = plus.webview.getWebviewById(id);
		pageId.addEventListener('close', function() {
			plus.navigator.setStatusBarStyle('dark');
			getOrderMessage();
		});
	},false);
	
	getOrderMessage();
	
	//神策埋点
	function joyTrack(){
		//订单消息分类点击
		jTrack.regEventsLive('#messageInfo','a','joyMsgCateClick','jtrack_msgcate_name:this.innerText,jtrack_msgcate_id:attr.data-msgtypeid,jtrack_msgcount:attr.data-unReadCount');
	}
	
	$.plusReady(function() {
		plus.navigator.setStatusBarStyle('dark');
		joyTrack();
	});
	
})(mui,document,messageCenterSvc);
