(function($,doc) {
	var mId = common.utils.queryString('mId');
	var user = app.getUser();
	var authorInfo;//作者id
	var tab_index=0;
	var rq_params={pageSize:5,pageNum:1};//头条和头条评论的请求参数
	var articleParams = {pageSize:10,pageNum:1};//文章评论的参数
	var visualParams = {pageSize:10,pageNum:1,count:1}; //小视频请求参数
	var default_img = '../image/defaultheader.png';
	var param = {
		type: 0,
		page: {
			pageSize: 5,
			pageNum: 1,
			count: 1
		},
		pagers: {},
		getpager: function(){
			var page = param.pagers[param.type];
			if(!page){
				var page = {
					pageSize: 5,
					pageNum: 1,
					count: 1,
					releaseOperator: mId
				}
				param.pagers[param.type] = page;
			}
			return page;
		}
	}
	$.previewImage();
	$('#pullRefreshs .mui-scroll-wrapper').scroll({
		bounce: false,
		indicators: true,
		deceleration: mui.os.ios ? 0.003 : 0.0009
	});
     //处理图片
    function dealPic(imgList,m,opacity){
    		var imgHTML=[],imgStr="";
    		for(k=0;k<imgList.length;k++){
    			imgHTML=imgHTML.concat([
	    			'<div class="info_img pic"><div style="background:url(',imgList[k],') no-repeat 50% 50%;background-size:cover;"><img src="',imgList[k],'" data-preview-src="" data-preview-group="',m,'" style="opacity:' + opacity + '"/></div></div>'
	    		]);
	    	}
	    	imgStr = imgHTML.join("");
	    	return imgStr;
    }
	
	function pullupRefresh(pullSel,index){
		var params = param.pagers[index];
		switch (index){
			case 0:
				//小视频
				params.pageNum++;
				getVisualInfo(params,pullSel);
				break;
			case 1:
				//悦头条
				params.pageNum++;
				getAllMes(params,pullSel)
				break;
			case 2:
				//头条评论
				params.pageNum++;
				getAllCom(params,pullSel)
				break;
			case 3:
				//文章评论
				params.pageNum++;
				getArticleCom(params,pullSel)
				break;
			case 4:
				//小视频评论
				params.pageNum++;
				getReviewList(params,pullSel);
				break;
		}
	}
	
	var scroll_obj;
	var setPullToRefresh= function(tab_index) {
		var node =document.querySelectorAll('#pullRefreshs .mui-scroll')[tab_index];
		var deferred = Q.defer();
		scroll_obj = $(node).pullToRefresh({
			up: {
				callback: function() {
					var self = this;
					setTimeout(function() {
						pullupRefresh(self,tab_index);
					}, 100);
				}
			}
		});
	}
	// 小视频详情
	function getVisualInfo(params,pullSel){
		var releaseOperatorId = params.releaseOperator,pageNum = params.pageNum,pageSize = params.pageSize;
		newsSvc.getVideoClipsList(releaseOperatorId,pageNum,pageSize).then(function(data){
			g('visual').querySelector('.nothing').classList.add('mui-hidden');
			if(data && data.list.length > 0){
				g('noVisual').classList.add('mui-hidden');
				$.each(data.list,function(idx,val){
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					oDiv.setAttribute("visualId",val.id);
					oDiv.setAttribute("type",val.showType);
					oDiv.setAttribute('status',val.status);
					var collect = val.isCollect == 0 ? 'jcon jcon-shoucang2' : 'jcon jcon-shoucang11',
						praise = val.isLike == 0 ? 'jcon jcon-dianzan' : 'jcon jcon-dianzan1';
					oDiv.innerHTML = '<div class="authorMes">' + 
							'<div class="author_pic"><img src="' + (val.authorHeadPath ? val.authorHeadPath : default_img) + '"></div>' +
							'<div class="author_info">' +
								'<p class="authorName">' + (val.authorName ? val.authorName : '暂无') + '</p>' +
								'<p class="publishTime">' + (val.releaseDate ? val.releaseDate : '暂无') + '</p>' +
							'</div>' +
						'</div>' +
						'<div class="content"><div>' + (val.content ? val.content : '暂无') + '</div></div>' +
						'<div class="visual_video"><div class="pic" data-img="' + val.image + '" style="background:url(' + val.image + ') no-repeat 0 0;background-size: cover;"></div><div class="float-btn jcon jcon-bofang"></div></div>' +
						'<div class="visual_icon">' +
							'<div class="visual_info"><span class="jcon jcon-xiaoxi1"><span class="num">' + (val.replyCount ? val.replyCount : '0') + '</span></span></div>' +
							'<div class="visual_praise" praise="' + val.isLike + '">' +
								'<span class="' + praise + '"><span class="num">' + (val.agreeCount ? val.agreeCount : '0') + '</span><b class="jcon-fabulous"></b></span>' +
							'</div>' +
							'<div class="visual_collect" collect="' + val.isCollect + '">' +
								'<span class="' + collect + '"></span>' +
							'</div>' +
							'<div class="visual_share">' +
								'<span class="jcon jcon-fenxiang1"></span>' +
							'</div>' +
						'</div>';
					g('visualDetail').appendChild(oDiv);
				})
			}else{
				if(params.pageNum > 1){
					return false;
				}
				g('noVisual').classList.remove('mui-hidden');
			}
			params.pageNum = data.pagination.pageNum;
			params.count = parseInt((data.pagination.pageSize + data.pagination.totalItems -1) / data.pagination.pageSize);
			g('tab_visual').setAttribute('load','1');
			if(pullSel){
				var len = $("#visualDetail .mes").length;
				pullSel.endPullUpToRefresh(len >= data.pagination.totalItems);
			}else{
				if(data.pagination.totalItems > data.pagination.pageSize){
					setPullToRefresh(0);
				}else{
				}
			}
			
		}).catch(function(err){
			
		})
	}
	
	//获取悦头条
	function getAllMes(params,pullSel){
		var id=params.releaseOperator;
		var pageNum = params.pageNum;
		var pageSize = params.pageSize;
		var default_img = '../o2o/image/defaultheader.png';
		newsSvc.getAllMes(id,pageNum,pageSize).then(function(res){
			g('toutiao').querySelector('.nothing').classList.add('mui-hidden');
			var list = res.data;
			var imgArr=[];
			if(list.length<=0){
				if(pullSel){
					g("noMes").classList.add("mui-hidden");
				}else{
					g("noMes").classList.remove("mui-hidden");
				}
			}else{
				g("noMes").classList.add("mui-hidden");
				for(var m=0;m<list.length;m++){
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					var value = list[m];
					var htmlCon=[],imgStr="";
					var img = value.imageList;
  					var imgClass="";
					if(value.content.indexOf("img")>0){
						value.content =value.content.replace(/<img.*\/>/ig, "")
					}
					if(img){
						var len = img.length;
						var opacity = 0;
						if(len>0){
							if(len==2||len==4){
								imgClass = "imgs two";
							};
							if(len==1){
								imgClass = "imgs one";
							};
							if(len==3||len>4){
								imgClass = "imgs three";
							}
						}
						imgStr = dealPic(img,m,opacity)
					}
					if(value.releaseOperatorHeadPath){
						default_img = value.releaseOperatorHeadPath;
					}
					htmlCon=htmlCon.concat([
						 '<div class="authorMes"><div class="author_pic">',
						 '<img src="',default_img,'" /></div>',
						 '<div class="author_info"><p class="authorName">',value.releaseOperatorName,'</p><p class="publishTime">',value.releaseDate.split(' ')[0],'</p>',
							'</div></div><div class="content"><div>',value.content,'</div>',
							'</div><div class="picBox ',imgClass,'">',imgStr,'</div></div>'
					 ]);
 					oDiv.innerHTML = htmlCon.join("");
					g("toutiaoCon").appendChild(oDiv);
				}
				g("tab_toutia").setAttribute("load",1);
				// 多余隐藏
				var con = $('#toutiaoCon .content');
				for(var i=0;i<con.length;i++){
					var hig = con[i].offsetHeight;
					con[i].setAttribute("hig",hig);
					if(hig > 65){
						var showAll = doc.createElement("div");
						showAll.setAttribute("class","showAllText");
						showAll.innerHTML="全文";
						showAll.setAttribute("sort",i);
						con[i].classList.add("hide");
						con[i].appendChild(showAll);
						con[i].querySelector('.showAllText').setAttribute("sort",i);
					}
				}
			}
			if(pullSel){
				pullSel.endPullUpToRefresh(res.pages<=pageNum);
			}else{
				if(res.pages<pageNum){
					console.log(11)
				}else{
					setPullToRefresh(1);
				}
				
			}
		}).then(function(err){
			console.log(err)
		})
	};
	function delHtmlTag(str){
	　　return str.replace(/<[^>]+>/g,"");
	}

	//展开全文
	$("#toutiaoCon").on("tap",".showAllText",function(){
		var index = this.getAttribute("sort"),
			parent = this.parentElement;
		if(this.classList.contains("close")){//关闭状态
			parent.classList.add("hide");
			this.innerHTML="全文";
			this.classList.remove("close");
		}else{
			parent.classList.remove("hide");
			this.innerHTML="收起";
			this.classList.add("close");
		}
	})
	// 头条评论
	function getAllCom(params,pullSel){
		var id=params.releaseOperator;
		var pageNum = params.pageNum;
		var pageSize = params.pageSize;
		newsSvc.getCommentLists(id,pageSize,pageNum).then(function(res){
			g('comment').querySelector('.nothing').classList.add('mui-hidden');
			var list = res.list;
			if(list.length<=0){
				if(pullSel){
					g("noComment").classList.add("mui-hidden");
					pullSel.endPullUpToRefresh(true);
				}else{
					g("noComment").classList.remove("mui-hidden");
				}
			}else{
				g("noComment").classList.add("mui-hidden");
				$.each(list,function(key,value){
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					oDiv.setAttribute("minfoId",value.minfoId);
					oDiv.setAttribute("minfoType",value.minfoType);
					oDiv.setAttribute("status",value.status);
					var htmlCon=[];
					var userName;
					if(value.content==""){
						value.content="#悦头条#"
					}else{
						if(value.content.indexOf("img")>0){
							value.content =value.content.replace(/<img.*\/>/ig, "")
						}
						value.content =delHtmlTag(value.content);
					}
				    if(value.minfoType==4){
					   //纯文字
					   htmlCon=htmlCon.concat([
					   	 '<div class="authorMes"><div class="author_pic">',
					   	 '<img src="',authorInfo.headPath,'"></div>',
					   	'<div class="author_info"><p class="authorName">',authorInfo.userName,'</p>',
					   	'<p class="publishTime">',value.createDate,'</p></div></div>',
					   	'<div class="comment_txt">',value.content,'</div>',
					   	'<div class="minfn_info word"><div class="wordTxt mui-ellipsis-2">',value.title,'</div></div>'
					   ]);
					   oDiv.innerHTML = htmlCon.join("");
				    }else{
					   //文字和图片
					   htmlCon = htmlCon.concat([
						   '<div class="authorMes"><div class="author_pic">',
							'<img src="',authorInfo.headPath,'" /></div><div class="author_info">',
							'<p class="authorName">',authorInfo.userName,'</p><p class="publishTime">',value.createDate,'</p>',
							'</div></div><div class="comment_txt">',value.content,'</div>',
							'<div class="minfn_info pic clearfix">',
							'<div class="minfn_info_pic" style="background:url(',value.image,') no-repeat 50% 50%;background-size:cover;"></div>',
							'<div class="minfn_info word">',
							'<div class="wordTxt mui-ellipsis-2">',value.title,'</div></div></div>'
					   ]);
					    oDiv.innerHTML = htmlCon.join("");
				    }
				   g("author_comment").appendChild(oDiv);
				})
				g("tab_comment").setAttribute("load",1);
			}
			if(pullSel){
				var len = $("#author_comment .mes").length;
				pullSel.endPullUpToRefresh(len>=res.pagination.totalItems);
			}else{
				if(res.pagination.totalItems > res.pagination.pageSize){
					setPullToRefresh(2);
				}
			}	
		}).then(function(err){
			console.log(err)
		});
	};
	var getAuthorInfo = function(id){
		newsSvc.getUserInfoByUserId(id).then(function(res){
			authorInfo = res.userInfo;
			g("follow_num").innerHTML=authorInfo.followCount;
			g("follow_fans").innerHTML=authorInfo.followedCount;
			g("authorName").innerHTML = authorInfo.userName;
			if(authorInfo.signName){g("personal_brief").innerHTML = authorInfo.signName;}
			jel('#followBtn').attr('class',authorInfo.isFollow==1?'followBtn followed':'followBtn nofollow');
			jel('#followBtn').html(authorInfo.isFollow==1?'已关注':'+关注');
			if(authorInfo.headPath){
				default_img = authorInfo.headPath;
			}
			g('autorImg').setAttribute('src',default_img);
		}).catch(function(err){
			console.log(err.message.err)
		})
	};
	// 文章评论
	function getArticleCom(params,pullSel){
		newsSvc.getArticleCom(params.releaseOperator,params.pageSize,params.pageNum).then(function(res){
			g('article_comment').querySelector('.nothing').classList.add('mui-hidden');
			var comment_list = res.list;
			if(comment_list.length>0){
				g("no_article_comment").classList.add("mui-hidden");
				for(var m=0;m<comment_list.length;m++){
					var value = comment_list[m];
					var htmlCon=[];
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					oDiv.setAttribute("minfoId",value.documentId);
					oDiv.setAttribute("minfoType",value.docType);
					oDiv.setAttribute("status",value.status);
					htmlCon = htmlCon.concat([
					   '<div class="authorMes"><div class="author_pic">',
						'<img src="',authorInfo.headPath,'" /></div><div class="author_info">',
						'<p class="authorName">',authorInfo.userName,'</p><p class="publishTime">',value.createDate,'</p>',
						'</div></div><div class="comment_txt">',value.content,'</div>',
						'<div class="minfn_info pic clearfix">',
						'<div class="minfn_info_pic" style="background:url(',value.image,') no-repeat 50% 50%;background-size:cover;"></div>',
						'<div class="minfn_info word">',
						'<div class="wordTxt mui-ellipsis-2">',value.title,'</div></div></div>'
					]);
					oDiv.innerHTML = htmlCon.join("");
					g("articleCom").appendChild(oDiv);
				};
				g("article_tab_comment").setAttribute("load",1);
				
			}else{
				if(pullSel){
					g("no_article_comment").classList.add("mui-hidden");
					pullSel.endPullUpToRefresh(true);
				}else{
					g("no_article_comment").classList.remove("mui-hidden");
				}
			}
			if(pullSel){
				var len = $("#articleCom .mes").length;
				pullSel.endPullUpToRefresh(len>=res.pagination.totalItems);
			}else{
				if(res.pagination.totalItems >= res.pagination.pageSize){
					setPullToRefresh(3); //文章
				}
			}
		}).catch(function(e){
			console.log(err.message.err)
		})
	}
	
	// 小视频评论
	function getReviewList(params,pullSel){
		newsSvc.getFirstReviewList(params.releaseOperator,params.pageNum,params.pageSize).then(function(data){
			g('visual_comment').querySelector('.nothing').classList.add('mui-hidden');
			if(data && data.list.length > 0){
				g('no_visual_comment').classList.add('mui-hidden');
				$.each(data.list,function(idx,val){
					var oDiv = doc.createElement("div");
					oDiv.setAttribute("class","mes");
					oDiv.setAttribute("visualId",val.contentId);
					oDiv.setAttribute("status",val.status);
					oDiv.innerHTML = '<div class="authorMes">' +
							'<div class="author_pic"><img src="' + authorInfo.headPath + '"></div>' +
							'<div class="author_info">' +
								'<p class="authorName">' + authorInfo.userName + '</p>' +
								'<p class="publishTime">' + val.showTime + '</p>' +
							'</div>' +
						'</div>' +
						'<div class="comment_txt">' + val.content + '</div>' +
						'<div class="minfn_info pic clearfix">' +
							'<div class="minfn_info_pic" style="background:url(' + val.image + ') no-repeat 50% 50%;background-size:cover;"><div class="float-btn jcon jcon-bofang"></div></div>' +
							'<div class="minfn_info word">' +
								'<div class="wordTxt mui-ellipsis-2">' + val.title + '</div>' +
							'</div>' +
						'</div>' +
					'</div>';
					g('visualCom').appendChild(oDiv);
				})
			}else{
				if(params.pageNum <= 1){
					g('no_visual_comment').classList.remove('mui-hidden');
				}
			}
			g('visual_tab_comment').setAttribute('load','1');
			if(pullSel){
				var len = $("#visualCom .mes").length;
				pullSel.endPullUpToRefresh(len>=data.pagination.totalItems);
			}else{
				if(data.pagination.totalItems >= data.pagination.pageSize){
					setPullToRefresh(4)
				}
			}
		}).catch(function(err){
			
		})
	}
	
	//关注
	g('followBtn').addEventListener('tap',function(){
		if(app.checkLogin()){
			var folType = this.classList.contains('nofollow') ? 1:0;//未关注是1
			var userId = user.userId;
			newsSvc.followMan(folType,mId,userId).then(function(data){
	 			jel('#followBtn').attr('class',folType==1?'followBtn followed':'followBtn nofollow');
				if(folType==1){
					g('followBtn').innerHTML="已关注";
					$.toast("关注成功");
				}else{
					g('followBtn').innerHTML="+关注";
					$.toast("取消关注");
				}
				app.fireEvent('minfo-video','refreshFollowBth');
				app.fireEvent('minfo','refreshMinfoBth');
				getAuthorInfo(mId);
	 		}).catch(function(err){
	 			console.error(err.message,err);
	 		});
		}else{
			app.toLogin();
		}
	},false);
	
	g('slider').addEventListener('slide', function(event) {
		var index= event.detail.slideNumber;
		tab_index = index;
		var load = $("#tabs a")[index];
		var judge = load.getAttribute("load");
		if(judge==0){
			param.type = index;
			var params = param.getpager(),
				param_info = param.pagers[param.type];
			param.pagers[param.type].releaseOperator = mId;
			switch (index){
				case 0:
					getVisualInfo(param_info); // 小视频
					break;
				case 1:
					getAllMes(param_info); // 悦头条
					break;
				case 2:
					getAllCom(param_info); //头条评论
					break;
				case 3:
					getArticleCom(param_info); //文章评论
					break;
				case 4:
					getReviewList(param_info); //小视频评论
					break;
			}
		}
	},false);
	//点击头条评论进入详情
	$("#author_comment").on("tap",".mes",function(){
		var minfoId = this.getAttribute("minfoId");
		var minfoType = this.getAttribute('minfoType');
		var status = parseInt(this.getAttribute('status'));
		if(status !== 2){
			$.toast('该内容已删除，无法查看哦！');
			return false;
		}else {
			if(minfoType == 1 || minfoType == 3){
				// 视频
				$.openWindow("minfo-video.html?mId"+minfoId);
			}else{
				//文章
				$.openWindow("minfo.html?mId="+minfoId);
			}
		}
	})
	// 文章评论 详情
	$("#articleCom").on("tap",".mes",function(){
		var minfoId = this.getAttribute("minfoId");
		var minfoType = this.getAttribute('minfoType');
		var status = parseInt(this.getAttribute('status'));
		if(status !== 2){
			$.toast('该内容已删除，无法查看哦！');
			return false;
		}else {
			if(minfoType == 2){
				// 视频
				$.openWindow("../article-video.html?aid="+minfoId);
			}else{
				//文章
				$.openWindow("../article.html?aid="+minfoId);
			}
		}
	})
	// 初始化
	$.init({
		swipeBack:false, //关闭右滑关闭功能
		gestureConfig: {
			tap: true,
			swipe: true
		}
	})

	$.plusReady(function(){
		getAuthorInfo(mId);
		var page = param.getpager();
		getVisualInfo(param.pagers[param.type]);
	})
	
	// 小视频详情
	$('#visualDetail').on('tap','.visual_video',function(e){
		e.stopPropagation();
		var visualId = this.parentNode.getAttribute('visualId');
		refreshData(visualId);
	})
	
	// 小视频-消息
	$('#visualDetail').on('tap','.visual_info',function(e){
		e.stopPropagation();
		var visualId = this.parentNode.parentNode.getAttribute('visualId');
		refreshData(visualId);
	})
	
	// 小视频-评论
	$('#visualCom').on('tap','.mes',function(e){
		e.stopPropagation();
		var visualId = this.getAttribute('visualId');
		refreshData(visualId);
	})
	
	// 小视频-点赞
	$('#visualDetail').on('tap','.visual_praise',function(){
		var visualId = this.parentNode.parentNode.getAttribute('visualId'),
			praise = this.getAttribute('praise'),
			praise_num = parseInt(this.querySelector('span.num').innerHTML);
			operateType = praise == 0 ? 1 : 0,
			self = this;
		newsSvc.getliked(visualId,0,operateType).then(function(data){
			self.setAttribute('praise',praise == 0 ? 1 : 0);
			self.setAttribute('praised',praise == 0 ? 1 : 0);
			self.querySelector('span.jcon').setAttribute('class',praise == 0 ? 'jcon jcon-dianzan1' : 'jcon jcon-dianzan');
			self.querySelector('span.num').innerHTML = (praise == 0 ? praise_num+1 : praise_num-1);
			var count = self.querySelector('span.num').innerHTML;
			$.fire(plus.webview.getLaunchWebview(),'praiseFeed',{
				aid: visualId,
				operateType: operateType,
				count: count == "" ? 0 : count
			})
		}).catch(function(err){
			
		})
		
	})
	
	// 小视频-收藏
	$('#visualDetail').on('tap','.visual_collect',function(){
		var visualId = this.parentNode.parentNode.getAttribute('visualId'),
			collect = this.getAttribute('collect'),
			operateType = collect == 0 ? 1 : 0,
			self = this;
		newsSvc.getcollects(visualId,operateType).then(function(data){
			self.setAttribute('collect',collect == 0 ? 1 : 0);
			self.querySelector('span.jcon').setAttribute('class',collect == 0 ? 'jcon jcon-shoucang11' : 'jcon jcon-shoucang2');
		})


	})
	
	// 小视频-分享
	$('#visualDetail').on('tap','.visual_share',function(){
		var parent = this.parentNode.parentNode,
			visualId = parent.getAttribute('visualId'),
			type = parent.getAttribute('type'),
			content = parent.querySelector('.content div').innerHTML,
			imgEl = parent.querySelector('.pic').getAttribute('data-img');
		var shareMsg = {
			href:  app._webUrl + '/visual.html?visualId=' + visualId + '&showType=' + type,
			title: '#小视频#',
			content:content !== '' ? content : '#小视频#',
			funs: ["more"]
		};
		if(imgEl){
			shareMsg.thumbs = imgEl;
		}
		share.showShares({funs:['copyUrl','brcode','more']},shareMsg,function(){
			newsSvc.addForwardAmount(visualId).then(function(data){
				console.log('分享次数');
			}).catch(function(err){
				console.log(err.message);
			})
	    		$.toast('分享成功');
	    },function(e){
	    		console.log(e);
	    		$.toast('分享失败');
    		});
    		var box = document.querySelectorAll('.joy-share-box');
    		if(box.length > 0){
    			$.each(box, function(idx,val) {
    				console.log(val.querySelectorAll('li[class="funs"]'));
    				var len = val.querySelectorAll('li[class="funs"]').length;
    				if(len > 0){
    					val.querySelectorAll('li[class="funs"]')[0].classList.add('mui-hidden');
    				}
    			});
    		}
		
	})
	
	var refreshData = function(visualId){
		var page = $.openWindow({url:'../visualFrequency.html?visualId='+visualId,id:'visual' + Math.random(0,200).toFixed(2)}),
			pageId = plus.webview.getWebviewById(page.id);
		// 监听页面关闭
		pageId.addEventListener('close',function(){
			getAuthorInfo(mId);
		})
	}
	
})(mui,document);