(function($,theShare){
	var logoImg = '_www/images/logo.jpg';
	theShare.shares = {};
	theShare.msg = {};
	
	mui.init({
		swipeBack:false,
		beforeback:function(){
			document.body.style.background = 'rgba(0,0,0,0)';
		}
	})

	function saveImg(imgs,callback){
		plus.nativeUI.showWaiting('正在获取图片...');
		var dl = downloader.createDownload(imgs,{path:'_downloads/share/'});
		dl.addEventListener('allComplete',function(e){
			plus.nativeUI.closeWaiting();
			if(e.data.succeedFiles.length==0) $.toast('获取分享图片失败');
			callback(e.data.succeedFiles);
		},false);
	};
	function compressImg(src,callback){
		if(!src) return callback(logoImg);
		var dst = src.replace(/^(.+)\/([^\/]+)\.(.+)$/,'$1/$2_thumbs.jpg');
		var zipOptions = {
			src:src,
			dst:dst,
			format:'jpg',
			width:"192px",
			overwrite:true,
			quality:50
        };
    	plus.zip.compressImage(zipOptions,function() {    		
			callback(dst);
		},function(error) {
			callback(logoImg);
		});
	}
	function arryDisConcat(a1,a2){
		var all = [],result=[];
		all = [].concat(a1||[],a2||[]);
		for(var m in all){
			if(result.indexOf(all[m])<0){
				result.push(all[m])
			}
		}
		return result;
	}
	
	function g(id){  return document.getElementById(id); }
	function shareMessage(share,ex,msg,successCB,errorCB) {
		successCB = successCB || $.noop;
		errorCB = errorCB || $.noop;
		msg = msg || theShare.msg;
		var msgextra = $.extend(true, {extra: {scene: ex}},msg);
		var imgs = arryDisConcat(msgextra.thumbs,msgextra.pictures);
		var send = function(msg){
			var thumbs = msg.thumbs&&msg.thumbs.length>0?msg.thumbs[0]:null;
			compressImg(thumbs,function(dst){
				msg.thumbs = [dst];
				var shareobj = typeof(share)==='string' ? theShare.shares[share]:share; 
		 		if(shareobj && shareobj.send){
		 			msgextra.type = msgextra.type||'web';
					if(~shareobj.id.indexOf('qq')){
						msgextra.type = msgextra.type=='web'?'text':msgextra.type;
					}else if(~shareobj.id.indexOf('sinaweibo')){
						if(msgextra.href && plus.runtime.innerVersion<'1.9.9.43167') {
							msgextra.content = msgextra.content+'\n'+msgextra.href;
						}
					}
					shareobj.send(msgextra, function() {
						downloader.removeDir('_downloads/share/');
						successCB();
						console.log('分享到"' + share.description + '"成功！');
					}, function(e) {
						downloader.removeDir('_downloads/share/');
						errorCB(e);
						console.log('分享到"' + share.description + '"失败:' + e.code + ' - ' + e.message);
					});
					
					//神策分享埋点
					if(window.SDAnalytics){
						var platform=1;
						if(ex=='WXSceneSession'){
							platform=1;
						}else if(ex=='WXSceneTimeline'){
							platform=2;
						}else if(shareobj.id=='qq'){
							platform=3;
						}else if(shareobj.id=='sinaweibo'){
							platform=4;
						}
						SDAnalytics.customTrack('joyShare',{
							 jtrack_share_title:msg.title,
							 jtrack_share_url:msg.href,
							 jtrack_share_platform:platform
						});
					}
		 		}
			});
		};
	    var limgs = [],simgs=[];
		for(var i in imgs){
			if(/http[s]{0,1}:\/\//.test(imgs[i])){
				simgs.push(imgs[i]);
			}else{
				limgs.push(imgs[i]);
			}
		}
		
		if(simgs.length>0){
			saveImg(simgs,function(pics){
				var pictures = limgs.concat(pics);
				msgextra.thumbs = pictures;
				msgextra.pictures = pictures;
				send(msgextra);
			});
		}else{
			var pictures = imgs;
			msgextra.thumbs = pictures;
			msgextra.pictures = pictures;
			send(msgextra);
		}
	}
	function goShare(svcName,ex,msg,successCB,errorCB) {
		successCB = successCB || $.noop;
		errorCB = errorCB || $.noop;
		var share = theShare.shares[svcName];
		if(share){
		    if (share.authenticated) {
		        shareMessage(share,ex,msg,successCB,errorCB);
		    } else {
				share.authorize(function() {
				    shareMessage(share,ex,msg,successCB,errorCB);
				}, function(e) {
					errorCB(e);
				    console.log("认证授权失败：" + e.code + " - " + e.message);
				});
		    }
		}else{
			errorCB({message:'没有此分享服务'});
		    console.log('没有此分享服务');
		}
    };
	function moreShareAndroid(shareTip,shareText){
		var Context = plus.android.importClass("android.content.Intent");
	    var Main = plus.android.runtimeMainActivity();
	    var shareIntent=new Context(Context.ACTION_SEND);
	    shareIntent.setType("text/plain"); 
	    shareIntent.putExtra(Context.EXTRA_TEXT, shareText);
	    Main.startActivity(Context.createChooser(shareIntent,shareTip));
	};
	function moreShare(msg,successCB,errorCB){
		successCB = successCB || $.noop;
		errorCB = errorCB || $.noop;
		msg = msg || theShare.msg;
		
		var imgs = arryDisConcat(msg.thumbs,msg.pictures);
		var send = function(msg){
			var thumbs = msg.thumbs&&msg.thumbs[0]?msg.thumbs[0]:null;
			compressImg(thumbs,function(dst){
				msg.thumbs = [dst];
				//系统分享 不添加图片
				delete msg.pictures;
				plus.share.sendWithSystem(msg, function(){
					//downloader.removeDir('_downloads/share/');
					//successCB();
				}, function(e){
					downloader.removeDir('_downloads/share/');
					errorCB(e);
					console.log(e.code + ' - ' + e.message);
				});
				successCB();
			});
		};
		var limgs = [],simgs=[];
		for(var i in imgs){
			if(/http[s]{0,1}:\/\//.test(imgs[i])){
				simgs.push(imgs[i]);
			}else{
				limgs.push(imgs[i]);
			}
		}
		if(simgs.length>0){
			saveImg(simgs,function(pics){
				var pictures = limgs.concat(pics);
				msg.thumbs = [pictures.length>0?pictures[0]:''];
				msg.pictures = pictures;
				send(msg);
			});
		}else{
			send(msg);
		}
	};
	
	function joyShare(options,msg,successCB,errorCB){
		var timestamp = Date.now();
		var jshare = this;
		jshare.id = timestamp;
		jshare.boxId = 'shareBox_'+jshare.id;
		jshare.sheetId = 'shareSheet_'+jshare.id;
		jshare.brcodeBoxId = 'qrcodeBox_'+jshare.id;
		jshare.successCB = successCB;
		jshare.errorCB = errorCB;
		
		setMessage(msg);
		setOptions(options);
		createUI();

		function setMessage(msg){
			jshare.msg = $.extend({}, msg);
		}
		function setOptions(options){
			jshare.options = $.extend({
				btns:['WXSceneSession','WXSceneTimeline','qq','sinaweibo'],
				funs:['copyUrl','brcode','more'],
				type:'popoverBottom',
				showCancleBtn:true
			},options);
		}
		//"WXSceneSession"分享到微信的“我的好友”； "WXSceneTimeline"分享到微信的“朋友圈”中； "WXSceneFavorite"分享到微信的“我的收藏”中。 默认值为"WXSceneSession"。
		function createUI(){
			var id = jshare.id,
				options=jshare.options,
				boxId = 'shareBox_'+id;	
				
			var shareBox = g(boxId)
			if(!shareBox){
				g('content').innerHTML='';
				shareBox = g('content').appendChild(document.createElement("div"));
			} 
			shareBox.id =  boxId;
			shareBox.className = 'joy-share-box';
			var btns={
				WXSceneSession:'<a share="weixin" ex="WXSceneSession" class="weixin icon-item"><i class="mui-icon jcon jcon-weixin"></i><span>微信</span></a>',
				WXSceneTimeline:'<a share="weixin" ex="WXSceneTimeline" class="pengyouquan icon-item"><i class="mui-icon jcon jcon-pengyou"></i><span>朋友圈</span></a>',
				qq:'<a share="qq" class="qq icon-item"><i class="mui-icon jcon jcon-qq"></i><span>QQ</span></a>',
				sinaweibo:'<a share="sinaweibo" class="weibo icon-item"><i class="mui-icon jcon jcon-weibo"></i><span>微博</span></a>'
			};
			var funs={
				copyUrl:'<a class="copy-url icon-item"><i class="mui-icon jcon jcon-copy"></i><span>复制</span></a>',
				brcode:'<a class="brcode icon-item"><i class="mui-icon jcon jcon-qrcode"></i><span>二维码</span></a>',
				more:'<a id="moreShare_'+id+'" class="share-more icon-item"><i class="mui-icon jcon jcon-more"></i><span>更多</span></a>'
			};
			
			var addBtns = '',addFuns='';
			for(var i in options.btns){ addBtns += btns[options.btns[i]]; }
			for(var m in options.funs){ 
				var fun = options.funs[m];
				if(typeof fun==='string'){
					addFuns += funs[fun]; 
				}else{
					addFuns += [
						'<a id="',fun.name,'_',id,'" index="',m,'" name="',fun.name,'" class="icon-item share-ext">',
							'<i class="mui-icon ',fun.iconClass,'"></i>',
							'<span>',fun.text,'</span>',
						'</a>'].join('');
				}
			}
			var sheetId = 'shareSheet_'+id,$sheetId='#'+sheetId;
			var html = [
				'<div id="',sheetId,'" class="mui-popover mui-popover-bottom mui-popover-action mui-active share-sheet">',
				    '<ul class="services">',
				    	'<li class="icons">',addBtns,'</li>',
						'<li class="funs">',addFuns,'</li>',
				    '</ul>',
				    '<ul class="btns">',
				    	'<li class="cancel_box"><a class="hide-share">取消</a></li>',
			      	'</ul>',
				'</div>'].join('');
			if(options.funs && options.funs.indexOf('brcode')>=0){
				var brcodeBoxId = 'qrcodeBox_'+id,
					$brcodeBoxId='#'+brcodeBoxId,
					qrcodeShowId= 'qrcodeShow_'+id;
				html += [
				'<div id="',brcodeBoxId,'" class="mui-popover mui-popover-bottom mui-popover-action qrcode-box">',
					'<div class="mui-popup-inner">',
						'<div class="mui-popup-title">扫描二维码阅读</div>',
						'<div id="',qrcodeShowId,'" class="mui-popup-text"></div>',
					'</div>',
					'<div class="mui-popup-buttons">',
						'<a class="mui-popup-button mui-popup-button-bold hide-share-brcode">确定</a>',
					'</div>',
				'</div>'].join('');
			}
			shareBox.innerHTML = html;
			$($sheetId+' .icons').on('tap','.icon-item',function () {
				if(!jshare.msg) { 
					$.toast('分享内容初始化失败'); 
					return;
				}
		        var shareName = this.getAttribute('share');
		        var ex = this.getAttribute('ex');
		        var pmsg = jshare.msg[shareName+(ex?'_'+ex:'')];
		        if(pmsg){
		        		goShare(shareName,ex,pmsg,function(){
			        		$($sheetId).popover('hide');
				    		if(jshare.successCB) jshare.successCB();
				    		if(options.autoDestroy){
				    			mui.currentWebview.close();
				    		}else{
				    			mui.currentWebview.hide();
				    		}
			        },jshare.errorCB);
		        }else{
			        goShare(shareName,ex,jshare.msg,function(){
			        		$($sheetId).popover('hide');
				    		if(jshare.successCB) jshare.successCB();
				    		if(options.autoDestroy){
				    			mui.currentWebview.close();
				    		}else{
				    			mui.currentWebview.hide();
				    		}
			        },jshare.errorCB);
		        }
		    });
		    
			$($sheetId).on('tap','.hide-share',function () {
		        $($sheetId).popover('hide');
		        if(options.autoDestroy){
		    			mui.currentWebview.close();
		    		}else{
		    			mui.currentWebview.hide();
		    		}
		    });
		    
		    $($sheetId+' .funs').on('tap','.copy-url',function () {
				if(!jshare.msg) { 
					$.toast('分享内容初始化失败'); 
					return;
				}
				
		        app.copyText(jshare.msg.href);
		        $.toast('链接已复制到剪贴板');
		        
		        $($sheetId).popover('hide');
		        if(options.autoDestroy){
		    			mui.currentWebview.close();
		    		}else{
		    			mui.currentWebview.hide();
		    		}
		    });
	 	    $($sheetId+' .funs').on('tap','.brcode',function () {
				if(!jshare.msg) { 
					$.toast('分享内容初始化失败'); 
					return;
				}
			    	var qrcodeShow = g(qrcodeShowId);
			    	qrcodeShow.innerHTML="";
			    	var qrcode = new QRCode(qrcodeShow);
					qrcode.makeCode(jshare.msg.href);
					$($sheetId).popover('hide');
			    	$($brcodeBoxId).popover('show');
			    
			    setTimeout(function(){
			    		var backdrop = $('.mui-backdrop')[0];
			    		if(backdrop) backdrop.remove();
			    	},0);
		    });
		    $($sheetId+' .funs').on('tap','.share-more', function(){
		    		if(!jshare.msg) { 
					$.toast('分享内容初始化失败'); 
					return;
				}
			    	//moreShare("分享到...",jshare.msg.content+";"+jshare.msg.href);
			    	moreShare(jshare.msg, function(){
			    		if(jshare.successCB) jshare.successCB();
				    	$($sheetId).popover('hide');
				    if(options.autoDestroy){
			    			mui.currentWebview.close();
			    		}else{
			    			mui.currentWebview.hide();
			    		}
			    	},jshare.errorCB);
			    	
		    });
		    $($sheetId+' .funs').on('tap','.share-ext',function () {
		        var name = this.getAttribute('name'),
		        	index = this.getAttribute('index'),
		        	fun = jshare.options.funs[index];
		        if(fun&&fun.callback) fun.callback();
		        $($sheetId).popover('hide');
		       if(options.autoDestroy){
		    			mui.currentWebview.close();
		    		}else{
		    			mui.currentWebview.hide();
		    		}
		    });
		    $($brcodeBoxId).on('tap','.hide-share-brcode',function () {
				$($sheetId).popover('hide');
				$($brcodeBoxId).popover('hide');
		    		if(options.autoDestroy){
		    			mui.currentWebview.close();
		    		}else{
		    			mui.currentWebview.hide();
		    		}
		    });
		}
		
		jshare.update = function(options,msg,successCB,errorCB){
			shareBox.innerHTML='';
			setMessage(msg);
			setOptions(options);
			createUI();
			jshare.successCB = successCB;
			jshare.errorCB = errorCB;
		};
		jshare.setOptions = setOptions;
		jshare.setMessage = setMessage;
		jshare.show = function(){
			$('#'+jshare.sheetId).popover('show');
		};
	};
	
	var jshare;
	function showShares(options,msg,successCB,errorCB){
		if(jshare){
			jshare.update(options,msg,successCB,errorCB);
			jshare.show();
			console.log('xxx');
		}else{
			if(options.shareWebview){
				jshare = new joyShare(options,msg,successCB,errorCB);
				setTimeout(function(){
					shareWebview(options.shareWebview,function(msg){
						jshare.setMessage(msg);
					});
				},0);
			}else{
				jshare = new joyShare(options,msg,successCB,errorCB);
			}
			document.body.style.background = 'rgba(0,0,0,0.3)';
		}
	}
	
	document.addEventListener('showShares',function(e){
		var options = e.detail.options;
		var msg = e.detail.msg;
		var successCB = e.detail.successCB;
		var errorCB = e.detail.errorCB;
		showShares(showShares);
	},false);
	
	
	function shareWebview(ws,callback){
		var bitmap = new plus.nativeObj.Bitmap('test');
		ws = plus.webview.getWebviewById(typeof ws =='object' ?ws.id:ws);
		ws.draw(bitmap,function(){
			bitmap.save('_downloads/share/webdraw.jpg',{
				overwrite:true,
				format:'jpg',
				clip:{top:'0px',left:'0px',width:'100%',height:document.documentElement.clientWidth+'px'}
			},function(){
				var txt = ws.getTitle();
				callback({
				 	title:txt,
				 	content:txt,
					thumbs:['_downloads/share/webdraw.jpg'],
					href:ws.getURL()
				});
			},function(){
				callback({
				 	title:ws.getTitle(),
					href:ws.getURL()
				});
			});
		},function(e){
			callback({
				title:ws.getTitle(),
				href:ws.getURL()
			});
		});
	}
	
	
	$.plusReady(function(){
		plus.share.getServices(function(s) {
			if (s && s.length > 0) {
				var shares = {};
				for (var i = 0; i < s.length; i++) {
					var t = s[i];
					shares[t.id] = t;
				}
				theShare.shares = shares;
				
				var cwv = mui.currentWebview;
				var options = cwv.options;
				var msg = cwv.msg;
				var successCB = cwv.successCB;
				var errorCB = cwv.errorCB;
				showShares(options,msg,successCB,errorCB);
			}
		}, function() {
			console.log("获取分享服务列表失败");
		});
		
		
	});

})(mui,window.share={});
