(function(plus){
    var _BARCODE = 'IDCardOCR';
    plus.IDCardOCR = {
        /**
         * 拍照识别身份证
         * @param {Object} options  {type:"正反面",direction:"拍照界面方向，1-横屏（默认），2-竖屏",urlType:"返回图片路径类型，1-相对路径（默认），2-base64"}
         * @param {function} successCallback 识别成功回调
         * @param {function} errorCallback 识别失败回调
         * @returns {Object} '{type:"正反面",path:"图片保持路径",base64:"图片base64编码"}'
         */
        doScan:function (options,successCallback,errorCallback){
            var success = typeof successCallback !== 'function'? null:function(args){
                successCallback(JSON.parse(args));
            };
            var fail = typeof errorCallback !== 'function'?null:function(error){
                errorCallback(JSON.parse(error));
            };
            callbackID = plus.bridge.callbackId(success,fail);

            plus.bridge.exec(_BARCODE, "scanIDCard", [callbackID,options]);
        },
        /**
         * 选择图片识别身份证
         * @param {Object} options {type:"正反面",path:"图片路径||base64"}
         * @param {function} successCallback 识别成功回调
         * @param {function} errorCallback 识别失败回调
         * @returns {Object} '{type:"正反面",isLegal:"true||false,是否有效"}'
         */
        detectImg:function (options,successCallback,errorCallback){
            var success = typeof successCallback !== 'function'? null:function(args){
                successCallback(JSON.parse(args));
            };
            var fail = typeof errorCallback !== 'function'?null:function(error){
                errorCallback(JSON.parse(error));
            };
            callbackID = plus.bridge.callbackId(success,fail);

            plus.bridge.exec(_BARCODE, "detectImg", [callbackID,options]);
        }
    };
})(window.plus);