(function(plus){
 var _BARCODE = 'PermissionUtil',
        B = plus.bridge;
    var PermissionNames = {
        CAMERA:"android.permission.CAMERA",
        CONTACTS:"android.permission.WRITE_CONTACTS",
        GALLERY:"android.permission.WRITE_EXTERNAL_STORAGE",
        LOCATION:"android.permission.ACCESS_COARSE_LOCATION",
        RECORD:"android.permission.RECORD_AUDIO",
        SHORTCUT:"com.android.launcher.permission.INSTALL_SHORTCUT"
    };
    var PermissionUtil = {
        permissionState:function(permission){
            permission = PermissionNames[permission]||permission;
            return plus.bridge.execSync(_BARCODE, "permissionState", [permission]);
        },
        requestPermission:function (permissions,successCallback,errorCallback){
            var success = typeof successCallback !== 'function'? null:function(args){
                successCallback(JSON.parse(args));
            };
            var fail = typeof errorCallback !== 'function'?null:function(error){
                errorCallback(JSON.parse(error));
            };
            callbackID = plus.bridge.callbackId(success,fail);
            if(typeof permissions=='string'){
                permissions = [PermissionNames[permissions]||permissions];
            }else if(Array.isArray(permissions)){
                for(var m in permissions){
                    permissions[m] = PermissionNames[permissions[m]]||permissions[m];
                }
            }else{
                fail({code:2,message:'parameter error'})
            }
            plus.bridge.exec(_BARCODE, "requestPermissions", [callbackID,permissions]);
        },
        requestSetting:function (callback){
            var success = typeof callback !== 'function'? null:function(args){
                callback();
            };
            callbackID = plus.bridge.callbackId(success,null);
            plus.bridge.exec(_BARCODE, "requestSetting", [callbackID]);
        },
        isRealNetConnect(successCallback,errorCallback){
             var success = typeof successCallback !== 'function'? null:function(args){
                            successCallback(JSON.parse(args));
             };
             var fail = typeof errorCallback !== 'function'?null:function(error){
                errorCallback(JSON.parse(error));
             };
             callbackID = plus.bridge.callbackId(success,fail);

             plus.bridge.exec(_BARCODE, "isRealNetConnect", [callbackID]);
        }
    };
    plus.PermissionNames = PermissionNames;
    plus.PermissionUtil = PermissionUtil;
})(window.plus);